// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "DynareBison.hh"


// Unqualified %code blocks.
#line 56 "../preprocessor/src/DynareBison.yy"

#include <ranges>
#include <utility>

/* Little hack: we redefine the macro which computes the locations, because
   we need to access the location from within the parsing driver for error
   and warning messages. */
#define YYLLOC_DEFAULT(Current, Rhs, N)                           \
  do                                                              \
    {                                                             \
      if (N)                                                      \
        {                                                         \
          (Current).begin = YYRHSLOC(Rhs, 1).begin;               \
          (Current).end   = YYRHSLOC(Rhs, N).end;                 \
        }                                                         \
      else                                                        \
        {                                                         \
          (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end; \
        }                                                         \
      driver.location = (Current);                                \
    }                                                             \
  while (false)

#include "ParsingDriver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex

#include <cctype>

string
str_tolower(string s)
{
  // Converting to unsigned char is needed, see https://en.cppreference.com/w/cpp/string/byte/tolower
  ranges::transform(s, s.begin(), [](unsigned char c){ return std::tolower(c); });
  return s;
}

#line 88 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 25 "../preprocessor/src/DynareBison.yy"
namespace Dynare {
#line 181 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"

  /// Build a parser object.
  parser::parser (ParsingDriver &driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------.
  | symbol.  |
  `---------*/

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_period_range: // period_range
        value.copy< AbstractShocksStatement::period_range_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.copy< PacTargetKind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.copy< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.copy< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.copy< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.copy< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.copy< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.copy< map<string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.copy< map<string, variant<bool, variant<int, string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.copy< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.copy< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.copy< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.copy< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.copy< pair<string, variant<bool, variant<int, string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.copy< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.copy< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.copy< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.copy< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.copy< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.copy< tuple<string, string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        value.copy< variant<int, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.copy< vector<AbstractShocksStatement::period_range_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        value.copy< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.copy< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.copy< vector<map<string, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.copy< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.copy< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.copy< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.copy< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.copy< vector<vector<string>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_period_range: // period_range
        value.move< AbstractShocksStatement::period_range_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.move< PacTargetKind > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.move< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.move< map<string, string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.move< map<string, variant<bool, variant<int, string>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.move< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.move< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.move< pair<string, variant<bool, variant<int, string>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.move< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.move< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.move< string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.move< tuple<string, string, string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        value.move< variant<int, string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<AbstractShocksStatement::period_range_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        value.move< vector<expr_t> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.move< vector<map<string, string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.move< vector<pair<string,string>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.move< vector<string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.move< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.move< vector<vector<string>> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_period_range: // period_range
        value.YY_MOVE_OR_COPY< AbstractShocksStatement::period_range_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.YY_MOVE_OR_COPY< PacTargetKind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.YY_MOVE_OR_COPY< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.YY_MOVE_OR_COPY< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.YY_MOVE_OR_COPY< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.YY_MOVE_OR_COPY< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.YY_MOVE_OR_COPY< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.YY_MOVE_OR_COPY< map<string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.YY_MOVE_OR_COPY< map<string, variant<bool, variant<int, string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.YY_MOVE_OR_COPY< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.YY_MOVE_OR_COPY< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.YY_MOVE_OR_COPY< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.YY_MOVE_OR_COPY< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.YY_MOVE_OR_COPY< pair<string, variant<bool, variant<int, string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.YY_MOVE_OR_COPY< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.YY_MOVE_OR_COPY< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.YY_MOVE_OR_COPY< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.YY_MOVE_OR_COPY< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.YY_MOVE_OR_COPY< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.YY_MOVE_OR_COPY< tuple<string, string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.YY_MOVE_OR_COPY< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        value.YY_MOVE_OR_COPY< variant<int, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.YY_MOVE_OR_COPY< vector<AbstractShocksStatement::period_range_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        value.YY_MOVE_OR_COPY< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.YY_MOVE_OR_COPY< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.YY_MOVE_OR_COPY< vector<map<string, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.YY_MOVE_OR_COPY< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.YY_MOVE_OR_COPY< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.YY_MOVE_OR_COPY< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.YY_MOVE_OR_COPY< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.YY_MOVE_OR_COPY< vector<vector<string>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_period_range: // period_range
        value.move< AbstractShocksStatement::period_range_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.move< PacTargetKind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.move< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.move< map<string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.move< map<string, variant<bool, variant<int, string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.move< map<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.move< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.move< pair<string, variant<bool, variant<int, string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.move< pair<tuple<string, string, string, string, string, string>, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.move< pair<vector<expr_t>, vector<expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.move< string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.move< tuple<string, string, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        value.move< variant<int, string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<AbstractShocksStatement::period_range_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        value.move< vector<expr_t> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.move< vector<map<string, string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.move< vector<pair<string,string>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.move< vector<string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.move< vector<tuple<string, string, vector<pair<string, string>>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.move< vector<vector<string>> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_period_range: // period_range
        value.copy< AbstractShocksStatement::period_range_t > (that.value);
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.copy< PacTargetKind > (that.value);
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.copy< PriorDistributions > (that.value);
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.copy< SymbolType > (that.value);
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.copy< expr_t > (that.value);
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.copy< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.copy< map<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.copy< map<string, string> > (that.value);
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.copy< map<string, variant<bool, variant<int, string>>> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.copy< map<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.copy< pair<expr_t,expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.copy< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.copy< pair<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.copy< pair<string, variant<bool, variant<int, string>>> > (that.value);
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.copy< pair<string,string> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.copy< pair<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.copy< pair<vector<expr_t>, vector<expr_t>> > (that.value);
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.copy< string > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.copy< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.copy< tuple<string, string, string> > (that.value);
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.copy< tuple<string,string,string,string> > (that.value);
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        value.copy< variant<int, string> > (that.value);
        break;

      case symbol_kind::S_period_list: // period_list
        value.copy< vector<AbstractShocksStatement::period_range_t> > (that.value);
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        value.copy< vector<expr_t> > (that.value);
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.copy< vector<int> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.copy< vector<map<string, string>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.copy< vector<pair<string,string>> > (that.value);
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.copy< vector<string> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.copy< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.copy< vector<tuple<string, string, vector<pair<string, string>>>> > (that.value);
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.copy< vector<vector<string>> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_period_range: // period_range
        value.move< AbstractShocksStatement::period_range_t > (that.value);
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        value.move< PacTargetKind > (that.value);
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        value.move< PriorDistributions > (that.value);
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        value.move< SymbolType > (that.value);
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        value.move< expr_t > (that.value);
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        value.move< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        value.move< map<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        value.move< map<string, string> > (that.value);
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        value.move< map<string, variant<bool, variant<int, string>>> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        value.move< map<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        value.move< pair<expr_t,expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        value.move< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        value.move< pair<string, expr_t> > (that.value);
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        value.move< pair<string, variant<bool, variant<int, string>>> > (that.value);
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        value.move< pair<string,string> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        value.move< pair<tuple<string, string, string, string, string, string>, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        value.move< pair<vector<expr_t>, vector<expr_t>> > (that.value);
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        value.move< string > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        value.move< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > (that.value);
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        value.move< tuple<string, string, string> > (that.value);
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        value.move< tuple<string,string,string,string> > (that.value);
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        value.move< variant<int, string> > (that.value);
        break;

      case symbol_kind::S_period_list: // period_list
        value.move< vector<AbstractShocksStatement::period_range_t> > (that.value);
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        value.move< vector<expr_t> > (that.value);
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        value.move< vector<int> > (that.value);
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        value.move< vector<map<string, string>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        value.move< vector<pair<string,string>> > (that.value);
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        value.move< vector<string> > (that.value);
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        value.move< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > (that.value);
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        value.move< vector<tuple<string, string, vector<pair<string, string>>>> > (that.value);
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        value.move< vector<vector<string>> > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n) YY_NOEXCEPT
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 51 "../preprocessor/src/DynareBison.yy"
{
  // Initialize the locations' filenames to the filename maintained by the lexer
  yyla.location.begin.filename = yyla.location.end.filename = &(driver.lexer->filename);
}

#line 1815 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            yyla.kind_ = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_period_range: // period_range
        yylhs.value.emplace< AbstractShocksStatement::period_range_t > ();
        break;

      case symbol_kind::S_pac_target_kind: // pac_target_kind
        yylhs.value.emplace< PacTargetKind > ();
        break;

      case symbol_kind::S_prior_distribution: // prior_distribution
      case symbol_kind::S_prior_pdf: // prior_pdf
        yylhs.value.emplace< PriorDistributions > ();
        break;

      case symbol_kind::S_change_type_arg: // change_type_arg
        yylhs.value.emplace< SymbolType > ();
        break;

      case symbol_kind::S_expression: // expression
      case symbol_kind::S_expression_or_empty: // expression_or_empty
      case symbol_kind::S_equation: // equation
      case symbol_kind::S_hand_side: // hand_side
        yylhs.value.emplace< expr_t > ();
        break;

      case symbol_kind::S_matched_irfs_list: // matched_irfs_list
        yylhs.value.emplace< map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ();
        break;

      case symbol_kind::S_occbin_constraints_regime_options_list: // occbin_constraints_regime_options_list
        yylhs.value.emplace< map<string, expr_t> > ();
        break;

      case symbol_kind::S_tag_pair_list: // tag_pair_list
        yylhs.value.emplace< map<string, string> > ();
        break;

      case symbol_kind::S_mshocks_options_list: // mshocks_options_list
        yylhs.value.emplace< map<string, variant<bool, variant<int, string>>> > ();
        break;

      case symbol_kind::S_matched_irfs_weights_list: // matched_irfs_weights_list
        yylhs.value.emplace< map<tuple<string, string, string, string, string, string>, expr_t> > ();
        break;

      case symbol_kind::S_calibration_range: // calibration_range
        yylhs.value.emplace< pair<expr_t,expr_t> > ();
        break;

      case symbol_kind::S_matched_irfs_elem: // matched_irfs_elem
        yylhs.value.emplace< pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ();
        break;

      case symbol_kind::S_occbin_constraints_regime_option: // occbin_constraints_regime_option
        yylhs.value.emplace< pair<string, expr_t> > ();
        break;

      case symbol_kind::S_mshocks_option: // mshocks_option
        yylhs.value.emplace< pair<string, variant<bool, variant<int, string>>> > ();
        break;

      case symbol_kind::S_partition_elem: // partition_elem
      case symbol_kind::S_tag_pair: // tag_pair
      case symbol_kind::S_subsamples_eq_opt: // subsamples_eq_opt
      case symbol_kind::S_matched_irfs_elem_var_varexo: // matched_irfs_elem_var_varexo
      case symbol_kind::S_integer_range_w_inf: // integer_range_w_inf
        yylhs.value.emplace< pair<string,string> > ();
        break;

      case symbol_kind::S_matched_irfs_weights_elem: // matched_irfs_weights_elem
        yylhs.value.emplace< pair<tuple<string, string, string, string, string, string>, expr_t> > ();
        break;

      case symbol_kind::S_matched_irfs_elem_values_weights: // matched_irfs_elem_values_weights
        yylhs.value.emplace< pair<vector<expr_t>, vector<expr_t>> > ();
        break;

      case symbol_kind::S_FALSE: // FALSE
      case symbol_kind::S_FLOAT_NUMBER: // FLOAT_NUMBER
      case symbol_kind::S_DATE: // DATE
      case symbol_kind::S_INT_NUMBER: // INT_NUMBER
      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_QUOTED_STRING: // QUOTED_STRING
      case symbol_kind::S_TEX_NAME: // TEX_NAME
      case symbol_kind::S_TRUE: // TRUE
      case symbol_kind::S_BIND: // BIND
      case symbol_kind::S_RELAX: // RELAX
      case symbol_kind::S_ERROR_BIND: // ERROR_BIND
      case symbol_kind::S_ERROR_RELAX: // ERROR_RELAX
      case symbol_kind::S_ALPHA: // ALPHA
      case symbol_kind::S_BETA: // BETA
      case symbol_kind::S_ABAND: // ABAND
      case symbol_kind::S_NINV: // NINV
      case symbol_kind::S_CMS: // CMS
      case symbol_kind::S_NCMS: // NCMS
      case symbol_kind::S_CNUM: // CNUM
      case symbol_kind::S_GAMMA: // GAMMA
      case symbol_kind::S_INV_GAMMA: // INV_GAMMA
      case symbol_kind::S_INV_GAMMA1: // INV_GAMMA1
      case symbol_kind::S_INV_GAMMA2: // INV_GAMMA2
      case symbol_kind::S_NORMAL: // NORMAL
      case symbol_kind::S_UNIFORM: // UNIFORM
      case symbol_kind::S_EPS: // EPS
      case symbol_kind::S_PDF: // PDF
      case symbol_kind::S_FIG: // FIG
      case symbol_kind::S_DR: // DR
      case symbol_kind::S_NONE: // NONE
      case symbol_kind::S_PRIOR: // PRIOR
      case symbol_kind::S_PRIOR_VARIANCE: // PRIOR_VARIANCE
      case symbol_kind::S_HESSIAN: // HESSIAN
      case symbol_kind::S_IDENTITY_MATRIX: // IDENTITY_MATRIX
      case symbol_kind::S_DIRICHLET: // DIRICHLET
      case symbol_kind::S_DIAGONAL: // DIAGONAL
      case symbol_kind::S_OPTIMAL: // OPTIMAL
      case symbol_kind::S_MFS: // MFS
      case symbol_kind::S_KIND: // KIND
      case symbol_kind::S_LL: // LL
      case symbol_kind::S_DL: // DL
      case symbol_kind::S_DD: // DD
      case symbol_kind::S_ADD: // ADD
      case symbol_kind::S_MULTIPLY: // MULTIPLY
      case symbol_kind::S_signed_integer: // signed_integer
      case symbol_kind::S_non_negative_number: // non_negative_number
      case symbol_kind::S_signed_number: // signed_number
      case symbol_kind::S_signed_inf: // signed_inf
      case symbol_kind::S_signed_number_w_inf: // signed_number_w_inf
      case symbol_kind::S_boolean: // boolean
      case symbol_kind::S_date_expr: // date_expr
      case symbol_kind::S_name_value_pair: // name_value_pair
      case symbol_kind::S_name_value_pair_list: // name_value_pair_list
      case symbol_kind::S_name_value_pair_with_boolean: // name_value_pair_with_boolean
      case symbol_kind::S_name_value_pair_with_boolean_list: // name_value_pair_with_boolean_list
      case symbol_kind::S_name_value_pair_with_suboptions: // name_value_pair_with_suboptions
      case symbol_kind::S_name_value_pair_with_suboptions_list: // name_value_pair_with_suboptions_list
      case symbol_kind::S_filename: // filename
      case symbol_kind::S_namespace_qualified_symbol: // namespace_qualified_symbol
      case symbol_kind::S_namespace_qualified_filename: // namespace_qualified_filename
      case symbol_kind::S_range: // range
      case symbol_kind::S_integer_range: // integer_range
      case symbol_kind::S_signed_integer_range: // signed_integer_range
      case symbol_kind::S_symbol: // symbol
        yylhs.value.emplace< string > ();
        break;

      case symbol_kind::S_occbin_constraints_regime: // occbin_constraints_regime
        yylhs.value.emplace< tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > ();
        break;

      case symbol_kind::S_matched_irfs_weights_elem_var_varexo: // matched_irfs_weights_elem_var_varexo
        yylhs.value.emplace< tuple<string, string, string> > ();
        break;

      case symbol_kind::S_prior_eq_opt: // prior_eq_opt
      case symbol_kind::S_options_eq_opt: // options_eq_opt
        yylhs.value.emplace< tuple<string,string,string,string> > ();
        break;

      case symbol_kind::S_integer_or_date: // integer_or_date
        yylhs.value.emplace< variant<int, string> > ();
        break;

      case symbol_kind::S_period_list: // period_list
        yylhs.value.emplace< vector<AbstractShocksStatement::period_range_t> > ();
        break;

      case symbol_kind::S_matched_moments_list: // matched_moments_list
      case symbol_kind::S_value_list: // value_list
      case symbol_kind::S_ramsey_constraints_list: // ramsey_constraints_list
        yylhs.value.emplace< vector<expr_t> > ();
        break;

      case symbol_kind::S_vec_int_number: // vec_int_number
      case symbol_kind::S_vec_int_elem: // vec_int_elem
      case symbol_kind::S_vec_int_1: // vec_int_1
      case symbol_kind::S_vec_int: // vec_int
        yylhs.value.emplace< vector<int> > ();
        break;

      case symbol_kind::S_tag_pair_list_for_selection: // tag_pair_list_for_selection
        yylhs.value.emplace< vector<map<string, string>> > ();
        break;

      case symbol_kind::S_symbol_list_with_tex: // symbol_list_with_tex
      case symbol_kind::S_partition_1: // partition_1
      case symbol_kind::S_partition: // partition
        yylhs.value.emplace< vector<pair<string,string>> > ();
        break;

      case symbol_kind::S_SYMBOL_VEC: // SYMBOL_VEC
      case symbol_kind::S_symbol_list: // symbol_list
      case symbol_kind::S_symbol_list_or_wildcard: // symbol_list_or_wildcard
      case symbol_kind::S_vec_str_1: // vec_str_1
      case symbol_kind::S_vec_str: // vec_str
      case symbol_kind::S_vec_value_1: // vec_value_1
      case symbol_kind::S_vec_value: // vec_value
      case symbol_kind::S_vec_value_w_inf_1: // vec_value_w_inf_1
      case symbol_kind::S_vec_value_w_inf: // vec_value_w_inf
        yylhs.value.emplace< vector<string> > ();
        break;

      case symbol_kind::S_occbin_constraints_regimes_list: // occbin_constraints_regimes_list
        yylhs.value.emplace< vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > ();
        break;

      case symbol_kind::S_symbol_list_with_tex_and_partition: // symbol_list_with_tex_and_partition
        yylhs.value.emplace< vector<tuple<string, string, vector<pair<string, string>>>> > ();
        break;

      case symbol_kind::S_vec_of_vec_value_1: // vec_of_vec_value_1
      case symbol_kind::S_vec_of_vec_value: // vec_of_vec_value
        yylhs.value.emplace< vector<vector<string>> > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 134: // dsample: DSAMPLE INT_NUMBER ';'
#line 407 "../preprocessor/src/DynareBison.yy"
          { driver.dsample(yystack_[1].value.as < string > ()); }
#line 2164 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 135: // dsample: DSAMPLE INT_NUMBER INT_NUMBER ';'
#line 409 "../preprocessor/src/DynareBison.yy"
          { driver.dsample(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 2170 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 136: // symbol_list: symbol_list symbol
#line 413 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 2179 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 137: // symbol_list: symbol_list COMMA symbol
#line 418 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 2188 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 138: // symbol_list: symbol
#line 423 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<string> > () = { yystack_[0].value.as < string > () }; }
#line 2194 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 139: // symbol_list_or_wildcard: symbol_list
#line 426 "../preprocessor/src/DynareBison.yy"
                          { yylhs.value.as < vector<string> > () = yystack_[0].value.as < vector<string> > (); }
#line 2200 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 140: // symbol_list_or_wildcard: ':'
#line 428 "../preprocessor/src/DynareBison.yy"
                          { yylhs.value.as < vector<string> > () = { ":" }; }
#line 2206 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 141: // symbol_list_with_tex: symbol_list_with_tex symbol
#line 432 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[0].value.as < string > (), "");
                       }
#line 2215 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 142: // symbol_list_with_tex: symbol_list_with_tex COMMA symbol
#line 437 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[0].value.as < string > (), "");
                       }
#line 2224 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 143: // symbol_list_with_tex: symbol
#line 442 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < vector<pair<string,string>> > () = {{yystack_[0].value.as < string > (), ""}}; }
#line 2230 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 144: // symbol_list_with_tex: symbol_list_with_tex symbol TEX_NAME
#line 444 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ());
                       }
#line 2239 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 145: // symbol_list_with_tex: symbol_list_with_tex COMMA symbol TEX_NAME
#line 449 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<pair<string,string>> > () = yystack_[3].value.as < vector<pair<string,string>> > ();
                         yylhs.value.as < vector<pair<string,string>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > ());
                       }
#line 2248 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 146: // symbol_list_with_tex: symbol TEX_NAME
#line 454 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < vector<pair<string,string>> > () = {{yystack_[1].value.as < string > (), yystack_[0].value.as < string > ()}}; }
#line 2254 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 147: // partition_elem: symbol EQUAL QUOTED_STRING
#line 458 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()}; }
#line 2260 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 148: // partition_1: '(' partition_elem
#line 461 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<pair<string,string>> > () = {yystack_[0].value.as < pair<string,string> > ()}; }
#line 2266 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 149: // partition_1: '(' COMMA partition_elem
#line 463 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<pair<string,string>> > () = {yystack_[0].value.as < pair<string,string> > ()}; }
#line 2272 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 150: // partition_1: partition_1 partition_elem
#line 465 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 2281 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 151: // partition_1: partition_1 COMMA partition_elem
#line 470 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > ();
                yylhs.value.as < vector<pair<string,string>> > ().push_back(yystack_[0].value.as < pair<string,string> > ());
              }
#line 2290 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 152: // partition: partition_1 ')'
#line 476 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<pair<string,string>> > () = yystack_[1].value.as < vector<pair<string,string>> > (); }
#line 2296 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 153: // partition: partition_1 COMMA ')'
#line 477 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<pair<string,string>> > () = yystack_[2].value.as < vector<pair<string,string>> > (); }
#line 2302 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 154: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol
#line 481 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[0].value.as < string > (), "", vector<pair<string,string>>{});
                                     }
#line 2311 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 155: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol
#line 486 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[2].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[0].value.as < string > (), "", vector<pair<string,string>>{});
                                     }
#line 2320 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 156: // symbol_list_with_tex_and_partition: symbol
#line 491 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[0].value.as < string > (), "", {}}}; }
#line 2326 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 157: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol partition
#line 493 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[2].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2335 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 158: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol partition
#line 498 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[3].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2344 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 159: // symbol_list_with_tex_and_partition: symbol partition
#line 503 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[1].value.as < string > (), "", yystack_[0].value.as < vector<pair<string,string>> > ()}}; }
#line 2350 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 160: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol TEX_NAME
#line 505 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[2].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > (), vector<pair<string,string>>{});
                                     }
#line 2359 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 161: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol TEX_NAME
#line 510 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[3].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[1].value.as < string > (), yystack_[0].value.as < string > (), vector<pair<string,string>>{});
                                     }
#line 2368 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 162: // symbol_list_with_tex_and_partition: symbol TEX_NAME
#line 515 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[1].value.as < string > (), yystack_[0].value.as < string > (), {}}}; }
#line 2374 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 163: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition symbol TEX_NAME partition
#line 517 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[3].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2383 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 164: // symbol_list_with_tex_and_partition: symbol_list_with_tex_and_partition COMMA symbol TEX_NAME partition
#line 522 "../preprocessor/src/DynareBison.yy"
                                     {
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = yystack_[4].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ();
                                       yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ().emplace_back(yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ());
                                     }
#line 2392 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 165: // symbol_list_with_tex_and_partition: symbol TEX_NAME partition
#line 527 "../preprocessor/src/DynareBison.yy"
                                     { yylhs.value.as < vector<tuple<string, string, vector<pair<string, string>>>> > () = {{yystack_[2].value.as < string > (), yystack_[1].value.as < string > (), yystack_[0].value.as < vector<pair<string,string>> > ()}}; }
#line 2398 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 166: // rplot: RPLOT symbol_list ';'
#line 530 "../preprocessor/src/DynareBison.yy"
                              { driver.rplot(yystack_[1].value.as < vector<string> > ()); }
#line 2404 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 167: // $@1: %empty
#line 532 "../preprocessor/src/DynareBison.yy"
                                              { driver.begin_model(); }
#line 2410 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 168: // trend_var: TREND_VAR '(' GROWTH_FACTOR EQUAL $@1 hand_side ')' symbol_list_with_tex ';'
#line 533 "../preprocessor/src/DynareBison.yy"
            { driver.end_trend_var(false, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<pair<string,string>> > ()); }
#line 2416 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 169: // $@2: %empty
#line 536 "../preprocessor/src/DynareBison.yy"
                                                          { driver.begin_model(); }
#line 2422 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 170: // log_trend_var: LOG_TREND_VAR '(' LOG_GROWTH_FACTOR EQUAL $@2 hand_side ')' symbol_list_with_tex ';'
#line 537 "../preprocessor/src/DynareBison.yy"
                { driver.end_trend_var(true, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<pair<string,string>> > ()); }
#line 2428 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 171: // var: VAR symbol_list_with_tex_and_partition ';'
#line 541 "../preprocessor/src/DynareBison.yy"
      { driver.var(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), {}, false); }
#line 2434 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 172: // var: VAR '(' LOG ')' symbol_list_with_tex_and_partition ';'
#line 543 "../preprocessor/src/DynareBison.yy"
      { driver.var(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), {}, true); }
#line 2440 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 173: // $@3: %empty
#line 544 "../preprocessor/src/DynareBison.yy"
                             { driver.begin_model(); }
#line 2446 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 174: // var: VAR '(' DEFLATOR EQUAL $@3 hand_side ')' symbol_list_with_tex_and_partition ';'
#line 545 "../preprocessor/src/DynareBison.yy"
      { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), false); }
#line 2452 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 175: // $@4: %empty
#line 546 "../preprocessor/src/DynareBison.yy"
                                       { driver.begin_model(); }
#line 2458 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 176: // var: VAR '(' LOG COMMA DEFLATOR EQUAL $@4 hand_side ')' symbol_list_with_tex_and_partition ';'
#line 547 "../preprocessor/src/DynareBison.yy"
      { driver.end_nonstationary_var(false, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), true); }
#line 2464 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 177: // $@5: %empty
#line 548 "../preprocessor/src/DynareBison.yy"
                                 { driver.begin_model(); }
#line 2470 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 178: // var: VAR '(' LOG_DEFLATOR EQUAL $@5 hand_side ')' symbol_list_with_tex_and_partition ';'
#line 549 "../preprocessor/src/DynareBison.yy"
      { driver.end_nonstationary_var(true, yystack_[3].value.as < expr_t > (), yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), false); }
#line 2476 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 179: // var: VAR '(' HETEROGENEITY EQUAL symbol ')' symbol_list_with_tex_and_partition ';'
#line 553 "../preprocessor/src/DynareBison.yy"
      { driver.var(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), yystack_[3].value.as < string > (), false); }
#line 2482 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 180: // var_remove: VAR_REMOVE symbol_list ';'
#line 556 "../preprocessor/src/DynareBison.yy"
                                        { driver.var_remove(yystack_[1].value.as < vector<string> > ()); }
#line 2488 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 181: // var_model: VAR_MODEL '(' var_model_options_list ')' ';'
#line 558 "../preprocessor/src/DynareBison.yy"
                                                         { driver.var_model(); }
#line 2494 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 187: // trend_component_model: TREND_COMPONENT_MODEL '(' trend_component_model_options_list ')' ';'
#line 570 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.trend_component_model(); }
#line 2500 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 193: // $@6: %empty
#line 582 "../preprocessor/src/DynareBison.yy"
                          { driver.begin_pac_model(); }
#line 2506 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 194: // pac_model: PAC_MODEL '(' $@6 pac_model_options_list ')' ';'
#line 582 "../preprocessor/src/DynareBison.yy"
                                                                                       { driver.pac_model(); }
#line 2512 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 203: // var_expectation_model: VAR_EXPECTATION_MODEL '(' var_expectation_model_options_list ')' ';'
#line 597 "../preprocessor/src/DynareBison.yy"
                        { driver.var_expectation_model(); }
#line 2518 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 206: // var_expectation_model_option: VARIABLE EQUAL symbol
#line 606 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("variable", yystack_[0].value.as < string > ()); }
#line 2524 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 207: // $@7: %empty
#line 607 "../preprocessor/src/DynareBison.yy"
                                                { driver.begin_model(); }
#line 2530 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 208: // var_expectation_model_option: EXPRESSION EQUAL $@7 hand_side
#line 608 "../preprocessor/src/DynareBison.yy"
                               {
                                 driver.var_expectation_model_expression = yystack_[0].value.as < expr_t > ();
                                 driver.reset_data_tree();
                               }
#line 2539 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 209: // var_expectation_model_option: AUXILIARY_MODEL_NAME EQUAL symbol
#line 613 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("auxiliary_model_name", yystack_[0].value.as < string > ()); }
#line 2545 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 210: // var_expectation_model_option: HORIZON EQUAL INT_NUMBER
#line 615 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("horizon", yystack_[0].value.as < string > ()); }
#line 2551 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 211: // var_expectation_model_option: HORIZON EQUAL integer_range_w_inf
#line 617 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("horizon", "[ " + yystack_[0].value.as < pair<string,string> > ().first + ' ' + yystack_[0].value.as < pair<string,string> > ().second + " ]"); }
#line 2557 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 212: // var_expectation_model_option: MODEL_NAME EQUAL symbol
#line 619 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("model_name", yystack_[0].value.as < string > ()); }
#line 2563 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 213: // var_expectation_model_option: DISCOUNT EQUAL expression
#line 621 "../preprocessor/src/DynareBison.yy"
                               { driver.var_expectation_model_discount = yystack_[0].value.as < expr_t > (); }
#line 2569 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 214: // var_expectation_model_option: TIME_SHIFT EQUAL signed_integer
#line 623 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("time_shift", yystack_[0].value.as < string > ()); }
#line 2575 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 215: // varexo: VAREXO symbol_list_with_tex_and_partition ';'
#line 627 "../preprocessor/src/DynareBison.yy"
         { driver.varexo(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), {}); }
#line 2581 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 216: // varexo: VAREXO '(' HETEROGENEITY EQUAL symbol ')' symbol_list_with_tex_and_partition ';'
#line 629 "../preprocessor/src/DynareBison.yy"
         { driver.varexo(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), yystack_[3].value.as < string > ()); }
#line 2587 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 217: // varexo_det: VAREXO_DET symbol_list_with_tex_and_partition ';'
#line 633 "../preprocessor/src/DynareBison.yy"
             { driver.varexo_det(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > ()); }
#line 2593 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 218: // predetermined_variables: PREDETERMINED_VARIABLES symbol_list ';'
#line 637 "../preprocessor/src/DynareBison.yy"
                          { driver.predetermined_variables(yystack_[1].value.as < vector<string> > ()); }
#line 2599 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 219: // parameters: PARAMETERS symbol_list_with_tex_and_partition ';'
#line 641 "../preprocessor/src/DynareBison.yy"
             { driver.parameters(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), {}); }
#line 2605 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 220: // parameters: PARAMETERS '(' HETEROGENEITY EQUAL symbol ')' symbol_list_with_tex_and_partition ';'
#line 643 "../preprocessor/src/DynareBison.yy"
             { driver.parameters(yystack_[1].value.as < vector<tuple<string, string, vector<pair<string, string>>>> > (), yystack_[3].value.as < string > ()); }
#line 2611 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 221: // model_local_variable: MODEL_LOCAL_VARIABLE symbol_list_with_tex ';'
#line 647 "../preprocessor/src/DynareBison.yy"
                       { driver.model_local_variable(yystack_[1].value.as < vector<pair<string,string>> > ()); }
#line 2617 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 222: // change_type: CHANGE_TYPE '(' change_type_arg ')' symbol_list ';'
#line 651 "../preprocessor/src/DynareBison.yy"
              { driver.change_type(yystack_[3].value.as < SymbolType > (), yystack_[1].value.as < vector<string> > ()); }
#line 2623 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 223: // change_type_arg: PARAMETERS
#line 655 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::parameter; }
#line 2629 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 224: // change_type_arg: VAR
#line 657 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::endogenous; }
#line 2635 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 225: // change_type_arg: VAREXO
#line 659 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::exogenous; }
#line 2641 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 226: // change_type_arg: VAREXO_DET
#line 661 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < SymbolType > () = SymbolType::exogenousDet; }
#line 2647 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 227: // heterogeneity_dimension: HETEROGENEITY_DIMENSION symbol_list ';'
#line 665 "../preprocessor/src/DynareBison.yy"
                          { driver.heterogeneity_dimension(yystack_[1].value.as < vector<string> > ()); }
#line 2653 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 228: // init_param: symbol EQUAL expression ';'
#line 668 "../preprocessor/src/DynareBison.yy"
                                         { driver.init_param(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2659 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 229: // expression: '(' expression ')'
#line 671 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > (); }
#line 2665 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 230: // expression: namespace_qualified_symbol
#line 673 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_expression_variable(yystack_[0].value.as < string > ()); }
#line 2671 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 231: // expression: non_negative_number
#line 675 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 2677 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 232: // expression: expression PLUS expression
#line 677 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2683 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 233: // expression: expression MINUS expression
#line 679 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2689 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 234: // expression: expression DIVIDE expression
#line 681 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2695 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 235: // expression: expression TIMES expression
#line 683 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2701 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 236: // expression: expression POWER expression
#line 685 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2707 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 237: // expression: expression LESS expression
#line 687 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2713 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 238: // expression: expression GREATER expression
#line 689 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2719 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 239: // expression: expression LESS_EQUAL expression
#line 691 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2725 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 240: // expression: expression GREATER_EQUAL expression
#line 693 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2731 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 241: // expression: expression EQUAL_EQUAL expression
#line 695 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2737 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 242: // expression: expression EXCLAMATION_EQUAL expression
#line 697 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 2743 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 243: // expression: MINUS expression
#line 699 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 2749 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 244: // expression: PLUS expression
#line 701 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2755 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 245: // expression: EXP '(' expression ')'
#line 703 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 2761 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 246: // expression: LOG '(' expression ')'
#line 705 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2767 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 247: // expression: LN '(' expression ')'
#line 707 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 2773 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 248: // expression: LOG10 '(' expression ')'
#line 709 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 2779 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 249: // expression: SIN '(' expression ')'
#line 711 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 2785 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 250: // expression: COS '(' expression ')'
#line 713 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 2791 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 251: // expression: TAN '(' expression ')'
#line 715 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 2797 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 252: // expression: ASIN '(' expression ')'
#line 717 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 2803 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 253: // expression: ACOS '(' expression ')'
#line 719 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 2809 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 254: // expression: ATAN '(' expression ')'
#line 721 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 2815 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 255: // expression: SINH '(' expression ')'
#line 723 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sinh(yystack_[1].value.as < expr_t > ()); }
#line 2821 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 256: // expression: COSH '(' expression ')'
#line 725 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cosh(yystack_[1].value.as < expr_t > ()); }
#line 2827 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 257: // expression: TANH '(' expression ')'
#line 727 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_tanh(yystack_[1].value.as < expr_t > ()); }
#line 2833 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 258: // expression: ASINH '(' expression ')'
#line 729 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_asinh(yystack_[1].value.as < expr_t > ()); }
#line 2839 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 259: // expression: ACOSH '(' expression ')'
#line 731 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_acosh(yystack_[1].value.as < expr_t > ()); }
#line 2845 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 260: // expression: ATANH '(' expression ')'
#line 733 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_atanh(yystack_[1].value.as < expr_t > ()); }
#line 2851 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 261: // expression: SQRT '(' expression ')'
#line 735 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 2857 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 262: // expression: CBRT '(' expression ')'
#line 737 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 2863 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 263: // expression: ABS '(' expression ')'
#line 739 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 2869 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 264: // expression: SIGN '(' expression ')'
#line 741 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 2875 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 265: // expression: MAX '(' expression COMMA expression ')'
#line 743 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2881 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 266: // expression: MIN '(' expression COMMA expression ')'
#line 745 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2887 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 267: // $@8: %empty
#line 746 "../preprocessor/src/DynareBison.yy"
                                        { driver.push_external_function_arg_vector_onto_stack(); }
#line 2893 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 268: // expression: namespace_qualified_symbol $@8 '(' comma_expression ')'
#line 747 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), false); }
#line 2899 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 269: // expression: NORMCDF '(' expression COMMA expression COMMA expression ')'
#line 749 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2905 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 270: // expression: NORMCDF '(' expression ')'
#line 751 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 2911 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 271: // expression: NORMPDF '(' expression COMMA expression COMMA expression ')'
#line 753 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 2917 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 272: // expression: NORMPDF '(' expression ')'
#line 755 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 2923 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 273: // expression: ERF '(' expression ')'
#line 757 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 2929 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 274: // expression: ERFC '(' expression ')'
#line 759 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_erfc(yystack_[1].value.as < expr_t > ()); }
#line 2935 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 275: // expression: NAN_CONSTANT
#line 761 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2941 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 276: // expression: INF_CONSTANT
#line 763 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_inf_constant(); }
#line 2947 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 277: // comma_expression: expression
#line 767 "../preprocessor/src/DynareBison.yy"
                   { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2953 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 278: // comma_expression: comma_expression COMMA expression
#line 769 "../preprocessor/src/DynareBison.yy"
                   { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 2959 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 279: // expression_or_empty: %empty
#line 773 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < expr_t > () = driver.add_nan_constant(); }
#line 2965 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 280: // expression_or_empty: expression
#line 774 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 2971 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 281: // initval: INITVAL ';' initval_list END ';'
#line 778 "../preprocessor/src/DynareBison.yy"
          { driver.end_initval(false); }
#line 2977 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 282: // initval: INITVAL '(' ALL_VALUES_REQUIRED ')' ';' initval_list END ';'
#line 780 "../preprocessor/src/DynareBison.yy"
          { driver.end_initval(true); }
#line 2983 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 285: // initval_elem: symbol EQUAL expression ';'
#line 787 "../preprocessor/src/DynareBison.yy"
                                           { driver.init_val(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 2989 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 286: // histval_file: HISTVAL_FILE '(' h_options_list ')' ';'
#line 790 "../preprocessor/src/DynareBison.yy"
              { driver.histval_file(); }
#line 2995 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 287: // initval_file: INITVAL_FILE '(' h_options_list ')' ';'
#line 793 "../preprocessor/src/DynareBison.yy"
              { driver.initval_file(); }
#line 3001 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 300: // integer_or_date: INT_NUMBER
#line 812 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < variant<int, string> > ().emplace<int>(stoi(yystack_[0].value.as < string > ())); }
#line 3007 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 301: // integer_or_date: date_expr
#line 814 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < variant<int, string> > ().emplace<string>(yystack_[0].value.as < string > ()); }
#line 3013 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 302: // endval: ENDVAL ';' endval_list END ';'
#line 818 "../preprocessor/src/DynareBison.yy"
         { driver.end_endval(false); }
#line 3019 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 303: // endval: ENDVAL '(' ALL_VALUES_REQUIRED ')' ';' endval_list END ';'
#line 820 "../preprocessor/src/DynareBison.yy"
         { driver.end_endval(true); }
#line 3025 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 304: // endval: ENDVAL '(' LEARNT_IN EQUAL integer_or_date ')' ';' endval_list END ';'
#line 822 "../preprocessor/src/DynareBison.yy"
         { driver.end_endval_learnt_in(yystack_[5].value.as < variant<int, string> > ()); }
#line 3031 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 307: // endval_elem: symbol EQUAL expression ';'
#line 830 "../preprocessor/src/DynareBison.yy"
              { driver.end_val(EndValLearntInStatement::LearntEndValType::level, yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3037 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 308: // endval_elem: symbol PLUS_EQUAL expression ';'
#line 832 "../preprocessor/src/DynareBison.yy"
              { driver.end_val(EndValLearntInStatement::LearntEndValType::add, yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3043 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 309: // endval_elem: symbol TIMES_EQUAL expression ';'
#line 834 "../preprocessor/src/DynareBison.yy"
              { driver.end_val(EndValLearntInStatement::LearntEndValType::multiply, yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3049 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 310: // histval: HISTVAL ';' histval_list END ';'
#line 838 "../preprocessor/src/DynareBison.yy"
          { driver.end_histval(false); }
#line 3055 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 311: // histval: HISTVAL '(' ALL_VALUES_REQUIRED ')' ';' histval_list END ';'
#line 840 "../preprocessor/src/DynareBison.yy"
          { driver.end_histval(true); }
#line 3061 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 314: // histval_elem: symbol '(' signed_integer ')' EQUAL expression ';'
#line 847 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.hist_val(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3067 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 315: // $@9: %empty
#line 849 "../preprocessor/src/DynareBison.yy"
                        { driver.begin_epilogue(); }
#line 3073 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 316: // epilogue: EPILOGUE ';' $@9 epilogue_equation_list END ';'
#line 850 "../preprocessor/src/DynareBison.yy"
                                          { driver.end_epilogue(); }
#line 3079 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 319: // $@10: %empty
#line 857 "../preprocessor/src/DynareBison.yy"
                         { driver.add_epilogue_variable(yystack_[0].value.as < string > ()); }
#line 3085 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 320: // epilogue_equation: NAME $@10 EQUAL expression ';'
#line 858 "../preprocessor/src/DynareBison.yy"
                    { driver.add_epilogue_equal(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3091 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 321: // compilation_setup: COMPILATION_SETUP '(' compilation_setup_options_list ')' ';'
#line 861 "../preprocessor/src/DynareBison.yy"
                                                                                 { }
#line 3097 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 324: // compilation_setup_option: SUBSTITUTE_FLAGS EQUAL QUOTED_STRING
#line 868 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_substitute_flags(yystack_[0].value.as < string > ()); }
#line 3103 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 325: // compilation_setup_option: ADD_FLAGS EQUAL QUOTED_STRING
#line 870 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_add_flags(yystack_[0].value.as < string > ()); }
#line 3109 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 326: // compilation_setup_option: SUBSTITUTE_LIBS EQUAL QUOTED_STRING
#line 872 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_substitute_libs(yystack_[0].value.as < string > ()); }
#line 3115 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 327: // compilation_setup_option: ADD_LIBS EQUAL QUOTED_STRING
#line 874 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_add_libs(yystack_[0].value.as < string > ()); }
#line 3121 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 328: // compilation_setup_option: COMPILER EQUAL QUOTED_STRING
#line 876 "../preprocessor/src/DynareBison.yy"
                           { driver.compilation_setup_compiler(yystack_[0].value.as < string > ()); }
#line 3127 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 329: // $@11: %empty
#line 879 "../preprocessor/src/DynareBison.yy"
                                      { driver.begin_matched_moments(); }
#line 3133 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 330: // matched_moments: MATCHED_MOMENTS ';' $@11 matched_moments_list END ';'
#line 880 "../preprocessor/src/DynareBison.yy"
                                               { driver.end_matched_moments(yystack_[2].value.as < vector<expr_t> > ()); }
#line 3139 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 331: // matched_moments_list: hand_side ';'
#line 884 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < vector<expr_t> > () = {yystack_[1].value.as < expr_t > ()}; }
#line 3145 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 332: // matched_moments_list: matched_moments_list hand_side ';'
#line 886 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
                         yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
                       }
#line 3154 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 333: // $@12: %empty
#line 892 "../preprocessor/src/DynareBison.yy"
                                            { driver.begin_occbin_constraints(); }
#line 3160 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 334: // occbin_constraints: OCCBIN_CONSTRAINTS ';' $@12 occbin_constraints_regimes_list END ';'
#line 893 "../preprocessor/src/DynareBison.yy"
                                                             { driver.end_occbin_constraints(yystack_[2].value.as < vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > ()); }
#line 3166 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 335: // occbin_constraints_regimes_list: occbin_constraints_regime
#line 898 "../preprocessor/src/DynareBison.yy"
                                  { yylhs.value.as < vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > () = {yystack_[0].value.as < tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > ()}; }
#line 3172 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 336: // occbin_constraints_regimes_list: occbin_constraints_regimes_list occbin_constraints_regime
#line 900 "../preprocessor/src/DynareBison.yy"
                                  {
                                    yylhs.value.as < vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > () = yystack_[1].value.as < vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > ();
                                    yylhs.value.as < vector<tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t>> > ().push_back(yystack_[0].value.as < tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > ());
                                  }
#line 3181 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 337: // occbin_constraints_regime: NAME QUOTED_STRING ';' occbin_constraints_regime_options_list
#line 907 "../preprocessor/src/DynareBison.yy"
                            {
                              BinaryOpNode *bind = dynamic_cast<BinaryOpNode *>(yystack_[0].value.as < map<string, expr_t> > ()["bind"]);
                              if (bind && !(bind->op_code == BinaryOpcode::less
                                            || bind->op_code == BinaryOpcode::greater
                                            || bind->op_code == BinaryOpcode::lessEqual
                                            || bind->op_code == BinaryOpcode::greaterEqual))
                                driver.error("The 'bind' expression must be an inequality constraint");
                              BinaryOpNode *relax = dynamic_cast<BinaryOpNode *>(yystack_[0].value.as < map<string, expr_t> > ()["relax"]);
                              if (relax && !(relax->op_code == BinaryOpcode::less
                                             || relax->op_code == BinaryOpcode::greater
                                             || relax->op_code == BinaryOpcode::lessEqual
                                             || relax->op_code == BinaryOpcode::greaterEqual))
                                driver.error("The 'relax' expression must be an inequality constraint");
                              yylhs.value.as < tuple<string, BinaryOpNode*, BinaryOpNode*, expr_t, expr_t> > () = {yystack_[2].value.as < string > (), bind, relax, yystack_[0].value.as < map<string, expr_t> > ()["error_bind"], yystack_[0].value.as < map<string, expr_t> > ()["error_relax"]};
                            }
#line 3201 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 338: // occbin_constraints_regime_options_list: occbin_constraints_regime_option
#line 925 "../preprocessor/src/DynareBison.yy"
                                         { yylhs.value.as < map<string, expr_t> > () = {yystack_[0].value.as < pair<string, expr_t> > ()}; }
#line 3207 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 339: // occbin_constraints_regime_options_list: occbin_constraints_regime_options_list occbin_constraints_regime_option
#line 927 "../preprocessor/src/DynareBison.yy"
                                         {
                                           yylhs.value.as < map<string, expr_t> > () = yystack_[1].value.as < map<string, expr_t> > ();
                                           auto [it, success] = yylhs.value.as < map<string, expr_t> > ().insert(yystack_[0].value.as < pair<string, expr_t> > ());
                                           if (!success)
                                             driver.error("The '" + yystack_[0].value.as < pair<string, expr_t> > ().first + "' clause is declared multiple times");
                                         }
#line 3218 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 340: // occbin_constraints_regime_option: BIND hand_side ';'
#line 936 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"bind", yystack_[1].value.as < expr_t > ()}; }
#line 3224 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 341: // occbin_constraints_regime_option: RELAX hand_side ';'
#line 938 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"relax", yystack_[1].value.as < expr_t > ()}; }
#line 3230 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 342: // occbin_constraints_regime_option: ERROR_BIND hand_side ';'
#line 940 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"error_bind", yystack_[1].value.as < expr_t > ()}; }
#line 3236 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 343: // occbin_constraints_regime_option: ERROR_RELAX hand_side ';'
#line 942 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<string, expr_t> > () = {"error_relax", yystack_[1].value.as < expr_t > ()}; }
#line 3242 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 344: // $@13: %empty
#line 946 "../preprocessor/src/DynareBison.yy"
                  { driver.begin_pac_target_info(yystack_[2].value.as < string > ()); }
#line 3248 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 345: // pac_target_info: PAC_TARGET_INFO '(' symbol ')' ';' $@13 pac_target_info_statement_list END ';'
#line 949 "../preprocessor/src/DynareBison.yy"
                  { driver.end_pac_target_info(); }
#line 3254 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 348: // pac_target_info_statement: TARGET hand_side ';'
#line 957 "../preprocessor/src/DynareBison.yy"
                            { driver.set_pac_target_info_target(yystack_[1].value.as < expr_t > ()); }
#line 3260 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 349: // pac_target_info_statement: AUXNAME_TARGET_NONSTATIONARY symbol ';'
#line 959 "../preprocessor/src/DynareBison.yy"
                            { driver.set_pac_target_info_auxname_target_nonstationary(yystack_[1].value.as < string > ()); }
#line 3266 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 351: // pac_target_info_component: COMPONENT hand_side ';' pac_target_info_component_list
#line 965 "../preprocessor/src/DynareBison.yy"
                            { driver.add_pac_target_info_component(yystack_[2].value.as < expr_t > ()); }
#line 3272 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 354: // pac_target_info_component_elem: GROWTH hand_side ';'
#line 973 "../preprocessor/src/DynareBison.yy"
                                 { driver.set_pac_target_info_component_growth(yystack_[1].value.as < expr_t > ()); }
#line 3278 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 355: // pac_target_info_component_elem: AUXNAME symbol ';'
#line 975 "../preprocessor/src/DynareBison.yy"
                                 { driver.set_pac_target_info_component_auxname(yystack_[1].value.as < string > ()); }
#line 3284 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 356: // pac_target_info_component_elem: KIND pac_target_kind ';'
#line 977 "../preprocessor/src/DynareBison.yy"
                                 { driver.set_pac_target_info_component_kind(yystack_[1].value.as < PacTargetKind > ()); }
#line 3290 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 357: // pac_target_kind: LL
#line 981 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < PacTargetKind > () = PacTargetKind::ll; }
#line 3296 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 358: // pac_target_kind: DL
#line 983 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < PacTargetKind > () = PacTargetKind::dl; }
#line 3302 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 359: // pac_target_kind: DD
#line 985 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < PacTargetKind > () = PacTargetKind::dd; }
#line 3308 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 360: // resid: RESID ';'
#line 989 "../preprocessor/src/DynareBison.yy"
        { driver.resid(); }
#line 3314 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 361: // resid: RESID '(' o_non_zero ')' ';'
#line 991 "../preprocessor/src/DynareBison.yy"
        { driver.resid(); }
#line 3320 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 362: // model_option: BLOCK
#line 997 "../preprocessor/src/DynareBison.yy"
                     { driver.block(); }
#line 3326 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 363: // model_option: CUTOFF EQUAL non_negative_number
#line 998 "../preprocessor/src/DynareBison.yy"
                                                { driver.cutoff(yystack_[0].value.as < string > ()); }
#line 3332 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 364: // model_option: MFS EQUAL INT_NUMBER
#line 999 "../preprocessor/src/DynareBison.yy"
                                    { driver.mfs(yystack_[0].value.as < string > ()); }
#line 3338 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 365: // model_option: STATIC_MFS EQUAL INT_NUMBER
#line 1000 "../preprocessor/src/DynareBison.yy"
                                           { driver.static_mfs(yystack_[0].value.as < string > ()); }
#line 3344 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 366: // model_option: BYTECODE
#line 1001 "../preprocessor/src/DynareBison.yy"
                        { driver.bytecode(); }
#line 3350 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 367: // model_option: USE_DLL
#line 1002 "../preprocessor/src/DynareBison.yy"
                       { driver.use_dll(); }
#line 3356 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 368: // model_option: NO_STATIC
#line 1003 "../preprocessor/src/DynareBison.yy"
                         { driver.no_static(); }
#line 3362 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 369: // model_option: DIFFERENTIATE_FORWARD_VARS
#line 1004 "../preprocessor/src/DynareBison.yy"
                                          { driver.differentiate_forward_vars_all(); }
#line 3368 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 370: // model_option: DIFFERENTIATE_FORWARD_VARS EQUAL '(' symbol_list ')'
#line 1005 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.differentiate_forward_vars_some(yystack_[1].value.as < vector<string> > ()); }
#line 3374 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 371: // model_option: LINEAR
#line 1006 "../preprocessor/src/DynareBison.yy"
                      { driver.linear(); }
#line 3380 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 373: // model_option: BALANCED_GROWTH_TEST_TOL EQUAL non_negative_number
#line 1008 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.balanced_growth_test_tol(yystack_[0].value.as < string > ()); }
#line 3386 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 376: // $@14: %empty
#line 1015 "../preprocessor/src/DynareBison.yy"
                  { driver.begin_model(); }
#line 3392 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 377: // model: MODEL ';' $@14 equation_list END ';'
#line 1016 "../preprocessor/src/DynareBison.yy"
                              { driver.end_model(); }
#line 3398 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 378: // $@15: %empty
#line 1017 "../preprocessor/src/DynareBison.yy"
                                             { driver.begin_model(); }
#line 3404 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 379: // model: MODEL '(' model_options_list ')' ';' $@15 equation_list END ';'
#line 1018 "../preprocessor/src/DynareBison.yy"
                              { driver.end_model(); }
#line 3410 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 380: // $@16: %empty
#line 1019 "../preprocessor/src/DynareBison.yy"
                                                 { driver.begin_heterogeneous_model(yystack_[1].value.as < string > ()); }
#line 3416 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 381: // model: MODEL '(' HETEROGENEITY EQUAL symbol ')' $@16 ';' equation_list END ';'
#line 1020 "../preprocessor/src/DynareBison.yy"
                              { driver.end_model(); }
#line 3422 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 386: // equation: hand_side EQUAL hand_side ';'
#line 1030 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > (), {}); }
#line 3428 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 387: // equation: hand_side ';'
#line 1032 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > (), {}); }
#line 3434 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 388: // equation: '[' tag_pair_list ']' hand_side EQUAL hand_side ';'
#line 1034 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > (), yystack_[5].value.as < map<string, string> > ()); }
#line 3440 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 389: // equation: '[' tag_pair_list ']' hand_side ';'
#line 1036 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[1].value.as < expr_t > (), yystack_[3].value.as < map<string, string> > ()); }
#line 3446 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 390: // equation: hand_side EQUAL hand_side PERPENDICULAR hand_side ';'
#line 1038 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), {}, yystack_[1].value.as < expr_t > ()); }
#line 3452 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 391: // equation: hand_side PERPENDICULAR hand_side ';'
#line 1040 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[3].value.as < expr_t > (), {}, yystack_[1].value.as < expr_t > ()); }
#line 3458 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 392: // equation: '[' tag_pair_list ']' hand_side EQUAL hand_side PERPENDICULAR hand_side ';'
#line 1042 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[7].value.as < map<string, string> > (), yystack_[1].value.as < expr_t > ()); }
#line 3464 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 393: // equation: '[' tag_pair_list ']' hand_side PERPENDICULAR hand_side ';'
#line 1044 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < expr_t > () = driver.add_model_equal_with_zero_rhs(yystack_[3].value.as < expr_t > (), yystack_[5].value.as < map<string, string> > (), yystack_[1].value.as < expr_t > ()); }
#line 3470 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 394: // tag_pair_list: tag_pair_list COMMA tag_pair
#line 1048 "../preprocessor/src/DynareBison.yy"
                {
                  yylhs.value.as < map<string, string> > () = yystack_[2].value.as < map<string, string> > ();
                  auto [it, success] = yylhs.value.as < map<string, string> > ().emplace(yystack_[0].value.as < pair<string,string> > ());
                  if (!success)
                    driver.error("Tag '" + yystack_[0].value.as < pair<string,string> > ().first + "' cannot be used twice for the same equation");
                }
#line 3481 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 395: // tag_pair_list: tag_pair
#line 1055 "../preprocessor/src/DynareBison.yy"
                { yylhs.value.as < map<string, string> > () = {yystack_[0].value.as < pair<string,string> > ()}; }
#line 3487 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 396: // tag_pair: symbol EQUAL QUOTED_STRING
#line 1059 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < pair<string,string> > () = {str_tolower(yystack_[2].value.as < string > ()), yystack_[0].value.as < string > ()}; }
#line 3493 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 397: // tag_pair: symbol
#line 1061 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < pair<string,string> > () = {str_tolower(yystack_[0].value.as < string > ()), ""}; }
#line 3499 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 398: // hand_side: '(' hand_side ')'
#line 1065 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = yystack_[1].value.as < expr_t > (); }
#line 3505 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 399: // hand_side: namespace_qualified_symbol
#line 1067 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_model_variable(yystack_[0].value.as < string > ()); }
#line 3511 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 400: // hand_side: symbol PIPE_E
#line 1069 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::endogenous, yystack_[1].value.as < string > ()); }
#line 3517 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 401: // hand_side: symbol PIPE_X
#line 1071 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::exogenous, yystack_[1].value.as < string > ()); }
#line 3523 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 402: // hand_side: symbol PIPE_P
#line 1073 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.declare_or_change_type(SymbolType::parameter, yystack_[1].value.as < string > ()); }
#line 3529 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 403: // hand_side: non_negative_number
#line 1075 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_non_negative_constant(yystack_[0].value.as < string > ()); }
#line 3535 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 404: // hand_side: hand_side PLUS hand_side
#line 1077 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_plus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3541 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 405: // hand_side: hand_side MINUS hand_side
#line 1079 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_minus(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3547 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 406: // hand_side: hand_side DIVIDE hand_side
#line 1081 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_divide(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3553 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 407: // hand_side: hand_side TIMES hand_side
#line 1083 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_times(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3559 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 408: // hand_side: hand_side LESS hand_side
#line 1085 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_less(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3565 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 409: // hand_side: hand_side GREATER hand_side
#line 1087 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_greater(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3571 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 410: // hand_side: hand_side LESS_EQUAL hand_side
#line 1089 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_less_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3577 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 411: // hand_side: hand_side GREATER_EQUAL hand_side
#line 1091 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_greater_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3583 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 412: // hand_side: hand_side EQUAL_EQUAL hand_side
#line 1093 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_equal_equal(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3589 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 413: // hand_side: hand_side EXCLAMATION_EQUAL hand_side
#line 1095 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_different(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3595 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 414: // hand_side: hand_side POWER hand_side
#line 1097 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_power(yystack_[2].value.as < expr_t > (), yystack_[0].value.as < expr_t > ()); }
#line 3601 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 415: // hand_side: EXPECTATION '(' signed_integer ')' '(' hand_side ')'
#line 1099 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_expectation(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3607 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 416: // hand_side: VAR_EXPECTATION '(' symbol ')'
#line 1101 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_var_expectation(yystack_[1].value.as < string > ()); }
#line 3613 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 417: // hand_side: PAC_EXPECTATION '(' symbol ')'
#line 1103 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_pac_expectation(yystack_[1].value.as < string > ()); }
#line 3619 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 418: // hand_side: PAC_TARGET_NONSTATIONARY '(' symbol ')'
#line 1105 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_pac_target_nonstationary(yystack_[1].value.as < string > ()); }
#line 3625 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 419: // hand_side: MINUS hand_side
#line 1107 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_uminus(yystack_[0].value.as < expr_t > ()); }
#line 3631 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 420: // hand_side: PLUS hand_side
#line 1109 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = yystack_[0].value.as < expr_t > (); }
#line 3637 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 421: // hand_side: EXP '(' hand_side ')'
#line 1111 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_exp(yystack_[1].value.as < expr_t > ()); }
#line 3643 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 422: // hand_side: DIFF '(' hand_side ')'
#line 1113 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_diff(yystack_[1].value.as < expr_t > ()); }
#line 3649 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 423: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING ')'
#line 1115 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < string > (), "1"); }
#line 3655 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 424: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING COMMA INT_NUMBER ')'
#line 1117 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 3661 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 425: // hand_side: ADL '(' hand_side COMMA QUOTED_STRING COMMA vec_int ')'
#line 1119 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_adl(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < vector<int> > ()); }
#line 3667 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 426: // hand_side: LOG '(' hand_side ')'
#line 1121 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3673 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 427: // hand_side: LN '(' hand_side ')'
#line 1123 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log(yystack_[1].value.as < expr_t > ()); }
#line 3679 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 428: // hand_side: LOG10 '(' hand_side ')'
#line 1125 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_log10(yystack_[1].value.as < expr_t > ()); }
#line 3685 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 429: // hand_side: SIN '(' hand_side ')'
#line 1127 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sin(yystack_[1].value.as < expr_t > ()); }
#line 3691 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 430: // hand_side: COS '(' hand_side ')'
#line 1129 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_cos(yystack_[1].value.as < expr_t > ()); }
#line 3697 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 431: // hand_side: TAN '(' hand_side ')'
#line 1131 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_tan(yystack_[1].value.as < expr_t > ()); }
#line 3703 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 432: // hand_side: ASIN '(' hand_side ')'
#line 1133 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_asin(yystack_[1].value.as < expr_t > ()); }
#line 3709 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 433: // hand_side: ACOS '(' hand_side ')'
#line 1135 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_acos(yystack_[1].value.as < expr_t > ()); }
#line 3715 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 434: // hand_side: ATAN '(' hand_side ')'
#line 1137 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_atan(yystack_[1].value.as < expr_t > ()); }
#line 3721 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 435: // hand_side: SINH '(' hand_side ')'
#line 1139 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sinh(yystack_[1].value.as < expr_t > ()); }
#line 3727 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 436: // hand_side: COSH '(' hand_side ')'
#line 1141 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_cosh(yystack_[1].value.as < expr_t > ()); }
#line 3733 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 437: // hand_side: TANH '(' hand_side ')'
#line 1143 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_tanh(yystack_[1].value.as < expr_t > ()); }
#line 3739 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 438: // hand_side: ASINH '(' hand_side ')'
#line 1145 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_asinh(yystack_[1].value.as < expr_t > ()); }
#line 3745 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 439: // hand_side: ACOSH '(' hand_side ')'
#line 1147 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_acosh(yystack_[1].value.as < expr_t > ()); }
#line 3751 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 440: // hand_side: ATANH '(' hand_side ')'
#line 1149 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_atanh(yystack_[1].value.as < expr_t > ()); }
#line 3757 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 441: // hand_side: SQRT '(' hand_side ')'
#line 1151 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sqrt(yystack_[1].value.as < expr_t > ()); }
#line 3763 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 442: // hand_side: CBRT '(' hand_side ')'
#line 1153 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < expr_t > () = driver.add_cbrt(yystack_[1].value.as < expr_t > ()); }
#line 3769 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 443: // hand_side: ABS '(' hand_side ')'
#line 1155 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_abs(yystack_[1].value.as < expr_t > ()); }
#line 3775 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 444: // hand_side: SIGN '(' hand_side ')'
#line 1157 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sign(yystack_[1].value.as < expr_t > ()); }
#line 3781 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 445: // hand_side: MAX '(' hand_side COMMA hand_side ')'
#line 1159 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_max(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3787 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 446: // hand_side: MIN '(' hand_side COMMA hand_side ')'
#line 1161 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_min(yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3793 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 447: // $@17: %empty
#line 1162 "../preprocessor/src/DynareBison.yy"
                                       { driver.push_external_function_arg_vector_onto_stack(); }
#line 3799 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 448: // hand_side: namespace_qualified_symbol $@17 '(' comma_hand_side ')'
#line 1163 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_model_var_or_external_function(yystack_[4].value.as < string > (), true); }
#line 3805 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 449: // hand_side: NORMCDF '(' hand_side COMMA hand_side COMMA hand_side ')'
#line 1165 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3811 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 450: // hand_side: NORMCDF '(' hand_side ')'
#line 1167 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normcdf(yystack_[1].value.as < expr_t > ()); }
#line 3817 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 451: // hand_side: NORMPDF '(' hand_side COMMA hand_side COMMA hand_side ')'
#line 1169 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[5].value.as < expr_t > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 3823 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 452: // hand_side: NORMPDF '(' hand_side ')'
#line 1171 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_normpdf(yystack_[1].value.as < expr_t > ()); }
#line 3829 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 453: // hand_side: ERF '(' hand_side ')'
#line 1173 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_erf(yystack_[1].value.as < expr_t > ()); }
#line 3835 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 454: // hand_side: ERFC '(' hand_side ')'
#line 1175 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_erfc(yystack_[1].value.as < expr_t > ()); }
#line 3841 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 455: // hand_side: STEADY_STATE '(' hand_side ')'
#line 1177 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_steady_state(yystack_[1].value.as < expr_t > ()); }
#line 3847 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 456: // hand_side: SUM '(' hand_side ')'
#line 1179 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < expr_t > () = driver.add_sum(yystack_[1].value.as < expr_t > ()); }
#line 3853 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 457: // comma_hand_side: hand_side
#line 1183 "../preprocessor/src/DynareBison.yy"
                  { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3859 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 458: // comma_hand_side: comma_hand_side COMMA hand_side
#line 1185 "../preprocessor/src/DynareBison.yy"
                  { driver.add_external_function_arg(yystack_[0].value.as < expr_t > ()); }
#line 3865 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 459: // pound_expression: '#' symbol EQUAL hand_side ';'
#line 1189 "../preprocessor/src/DynareBison.yy"
                  { driver.declare_and_init_model_local_variable(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 3871 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 460: // model_remove: MODEL_REMOVE '(' tag_pair_list_for_selection ')' ';'
#line 1192 "../preprocessor/src/DynareBison.yy"
               { driver.model_remove(yystack_[2].value.as < vector<map<string, string>> > ()); }
#line 3877 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 461: // $@18: %empty
#line 1195 "../preprocessor/src/DynareBison.yy"
               { driver.begin_model_replace(yystack_[2].value.as < vector<map<string, string>> > ()); }
#line 3883 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 462: // model_replace: MODEL_REPLACE '(' tag_pair_list_for_selection ')' ';' $@18 equation_list END ';'
#line 1197 "../preprocessor/src/DynareBison.yy"
               { driver.end_model(); }
#line 3889 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 464: // tag_pair_list_for_selection: QUOTED_STRING
#line 1202 "../preprocessor/src/DynareBison.yy"
                              { yylhs.value.as < vector<map<string, string>> > () = {{{"name", yystack_[0].value.as < string > ()}}}; }
#line 3895 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 465: // tag_pair_list_for_selection: tag_pair
#line 1204 "../preprocessor/src/DynareBison.yy"
                              { yylhs.value.as < vector<map<string, string>> > () = {{yystack_[0].value.as < pair<string,string> > ()}}; }
#line 3901 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 466: // tag_pair_list_for_selection: '[' tag_pair_list ']'
#line 1206 "../preprocessor/src/DynareBison.yy"
                              { yylhs.value.as < vector<map<string, string>> > () = {yystack_[1].value.as < map<string, string> > ()}; }
#line 3907 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 467: // tag_pair_list_for_selection: tag_pair_list_for_selection COMMA QUOTED_STRING
#line 1208 "../preprocessor/src/DynareBison.yy"
                              {
                                yylhs.value.as < vector<map<string, string>> > () = yystack_[2].value.as < vector<map<string, string>> > ();
                                yylhs.value.as < vector<map<string, string>> > ().push_back({{"name", yystack_[0].value.as < string > ()}});
                              }
#line 3916 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 468: // tag_pair_list_for_selection: tag_pair_list_for_selection COMMA tag_pair
#line 1213 "../preprocessor/src/DynareBison.yy"
                              {
                                yylhs.value.as < vector<map<string, string>> > () = yystack_[2].value.as < vector<map<string, string>> > ();
                                yylhs.value.as < vector<map<string, string>> > ().push_back({yystack_[0].value.as < pair<string,string> > ()});
                              }
#line 3925 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 469: // tag_pair_list_for_selection: tag_pair_list_for_selection COMMA '[' tag_pair_list ']'
#line 1218 "../preprocessor/src/DynareBison.yy"
                              {
                                yylhs.value.as < vector<map<string, string>> > () = yystack_[4].value.as < vector<map<string, string>> > ();
                                yylhs.value.as < vector<map<string, string>> > ().push_back(yystack_[1].value.as < map<string, string> > ());
                              }
#line 3934 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 470: // shocks: SHOCKS ';' shock_list END ';'
#line 1224 "../preprocessor/src/DynareBison.yy"
                                       { driver.end_shocks(false); }
#line 3940 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 471: // shocks: SHOCKS '(' OVERWRITE ')' ';' shock_list END ';'
#line 1225 "../preprocessor/src/DynareBison.yy"
                                                         { driver.end_shocks(true); }
#line 3946 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 472: // shocks: SHOCKS '(' OVERWRITE ')' ';' END ';'
#line 1226 "../preprocessor/src/DynareBison.yy"
                                               { driver.end_shocks(true); }
#line 3952 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 473: // shocks: SHOCKS '(' SURPRISE ')' ';' det_shock_list END ';'
#line 1227 "../preprocessor/src/DynareBison.yy"
                                                            { driver.end_shocks_surprise(false); }
#line 3958 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 474: // shocks: SHOCKS '(' SURPRISE COMMA OVERWRITE ')' ';' det_shock_list END ';'
#line 1228 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.end_shocks_surprise(true); }
#line 3964 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 475: // shocks: SHOCKS '(' OVERWRITE COMMA SURPRISE ')' ';' det_shock_list END ';'
#line 1229 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.end_shocks_surprise(true); }
#line 3970 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 476: // shocks: SHOCKS '(' LEARNT_IN EQUAL integer_or_date ')' ';' det_shock_list END ';'
#line 1230 "../preprocessor/src/DynareBison.yy"
                                                                                   { driver.end_shocks_learnt_in(yystack_[5].value.as < variant<int, string> > (), false); }
#line 3976 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 477: // shocks: SHOCKS '(' LEARNT_IN EQUAL integer_or_date COMMA OVERWRITE ')' ';' det_shock_list END ';'
#line 1231 "../preprocessor/src/DynareBison.yy"
                                                                                                   { driver.end_shocks_learnt_in(yystack_[7].value.as < variant<int, string> > (), true); }
#line 3982 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 478: // shocks: SHOCKS '(' OVERWRITE COMMA LEARNT_IN EQUAL integer_or_date ')' ';' det_shock_list END ';'
#line 1232 "../preprocessor/src/DynareBison.yy"
                                                                                                   { driver.end_shocks_learnt_in(yystack_[5].value.as < variant<int, string> > (), true); }
#line 3988 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 479: // shocks: SHOCKS '(' HETEROGENEITY EQUAL symbol ')' ';' stoch_shock_list END ';'
#line 1234 "../preprocessor/src/DynareBison.yy"
         { driver.end_heterogeneous_shocks(yystack_[5].value.as < string > (), false); }
#line 3994 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 480: // shocks: SHOCKS '(' HETEROGENEITY EQUAL symbol COMMA OVERWRITE ')' ';' stoch_shock_list END ';'
#line 1236 "../preprocessor/src/DynareBison.yy"
         { driver.end_heterogeneous_shocks(yystack_[7].value.as < string > (), true); }
#line 4000 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 481: // shocks: SHOCKS '(' OVERWRITE COMMA HETEROGENEITY EQUAL symbol ')' ';' stoch_shock_list END ';'
#line 1238 "../preprocessor/src/DynareBison.yy"
         { driver.end_heterogeneous_shocks(yystack_[5].value.as < string > (), true); }
#line 4006 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 486: // stoch_shock_elem: VAR symbol ';' STDERR expression ';'
#line 1250 "../preprocessor/src/DynareBison.yy"
                   { driver.add_stderr_shock(yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4012 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 487: // stoch_shock_elem: VAR symbol EQUAL expression ';'
#line 1252 "../preprocessor/src/DynareBison.yy"
                   { driver.add_var_shock(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4018 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 488: // stoch_shock_elem: VAR symbol COMMA symbol EQUAL expression ';'
#line 1254 "../preprocessor/src/DynareBison.yy"
                   { driver.add_covar_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4024 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 489: // stoch_shock_elem: CORR symbol COMMA symbol EQUAL expression ';'
#line 1256 "../preprocessor/src/DynareBison.yy"
                   { driver.add_correl_shock(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 4030 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 492: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 1264 "../preprocessor/src/DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<AbstractShocksStatement::period_range_t> > (), yystack_[1].value.as < vector<expr_t> > (), ParsingDriver::DetShockType::standard); }
#line 4036 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 493: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' ADD value_list ';'
#line 1266 "../preprocessor/src/DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<AbstractShocksStatement::period_range_t> > (), yystack_[1].value.as < vector<expr_t> > (), ParsingDriver::DetShockType::add); }
#line 4042 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 494: // det_shock_elem: VAR symbol ';' PERIODS period_list ';' MULTIPLY value_list ';'
#line 1268 "../preprocessor/src/DynareBison.yy"
                 { driver.add_det_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<AbstractShocksStatement::period_range_t> > (), yystack_[1].value.as < vector<expr_t> > (), ParsingDriver::DetShockType::multiply); }
#line 4048 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 497: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS ';' heteroskedastic_shock_list END ';'
#line 1276 "../preprocessor/src/DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(false); }
#line 4054 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 498: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS '(' OVERWRITE ')' ';' heteroskedastic_shock_list END ';'
#line 1278 "../preprocessor/src/DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(true); }
#line 4060 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 499: // heteroskedastic_shocks: HETEROSKEDASTIC_SHOCKS '(' OVERWRITE ')' ';' END ';'
#line 1280 "../preprocessor/src/DynareBison.yy"
                         { driver.end_heteroskedastic_shocks(true); }
#line 4066 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 502: // heteroskedastic_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 1288 "../preprocessor/src/DynareBison.yy"
                             { driver.add_heteroskedastic_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<AbstractShocksStatement::period_range_t> > (), yystack_[1].value.as < vector<expr_t> > (), false); }
#line 4072 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 503: // heteroskedastic_shock_elem: VAR symbol ';' PERIODS period_list ';' SCALES value_list ';'
#line 1290 "../preprocessor/src/DynareBison.yy"
                             { driver.add_heteroskedastic_shock(yystack_[7].value.as < string > (), yystack_[4].value.as < vector<AbstractShocksStatement::period_range_t> > (), yystack_[1].value.as < vector<expr_t> > (), true); }
#line 4078 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 504: // $@19: %empty
#line 1293 "../preprocessor/src/DynareBison.yy"
                                          { driver.begin_svar_identification(); }
#line 4084 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 505: // svar_identification: SVAR_IDENTIFICATION $@19 ';' svar_identification_list END ';'
#line 1294 "../preprocessor/src/DynareBison.yy"
                      { driver.end_svar_identification(); }
#line 4090 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 508: // svar_identification_elem: EXCLUSION LAG INT_NUMBER ';' svar_equation_list
#line 1302 "../preprocessor/src/DynareBison.yy"
                           { driver.combine_lag_and_restriction(yystack_[2].value.as < string > ()); }
#line 4096 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 509: // svar_identification_elem: EXCLUSION CONSTANTS ';'
#line 1304 "../preprocessor/src/DynareBison.yy"
                           { driver.add_constants_exclusion(); }
#line 4102 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 510: // $@20: %empty
#line 1306 "../preprocessor/src/DynareBison.yy"
                         { driver.add_restriction_equation_nbr(yystack_[1].value.as < string > ()); }
#line 4108 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 511: // $@21: %empty
#line 1308 "../preprocessor/src/DynareBison.yy"
                                { driver.add_restriction_equal(); }
#line 4114 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 513: // svar_identification_elem: UPPER_CHOLESKY ';'
#line 1311 "../preprocessor/src/DynareBison.yy"
                           { driver.add_upper_cholesky(); }
#line 4120 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 514: // svar_identification_elem: LOWER_CHOLESKY ';'
#line 1313 "../preprocessor/src/DynareBison.yy"
                           { driver.add_lower_cholesky(); }
#line 4126 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 515: // svar_equation_list: svar_equation_list EQUATION INT_NUMBER COMMA symbol_list ';'
#line 1317 "../preprocessor/src/DynareBison.yy"
                     { driver.add_restriction_in_equation(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 4132 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 516: // svar_equation_list: EQUATION INT_NUMBER COMMA symbol_list ';'
#line 1319 "../preprocessor/src/DynareBison.yy"
                     { driver.add_restriction_in_equation(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 4138 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 517: // restriction_expression: expression
#line 1322 "../preprocessor/src/DynareBison.yy"
                                    { driver.check_restriction_expression_constant(yystack_[0].value.as < expr_t > ()); }
#line 4144 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 521: // restriction_elem_expression: COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1331 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4150 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 522: // restriction_elem_expression: PLUS COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1333 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4156 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 523: // restriction_elem_expression: MINUS COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1335 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_negative_restriction_element(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4162 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 524: // restriction_elem_expression: expression TIMES COEFF '(' symbol COMMA INT_NUMBER ')'
#line 1337 "../preprocessor/src/DynareBison.yy"
                                 { driver.add_positive_restriction_element(yystack_[7].value.as < expr_t > (), yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 4168 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 525: // svar_global_identification_check: SVAR_GLOBAL_IDENTIFICATION_CHECK ';'
#line 1341 "../preprocessor/src/DynareBison.yy"
                                  { driver.add_svar_global_identification_check(); }
#line 4174 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 526: // markov_switching: MARKOV_SWITCHING '(' ms_options_list ')' ';'
#line 1345 "../preprocessor/src/DynareBison.yy"
                   { driver.markov_switching(); }
#line 4180 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 535: // svar: SVAR '(' svar_options_list ')' ';'
#line 1361 "../preprocessor/src/DynareBison.yy"
       { driver.svar(); }
#line 4186 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 542: // mshocks: MSHOCKS ';' mshock_list END ';'
#line 1375 "../preprocessor/src/DynareBison.yy"
          { driver.end_mshocks(false, false); }
#line 4192 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 543: // mshocks: MSHOCKS '(' mshocks_options_list ')' ';' mshock_list END ';'
#line 1377 "../preprocessor/src/DynareBison.yy"
          {
            /* NB: the following relies on the fact that bool is the first
               alternative in the variant, so that default initialization of the
               variant by the [] operator will give false */
            if (yystack_[5].value.as < map<string, variant<bool, variant<int, string>>> > ().contains("learnt_in"))
              driver.end_mshocks_learnt_in(get<variant<int, string>>(yystack_[5].value.as < map<string, variant<bool, variant<int, string>>> > ().at("learnt_in")),
                                           get<bool>(yystack_[5].value.as < map<string, variant<bool, variant<int, string>>> > ()["overwrite"]),
                                           get<bool>(yystack_[5].value.as < map<string, variant<bool, variant<int, string>>> > ()["relative_to_initval"]));
            else
              driver.end_mshocks(get<bool>(yystack_[5].value.as < map<string, variant<bool, variant<int, string>>> > ()["overwrite"]), get<bool>(yystack_[5].value.as < map<string, variant<bool, variant<int, string>>> > ()["relative_to_initval"]));
          }
#line 4208 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 544: // mshocks_options_list: mshocks_option
#line 1391 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < map<string, variant<bool, variant<int, string>>> > () = {yystack_[0].value.as < pair<string, variant<bool, variant<int, string>>> > ()}; }
#line 4214 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 545: // mshocks_options_list: mshocks_options_list mshocks_option
#line 1393 "../preprocessor/src/DynareBison.yy"
                       {
                         yylhs.value.as < map<string, variant<bool, variant<int, string>>> > () = yystack_[1].value.as < map<string, variant<bool, variant<int, string>>> > ();
                         auto [it, success] = yylhs.value.as < map<string, variant<bool, variant<int, string>>> > ().insert(yystack_[0].value.as < pair<string, variant<bool, variant<int, string>>> > ());
                         if (!success)
                           driver.error("The '" + yystack_[0].value.as < pair<string, variant<bool, variant<int, string>>> > ().first + "' option is declared multiple times");
                       }
#line 4225 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 546: // mshocks_option: OVERWRITE
#line 1402 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string, variant<bool, variant<int, string>>> > () = {"overwrite", true}; }
#line 4231 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 547: // mshocks_option: LEARNT_IN EQUAL integer_or_date
#line 1404 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string, variant<bool, variant<int, string>>> > () = {"learnt_in", yystack_[0].value.as < variant<int, string> > ()}; }
#line 4237 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 548: // mshocks_option: RELATIVE_TO_INITVAL
#line 1406 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < pair<string, variant<bool, variant<int, string>>> > () = {"relative_to_initval", true}; }
#line 4243 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 551: // period_list: period_range
#line 1414 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<AbstractShocksStatement::period_range_t> > () = { yystack_[0].value.as < AbstractShocksStatement::period_range_t > () }; }
#line 4249 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 552: // period_list: period_list period_range
#line 1416 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<AbstractShocksStatement::period_range_t> > () = yystack_[1].value.as < vector<AbstractShocksStatement::period_range_t> > ();
                yylhs.value.as < vector<AbstractShocksStatement::period_range_t> > ().emplace_back(yystack_[0].value.as < AbstractShocksStatement::period_range_t > ());
              }
#line 4258 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 553: // period_list: period_list COMMA period_range
#line 1421 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<AbstractShocksStatement::period_range_t> > () = yystack_[2].value.as < vector<AbstractShocksStatement::period_range_t> > ();
                yylhs.value.as < vector<AbstractShocksStatement::period_range_t> > ().emplace_back(yystack_[0].value.as < AbstractShocksStatement::period_range_t > ());
              }
#line 4267 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 554: // period_range: INT_NUMBER
#line 1428 "../preprocessor/src/DynareBison.yy"
               {
                 int p = stoi(yystack_[0].value.as < string > ());
                 yylhs.value.as < AbstractShocksStatement::period_range_t > ().emplace<pair<int, int>>(p, p);
               }
#line 4276 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 555: // period_range: INT_NUMBER ':' INT_NUMBER
#line 1433 "../preprocessor/src/DynareBison.yy"
               {
                 int p1 = stoi(yystack_[2].value.as < string > ()), p2 = stoi(yystack_[0].value.as < string > ());
                 if (p1 > p2)
                   driver.error("Can't have first period index greater than second index in range specification");
                 yylhs.value.as < AbstractShocksStatement::period_range_t > ().emplace<pair<int, int>>(p1, p2);
               }
#line 4287 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 556: // period_range: date_expr
#line 1440 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < AbstractShocksStatement::period_range_t > ().emplace<pair<string, string>>(yystack_[0].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4293 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 557: // period_range: date_expr ':' date_expr
#line 1442 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < AbstractShocksStatement::period_range_t > ().emplace<pair<string, string>>(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 4299 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 558: // value_list: value_list COMMA '(' expression ')'
#line 1446 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[4].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
             }
#line 4308 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 559: // value_list: value_list '(' expression ')'
#line 1451 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[3].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
             }
#line 4317 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 560: // value_list: '(' expression ')'
#line 1456 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < vector<expr_t> > () = {yystack_[1].value.as < expr_t > ()}; }
#line 4323 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 561: // value_list: value_list COMMA signed_number
#line 1458 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[0].value.as < string > ().at(0) == '-'
                            ? driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1)))
                            : driver.add_non_negative_constant(yystack_[0].value.as < string > ()));
             }
#line 4334 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 562: // value_list: value_list signed_number
#line 1465 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = yystack_[1].value.as < vector<expr_t> > ();
               yylhs.value.as < vector<expr_t> > ().push_back(yystack_[0].value.as < string > ().at(0) == '-'
                            ? driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1)))
                            : driver.add_non_negative_constant(yystack_[0].value.as < string > ()));
             }
#line 4345 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 563: // value_list: signed_number
#line 1472 "../preprocessor/src/DynareBison.yy"
             {
               yylhs.value.as < vector<expr_t> > () = {yystack_[0].value.as < string > ().at(0) == '-'
                     ? driver.add_uminus(driver.add_non_negative_constant(yystack_[0].value.as < string > ().substr(1)))
                     : driver.add_non_negative_constant(yystack_[0].value.as < string > ())};
             }
#line 4355 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 564: // steady: STEADY ';'
#line 1480 "../preprocessor/src/DynareBison.yy"
         { driver.steady(); }
#line 4361 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 565: // steady: STEADY '(' steady_options_list ')' ';'
#line 1482 "../preprocessor/src/DynareBison.yy"
         { driver.steady(); }
#line 4367 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 580: // check: CHECK ';'
#line 1504 "../preprocessor/src/DynareBison.yy"
        { driver.check(); }
#line 4373 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 581: // check: CHECK '(' check_options_list ')' ';'
#line 1506 "../preprocessor/src/DynareBison.yy"
        { driver.check(); }
#line 4379 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 586: // model_info: MODEL_INFO ';'
#line 1518 "../preprocessor/src/DynareBison.yy"
             { driver.model_info(); }
#line 4385 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 587: // model_info: MODEL_INFO '(' model_info_options_list ')' ';'
#line 1520 "../preprocessor/src/DynareBison.yy"
              { driver.model_info(); }
#line 4391 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 593: // perfect_foresight_setup: PERFECT_FORESIGHT_SETUP ';'
#line 1533 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_setup(); }
#line 4397 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 594: // perfect_foresight_setup: PERFECT_FORESIGHT_SETUP '(' perfect_foresight_setup_options_list ')' ';'
#line 1535 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_setup(); }
#line 4403 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 602: // perfect_foresight_solver: PERFECT_FORESIGHT_SOLVER ';'
#line 1550 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_solver(); }
#line 4409 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 603: // perfect_foresight_solver: PERFECT_FORESIGHT_SOLVER '(' perfect_foresight_solver_options_list ')' ';'
#line 1552 "../preprocessor/src/DynareBison.yy"
                          { driver.perfect_foresight_solver(); }
#line 4415 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 632: // perfect_foresight_with_expectation_errors_setup: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP ';'
#line 1588 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_setup(); }
#line 4421 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 633: // perfect_foresight_with_expectation_errors_setup: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP '(' perfect_foresight_with_expectation_errors_setup_options_list ')' ';'
#line 1590 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_setup(); }
#line 4427 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 640: // perfect_foresight_with_expectation_errors_solver: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER ';'
#line 1604 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_solver(); }
#line 4433 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 641: // perfect_foresight_with_expectation_errors_solver: PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER '(' perfect_foresight_with_expectation_errors_solver_options_list ')' ';'
#line 1606 "../preprocessor/src/DynareBison.yy"
                                                  { driver.perfect_foresight_with_expectation_errors_solver(); }
#line 4439 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 646: // method_of_moments: METHOD_OF_MOMENTS ';'
#line 1618 "../preprocessor/src/DynareBison.yy"
                    { driver.method_of_moments(); }
#line 4445 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 647: // method_of_moments: METHOD_OF_MOMENTS '(' method_of_moments_options_list ')' ';'
#line 1620 "../preprocessor/src/DynareBison.yy"
                    { driver.method_of_moments(); }
#line 4451 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 740: // prior_function: PRIOR_FUNCTION '(' prior_posterior_function_options_list ')' ';'
#line 1720 "../preprocessor/src/DynareBison.yy"
                 { driver.prior_posterior_function(true); }
#line 4457 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 741: // posterior_function: POSTERIOR_FUNCTION '(' prior_posterior_function_options_list ')' ';'
#line 1724 "../preprocessor/src/DynareBison.yy"
                     { driver.prior_posterior_function(false); }
#line 4463 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 746: // simul: SIMUL ';'
#line 1736 "../preprocessor/src/DynareBison.yy"
        { driver.simul(); }
#line 4469 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 747: // simul: SIMUL '(' simul_options_list ')' ';'
#line 1738 "../preprocessor/src/DynareBison.yy"
        { driver.simul(); }
#line 4475 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 752: // external_function: EXTERNAL_FUNCTION '(' external_function_options_list ')' ';'
#line 1750 "../preprocessor/src/DynareBison.yy"
                    { driver.external_function(); }
#line 4481 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 759: // stoch_simul: STOCH_SIMUL ';'
#line 1764 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul({}); }
#line 4487 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 760: // stoch_simul: STOCH_SIMUL '(' stoch_simul_options_list ')' ';'
#line 1766 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul({}); }
#line 4493 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 761: // stoch_simul: STOCH_SIMUL symbol_list ';'
#line 1768 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul(yystack_[1].value.as < vector<string> > ()); }
#line 4499 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 762: // stoch_simul: STOCH_SIMUL '(' stoch_simul_options_list ')' symbol_list ';'
#line 1770 "../preprocessor/src/DynareBison.yy"
              { driver.stoch_simul(yystack_[1].value.as < vector<string> > ()); }
#line 4505 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 817: // signed_integer: PLUS INT_NUMBER
#line 1834 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4511 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 818: // signed_integer: MINUS INT_NUMBER
#line 1836 "../preprocessor/src/DynareBison.yy"
                 {
                   yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                   yylhs.value.as < string > ().insert(0, "-");
                 }
#line 4520 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 819: // signed_integer: INT_NUMBER
#line 1840 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4526 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 820: // non_negative_number: INT_NUMBER
#line 1843 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4532 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 821: // non_negative_number: FLOAT_NUMBER
#line 1844 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4538 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 822: // signed_number: PLUS non_negative_number
#line 1848 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4544 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 823: // signed_number: MINUS non_negative_number
#line 1850 "../preprocessor/src/DynareBison.yy"
               {
                 yylhs.value.as < string > () = yystack_[0].value.as < string > ();
                 yylhs.value.as < string > ().insert(0, "-");
               }
#line 4553 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 824: // signed_number: non_negative_number
#line 1854 "../preprocessor/src/DynareBison.yy"
                { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4559 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 825: // signed_inf: PLUS INF_CONSTANT
#line 1858 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < string > () = "Inf"; }
#line 4565 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 826: // signed_inf: MINUS INF_CONSTANT
#line 1860 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < string > () = "-Inf"; }
#line 4571 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 827: // signed_inf: INF_CONSTANT
#line 1862 "../preprocessor/src/DynareBison.yy"
             { yylhs.value.as < string > () = "Inf"; }
#line 4577 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 828: // signed_number_w_inf: signed_inf
#line 1865 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4583 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 829: // signed_number_w_inf: signed_number
#line 1866 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4589 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 830: // boolean: TRUE
#line 1869 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4595 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 831: // boolean: FALSE
#line 1870 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 4601 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 832: // estimated_params: ESTIMATED_PARAMS ';' estimated_list END ';'
#line 1874 "../preprocessor/src/DynareBison.yy"
                   { driver.estimated_params(false); }
#line 4607 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 833: // estimated_params: ESTIMATED_PARAMS '(' OVERWRITE ')' ';' estimated_list END ';'
#line 1876 "../preprocessor/src/DynareBison.yy"
                   { driver.estimated_params(true); }
#line 4613 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 834: // estimated_list: estimated_list estimated_elem
#line 1880 "../preprocessor/src/DynareBison.yy"
                 { driver.add_estimated_params_element(); }
#line 4619 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 835: // estimated_list: estimated_elem
#line 1882 "../preprocessor/src/DynareBison.yy"
                 { driver.add_estimated_params_element(); }
#line 4625 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 838: // estimated_elem1: STDERR symbol
#line 1889 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 1;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 4634 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 839: // estimated_elem1: symbol
#line 1894 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = yystack_[0].value.as < string > ();
                  }
#line 4643 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 840: // estimated_elem1: CORR symbol COMMA symbol
#line 1899 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 3;
                    driver.estim_params.name = yystack_[2].value.as < string > ();
                    driver.estim_params.name2 = yystack_[0].value.as < string > ();
                  }
#line 4653 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 841: // estimated_elem1: DSGE_PRIOR_WEIGHT
#line 1905 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = "dsge_prior_weight";
                  }
#line 4662 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 842: // estimated_elem2: prior_pdf COMMA estimated_elem3
#line 1912 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4670 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 843: // estimated_elem2: expression_or_empty COMMA prior_pdf COMMA estimated_elem3
#line 1916 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4679 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 844: // estimated_elem2: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA prior_pdf COMMA estimated_elem3
#line 1921 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.prior = yystack_[2].value.as < PriorDistributions > ();
                  }
#line 4690 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 845: // estimated_elem2: expression
#line 1928 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[0].value.as < expr_t > ();
                  }
#line 4698 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 846: // estimated_elem2: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1932 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.init_val = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.low_bound = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.up_bound = yystack_[0].value.as < expr_t > ();
                  }
#line 4708 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 847: // estimated_elem3: expression_or_empty COMMA expression_or_empty
#line 1940 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[0].value.as < expr_t > ();
                  }
#line 4717 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 848: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1945 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[0].value.as < expr_t > ();
                  }
#line 4727 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 849: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression_or_empty
#line 1951 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[0].value.as < expr_t > ();
                  }
#line 4738 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 850: // estimated_elem3: expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression_or_empty COMMA expression
#line 1958 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.estim_params.mean = yystack_[8].value.as < expr_t > ();
                    driver.estim_params.std = yystack_[6].value.as < expr_t > ();
                    driver.estim_params.p3 = yystack_[4].value.as < expr_t > ();
                    driver.estim_params.p4 = yystack_[2].value.as < expr_t > ();
                    driver.estim_params.jscale = yystack_[0].value.as < expr_t > ();
                  }
#line 4750 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 851: // estimated_params_init: ESTIMATED_PARAMS_INIT ';' estimated_init_list END ';'
#line 1968 "../preprocessor/src/DynareBison.yy"
                        { driver.estimated_params_init(); }
#line 4756 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 852: // estimated_params_init: ESTIMATED_PARAMS_INIT '(' USE_CALIBRATION ')' ';' END ';'
#line 1970 "../preprocessor/src/DynareBison.yy"
                        { driver.estimated_params_init(true); }
#line 4762 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 853: // estimated_params_init: ESTIMATED_PARAMS_INIT '(' USE_CALIBRATION ')' ';' estimated_init_list END ';'
#line 1972 "../preprocessor/src/DynareBison.yy"
                        { driver.estimated_params_init(true); }
#line 4768 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 854: // estimated_init_list: estimated_init_list estimated_init_elem
#line 1976 "../preprocessor/src/DynareBison.yy"
                      { driver.add_estimated_params_element(); }
#line 4774 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 855: // estimated_init_list: estimated_init_elem
#line 1978 "../preprocessor/src/DynareBison.yy"
                      { driver.add_estimated_params_element(); }
#line 4780 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 856: // estimated_init_elem: STDERR symbol COMMA expression ';'
#line 1982 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.estim_params.type = 1;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4790 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 857: // estimated_init_elem: CORR symbol COMMA symbol COMMA expression ';'
#line 1988 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.estim_params.type = 3;
                        driver.estim_params.name = yystack_[5].value.as < string > ();
                        driver.estim_params.name2 = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4801 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 858: // estimated_init_elem: symbol COMMA expression ';'
#line 1995 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.estim_params.type = 2;
                        driver.estim_params.name = yystack_[3].value.as < string > ();
                        driver.estim_params.init_val = yystack_[1].value.as < expr_t > ();
                      }
#line 4811 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 859: // estimated_params_bounds: ESTIMATED_PARAMS_BOUNDS ';' estimated_bounds_list END ';'
#line 2003 "../preprocessor/src/DynareBison.yy"
                          { driver.estimated_params_bounds(); }
#line 4817 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 860: // estimated_bounds_list: estimated_bounds_list estimated_bounds_elem
#line 2006 "../preprocessor/src/DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4823 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 861: // estimated_bounds_list: estimated_bounds_elem
#line 2008 "../preprocessor/src/DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4829 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 862: // estimated_bounds_elem: STDERR symbol COMMA expression COMMA expression ';'
#line 2012 "../preprocessor/src/DynareBison.yy"
                        {
                          driver.estim_params.type = 1;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4840 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 863: // estimated_bounds_elem: CORR symbol COMMA symbol COMMA expression COMMA expression ';'
#line 2019 "../preprocessor/src/DynareBison.yy"
                        {
                          driver.estim_params.type = 3;
                          driver.estim_params.name = yystack_[7].value.as < string > ();
                          driver.estim_params.name2 = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4852 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 864: // estimated_bounds_elem: symbol COMMA expression COMMA expression ';'
#line 2027 "../preprocessor/src/DynareBison.yy"
                        {
                          driver.estim_params.type = 2;
                          driver.estim_params.name = yystack_[5].value.as < string > ();
                          driver.estim_params.low_bound = yystack_[3].value.as < expr_t > ();
                          driver.estim_params.up_bound = yystack_[1].value.as < expr_t > ();
                        }
#line 4863 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 865: // estimated_params_remove: ESTIMATED_PARAMS_REMOVE ';' estimated_remove_list END ';'
#line 2036 "../preprocessor/src/DynareBison.yy"
                          { driver.estimated_params_remove(); }
#line 4869 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 868: // estimated_remove_elem: estimated_elem1 ';'
#line 2043 "../preprocessor/src/DynareBison.yy"
                        { driver.add_estimated_params_element(); }
#line 4875 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 869: // osr_params_bounds: OSR_PARAMS_BOUNDS ';' osr_bounds_list END ';'
#line 2046 "../preprocessor/src/DynareBison.yy"
                    { driver.osr_params_bounds(); }
#line 4881 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 870: // osr_bounds_list: osr_bounds_list osr_bounds_elem
#line 2049 "../preprocessor/src/DynareBison.yy"
                  { driver.add_osr_params_element(); }
#line 4887 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 871: // osr_bounds_list: osr_bounds_elem
#line 2051 "../preprocessor/src/DynareBison.yy"
                  { driver.add_osr_params_element(); }
#line 4893 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 872: // osr_bounds_elem: symbol COMMA expression COMMA expression ';'
#line 2055 "../preprocessor/src/DynareBison.yy"
                  {
                    driver.osr_params.name = yystack_[5].value.as < string > ();
                    driver.osr_params.low_bound = yystack_[3].value.as < expr_t > ();
                    driver.osr_params.up_bound = yystack_[1].value.as < expr_t > ();
                  }
#line 4903 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 873: // prior_distribution: BETA
#line 2063 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4909 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 874: // prior_distribution: GAMMA
#line 2065 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4915 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 875: // prior_distribution: NORMAL
#line 2067 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4921 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 876: // prior_distribution: INV_GAMMA
#line 2069 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4927 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 877: // prior_distribution: INV_GAMMA1
#line 2071 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4933 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 878: // prior_distribution: UNIFORM
#line 2073 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4939 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 879: // prior_distribution: INV_GAMMA2
#line 2075 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4945 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 880: // prior_distribution: DIRICHLET
#line 2077 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::dirichlet; }
#line 4951 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 881: // prior_distribution: WEIBULL
#line 2079 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 4957 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 882: // prior_pdf: BETA_PDF
#line 2083 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::beta; }
#line 4963 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 883: // prior_pdf: GAMMA_PDF
#line 2085 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::gamma; }
#line 4969 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 884: // prior_pdf: NORMAL_PDF
#line 2087 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::normal; }
#line 4975 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 885: // prior_pdf: INV_GAMMA_PDF
#line 2089 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma; }
#line 4981 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 886: // prior_pdf: INV_GAMMA1_PDF
#line 2091 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma1; }
#line 4987 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 887: // prior_pdf: UNIFORM_PDF
#line 2093 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::uniform; }
#line 4993 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 888: // prior_pdf: INV_GAMMA2_PDF
#line 2095 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::invGamma2; }
#line 4999 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 889: // prior_pdf: WEIBULL_PDF
#line 2097 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < PriorDistributions > () = PriorDistributions::weibull; }
#line 5005 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 890: // date_expr: DATE
#line 2101 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < string > () = "dates('" + yystack_[0].value.as < string > () + "')"; }
#line 5011 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 891: // date_expr: date_expr PLUS INT_NUMBER
#line 2103 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < string > () = yystack_[2].value.as < string > () + '+' + yystack_[0].value.as < string > (); }
#line 5017 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 892: // set_time: SET_TIME '(' date_expr ')' ';'
#line 2107 "../preprocessor/src/DynareBison.yy"
           { driver.set_time(yystack_[2].value.as < string > ()); }
#line 5023 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 893: // data: DATA '(' data_options_list ')' ';'
#line 2111 "../preprocessor/src/DynareBison.yy"
       { driver.estimation_data(); }
#line 5029 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 903: // subsamples: subsamples_eq_opt '(' subsamples_name_list ')' ';'
#line 2128 "../preprocessor/src/DynareBison.yy"
             { driver.set_subsamples(yystack_[4].value.as < pair<string,string> > ().first, yystack_[4].value.as < pair<string,string> > ().second); }
#line 5035 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 904: // subsamples_eq: subsamples_eq_opt EQUAL subsamples_eq_opt ';'
#line 2132 "../preprocessor/src/DynareBison.yy"
                { driver.copy_subsamples(yystack_[3].value.as < pair<string,string> > ().first, yystack_[3].value.as < pair<string,string> > ().second, yystack_[1].value.as < pair<string,string> > ().first, yystack_[1].value.as < pair<string,string> > ().second); }
#line 5041 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 905: // subsamples_eq_opt: symbol '.' SUBSAMPLES
#line 2136 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), ""}; }
#line 5047 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 906: // subsamples_eq_opt: STD '(' symbol ')' '.' SUBSAMPLES
#line 2138 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = {yystack_[3].value.as < string > (), ""}; }
#line 5053 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 907: // subsamples_eq_opt: CORR '(' symbol COMMA symbol ')' '.' SUBSAMPLES
#line 2140 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<string,string> > () = {yystack_[5].value.as < string > (), yystack_[3].value.as < string > ()}; }
#line 5059 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 910: // $@22: %empty
#line 2147 "../preprocessor/src/DynareBison.yy"
                         { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5065 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 911: // prior: symbol '.' PRIOR $@22 '(' prior_options_list ')' ';'
#line 2148 "../preprocessor/src/DynareBison.yy"
        { driver.set_prior(yystack_[7].value.as < string > (), ""); }
#line 5071 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 912: // $@23: %empty
#line 2149 "../preprocessor/src/DynareBison.yy"
                                    { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5077 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 913: // prior: symbol '.' symbol '.' PRIOR $@23 '(' prior_options_list ')' ';'
#line 2150 "../preprocessor/src/DynareBison.yy"
        { driver.set_prior(yystack_[9].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 5083 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 914: // $@24: %empty
#line 2151 "../preprocessor/src/DynareBison.yy"
                             { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5089 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 915: // prior: SYMBOL_VEC '.' PRIOR $@24 '(' joint_prior_options_list ')' ';'
#line 2152 "../preprocessor/src/DynareBison.yy"
        { driver.set_joint_prior(yystack_[7].value.as < vector<string> > ()); }
#line 5095 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 916: // $@25: %empty
#line 2153 "../preprocessor/src/DynareBison.yy"
                                     { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5101 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 917: // prior: STD '(' symbol ')' '.' PRIOR $@25 '(' prior_options_list ')' ';'
#line 2154 "../preprocessor/src/DynareBison.yy"
        { driver.set_std_prior(yystack_[8].value.as < string > (), ""); }
#line 5107 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 918: // $@26: %empty
#line 2155 "../preprocessor/src/DynareBison.yy"
                                                { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5113 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 919: // prior: STD '(' symbol ')' '.' symbol '.' PRIOR $@26 '(' prior_options_list ')' ';'
#line 2156 "../preprocessor/src/DynareBison.yy"
        { driver.set_std_prior(yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 5119 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 920: // $@27: %empty
#line 2157 "../preprocessor/src/DynareBison.yy"
                                                   { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5125 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 921: // prior: CORR '(' symbol COMMA symbol ')' '.' PRIOR $@27 '(' prior_options_list ')' ';'
#line 2158 "../preprocessor/src/DynareBison.yy"
        { driver.set_corr_prior(yystack_[10].value.as < string > (), yystack_[8].value.as < string > (), ""); }
#line 5131 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 922: // $@28: %empty
#line 2159 "../preprocessor/src/DynareBison.yy"
                                                              { driver.set_prior_variance(); driver.prior_shape = PriorDistributions::noShape; }
#line 5137 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 923: // prior: CORR '(' symbol COMMA symbol ')' '.' symbol '.' PRIOR $@28 '(' prior_options_list ')' ';'
#line 2160 "../preprocessor/src/DynareBison.yy"
        { driver.set_corr_prior(yystack_[12].value.as < string > (), yystack_[10].value.as < string > (), yystack_[7].value.as < string > ()); }
#line 5143 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 948: // prior_eq: prior_eq_opt EQUAL prior_eq_opt ';'
#line 2196 "../preprocessor/src/DynareBison.yy"
           { driver.copy_prior(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                               get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 5150 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 949: // prior_eq_opt: symbol '.' PRIOR
#line 2201 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[2].value.as < string > (), "", ""}; }
#line 5156 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 950: // prior_eq_opt: symbol '.' symbol '.' PRIOR
#line 2203 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5162 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 951: // prior_eq_opt: STD '(' symbol ')' '.' PRIOR
#line 2205 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[3].value.as < string > (), "", ""}; }
#line 5168 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 952: // prior_eq_opt: STD '(' symbol ')' '.' symbol '.' PRIOR
#line 2207 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5174 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 953: // prior_eq_opt: CORR '(' symbol COMMA symbol ')' '.' PRIOR
#line 2209 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), ""}; }
#line 5180 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 954: // prior_eq_opt: CORR '(' symbol COMMA symbol ')' '.' symbol '.' PRIOR
#line 2211 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > ()}; }
#line 5186 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 955: // options: symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2215 "../preprocessor/src/DynareBison.yy"
          { driver.set_options(yystack_[6].value.as < string > (), ""); }
#line 5192 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 956: // options: symbol '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2217 "../preprocessor/src/DynareBison.yy"
          { driver.set_options(yystack_[8].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 5198 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 957: // options: STD '(' symbol ')' '.' OPTIONS '(' options_options_list ')' ';'
#line 2219 "../preprocessor/src/DynareBison.yy"
          { driver.set_std_options(yystack_[7].value.as < string > (), ""); }
#line 5204 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 958: // options: STD '(' symbol ')' '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2221 "../preprocessor/src/DynareBison.yy"
          { driver.set_std_options(yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 5210 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 959: // options: CORR '(' symbol COMMA symbol ')' '.' OPTIONS '(' options_options_list ')' ';'
#line 2223 "../preprocessor/src/DynareBison.yy"
          { driver.set_corr_options(yystack_[9].value.as < string > (), yystack_[7].value.as < string > (), ""); }
#line 5216 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 960: // options: CORR '(' symbol COMMA symbol ')' '.' symbol '.' OPTIONS '(' options_options_list ')' ';'
#line 2225 "../preprocessor/src/DynareBison.yy"
          { driver.set_corr_options(yystack_[11].value.as < string > (), yystack_[9].value.as < string > (), yystack_[6].value.as < string > ()); }
#line 5222 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 966: // options_eq: options_eq_opt EQUAL options_eq_opt ';'
#line 2238 "../preprocessor/src/DynareBison.yy"
             { driver.copy_options(get<0>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[3].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[3].value.as < tuple<string,string,string,string> > ()),
                                   get<0>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<1>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<2>(yystack_[1].value.as < tuple<string,string,string,string> > ()), get<3>(yystack_[1].value.as < tuple<string,string,string,string> > ())); }
#line 5229 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 967: // options_eq_opt: symbol '.' OPTIONS
#line 2243 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[2].value.as < string > (), "", ""}; }
#line 5235 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 968: // options_eq_opt: symbol '.' symbol '.' OPTIONS
#line 2245 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"par", yystack_[4].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5241 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 969: // options_eq_opt: STD '(' symbol ')' '.' OPTIONS
#line 2247 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[3].value.as < string > (), "", ""}; }
#line 5247 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 970: // options_eq_opt: STD '(' symbol ')' '.' symbol '.' OPTIONS
#line 2249 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"std", yystack_[5].value.as < string > (), "", yystack_[2].value.as < string > ()}; }
#line 5253 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 971: // options_eq_opt: CORR '(' symbol COMMA symbol ')' '.' OPTIONS
#line 2251 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), ""}; }
#line 5259 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 972: // options_eq_opt: CORR '(' symbol COMMA symbol ')' '.' symbol '.' OPTIONS
#line 2253 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < tuple<string,string,string,string> > () = {"corr", yystack_[7].value.as < string > (), yystack_[5].value.as < string > (), yystack_[2].value.as < string > ()}; }
#line 5265 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 973: // estimation: ESTIMATION ';'
#line 2257 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation({}); }
#line 5271 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 974: // estimation: ESTIMATION '(' estimation_options_list ')' ';'
#line 2259 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation({}); }
#line 5277 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 975: // estimation: ESTIMATION symbol_list ';'
#line 2261 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation(yystack_[1].value.as < vector<string> > ()); }
#line 5283 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 976: // estimation: ESTIMATION '(' estimation_options_list ')' symbol_list ';'
#line 2263 "../preprocessor/src/DynareBison.yy"
             { driver.run_estimation(yystack_[1].value.as < vector<string> > ()); }
#line 5289 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1111: // name_value_pair: QUOTED_STRING COMMA QUOTED_STRING
#line 2405 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'',''" + yystack_[0].value.as < string > () + "''"; }
#line 5295 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1112: // name_value_pair: QUOTED_STRING COMMA signed_number
#line 2407 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 5301 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1113: // name_value_pair_list: name_value_pair
#line 2410 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5307 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1114: // name_value_pair_list: name_value_pair_list COMMA name_value_pair
#line 2412 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 5313 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1115: // name_value_pair_with_boolean: name_value_pair
#line 2415 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5319 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1116: // name_value_pair_with_boolean: QUOTED_STRING COMMA boolean
#line 2417 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "''," + yystack_[0].value.as < string > (); }
#line 5325 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1117: // name_value_pair_with_boolean_list: name_value_pair_with_boolean
#line 2420 "../preprocessor/src/DynareBison.yy"
                                    { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5331 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1118: // name_value_pair_with_boolean_list: name_value_pair_with_boolean_list COMMA name_value_pair_with_boolean
#line 2422 "../preprocessor/src/DynareBison.yy"
                                    { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 5337 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1119: // name_value_pair_with_suboptions: name_value_pair
#line 2426 "../preprocessor/src/DynareBison.yy"
                                  { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5343 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1120: // name_value_pair_with_suboptions: QUOTED_STRING COMMA vec_str
#line 2428 "../preprocessor/src/DynareBison.yy"
                                  {
                                    yylhs.value.as < string > () = "''" + yystack_[2].value.as < string > () + "'',{";
                                    for (auto &it : yystack_[0].value.as < vector<string> > ())
                                      {
                                        if (&it != &(yystack_[0].value.as < vector<string> > ()).front())
                                          yylhs.value.as < string > () += ",";
                                        yylhs.value.as < string > () += "''" + it + "''";
                                      }
                                    yylhs.value.as < string > () += '}';
                                  }
#line 5358 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1121: // name_value_pair_with_suboptions: QUOTED_STRING COMMA '(' name_value_pair_list ')'
#line 2439 "../preprocessor/src/DynareBison.yy"
                                  { yylhs.value.as < string > () = "''" + yystack_[4].value.as < string > () + "'',''(" + yystack_[1].value.as < string > () + ")''"; }
#line 5364 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1122: // name_value_pair_with_suboptions_list: name_value_pair_with_suboptions
#line 2442 "../preprocessor/src/DynareBison.yy"
                                       { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5370 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1123: // name_value_pair_with_suboptions_list: name_value_pair_with_suboptions_list COMMA name_value_pair_with_suboptions
#line 2444 "../preprocessor/src/DynareBison.yy"
                                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ',' + yystack_[0].value.as < string > (); }
#line 5376 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1124: // $@29: %empty
#line 2447 "../preprocessor/src/DynareBison.yy"
                { driver.check_varobs(); }
#line 5382 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1126: // varobs_list: varobs_list symbol
#line 2450 "../preprocessor/src/DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 5388 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1127: // varobs_list: varobs_list COMMA symbol
#line 2452 "../preprocessor/src/DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 5394 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1128: // varobs_list: symbol
#line 2454 "../preprocessor/src/DynareBison.yy"
              { driver.add_varobs(yystack_[0].value.as < string > ()); }
#line 5400 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1129: // $@30: %empty
#line 2457 "../preprocessor/src/DynareBison.yy"
                    { driver.check_varexobs(); }
#line 5406 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1131: // varexobs_list: varexobs_list symbol
#line 2460 "../preprocessor/src/DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 5412 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1132: // varexobs_list: varexobs_list COMMA symbol
#line 2462 "../preprocessor/src/DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 5418 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1133: // varexobs_list: symbol
#line 2464 "../preprocessor/src/DynareBison.yy"
              { driver.add_varexobs(yystack_[0].value.as < string > ()); }
#line 5424 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1134: // deterministic_trends: DETERMINISTIC_TRENDS ';' trend_list END ';'
#line 2467 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.set_deterministic_trends(); }
#line 5430 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1135: // observation_trends: OBSERVATION_TRENDS ';' trend_list END ';'
#line 2468 "../preprocessor/src/DynareBison.yy"
                                                               { driver.set_trends(); }
#line 5436 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1138: // trend_element: symbol '(' expression ')' ';'
#line 2474 "../preprocessor/src/DynareBison.yy"
                                               { driver.set_trend_element(yystack_[4].value.as < string > (), yystack_[2].value.as < expr_t > ()); }
#line 5442 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1139: // filter_initial_state: FILTER_INITIAL_STATE ';' filter_initial_state_list END ';'
#line 2477 "../preprocessor/src/DynareBison.yy"
                       { driver.set_filter_initial_state(); }
#line 5448 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1142: // filter_initial_state_element: symbol '(' signed_integer ')' EQUAL expression ';'
#line 2485 "../preprocessor/src/DynareBison.yy"
                               { driver.set_filter_initial_state_element(yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5454 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1143: // unit_root_vars: UNIT_ROOT_VARS symbol_list ';'
#line 2488 "../preprocessor/src/DynareBison.yy"
                                                { driver.set_unit_root_vars(); }
#line 5460 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1144: // optim_weights: OPTIM_WEIGHTS ';' optim_weights_list END ';'
#line 2490 "../preprocessor/src/DynareBison.yy"
                                                             { driver.optim_weights(); }
#line 5466 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1145: // optim_weights_list: optim_weights_list symbol expression ';'
#line 2493 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5472 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1146: // optim_weights_list: optim_weights_list symbol COMMA symbol expression ';'
#line 2495 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5478 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1147: // optim_weights_list: symbol expression ';'
#line 2497 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5484 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1148: // optim_weights_list: symbol COMMA symbol expression ';'
#line 2499 "../preprocessor/src/DynareBison.yy"
                     { driver.set_optim_weights(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 5490 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1149: // osr_params: OSR_PARAMS symbol_list ';'
#line 2502 "../preprocessor/src/DynareBison.yy"
                                        { driver.set_osr_params(yystack_[1].value.as < vector<string> > ()); }
#line 5496 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1161: // osr: OSR ';'
#line 2521 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr({}); }
#line 5502 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1162: // osr: OSR '(' osr_options_list ')' ';'
#line 2523 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr({}); }
#line 5508 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1163: // osr: OSR symbol_list ';'
#line 2525 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr(yystack_[1].value.as < vector<string> > ()); }
#line 5514 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1164: // osr: OSR '(' osr_options_list ')' symbol_list ';'
#line 2527 "../preprocessor/src/DynareBison.yy"
      { driver.run_osr(yystack_[1].value.as < vector<string> > ()); }
#line 5520 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1165: // dynatype: DYNATYPE '(' filename ')' ';'
#line 2531 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynatype(yystack_[2].value.as < string > (), {}); }
#line 5526 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1166: // dynatype: DYNATYPE '(' filename ')' symbol_list ';'
#line 2533 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynatype(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 5532 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1167: // dynasave: DYNASAVE '(' filename ')' ';'
#line 2537 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynasave(yystack_[2].value.as < string > (), {}); }
#line 5538 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1168: // dynasave: DYNASAVE '(' filename ')' symbol_list ';'
#line 2539 "../preprocessor/src/DynareBison.yy"
           { driver.run_dynasave(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 5544 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1169: // load_params_and_steady_state: LOAD_PARAMS_AND_STEADY_STATE '(' filename ')' ';'
#line 2543 "../preprocessor/src/DynareBison.yy"
                               { driver.run_load_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 5550 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1170: // save_params_and_steady_state: SAVE_PARAMS_AND_STEADY_STATE '(' filename ')' ';'
#line 2547 "../preprocessor/src/DynareBison.yy"
                               { driver.run_save_params_and_steady_state(yystack_[2].value.as < string > ()); }
#line 5556 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1171: // identification: IDENTIFICATION ';'
#line 2551 "../preprocessor/src/DynareBison.yy"
                 { driver.run_identification(); }
#line 5562 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1172: // identification: IDENTIFICATION '(' identification_options_list ')' ';'
#line 2553 "../preprocessor/src/DynareBison.yy"
                 { driver.run_identification(); }
#line 5568 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1210: // model_comparison: MODEL_COMPARISON mc_filename_list ';'
#line 2598 "../preprocessor/src/DynareBison.yy"
                   { driver.run_model_comparison(); }
#line 5574 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1211: // model_comparison: MODEL_COMPARISON '(' o_marginal_density ')' mc_filename_list ';'
#line 2600 "../preprocessor/src/DynareBison.yy"
                   { driver.run_model_comparison(); }
#line 5580 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1212: // filename: symbol
#line 2603 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5586 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1213: // filename: QUOTED_STRING
#line 2604 "../preprocessor/src/DynareBison.yy"
           { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5592 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1214: // namespace_qualified_symbol: symbol
#line 2607 "../preprocessor/src/DynareBison.yy"
                             { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5598 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1215: // namespace_qualified_symbol: namespace_qualified_symbol '.' symbol
#line 2609 "../preprocessor/src/DynareBison.yy"
                             { yylhs.value.as < string > () = yystack_[2].value.as < string > () + "." + yystack_[0].value.as < string > (); }
#line 5604 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1216: // namespace_qualified_filename: namespace_qualified_symbol
#line 2612 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5610 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1217: // namespace_qualified_filename: QUOTED_STRING
#line 2613 "../preprocessor/src/DynareBison.yy"
                               { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 5616 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1218: // parallel_local_filename_list: filename
#line 2617 "../preprocessor/src/DynareBison.yy"
                               { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 5622 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1219: // parallel_local_filename_list: parallel_local_filename_list COMMA filename
#line 2619 "../preprocessor/src/DynareBison.yy"
                               { driver.add_parallel_local_file(yystack_[0].value.as < string > ()); }
#line 5628 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1220: // mc_filename_list: filename
#line 2623 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5634 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1221: // mc_filename_list: filename '(' non_negative_number ')'
#line 2625 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5640 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1222: // mc_filename_list: mc_filename_list filename
#line 2627 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5646 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1223: // mc_filename_list: mc_filename_list filename '(' non_negative_number ')'
#line 2629 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5652 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1224: // mc_filename_list: mc_filename_list COMMA filename
#line 2631 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[0].value.as < string > ()); }
#line 5658 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1225: // mc_filename_list: mc_filename_list COMMA filename '(' non_negative_number ')'
#line 2633 "../preprocessor/src/DynareBison.yy"
                   { driver.add_mc_filename(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 5664 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1226: // $@31: %empty
#line 2636 "../preprocessor/src/DynareBison.yy"
                                      { driver.begin_planner_objective(); }
#line 5670 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1227: // $@32: %empty
#line 2637 "../preprocessor/src/DynareBison.yy"
                              { driver.end_planner_objective(yystack_[0].value.as < expr_t > ()); }
#line 5676 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1229: // ramsey_model: RAMSEY_MODEL ';'
#line 2640 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_model(); }
#line 5682 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1230: // ramsey_model: RAMSEY_MODEL '(' ramsey_model_options_list ')' ';'
#line 2642 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_model(); }
#line 5688 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1231: // ramsey_policy: RAMSEY_POLICY ';'
#line 2646 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy({}); }
#line 5694 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1232: // ramsey_policy: RAMSEY_POLICY '(' ramsey_policy_options_list ')' ';'
#line 2648 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy({}); }
#line 5700 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1233: // ramsey_policy: RAMSEY_POLICY symbol_list ';'
#line 2650 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5706 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1234: // ramsey_policy: RAMSEY_POLICY '(' ramsey_policy_options_list ')' symbol_list ';'
#line 2652 "../preprocessor/src/DynareBison.yy"
                { driver.ramsey_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5712 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1235: // $@33: %empty
#line 2656 "../preprocessor/src/DynareBison.yy"
                     { driver.begin_ramsey_constraints(); }
#line 5718 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1236: // ramsey_constraints: RAMSEY_CONSTRAINTS ';' $@33 ramsey_constraints_list END ';'
#line 2658 "../preprocessor/src/DynareBison.yy"
                     { driver.end_ramsey_constraints(yystack_[2].value.as < vector<expr_t> > ()); }
#line 5724 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1237: // ramsey_constraints_list: ramsey_constraints_list hand_side ';'
#line 2662 "../preprocessor/src/DynareBison.yy"
                          {
                            yylhs.value.as < vector<expr_t> > () = yystack_[2].value.as < vector<expr_t> > ();
                            yylhs.value.as < vector<expr_t> > ().push_back(yystack_[1].value.as < expr_t > ());
                          }
#line 5733 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1238: // ramsey_constraints_list: hand_side ';'
#line 2667 "../preprocessor/src/DynareBison.yy"
                          { yylhs.value.as < vector<expr_t> > () = { yystack_[1].value.as < expr_t > () }; }
#line 5739 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1239: // evaluate_planner_objective: EVALUATE_PLANNER_OBJECTIVE ';'
#line 2671 "../preprocessor/src/DynareBison.yy"
                             { driver.evaluate_planner_objective(); }
#line 5745 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1240: // evaluate_planner_objective: EVALUATE_PLANNER_OBJECTIVE '(' evaluate_planner_objective_options_list ')' ';'
#line 2673 "../preprocessor/src/DynareBison.yy"
                             { driver.evaluate_planner_objective(); }
#line 5751 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1245: // occbin_setup: OCCBIN_SETUP ';'
#line 2685 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_setup(); }
#line 5757 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1246: // occbin_setup: OCCBIN_SETUP '(' occbin_setup_options_list ')' ';'
#line 2687 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_setup(); }
#line 5763 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1276: // occbin_solver: OCCBIN_SOLVER ';'
#line 2723 "../preprocessor/src/DynareBison.yy"
                { driver.occbin_solver(); }
#line 5769 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1277: // occbin_solver: OCCBIN_SOLVER '(' occbin_solver_options_list ')' ';'
#line 2725 "../preprocessor/src/DynareBison.yy"
                { driver.occbin_solver(); }
#line 5775 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1288: // occbin_write_regimes: OCCBIN_WRITE_REGIMES ';'
#line 2743 "../preprocessor/src/DynareBison.yy"
                       { driver.occbin_write_regimes(); }
#line 5781 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1289: // occbin_write_regimes: OCCBIN_WRITE_REGIMES '(' occbin_write_regimes_options_list ')' ';'
#line 2745 "../preprocessor/src/DynareBison.yy"
                       { driver.occbin_write_regimes(); }
#line 5787 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1296: // occbin_graph: OCCBIN_GRAPH ';'
#line 2758 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph({}); }
#line 5793 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1297: // occbin_graph: OCCBIN_GRAPH '(' occbin_graph_options_list ')' ';'
#line 2760 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph({}); }
#line 5799 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1298: // occbin_graph: OCCBIN_GRAPH symbol_list ';'
#line 2762 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph(yystack_[1].value.as < vector<string> > ()); }
#line 5805 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1299: // occbin_graph: OCCBIN_GRAPH '(' occbin_graph_options_list ')' symbol_list ';'
#line 2764 "../preprocessor/src/DynareBison.yy"
               { driver.occbin_graph(yystack_[1].value.as < vector<string> > ()); }
#line 5811 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1303: // discretionary_policy: DISCRETIONARY_POLICY ';'
#line 2774 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy({}); }
#line 5817 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1304: // discretionary_policy: DISCRETIONARY_POLICY '(' discretionary_policy_options_list ')' ';'
#line 2776 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy({}); }
#line 5823 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1305: // discretionary_policy: DISCRETIONARY_POLICY symbol_list ';'
#line 2778 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5829 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1306: // discretionary_policy: DISCRETIONARY_POLICY '(' discretionary_policy_options_list ')' symbol_list ';'
#line 2780 "../preprocessor/src/DynareBison.yy"
                       { driver.discretionary_policy(yystack_[1].value.as < vector<string> > ()); }
#line 5835 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1322: // write_latex_dynamic_model: WRITE_LATEX_DYNAMIC_MODEL ';'
#line 2811 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_dynamic_model(false); }
#line 5841 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1323: // write_latex_dynamic_model: WRITE_LATEX_DYNAMIC_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2813 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_dynamic_model(true); }
#line 5847 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1324: // write_latex_static_model: WRITE_LATEX_STATIC_MODEL ';'
#line 2817 "../preprocessor/src/DynareBison.yy"
                           { driver.write_latex_static_model(false); }
#line 5853 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1325: // write_latex_static_model: WRITE_LATEX_STATIC_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2819 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_static_model(true); }
#line 5859 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1326: // write_latex_original_model: WRITE_LATEX_ORIGINAL_MODEL ';'
#line 2823 "../preprocessor/src/DynareBison.yy"
                           { driver.write_latex_original_model(false); }
#line 5865 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1327: // write_latex_original_model: WRITE_LATEX_ORIGINAL_MODEL '(' WRITE_EQUATION_TAGS ')' ';'
#line 2825 "../preprocessor/src/DynareBison.yy"
                            { driver.write_latex_original_model(true); }
#line 5871 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1328: // write_latex_steady_state_model: WRITE_LATEX_STEADY_STATE_MODEL ';'
#line 2829 "../preprocessor/src/DynareBison.yy"
                                 { driver.write_latex_steady_state_model(); }
#line 5877 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1329: // shock_decomposition: SHOCK_DECOMPOSITION ';'
#line 2833 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition({}); }
#line 5883 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1330: // shock_decomposition: SHOCK_DECOMPOSITION '(' shock_decomposition_options_list ')' ';'
#line 2835 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition({}); }
#line 5889 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1331: // shock_decomposition: SHOCK_DECOMPOSITION symbol_list ';'
#line 2837 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5895 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1332: // shock_decomposition: SHOCK_DECOMPOSITION '(' shock_decomposition_options_list ')' symbol_list ';'
#line 2839 "../preprocessor/src/DynareBison.yy"
                      { driver.shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5901 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1333: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION ';'
#line 2843 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition({}); }
#line 5907 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1334: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION '(' realtime_shock_decomposition_options_list ')' ';'
#line 2845 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition({}); }
#line 5913 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1335: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION symbol_list ';'
#line 2847 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5919 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1336: // realtime_shock_decomposition: REALTIME_SHOCK_DECOMPOSITION '(' realtime_shock_decomposition_options_list ')' symbol_list ';'
#line 2849 "../preprocessor/src/DynareBison.yy"
                               { driver.realtime_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5925 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1337: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION ';'
#line 2853 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition({}); }
#line 5931 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1338: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION '(' plot_shock_decomposition_options_list ')' ';'
#line 2855 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition({}); }
#line 5937 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1339: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION symbol_list ';'
#line 2857 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5943 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1340: // plot_shock_decomposition: PLOT_SHOCK_DECOMPOSITION '(' plot_shock_decomposition_options_list ')' symbol_list ';'
#line 2859 "../preprocessor/src/DynareBison.yy"
                           { driver.plot_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5949 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1341: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION ';'
#line 2863 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition({}); }
#line 5955 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1342: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION '(' initial_condition_decomposition_options_list ')' ';'
#line 2865 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition({}); }
#line 5961 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1343: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION symbol_list ';'
#line 2867 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5967 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1344: // initial_condition_decomposition: INITIAL_CONDITION_DECOMPOSITION '(' initial_condition_decomposition_options_list ')' symbol_list ';'
#line 2869 "../preprocessor/src/DynareBison.yy"
                                  { driver.initial_condition_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5973 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1345: // squeeze_shock_decomposition: SQUEEZE_SHOCK_DECOMPOSITION ';'
#line 2873 "../preprocessor/src/DynareBison.yy"
                              { driver.squeeze_shock_decomposition({}); }
#line 5979 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1346: // squeeze_shock_decomposition: SQUEEZE_SHOCK_DECOMPOSITION symbol_list ';'
#line 2875 "../preprocessor/src/DynareBison.yy"
                              { driver.squeeze_shock_decomposition(yystack_[1].value.as < vector<string> > ()); }
#line 5985 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1366: // bvar_density: BVAR_DENSITY INT_NUMBER ';'
#line 2904 "../preprocessor/src/DynareBison.yy"
               { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5991 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1367: // bvar_density: BVAR_DENSITY '(' bvar_density_options_list ')' INT_NUMBER ';'
#line 2906 "../preprocessor/src/DynareBison.yy"
               { driver.bvar_density(yystack_[1].value.as < string > ()); }
#line 5997 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1374: // bvar_forecast: BVAR_FORECAST INT_NUMBER ';'
#line 2920 "../preprocessor/src/DynareBison.yy"
                { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 6003 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1375: // bvar_forecast: BVAR_FORECAST '(' bvar_forecast_options_list ')' INT_NUMBER ';'
#line 2922 "../preprocessor/src/DynareBison.yy"
                { driver.bvar_forecast(yystack_[1].value.as < string > ()); }
#line 6009 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1376: // bvar_irf: BVAR_IRF '(' INT_NUMBER COMMA QUOTED_STRING ')' ';'
#line 2926 "../preprocessor/src/DynareBison.yy"
                { driver.bvar_irf(yystack_[4].value.as < string > (), yystack_[2].value.as < string > ()); }
#line 6015 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1427: // sbvar: SBVAR ';'
#line 2983 "../preprocessor/src/DynareBison.yy"
        { driver.sbvar(); }
#line 6021 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1428: // sbvar: SBVAR '(' sbvar_options_list ')' ';'
#line 2985 "../preprocessor/src/DynareBison.yy"
        { driver.sbvar(); }
#line 6027 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1445: // ms_variance_decomposition: MS_VARIANCE_DECOMPOSITION ';'
#line 3009 "../preprocessor/src/DynareBison.yy"
                            { driver.ms_variance_decomposition(); }
#line 6033 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1446: // ms_variance_decomposition: MS_VARIANCE_DECOMPOSITION '(' ms_variance_decomposition_options_list ')' ';'
#line 3011 "../preprocessor/src/DynareBison.yy"
                            { driver.ms_variance_decomposition(); }
#line 6039 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1463: // ms_forecast: MS_FORECAST ';'
#line 3035 "../preprocessor/src/DynareBison.yy"
              { driver.ms_forecast(); }
#line 6045 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1464: // ms_forecast: MS_FORECAST '(' ms_forecast_options_list ')' ';'
#line 3037 "../preprocessor/src/DynareBison.yy"
              { driver.ms_forecast(); }
#line 6051 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1481: // ms_irf: MS_IRF ';'
#line 3061 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf({}); }
#line 6057 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1482: // ms_irf: MS_IRF '(' ms_irf_options_list ')' ';'
#line 3063 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf({}); }
#line 6063 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1483: // ms_irf: MS_IRF symbol_list ';'
#line 3065 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf(yystack_[1].value.as < vector<string> > ()); }
#line 6069 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1484: // ms_irf: MS_IRF '(' ms_irf_options_list ')' symbol_list ';'
#line 3067 "../preprocessor/src/DynareBison.yy"
         { driver.ms_irf(yystack_[1].value.as < vector<string> > ()); }
#line 6075 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1491: // ms_compute_probabilities: MS_COMPUTE_PROBABILITIES ';'
#line 3081 "../preprocessor/src/DynareBison.yy"
                           { driver.ms_compute_probabilities(); }
#line 6081 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1492: // ms_compute_probabilities: MS_COMPUTE_PROBABILITIES '(' ms_compute_probabilities_options_list ')' ';'
#line 3083 "../preprocessor/src/DynareBison.yy"
                           { driver.ms_compute_probabilities(); }
#line 6087 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1503: // ms_compute_mdd: MS_COMPUTE_MDD ';'
#line 3101 "../preprocessor/src/DynareBison.yy"
                 { driver.ms_compute_mdd(); }
#line 6093 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1504: // ms_compute_mdd: MS_COMPUTE_MDD '(' ms_compute_mdd_options_list ')' ';'
#line 3103 "../preprocessor/src/DynareBison.yy"
                 { driver.ms_compute_mdd(); }
#line 6099 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1514: // ms_simulation: MS_SIMULATION ';'
#line 3120 "../preprocessor/src/DynareBison.yy"
                { driver.ms_simulation(); }
#line 6105 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1515: // ms_simulation: MS_SIMULATION '(' ms_simulation_options_list ')' ';'
#line 3122 "../preprocessor/src/DynareBison.yy"
                { driver.ms_simulation(); }
#line 6111 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1553: // ms_estimation: MS_ESTIMATION ';'
#line 3167 "../preprocessor/src/DynareBison.yy"
                { driver.ms_estimation(); }
#line 6117 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1554: // ms_estimation: MS_ESTIMATION '(' ms_estimation_options_list ')' ';'
#line 3169 "../preprocessor/src/DynareBison.yy"
                { driver.ms_estimation(); }
#line 6123 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1555: // sensitivity: SENSITIVITY ';'
#line 3173 "../preprocessor/src/DynareBison.yy"
              { driver.sensitivity(); }
#line 6129 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1556: // sensitivity: SENSITIVITY '(' sensitivity_options_list ')' ';'
#line 3175 "../preprocessor/src/DynareBison.yy"
              { driver.sensitivity(); }
#line 6135 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1557: // sensitivity: DYNARE_SENSITIVITY ';'
#line 3177 "../preprocessor/src/DynareBison.yy"
              {
                driver.warning("The 'dynare_sensitivity' command is deprecated. It has been renamed 'sensitivity'.");
                driver.sensitivity();
              }
#line 6144 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1558: // sensitivity: DYNARE_SENSITIVITY '(' sensitivity_options_list ')' ';'
#line 3182 "../preprocessor/src/DynareBison.yy"
              {
                driver.warning("The 'dynare_sensitivity' command is deprecated. It has been renamed 'sensitivity'.");
                driver.sensitivity();
              }
#line 6153 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1683: // homotopy_setup: HOMOTOPY_SETUP ';' homotopy_list END ';'
#line 3333 "../preprocessor/src/DynareBison.yy"
                 { driver.end_homotopy(false); }
#line 6159 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1684: // homotopy_setup: HOMOTOPY_SETUP '(' FROM_INITVAL_TO_ENDVAL ')' ';' END ';'
#line 3335 "../preprocessor/src/DynareBison.yy"
                 { driver.end_homotopy(true); }
#line 6165 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1685: // homotopy_setup: HOMOTOPY_SETUP '(' FROM_INITVAL_TO_ENDVAL ')' ';' homotopy_list END ';'
#line 3337 "../preprocessor/src/DynareBison.yy"
                 { driver.end_homotopy(true); }
#line 6171 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1688: // homotopy_item: symbol COMMA expression COMMA expression ';'
#line 3345 "../preprocessor/src/DynareBison.yy"
                { driver.homotopy_val(yystack_[5].value.as < string > (), yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()); }
#line 6177 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1689: // homotopy_item: symbol COMMA expression ';'
#line 3347 "../preprocessor/src/DynareBison.yy"
                { driver.homotopy_val(yystack_[3].value.as < string > (), nullptr, yystack_[1].value.as < expr_t > ()); }
#line 6183 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1690: // forecast: FORECAST ';'
#line 3351 "../preprocessor/src/DynareBison.yy"
          { driver.forecast({}); }
#line 6189 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1691: // forecast: FORECAST '(' forecast_options ')' ';'
#line 3353 "../preprocessor/src/DynareBison.yy"
          { driver.forecast({}); }
#line 6195 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1692: // forecast: FORECAST symbol_list ';'
#line 3355 "../preprocessor/src/DynareBison.yy"
          { driver.forecast(yystack_[1].value.as < vector<string> > ()); }
#line 6201 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1693: // forecast: FORECAST '(' forecast_options ')' symbol_list ';'
#line 3357 "../preprocessor/src/DynareBison.yy"
          { driver.forecast(yystack_[1].value.as < vector<string> > ()); }
#line 6207 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1701: // conditional_forecast: CONDITIONAL_FORECAST '(' conditional_forecast_options ')' ';'
#line 3372 "../preprocessor/src/DynareBison.yy"
                       { driver.conditional_forecast(); }
#line 6213 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1709: // plot_conditional_forecast: PLOT_CONDITIONAL_FORECAST symbol_list ';'
#line 3387 "../preprocessor/src/DynareBison.yy"
                            { driver.plot_conditional_forecast(nullopt, yystack_[1].value.as < vector<string> > ()); }
#line 6219 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1710: // plot_conditional_forecast: PLOT_CONDITIONAL_FORECAST '(' PERIODS EQUAL INT_NUMBER ')' symbol_list ';'
#line 3389 "../preprocessor/src/DynareBison.yy"
                            { driver.plot_conditional_forecast(yystack_[3].value.as < string > (), yystack_[1].value.as < vector<string> > ()); }
#line 6225 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1711: // conditional_forecast_paths: CONDITIONAL_FORECAST_PATHS ';' conditional_forecast_paths_shock_list END ';'
#line 3393 "../preprocessor/src/DynareBison.yy"
                             { driver.conditional_forecast_paths(); }
#line 6231 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1714: // conditional_forecast_paths_shock_elem: VAR symbol ';' PERIODS period_list ';' VALUES value_list ';'
#line 3401 "../preprocessor/src/DynareBison.yy"
                                        { driver.add_det_shock(
                                              yystack_[7].value.as < string > (), yystack_[4].value.as < vector<AbstractShocksStatement::period_range_t> > (), yystack_[1].value.as < vector<expr_t> > (),
                                              ParsingDriver::DetShockType::conditional_forecast); }
#line 6239 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1715: // $@34: %empty
#line 3406 "../preprocessor/src/DynareBison.yy"
                                            { driver.begin_steady_state_model(); }
#line 6245 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1716: // steady_state_model: STEADY_STATE_MODEL ';' $@34 steady_state_equation_list END ';'
#line 3407 "../preprocessor/src/DynareBison.yy"
                                                        { driver.reset_data_tree(); }
#line 6251 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1719: // steady_state_equation: symbol EQUAL expression ';'
#line 3415 "../preprocessor/src/DynareBison.yy"
                        { driver.add_steady_state_model_equal(yystack_[3].value.as < string > (), yystack_[1].value.as < expr_t > ()); }
#line 6257 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1720: // steady_state_equation: '[' symbol_list ']' EQUAL expression ';'
#line 3417 "../preprocessor/src/DynareBison.yy"
                        { driver.add_steady_state_model_equal_multiple(yystack_[4].value.as < vector<string> > (), yystack_[1].value.as < expr_t > ()); }
#line 6263 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1721: // calib_smoother: CALIB_SMOOTHER ';'
#line 3421 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother({}); }
#line 6269 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1722: // calib_smoother: CALIB_SMOOTHER '(' calib_smoother_options_list ')' ';'
#line 3423 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother({}); }
#line 6275 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1723: // calib_smoother: CALIB_SMOOTHER symbol_list ';'
#line 3425 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother(yystack_[1].value.as < vector<string> > ()); }
#line 6281 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1724: // calib_smoother: CALIB_SMOOTHER '(' calib_smoother_options_list ')' symbol_list ';'
#line 3427 "../preprocessor/src/DynareBison.yy"
                 { driver.calib_smoother(yystack_[1].value.as < vector<string> > ()); }
#line 6287 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1746: // generate_irfs: GENERATE_IRFS ';' END ';'
#line 3456 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6293 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1747: // generate_irfs: GENERATE_IRFS ';' generate_irfs_element_list END ';'
#line 3458 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6299 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1748: // generate_irfs: GENERATE_IRFS '(' generate_irfs_options_list ')' ';' END ';'
#line 3460 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6305 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1749: // generate_irfs: GENERATE_IRFS '(' generate_irfs_options_list ')' ';' generate_irfs_element_list END ';'
#line 3462 "../preprocessor/src/DynareBison.yy"
                { driver.end_generate_irfs(); }
#line 6311 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1756: // generate_irfs_element: NAME COMMA generate_irfs_exog_element_list ';'
#line 3478 "../preprocessor/src/DynareBison.yy"
                        { driver.add_generate_irfs_element(yystack_[3].value.as < string > ()); }
#line 6317 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1757: // generate_irfs_exog_element_list: generate_irfs_exog_element_list COMMA symbol EQUAL signed_number
#line 3482 "../preprocessor/src/DynareBison.yy"
                                  { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6323 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1758: // generate_irfs_exog_element_list: symbol EQUAL signed_number
#line 3484 "../preprocessor/src/DynareBison.yy"
                                  { driver.add_generate_irfs_exog_element(yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 6329 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1759: // extended_path: EXTENDED_PATH ';'
#line 3488 "../preprocessor/src/DynareBison.yy"
                { driver.extended_path(); }
#line 6335 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1760: // extended_path: EXTENDED_PATH '(' extended_path_options_list ')' ';'
#line 3490 "../preprocessor/src/DynareBison.yy"
                { driver.extended_path(); }
#line 6341 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1769: // model_diagnostics: MODEL_DIAGNOSTICS ';'
#line 3506 "../preprocessor/src/DynareBison.yy"
                    { driver.model_diagnostics(); }
#line 6347 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1770: // calibration_range: '[' expression COMMA expression ']'
#line 3510 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = {yystack_[3].value.as < expr_t > (), yystack_[1].value.as < expr_t > ()}; }
#line 6353 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1771: // calibration_range: PLUS
#line 3512 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = {driver.add_non_negative_constant("0"), driver.add_inf_constant()}; }
#line 6359 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1772: // calibration_range: MINUS
#line 3514 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < pair<expr_t,expr_t> > () = {driver.add_uminus(driver.add_inf_constant()),
                            driver.add_non_negative_constant("0")}; }
#line 6366 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1773: // moment_calibration: MOMENT_CALIBRATION ';' moment_calibration_list END ';'
#line 3519 "../preprocessor/src/DynareBison.yy"
                     { driver.end_moment_calibration(); }
#line 6372 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1776: // moment_calibration_item: symbol COMMA symbol COMMA calibration_range ';'
#line 3527 "../preprocessor/src/DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), "0", yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6378 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1777: // moment_calibration_item: symbol COMMA symbol '(' signed_integer ')' COMMA calibration_range ';'
#line 3529 "../preprocessor/src/DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6384 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1778: // moment_calibration_item: symbol COMMA symbol '(' signed_integer_range ')' COMMA calibration_range ';'
#line 3531 "../preprocessor/src/DynareBison.yy"
                          { driver.add_moment_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[4].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6390 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1779: // irf_calibration: IRF_CALIBRATION ';' irf_calibration_list END ';'
#line 3535 "../preprocessor/src/DynareBison.yy"
                  { driver.end_irf_calibration(); }
#line 6396 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1780: // irf_calibration: IRF_CALIBRATION '(' o_relative_irf ')' ';' irf_calibration_list END ';'
#line 3537 "../preprocessor/src/DynareBison.yy"
                  { driver.end_irf_calibration(); }
#line 6402 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1783: // irf_calibration_item: symbol COMMA symbol COMMA calibration_range ';'
#line 3545 "../preprocessor/src/DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[5].value.as < string > (), "1", yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6408 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1784: // irf_calibration_item: symbol '(' INT_NUMBER ')' COMMA symbol COMMA calibration_range ';'
#line 3547 "../preprocessor/src/DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6414 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1785: // irf_calibration_item: symbol '(' integer_range ')' COMMA symbol COMMA calibration_range ';'
#line 3549 "../preprocessor/src/DynareBison.yy"
                       { driver.add_irf_calibration_item(yystack_[8].value.as < string > (), yystack_[6].value.as < string > (), yystack_[3].value.as < string > (), yystack_[1].value.as < pair<expr_t,expr_t> > ()); }
#line 6420 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1786: // smoother2histval: SMOOTHER2HISTVAL ';'
#line 3553 "../preprocessor/src/DynareBison.yy"
                   { driver.smoother2histval(); }
#line 6426 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1787: // smoother2histval: SMOOTHER2HISTVAL '(' smoother2histval_options_list ')' ';'
#line 3555 "../preprocessor/src/DynareBison.yy"
                   { driver.smoother2histval(); }
#line 6432 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1795: // shock_groups: SHOCK_GROUPS ';' shock_group_list END ';'
#line 3570 "../preprocessor/src/DynareBison.yy"
               { driver.end_shock_groups("default"); }
#line 6438 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1796: // shock_groups: SHOCK_GROUPS '(' NAME EQUAL symbol ')' ';' shock_group_list END ';'
#line 3572 "../preprocessor/src/DynareBison.yy"
               { driver.end_shock_groups(yystack_[5].value.as < string > ()); }
#line 6444 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1799: // shock_group_element: symbol EQUAL shock_name_list ';'
#line 3579 "../preprocessor/src/DynareBison.yy"
                                                       { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 6450 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1800: // shock_group_element: QUOTED_STRING EQUAL shock_name_list ';'
#line 3580 "../preprocessor/src/DynareBison.yy"
                                                              { driver.add_shock_group(yystack_[3].value.as < string > ()); }
#line 6456 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1801: // shock_name_list: shock_name_list COMMA symbol
#line 3583 "../preprocessor/src/DynareBison.yy"
                                               { driver.add_shock_group_element(yystack_[0].value.as < string > ()); }
#line 6462 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1802: // shock_name_list: shock_name_list symbol
#line 3584 "../preprocessor/src/DynareBison.yy"
                                         { driver.add_shock_group_element(yystack_[0].value.as < string > ()); }
#line 6468 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1803: // shock_name_list: symbol
#line 3585 "../preprocessor/src/DynareBison.yy"
                         { driver.add_shock_group_element(yystack_[0].value.as < string > ()); }
#line 6474 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1804: // init2shocks: INIT2SHOCKS ';' init2shocks_list END ';'
#line 3589 "../preprocessor/src/DynareBison.yy"
              { driver.end_init2shocks("default"); }
#line 6480 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1805: // init2shocks: INIT2SHOCKS '(' NAME EQUAL symbol ')' ';' init2shocks_list END ';'
#line 3591 "../preprocessor/src/DynareBison.yy"
              { driver.end_init2shocks(yystack_[5].value.as < string > ()); }
#line 6486 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1808: // init2shocks_element: symbol symbol ';'
#line 3598 "../preprocessor/src/DynareBison.yy"
                                        { driver.add_init2shocks(yystack_[2].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 6492 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1809: // init2shocks_element: symbol COMMA symbol ';'
#line 3599 "../preprocessor/src/DynareBison.yy"
                                              { driver.add_init2shocks(yystack_[3].value.as < string > (), yystack_[1].value.as < string > ()); }
#line 6498 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1810: // matched_irfs: MATCHED_IRFS ';' matched_irfs_list END ';'
#line 3603 "../preprocessor/src/DynareBison.yy"
               { driver.matched_irfs(yystack_[2].value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (), false); }
#line 6504 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1811: // matched_irfs: MATCHED_IRFS '(' OVERWRITE ')' ';' matched_irfs_list END ';'
#line 3605 "../preprocessor/src/DynareBison.yy"
               { driver.matched_irfs(yystack_[2].value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > (), true); }
#line 6510 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1812: // matched_irfs_list: matched_irfs_elem
#line 3609 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > () = {yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ()}; }
#line 6516 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1813: // matched_irfs_list: matched_irfs_list matched_irfs_elem
#line 3611 "../preprocessor/src/DynareBison.yy"
                    {
                      yylhs.value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > () = yystack_[1].value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ();
                      auto [it, success] = yylhs.value.as < map<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ().insert(yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ());
                      if (!success)
                        driver.error("matched_irfs: the pair endogenous " + yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ().first.first + " with exogenous " + yystack_[0].value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > ().first.second + " appears two times");
                    }
#line 6527 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1814: // matched_irfs_elem: matched_irfs_elem_var_varexo PERIODS period_list ';' matched_irfs_elem_values_weights
#line 3622 "../preprocessor/src/DynareBison.yy"
                    {
                      if (yystack_[2].value.as < vector<AbstractShocksStatement::period_range_t> > ().size() != yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().first.size())
                        driver.error("matched_irfs: the 'periods' and 'values' keywords are not followed by the same number of elements");
                      if (yystack_[2].value.as < vector<AbstractShocksStatement::period_range_t> > ().size() != yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().second.size())
                        driver.error("matched_irfs: the 'periods' and 'values' keywords are not followed by the same number of elements");
                      vector<tuple<int, int, expr_t, expr_t>> v;
                      v.reserve(yystack_[2].value.as < vector<AbstractShocksStatement::period_range_t> > ().size());
                      for (size_t i {0}; i < yystack_[2].value.as < vector<AbstractShocksStatement::period_range_t> > ().size(); i++)
                        try
                          {
                            auto [p1, p2] = get<pair<int, int>>(yystack_[2].value.as < vector<AbstractShocksStatement::period_range_t> > ()[i]);
                            v.emplace_back(p1, p2, yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().first[i], yystack_[0].value.as < pair<vector<expr_t>, vector<expr_t>> > ().second[i]);
                          }
                        catch (bad_variant_access&)
                          {
                            driver.error("matched_irfs: dates are not allowed in the 'periods' keyword");
                          }
                      yylhs.value.as < pair<pair<string, string>, vector<tuple<int, int, expr_t, expr_t>>> > () = {yystack_[4].value.as < pair<string,string> > (), v};
                    }
#line 6551 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1815: // matched_irfs_elem_var_varexo: VAR symbol ';' VAREXO symbol ';'
#line 3644 "../preprocessor/src/DynareBison.yy"
                               {
                                 driver.check_symbol_is_endogenous(yystack_[4].value.as < string > ());
                                 driver.check_symbol_is_exogenous(yystack_[1].value.as < string > (), false);
                                 yylhs.value.as < pair<string,string> > () = {yystack_[4].value.as < string > (), yystack_[1].value.as < string > ()};
                               }
#line 6561 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1816: // matched_irfs_elem_var_varexo: VAREXO symbol ';' VAR symbol ';'
#line 3650 "../preprocessor/src/DynareBison.yy"
                               {
                                 driver.check_symbol_is_endogenous(yystack_[1].value.as < string > ());
                                 driver.check_symbol_is_exogenous(yystack_[4].value.as < string > (), false);
                                 yylhs.value.as < pair<string,string> > () = {yystack_[1].value.as < string > (), yystack_[4].value.as < string > ()};
                               }
#line 6571 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1817: // matched_irfs_elem_values_weights: VALUES value_list ';'
#line 3658 "../preprocessor/src/DynareBison.yy"
                                   {
                                     yylhs.value.as < pair<vector<expr_t>, vector<expr_t>> > () = {yystack_[1].value.as < vector<expr_t> > (), vector(yystack_[1].value.as < vector<expr_t> > ().size(),
                                                      driver.add_non_negative_constant("1"))};
                                   }
#line 6580 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1818: // matched_irfs_elem_values_weights: VALUES value_list ';' WEIGHTS value_list ';'
#line 3663 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<vector<expr_t>, vector<expr_t>> > () = {yystack_[4].value.as < vector<expr_t> > (), yystack_[1].value.as < vector<expr_t> > ()}; }
#line 6586 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1819: // matched_irfs_elem_values_weights: WEIGHTS value_list ';' VALUES value_list ';'
#line 3665 "../preprocessor/src/DynareBison.yy"
                                   { yylhs.value.as < pair<vector<expr_t>, vector<expr_t>> > () = {yystack_[1].value.as < vector<expr_t> > (), yystack_[4].value.as < vector<expr_t> > ()}; }
#line 6592 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1820: // matched_irfs_weights: MATCHED_IRFS_WEIGHTS ';' matched_irfs_weights_list END ';'
#line 3669 "../preprocessor/src/DynareBison.yy"
                       { driver.matched_irfs_weights(yystack_[2].value.as < map<tuple<string, string, string, string, string, string>, expr_t> > (), false); }
#line 6598 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1821: // matched_irfs_weights: MATCHED_IRFS_WEIGHTS '(' OVERWRITE ')' ';' matched_irfs_weights_list END ';'
#line 3671 "../preprocessor/src/DynareBison.yy"
                       { driver.matched_irfs_weights(yystack_[2].value.as < map<tuple<string, string, string, string, string, string>, expr_t> > (), true); }
#line 6604 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1822: // matched_irfs_weights_list: matched_irfs_weights_elem
#line 3675 "../preprocessor/src/DynareBison.yy"
                            { yylhs.value.as < map<tuple<string, string, string, string, string, string>, expr_t> > () = {yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ()}; }
#line 6610 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1823: // matched_irfs_weights_list: matched_irfs_weights_list matched_irfs_weights_elem
#line 3677 "../preprocessor/src/DynareBison.yy"
                            {
                              yylhs.value.as < map<tuple<string, string, string, string, string, string>, expr_t> > () = yystack_[1].value.as < map<tuple<string, string, string, string, string, string>, expr_t> > ();
                              auto [it, success] = yylhs.value.as < map<tuple<string, string, string, string, string, string>, expr_t> > ().insert(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ());
                              if (!success)
                                driver.error("matched_irfs: the tuple (" + get<0>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first)
                                             + "(" + get<1>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + ")," + get<2>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first)
                                             + "," + get<3>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + "(" + get<4>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + "),"
                                             + get<5>(yystack_[0].value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > ().first) + ") appears two times");
                            }
#line 6624 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1824: // matched_irfs_weights_elem: matched_irfs_weights_elem_var_varexo COMMA matched_irfs_weights_elem_var_varexo COMMA expression ';'
#line 3691 "../preprocessor/src/DynareBison.yy"
                            {
                              yylhs.value.as < pair<tuple<string, string, string, string, string, string>, expr_t> > () = {{get<0>(yystack_[5].value.as < tuple<string, string, string> > ()), get<1>(yystack_[5].value.as < tuple<string, string, string> > ()), get<2>(yystack_[5].value.as < tuple<string, string, string> > ()),
                                     get<0>(yystack_[3].value.as < tuple<string, string, string> > ()), get<1>(yystack_[3].value.as < tuple<string, string, string> > ()), get<2>(yystack_[3].value.as < tuple<string, string, string> > ())},
                                    yystack_[1].value.as < expr_t > ()};
                            }
#line 6634 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1825: // matched_irfs_weights_elem_var_varexo: symbol '(' INT_NUMBER ')' COMMA symbol
#line 3699 "../preprocessor/src/DynareBison.yy"
                                       {
                                         driver.check_symbol_is_endogenous(yystack_[5].value.as < string > ());
                                         driver.check_symbol_is_exogenous(yystack_[0].value.as < string > (), false);
                                         yylhs.value.as < tuple<string, string, string> > () = {yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[0].value.as < string > ()};
                                       }
#line 6644 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1826: // matched_irfs_weights_elem_var_varexo: symbol '(' integer_range ')' COMMA symbol
#line 3705 "../preprocessor/src/DynareBison.yy"
                                       {
                                         driver.check_symbol_is_endogenous(yystack_[5].value.as < string > ());
                                         driver.check_symbol_is_exogenous(yystack_[0].value.as < string > (), false);
                                         yylhs.value.as < tuple<string, string, string> > () = {yystack_[5].value.as < string > (), yystack_[3].value.as < string > (), yystack_[0].value.as < string > ()};
                                       }
#line 6654 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1827: // o_solve_algo: SOLVE_ALGO EQUAL INT_NUMBER
#line 3712 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("solve_algo", yystack_[0].value.as < string > ()); }
#line 6660 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1828: // o_stack_solve_algo: STACK_SOLVE_ALGO EQUAL INT_NUMBER
#line 3713 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("stack_solve_algo", yystack_[0].value.as < string > ()); }
#line 6666 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1829: // o_robust_lin_solve: ROBUST_LIN_SOLVE
#line 3714 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("simul.robust_lin_solve", "true"); }
#line 6672 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1830: // o_endogenous_terminal_period: ENDOGENOUS_TERMINAL_PERIOD
#line 3715 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("endogenous_terminal_period", "true"); }
#line 6678 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1831: // o_order: ORDER EQUAL INT_NUMBER
#line 3716 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("order", yystack_[0].value.as < string > ()); }
#line 6684 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1832: // o_replic: REPLIC EQUAL INT_NUMBER
#line 3717 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("replic", yystack_[0].value.as < string > ()); }
#line 6690 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1833: // o_drop: DROP EQUAL INT_NUMBER
#line 3718 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("drop", yystack_[0].value.as < string > ()); }
#line 6696 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1834: // o_ar: AR EQUAL INT_NUMBER
#line 3719 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("ar", yystack_[0].value.as < string > ()); }
#line 6702 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1835: // o_nocorr: NOCORR
#line 3720 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("nocorr", "true"); }
#line 6708 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1836: // o_nofunctions: NOFUNCTIONS
#line 3721 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("nofunctions", "true"); }
#line 6714 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1837: // o_nomoments: NOMOMENTS
#line 3722 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("nomoments", "true"); }
#line 6720 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1838: // o_nomodelsummary: NOMODELSUMMARY
#line 3723 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("nomodelsummary", "true"); }
#line 6726 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1839: // o_irf: IRF EQUAL INT_NUMBER
#line 3724 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("irf", yystack_[0].value.as < string > ()); }
#line 6732 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1840: // o_irf_shocks: IRF_SHOCKS EQUAL '(' symbol_list ')'
#line 3725 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_symbol_list("irf_shocks", yystack_[1].value.as < vector<string> > ()); }
#line 6738 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1841: // o_hp_filter: HP_FILTER EQUAL non_negative_number
#line 3726 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("hp_filter", yystack_[0].value.as < string > ()); }
#line 6744 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1842: // o_hp_ngrid: HP_NGRID EQUAL INT_NUMBER
#line 3727 "../preprocessor/src/DynareBison.yy"
                                       {
                                         driver.warning("The 'hp_ngrid' option is deprecated. It has been superseded by the 'filtered_theoretical_moments_grid' option.");
                                         driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ());
                                       }
#line 6753 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1843: // o_filtered_theoretical_moments_grid: FILTERED_THEORETICAL_MOMENTS_GRID EQUAL INT_NUMBER
#line 3731 "../preprocessor/src/DynareBison.yy"
                                                                                         { driver.option_num("filtered_theoretical_moments_grid", yystack_[0].value.as < string > ()); }
#line 6759 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1844: // o_one_sided_hp_filter: ONE_SIDED_HP_FILTER EQUAL non_negative_number
#line 3732 "../preprocessor/src/DynareBison.yy"
                                                                      { driver.option_num("one_sided_hp_filter", yystack_[0].value.as < string > ()); }
#line 6765 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1845: // o_periods: PERIODS EQUAL INT_NUMBER
#line 3733 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("periods", yystack_[0].value.as < string > ()); }
#line 6771 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1846: // o_solver_periods: SOLVER_PERIODS EQUAL INT_NUMBER
#line 3734 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("ep.periods", yystack_[0].value.as < string > ()); }
#line 6777 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1847: // o_extended_path_order: ORDER EQUAL INT_NUMBER
#line 3735 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("ep.stochastic.order", yystack_[0].value.as < string > ()); }
#line 6783 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1848: // o_hybrid: HYBRID
#line 3736 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ep.stochastic.hybrid_order", "2"); }
#line 6789 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1849: // o_use_first_order_solution: USE_FIRST_ORDER_SOLUTION
#line 3737 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("ep.use_first_order_solution_as_initial_guess", "true"); }
#line 6795 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1850: // o_steady_maxit: MAXIT EQUAL INT_NUMBER
#line 3738 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("steady.maxit", yystack_[0].value.as < string > ()); }
#line 6801 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1851: // o_simul_maxit: MAXIT EQUAL INT_NUMBER
#line 3739 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 6807 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1852: // o_bandpass_filter: BANDPASS_FILTER
#line 3740 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("bandpass.indicator", "true"); }
#line 6813 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1853: // o_bandpass_filter: BANDPASS_FILTER EQUAL vec_int
#line 3742 "../preprocessor/src/DynareBison.yy"
                    {
                      driver.option_num("bandpass.indicator", "true");
                      driver.option_vec_int("bandpass.passband", yystack_[0].value.as < vector<int> > ());
                    }
#line 6822 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1854: // o_dp_maxit: MAXIT EQUAL INT_NUMBER
#line 3747 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("dp.maxit", yystack_[0].value.as < string > ()); }
#line 6828 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1855: // o_osr_maxit: MAXIT EQUAL INT_NUMBER
#line 3748 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("osr.maxit", yystack_[0].value.as < string > ()); }
#line 6834 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1856: // o_osr_tolf: TOLF EQUAL non_negative_number
#line 3749 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("osr.tolf", yystack_[0].value.as < string > ()); }
#line 6840 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1857: // o_pf_tolf: TOLF EQUAL non_negative_number
#line 3750 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("dynatol.f", yystack_[0].value.as < string > ()); }
#line 6846 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1858: // o_pf_tolx: TOLX EQUAL non_negative_number
#line 3751 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("dynatol.x", yystack_[0].value.as < string > ()); }
#line 6852 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1859: // o_steady_tolf: TOLF EQUAL non_negative_number
#line 3752 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("solve_tolf", yystack_[0].value.as < string > ()); }
#line 6858 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1860: // o_steady_tolx: TOLX EQUAL non_negative_number
#line 3753 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("solve_tolx", yystack_[0].value.as < string > ()); }
#line 6864 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1861: // o_opt_algo: OPT_ALGO EQUAL INT_NUMBER
#line 3754 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 6870 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1862: // o_opt_algo: OPT_ALGO EQUAL filename
#line 3755 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("osr.opt_algo", yystack_[0].value.as < string > ()); }
#line 6876 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1863: // o_markowitz: MARKOWITZ EQUAL non_negative_number
#line 3757 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("markowitz", yystack_[0].value.as < string > ()); }
#line 6882 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1864: // o_pf_steady_solve_algo: STEADY_SOLVE_ALGO EQUAL INT_NUMBER
#line 3760 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("simul.steady_solve_algo", yystack_[0].value.as < string > ()); }
#line 6888 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1865: // o_pf_steady_maxit: STEADY_MAXIT EQUAL INT_NUMBER
#line 3761 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("simul.steady_maxit", yystack_[0].value.as < string > ()); }
#line 6894 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1866: // o_pf_steady_tolf: STEADY_TOLF EQUAL non_negative_number
#line 3762 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("simul.steady_tolf", yystack_[0].value.as < string > ()); }
#line 6900 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1867: // o_pf_steady_tolx: STEADY_TOLX EQUAL non_negative_number
#line 3763 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("simul.steady_tolx", yystack_[0].value.as < string > ()); }
#line 6906 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1868: // o_pf_steady_markowitz: STEADY_MARKOWITZ EQUAL non_negative_number
#line 3764 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("simul.steady_markowitz", yystack_[0].value.as < string > ()); }
#line 6912 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1869: // o_minimal_solving_periods: MINIMAL_SOLVING_PERIODS EQUAL non_negative_number
#line 3766 "../preprocessor/src/DynareBison.yy"
                                                                              { driver.option_num("minimal_solving_periods", yystack_[0].value.as < string > ()); }
#line 6918 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1870: // o_simul_replic: SIMUL_REPLIC EQUAL INT_NUMBER
#line 3767 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("simul_replic", yystack_[0].value.as < string > ()); }
#line 6924 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1871: // o_qz_criterium: QZ_CRITERIUM EQUAL non_negative_number
#line 3768 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("qz_criterium", yystack_[0].value.as < string > ()); }
#line 6930 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1872: // o_qz_zero_threshold: QZ_ZERO_THRESHOLD EQUAL non_negative_number
#line 3769 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("qz_zero_threshold", yystack_[0].value.as < string > ()); }
#line 6936 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1873: // o_file: FILE EQUAL filename
#line 3770 "../preprocessor/src/DynareBison.yy"
                             { driver.option_str("file", yystack_[0].value.as < string > ()); }
#line 6942 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1874: // o_pac_name: MODEL_NAME EQUAL symbol
#line 3771 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("pac.model_name", yystack_[0].value.as < string > ()); }
#line 6948 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1875: // o_pac_aux_model_name: AUXILIARY_MODEL_NAME EQUAL symbol
#line 3772 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_str("pac.aux_model_name", yystack_[0].value.as < string > ()); }
#line 6954 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1876: // o_pac_discount: DISCOUNT EQUAL symbol
#line 3773 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_str("pac.discount", yystack_[0].value.as < string > ()); }
#line 6960 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1877: // $@35: %empty
#line 3774 "../preprocessor/src/DynareBison.yy"
                      { driver.begin_model(); }
#line 6966 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1878: // o_pac_growth: GROWTH $@35 EQUAL hand_side
#line 3774 "../preprocessor/src/DynareBison.yy"
                                                                { driver.set_pac_growth(yystack_[0].value.as < expr_t > ()); }
#line 6972 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1879: // o_pac_auxname: AUXNAME EQUAL symbol
#line 3775 "../preprocessor/src/DynareBison.yy"
                                     { driver.set_pac_auxname(yystack_[0].value.as < string > ()); }
#line 6978 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1880: // o_pac_kind: KIND EQUAL pac_target_kind
#line 3776 "../preprocessor/src/DynareBison.yy"
                                        { driver.set_pac_kind(yystack_[0].value.as < PacTargetKind > ()); }
#line 6984 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1881: // o_var_name: MODEL_NAME EQUAL symbol
#line 3777 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("var.model_name", yystack_[0].value.as < string > ()); }
#line 6990 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1882: // o_series: SERIES EQUAL symbol
#line 3778 "../preprocessor/src/DynareBison.yy"
                               { driver.option_str("series", yystack_[0].value.as < string > ()); }
#line 6996 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1883: // o_datafile: DATAFILE EQUAL filename
#line 3779 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("datafile", yystack_[0].value.as < string > ()); }
#line 7002 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1884: // o_filename: FILENAME EQUAL filename
#line 3780 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("filename", yystack_[0].value.as < string > ()); }
#line 7008 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1885: // o_var_eq_tags: EQTAGS EQUAL vec_str
#line 3781 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_vec_str("var.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 7014 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1886: // o_var_structural: STRUCTURAL
#line 3782 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("var.structural", "true"); }
#line 7020 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1887: // o_dirname: DIRNAME EQUAL filename
#line 3783 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_str("dirname", yystack_[0].value.as < string > ()); }
#line 7026 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1888: // o_huge_number: HUGE_NUMBER EQUAL non_negative_number
#line 3784 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("huge_number", yystack_[0].value.as < string > ()); }
#line 7032 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1889: // o_nobs: NOBS EQUAL vec_int
#line 3786 "../preprocessor/src/DynareBison.yy"
         { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 7038 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1890: // o_nobs: NOBS EQUAL vec_int_number
#line 3788 "../preprocessor/src/DynareBison.yy"
         { driver.option_vec_int("nobs", yystack_[0].value.as < vector<int> > ()); }
#line 7044 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1891: // o_trend_component_model_name: MODEL_NAME EQUAL symbol
#line 3790 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_str("trend_component.name", yystack_[0].value.as < string > ()); }
#line 7050 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1892: // o_trend_component_model_targets: TARGETS EQUAL vec_str
#line 3791 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_vec_str("trend_component.targets", yystack_[0].value.as < vector<string> > ()); }
#line 7056 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1893: // o_trend_component_model_eq_tags: EQTAGS EQUAL vec_str
#line 3792 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_vec_str("trend_component.eqtags", yystack_[0].value.as < vector<string> > ()); }
#line 7062 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1894: // o_conditional_variance_decomposition: CONDITIONAL_VARIANCE_DECOMPOSITION EQUAL vec_int
#line 3794 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 7068 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1895: // o_conditional_variance_decomposition: CONDITIONAL_VARIANCE_DECOMPOSITION EQUAL vec_int_number
#line 3796 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_vec_int("conditional_variance_decomposition", yystack_[0].value.as < vector<int> > ()); }
#line 7074 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1896: // o_est_first_obs: FIRST_OBS EQUAL vec_int
#line 3799 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 7080 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1897: // o_est_first_obs: FIRST_OBS EQUAL vec_int_number
#line 3801 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("first_obs", yystack_[0].value.as < vector<int> > ()); }
#line 7086 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1898: // o_posterior_sampling_method: POSTERIOR_SAMPLING_METHOD EQUAL QUOTED_STRING
#line 3804 "../preprocessor/src/DynareBison.yy"
                              { driver.option_str("posterior_sampler_options.posterior_sampling_method", yystack_[0].value.as < string > ()); }
#line 7092 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1899: // o_first_obs: FIRST_OBS EQUAL INT_NUMBER
#line 3805 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("first_obs", yystack_[0].value.as < string > ()); }
#line 7098 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1900: // o_data_first_obs: FIRST_OBS EQUAL date_expr
#line 3806 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_date("first_obs", yystack_[0].value.as < string > ()); }
#line 7104 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1901: // o_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL INT_NUMBER
#line 3807 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_num("first_simulation_period", yystack_[0].value.as < string > ()); }
#line 7110 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1902: // o_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL date_expr
#line 3808 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_date("first_simulation_period", yystack_[0].value.as < string > ()); }
#line 7116 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1903: // o_last_simulation_period: LAST_SIMULATION_PERIOD EQUAL INT_NUMBER
#line 3810 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("last_simulation_period", yystack_[0].value.as < string > ()); }
#line 7122 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1904: // o_last_simulation_period: LAST_SIMULATION_PERIOD EQUAL date_expr
#line 3811 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_date("last_simulation_period", yystack_[0].value.as < string > ()); }
#line 7128 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1905: // o_pf_first_simulation_period: FIRST_SIMULATION_PERIOD EQUAL date_expr
#line 3813 "../preprocessor/src/DynareBison.yy"
                                                                       { driver.option_date("simul.first_simulation_period", yystack_[0].value.as < string > ()); }
#line 7134 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1906: // o_pf_last_simulation_period: LAST_SIMULATION_PERIOD EQUAL date_expr
#line 3814 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_date("simul.last_simulation_period", yystack_[0].value.as < string > ()); }
#line 7140 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1907: // o_last_obs: LAST_OBS EQUAL INT_NUMBER
#line 3815 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("last_obs", yystack_[0].value.as < string > ()); }
#line 7146 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1908: // o_data_last_obs: LAST_OBS EQUAL date_expr
#line 3816 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_date("last_obs", yystack_[0].value.as < string > ()); }
#line 7152 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1909: // o_keep_kalman_algo_if_singularity_is_detected: KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED
#line 3817 "../preprocessor/src/DynareBison.yy"
                                                                                            { driver.option_num("kalman.keep_kalman_algo_if_singularity_is_detected", "true"); }
#line 7158 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1910: // o_data_nobs: NOBS EQUAL INT_NUMBER
#line 3818 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("nobs", yystack_[0].value.as < string > ()); }
#line 7164 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1911: // o_shift: SHIFT EQUAL signed_number
#line 3819 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("shift", yystack_[0].value.as < string > ()); }
#line 7170 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1912: // o_shape: SHAPE EQUAL prior_distribution
#line 3820 "../preprocessor/src/DynareBison.yy"
                                         { driver.prior_shape = yystack_[0].value.as < PriorDistributions > (); }
#line 7176 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1913: // o_mode: MODE EQUAL signed_number
#line 3821 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("mode", yystack_[0].value.as < string > ()); }
#line 7182 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1914: // o_mean: MEAN EQUAL signed_number
#line 3822 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("mean", yystack_[0].value.as < string > ()); }
#line 7188 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1915: // o_mean_vec: MEAN EQUAL vec_value
#line 3823 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_vec_value("mean", yystack_[0].value.as < vector<string> > ()); }
#line 7194 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1916: // o_truncate: TRUNCATE EQUAL vec_value
#line 3824 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_vec_value("truncate", yystack_[0].value.as < vector<string> > ()); }
#line 7200 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1917: // o_stdev: STDEV EQUAL non_negative_number
#line 3825 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("stdev", yystack_[0].value.as < string > ()); }
#line 7206 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1918: // o_jscale: JSCALE EQUAL non_negative_number
#line 3826 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("jscale", yystack_[0].value.as < string > ()); }
#line 7212 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1919: // o_init: INIT EQUAL signed_number
#line 3827 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("init", yystack_[0].value.as < string > ()); }
#line 7218 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1920: // o_bounds: BOUNDS EQUAL vec_value_w_inf
#line 3828 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_vec_value("bounds", yystack_[0].value.as < vector<string> > ()); }
#line 7224 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1921: // o_domain: DOMAINN EQUAL vec_value
#line 3829 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_vec_value("domain", yystack_[0].value.as < vector<string> > ()); }
#line 7230 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1922: // o_interval: INTERVAL EQUAL vec_value
#line 3830 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_vec_value("interval", yystack_[0].value.as < vector<string> > ()); }
#line 7236 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1923: // o_variance: VARIANCE EQUAL expression
#line 3831 "../preprocessor/src/DynareBison.yy"
                                       { driver.set_prior_variance(yystack_[0].value.as < expr_t > ()); }
#line 7242 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1924: // o_variance_mat: VARIANCE EQUAL vec_of_vec_value
#line 3832 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_vec_of_vec_value("variance", yystack_[0].value.as < vector<vector<string>> > ()); }
#line 7248 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1925: // o_prefilter: PREFILTER EQUAL INT_NUMBER
#line 3833 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("prefilter", yystack_[0].value.as < string > ()); }
#line 7254 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1926: // o_presample: PRESAMPLE EQUAL INT_NUMBER
#line 3834 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("presample", yystack_[0].value.as < string > ()); }
#line 7260 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1927: // o_lik_init: LIK_INIT EQUAL INT_NUMBER
#line 3835 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("lik_init", yystack_[0].value.as < string > ()); }
#line 7266 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1928: // o_nograph: NOGRAPH
#line 3837 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("nograph", "true"); }
#line 7272 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1929: // o_nograph: GRAPH
#line 3839 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("nograph", "false"); }
#line 7278 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1930: // o_posterior_nograph: POSTERIOR_NOGRAPH
#line 3842 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("no_graph.posterior", "true"); }
#line 7284 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1931: // o_posterior_nograph: POSTERIOR_GRAPH
#line 3844 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("no_graph.posterior", "false"); }
#line 7290 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1932: // o_psd_nograph: NOGRAPH
#line 3846 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("no_graph.plot_shock_decomposition", "true"); }
#line 7296 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1933: // o_shock_decomposition_nograph: NOGRAPH
#line 3847 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("no_graph.shock_decomposition", "true"); }
#line 7302 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1934: // o_init_state: INIT_STATE EQUAL INT_NUMBER
#line 3848 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("shock_decomp.init_state", yystack_[0].value.as < string > ()); }
#line 7308 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1935: // o_forecast_type: FORECAST EQUAL UNCONDITIONAL
#line 3850 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("shock_decomp.forecast_type", "unconditional"); }
#line 7314 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1936: // o_forecast_type: FORECAST EQUAL CONDITIONAL
#line 3852 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("shock_decomp.forecast_type", "conditional"); }
#line 7320 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1937: // o_shock_decomposition_presample: PRESAMPLE EQUAL INT_NUMBER
#line 3853 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("shock_decomp.presample", yystack_[0].value.as < string > ()); }
#line 7326 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1938: // o_shock_decomposition_forecast: FORECAST EQUAL INT_NUMBER
#line 3854 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("shock_decomp.forecast", yystack_[0].value.as < string > ()); }
#line 7332 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1939: // o_save_realtime: SAVE_REALTIME EQUAL vec_int
#line 3855 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_vec_int("shock_decomp.save_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 7338 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1940: // o_fast_realtime: FAST_REALTIME EQUAL vec_int
#line 3857 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("shock_decomp.fast_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 7344 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1941: // o_fast_realtime: FAST_REALTIME EQUAL vec_int_number
#line 3859 "../preprocessor/src/DynareBison.yy"
                  { driver.option_vec_int("shock_decomp.fast_realtime", yystack_[0].value.as < vector<int> > ()); }
#line 7350 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1942: // o_nodisplay: NODISPLAY
#line 3861 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("nodisplay", "true"); }
#line 7356 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1943: // o_icd_nodisplay: NODISPLAY
#line 3862 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("initial_condition_decomp.nodisplay", "true"); }
#line 7362 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1944: // o_psd_nodisplay: NODISPLAY
#line 3863 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("plot_shock_decomp.nodisplay", "true"); }
#line 7368 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1945: // o_psd_init2shocks: INIT2SHOCKS
#line 3864 "../preprocessor/src/DynareBison.yy"
                                { driver.option_str("plot_shock_decomp.init2shocks", "default"); }
#line 7374 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1946: // o_psd_init2shocks: INIT2SHOCKS EQUAL symbol
#line 3865 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_str("plot_shock_decomp.init2shocks", yystack_[0].value.as < string > ()); }
#line 7380 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1947: // o_icd_max_nrows: MAX_NROWS EQUAL INT_NUMBER
#line 3867 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("initial_condition_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 7386 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1948: // o_psd_max_nrows: MAX_NROWS EQUAL INT_NUMBER
#line 3868 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("plot_shock_decomp.max_nrows", yystack_[0].value.as < string > ()); }
#line 7392 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1949: // o_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3870 "../preprocessor/src/DynareBison.yy"
                 { driver.process_graph_format_option(); }
#line 7398 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1950: // o_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3872 "../preprocessor/src/DynareBison.yy"
                 { driver.process_graph_format_option(); }
#line 7404 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1951: // o_icd_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3875 "../preprocessor/src/DynareBison.yy"
                     { driver.initial_condition_decomp_process_graph_format_option(); }
#line 7410 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1952: // o_icd_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3877 "../preprocessor/src/DynareBison.yy"
                     { driver.initial_condition_decomp_process_graph_format_option(); }
#line 7416 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1953: // o_psd_graph_format: GRAPH_FORMAT EQUAL allowed_graph_formats
#line 3880 "../preprocessor/src/DynareBison.yy"
                     { driver.plot_shock_decomp_process_graph_format_option(); }
#line 7422 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1954: // o_psd_graph_format: GRAPH_FORMAT EQUAL '(' list_allowed_graph_formats ')'
#line 3882 "../preprocessor/src/DynareBison.yy"
                     { driver.plot_shock_decomp_process_graph_format_option(); }
#line 7428 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1955: // o_shock_decomposition_with_epilogue: WITH_EPILOGUE
#line 3884 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_num("shock_decomp.with_epilogue", "true"); }
#line 7434 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1956: // o_icd_with_epilogue: WITH_EPILOGUE
#line 3885 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("initial_condition_decomp.with_epilogue", "true"); }
#line 7440 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1957: // allowed_graph_formats: EPS
#line 3887 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("eps"); }
#line 7446 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1958: // allowed_graph_formats: FIG
#line 3889 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("fig"); }
#line 7452 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1959: // allowed_graph_formats: PDF
#line 3891 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("pdf"); }
#line 7458 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1960: // allowed_graph_formats: NONE
#line 3893 "../preprocessor/src/DynareBison.yy"
                        { driver.add_graph_format("none"); }
#line 7464 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1963: // o_subsample_name: symbol EQUAL date_expr ':' date_expr
#line 3900 "../preprocessor/src/DynareBison.yy"
                   { driver.set_subsample_name_equal_to_date_range(yystack_[4].value.as < string > (), yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()); }
#line 7470 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1964: // o_bvar_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3902 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("bvar.conf_sig", yystack_[0].value.as < string > ()); }
#line 7476 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1965: // o_forecasts_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3903 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("forecasts.conf_sig", yystack_[0].value.as < string > ()); }
#line 7482 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1966: // o_conditional_forecast_conf_sig: CONF_SIG EQUAL non_negative_number
#line 3904 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_num("conditional_forecast.conf_sig", yystack_[0].value.as < string > ()); }
#line 7488 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1967: // o_mh_conf_sig: MH_CONF_SIG EQUAL non_negative_number
#line 3905 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("mh_conf_sig", yystack_[0].value.as < string > ()); }
#line 7494 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1968: // o_mh_replic: MH_REPLIC EQUAL INT_NUMBER
#line 3906 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("mh_replic", yystack_[0].value.as < string > ()); }
#line 7500 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1969: // o_posterior_max_subsample_draws: POSTERIOR_MAX_SUBSAMPLE_DRAWS EQUAL INT_NUMBER
#line 3907 "../preprocessor/src/DynareBison.yy"
                                                                                 { driver.option_num("posterior_max_subsample_draws", yystack_[0].value.as < string > ()); }
#line 7506 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1970: // o_mh_drop: MH_DROP EQUAL non_negative_number
#line 3908 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("mh_drop", yystack_[0].value.as < string > ()); }
#line 7512 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1971: // o_mh_jscale: MH_JSCALE EQUAL non_negative_number
#line 3909 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("mh_jscale", yystack_[0].value.as < string > ()); }
#line 7518 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1972: // o_mh_tune_jscale: MH_TUNE_JSCALE EQUAL non_negative_number
#line 3911 "../preprocessor/src/DynareBison.yy"
                 { driver.option_num("mh_tune_jscale.target", yystack_[0].value.as < string > ()); driver.option_num("mh_tune_jscale.status", "true"); }
#line 7524 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1973: // o_mh_tune_jscale: MH_TUNE_JSCALE
#line 3912 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("mh_tune_jscale.status", "true"); }
#line 7530 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1974: // o_mh_tune_guess: MH_TUNE_GUESS EQUAL non_negative_number
#line 3913 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("mh_tune_jscale.guess", yystack_[0].value.as < string > ()); }
#line 7536 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1975: // o_optim: OPTIM EQUAL '(' name_value_pair_with_boolean_list ')'
#line 3914 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_str("optim_opt", yystack_[1].value.as < string > ()); }
#line 7542 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1976: // o_posterior_sampler_options: POSTERIOR_SAMPLER_OPTIONS EQUAL '(' name_value_pair_with_suboptions_list ')'
#line 3915 "../preprocessor/src/DynareBison.yy"
                                                                                                           { driver.option_str("posterior_sampler_options.sampling_opt", yystack_[1].value.as < string > ()); }
#line 7548 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1977: // o_proposal_distribution: PROPOSAL_DISTRIBUTION EQUAL symbol
#line 3916 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_str("posterior_sampler_options.posterior_sampling_method.proposal_distribution", yystack_[0].value.as < string > ()); }
#line 7554 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1978: // o_no_posterior_kernel_density: NO_POSTERIOR_KERNEL_DENSITY
#line 3918 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("estimation.moments_posterior_density.indicator", "false"); }
#line 7560 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1979: // o_mh_init_scale: MH_INIT_SCALE EQUAL non_negative_number
#line 3920 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("mh_init_scale", yystack_[0].value.as < string > ()); }
#line 7566 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1980: // o_mh_init_scale_factor: MH_INIT_SCALE_FACTOR EQUAL non_negative_number
#line 3921 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_num("mh_init_scale_factor", yystack_[0].value.as < string > ()); }
#line 7572 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1981: // o_mode_file: MODE_FILE EQUAL filename
#line 3922 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_str("mode_file", yystack_[0].value.as < string > ()); }
#line 7578 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1982: // o_mode_compute: MODE_COMPUTE EQUAL INT_NUMBER
#line 3923 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("mode_compute", yystack_[0].value.as < string > ()); }
#line 7584 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1983: // o_mode_compute: MODE_COMPUTE EQUAL symbol
#line 3924 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_str("mode_compute", yystack_[0].value.as < string > ()); }
#line 7590 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1984: // o_mode_check: MODE_CHECK
#line 3925 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("mode_check.status", "true"); }
#line 7596 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1985: // o_mode_check_neighbourhood_size: MODE_CHECK_NEIGHBOURHOOD_SIZE EQUAL signed_number_w_inf
#line 3926 "../preprocessor/src/DynareBison.yy"
                                                                                          { driver.option_num("mode_check.neighbourhood_size", yystack_[0].value.as < string > ()); }
#line 7602 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1986: // o_mode_check_number_of_points: MODE_CHECK_NUMBER_OF_POINTS EQUAL INT_NUMBER
#line 3927 "../preprocessor/src/DynareBison.yy"
                                                                             { driver.option_num("mode_check.number_of_points", yystack_[0].value.as < string > ()); }
#line 7608 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1987: // o_mode_check_symmetric_plots: MODE_CHECK_SYMMETRIC_PLOTS EQUAL INT_NUMBER
#line 3928 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.option_num("mode_check.symmetric_plots", yystack_[0].value.as < string > ()); }
#line 7614 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1988: // o_prior_trunc: PRIOR_TRUNC EQUAL non_negative_number
#line 3929 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("prior_trunc", yystack_[0].value.as < string > ()); }
#line 7620 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1989: // o_mh_posterior_mode_estimation: MH_POSTERIOR_MODE_ESTIMATION
#line 3930 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("mh_posterior_mode_estimation", "true"); }
#line 7626 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1990: // o_mh_nblocks: MH_NBLOCKS EQUAL INT_NUMBER
#line 3931 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("mh_nblck", yystack_[0].value.as < string > ()); }
#line 7632 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1991: // o_load_mh_file: LOAD_MH_FILE
#line 3932 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("load_mh_file", "true"); }
#line 7638 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1992: // o_load_results_after_load_mh: LOAD_RESULTS_AFTER_LOAD_MH
#line 3933 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("load_results_after_load_mh", "true"); }
#line 7644 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1993: // o_loglinear: LOGLINEAR
#line 3934 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("loglinear", "true"); }
#line 7650 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1994: // o_linear_approximation: LINEAR_APPROXIMATION
#line 3935 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("linear_approximation", "true"); }
#line 7656 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1995: // o_logdata: LOGDATA
#line 3936 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("logdata", "true"); }
#line 7662 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1996: // o_conditional_likelihood: CONDITIONAL_LIKELIHOOD
#line 3937 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("conditional_likelihood.status", "true"); }
#line 7668 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1997: // o_nodiagnostic: NODIAGNOSTIC
#line 3938 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("nodiagnostic", "true"); }
#line 7674 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1998: // o_bayesian_irf: BAYESIAN_IRF
#line 3939 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("bayesian_irf", "true"); }
#line 7680 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 1999: // o_dsge_var: DSGE_VAR EQUAL non_negative_number
#line 3941 "../preprocessor/src/DynareBison.yy"
             { driver.option_num("dsge_var", yystack_[0].value.as < string > ()); }
#line 7686 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2000: // o_dsge_var: DSGE_VAR EQUAL INF_CONSTANT
#line 3943 "../preprocessor/src/DynareBison.yy"
             { driver.option_num("dsge_var", "Inf"); }
#line 7692 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2001: // o_dsge_var: DSGE_VAR
#line 3945 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("dsge_var", "NaN"); }
#line 7698 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2002: // o_dsge_varlag: DSGE_VARLAG EQUAL INT_NUMBER
#line 3947 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("dsge_varlag", yystack_[0].value.as < string > ()); }
#line 7704 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2003: // o_tex: TEX
#line 3948 "../preprocessor/src/DynareBison.yy"
            { driver.option_num("TeX", "true"); }
#line 7710 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2004: // o_forecast: FORECAST EQUAL INT_NUMBER
#line 3949 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("forecast", yystack_[0].value.as < string > ()); }
#line 7716 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2005: // o_smoother: SMOOTHER
#line 3950 "../preprocessor/src/DynareBison.yy"
                      { driver.option_num("smoother", "true"); }
#line 7722 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2006: // o_moments_varendo: MOMENTS_VARENDO
#line 3951 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("moments_varendo", "true"); }
#line 7728 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2007: // o_contemporaneous_correlation: CONTEMPORANEOUS_CORRELATION
#line 3952 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("contemporaneous_correlation", "true"); }
#line 7734 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2008: // o_filtered_vars: FILTERED_VARS
#line 3953 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("filtered_vars", "true"); }
#line 7740 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2009: // o_relative_irf: RELATIVE_IRF
#line 3954 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("relative_irf", "true"); }
#line 7746 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2010: // o_fast_kalman_filter: FAST_KALMAN_FILTER
#line 3955 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("fast_kalman_filter", "true"); }
#line 7752 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2011: // o_kalman_algo: KALMAN_ALGO EQUAL INT_NUMBER
#line 3956 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("kalman_algo", yystack_[0].value.as < string > ()); }
#line 7758 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2012: // o_kalman_tol: KALMAN_TOL EQUAL non_negative_number
#line 3957 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_num("kalman_tol", yystack_[0].value.as < string > ()); }
#line 7764 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2013: // o_diffuse_kalman_tol: DIFFUSE_KALMAN_TOL EQUAL non_negative_number
#line 3958 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("diffuse_kalman_tol", yystack_[0].value.as < string > ()); }
#line 7770 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2014: // o_schur_vec_tol: SCHUR_VEC_TOL EQUAL non_negative_number
#line 3959 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("schur_vec_tol", yystack_[0].value.as < string > ()); }
#line 7776 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2015: // o_marginal_density: MARGINAL_DENSITY EQUAL LAPLACE
#line 3961 "../preprocessor/src/DynareBison.yy"
                     { driver.option_str("mc_marginal_density", "laplace"); }
#line 7782 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2016: // o_marginal_density: MARGINAL_DENSITY EQUAL MODIFIEDHARMONICMEAN
#line 3963 "../preprocessor/src/DynareBison.yy"
                     { driver.option_str("mc_marginal_density", "modifiedharmonicmean"); }
#line 7788 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2017: // o_print: PRINT
#line 3965 "../preprocessor/src/DynareBison.yy"
                { driver.option_num("noprint", "false"); }
#line 7794 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2018: // o_noprint: NOPRINT
#line 3966 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("noprint", "true"); }
#line 7800 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2019: // o_xls_sheet: XLS_SHEET EQUAL symbol
#line 3967 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 7806 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2020: // o_xls_sheet: XLS_SHEET EQUAL QUOTED_STRING
#line 3968 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_str("xls_sheet", yystack_[0].value.as < string > ()); }
#line 7812 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2021: // o_xls_range: XLS_RANGE EQUAL range
#line 3970 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_str("xls_range", yystack_[0].value.as < string > ()); }
#line 7818 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2022: // o_filter_step_ahead: FILTER_STEP_AHEAD EQUAL vec_int
#line 3971 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_vec_int("filter_step_ahead", yystack_[0].value.as < vector<int> > ()); }
#line 7824 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2023: // o_taper_steps: TAPER_STEPS EQUAL vec_int
#line 3972 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_vec_int("convergence.geweke.taper_steps", yystack_[0].value.as < vector<int> > ()); }
#line 7830 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2024: // o_geweke_interval: GEWEKE_INTERVAL EQUAL vec_value
#line 3973 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_vec_value("convergence.geweke.geweke_interval", yystack_[0].value.as < vector<string> > ()); }
#line 7836 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2025: // o_raftery_lewis_diagnostics: RAFTERY_LEWIS_DIAGNOSTICS
#line 3974 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("convergence.rafterylewis.indicator", "true"); }
#line 7842 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2026: // o_raftery_lewis_qrs: RAFTERY_LEWIS_QRS EQUAL vec_value
#line 3975 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_vec_value("convergence.rafterylewis.qrs", yystack_[0].value.as < vector<string> > ()); }
#line 7848 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2027: // o_brooks_gelman_plotrows: BROOKS_GELMAN_PLOTROWS EQUAL INT_NUMBER
#line 3976 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("convergence.brooksgelman.plotrows", yystack_[0].value.as < string > ()); }
#line 7854 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2028: // o_constant: CONSTANT
#line 3977 "../preprocessor/src/DynareBison.yy"
                      { driver.option_num("noconstant", "false"); }
#line 7860 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2029: // o_noconstant: NOCONSTANT
#line 3978 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("noconstant", "true"); }
#line 7866 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2030: // o_mh_recover: MH_RECOVER
#line 3979 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("mh_recover", "true"); }
#line 7872 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2031: // o_mh_initialize_from_previous_mcmc: MH_INITIALIZE_FROM_PREVIOUS_MCMC
#line 3980 "../preprocessor/src/DynareBison.yy"
                                                                      { driver.option_num("mh_initialize_from_previous_mcmc.status", "true"); }
#line 7878 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2032: // o_mh_initialize_from_previous_mcmc_directory: MH_INITIALIZE_FROM_PREVIOUS_MCMC_DIRECTORY EQUAL filename
#line 3981 "../preprocessor/src/DynareBison.yy"
                                                                                                         { driver.option_str("mh_initialize_from_previous_mcmc.directory", yystack_[0].value.as < string > ()); }
#line 7884 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2033: // o_mh_initialize_from_previous_mcmc_record: MH_INITIALIZE_FROM_PREVIOUS_MCMC_RECORD EQUAL filename
#line 3982 "../preprocessor/src/DynareBison.yy"
                                                                                                   { driver.option_str("mh_initialize_from_previous_mcmc.record", yystack_[0].value.as < string > ()); }
#line 7890 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2034: // o_mh_initialize_from_previous_mcmc_prior: MH_INITIALIZE_FROM_PREVIOUS_MCMC_PRIOR EQUAL filename
#line 3983 "../preprocessor/src/DynareBison.yy"
                                                                                                 { driver.option_str("mh_initialize_from_previous_mcmc.prior", yystack_[0].value.as < string > ()); }
#line 7896 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2035: // o_diffuse_filter: DIFFUSE_FILTER
#line 3984 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("diffuse_filter", "true"); }
#line 7902 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2036: // o_plot_priors: PLOT_PRIORS EQUAL INT_NUMBER
#line 3985 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("plot_priors", yystack_[0].value.as < string > ()); }
#line 7908 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2037: // o_aim_solver: AIM_SOLVER
#line 3986 "../preprocessor/src/DynareBison.yy"
                         { driver.option_num("aim_solver", "true"); }
#line 7914 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2038: // o_partial_information: PARTIAL_INFORMATION
#line 3987 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("partial_information", "true"); }
#line 7920 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2039: // o_sub_draws: SUB_DRAWS EQUAL INT_NUMBER
#line 3988 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("sub_draws", yystack_[0].value.as < string > ()); }
#line 7926 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2040: // o_planner_discount: PLANNER_DISCOUNT EQUAL expression
#line 3989 "../preprocessor/src/DynareBison.yy"
                                                       { driver.set_planner_discount(yystack_[0].value.as < expr_t > ()); }
#line 7932 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2041: // o_planner_discount_latex_name: PLANNER_DISCOUNT_LATEX_NAME EQUAL TEX_NAME
#line 3990 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.set_planner_discount_latex_name(yystack_[0].value.as < string > ()); }
#line 7938 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2042: // o_lyapunov: LYAPUNOV EQUAL FIXED_POINT
#line 3991 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("lyapunov_fp", "true"); }
#line 7944 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2043: // o_lyapunov: LYAPUNOV EQUAL DOUBLING
#line 3992 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("lyapunov_db", "true"); }
#line 7950 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2044: // o_lyapunov: LYAPUNOV EQUAL SQUARE_ROOT_SOLVER
#line 3993 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("lyapunov_srs", "true"); }
#line 7956 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2045: // o_lyapunov: LYAPUNOV EQUAL DEFAULT
#line 3994 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("lyapunov_fp", "false"); driver.option_num("lyapunov_db", "false"); driver.option_num("lyapunov_srs", "false"); }
#line 7962 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2046: // o_lyapunov_complex_threshold: LYAPUNOV_COMPLEX_THRESHOLD EQUAL non_negative_number
#line 3995 "../preprocessor/src/DynareBison.yy"
                                                                                    { driver.option_num("lyapunov_complex_threshold", yystack_[0].value.as < string > ()); }
#line 7968 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2047: // o_lyapunov_fixed_point_tol: LYAPUNOV_FIXED_POINT_TOL EQUAL non_negative_number
#line 3996 "../preprocessor/src/DynareBison.yy"
                                                                                { driver.option_num("lyapunov_fixed_point_tol", yystack_[0].value.as < string > ()); }
#line 7974 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2048: // o_lyapunov_doubling_tol: LYAPUNOV_DOUBLING_TOL EQUAL non_negative_number
#line 3997 "../preprocessor/src/DynareBison.yy"
                                                                          { driver.option_num("lyapunov_doubling_tol", yystack_[0].value.as < string > ()); }
#line 7980 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2049: // o_dr: DR EQUAL CYCLE_REDUCTION
#line 3998 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("dr_cycle_reduction", "true"); }
#line 7986 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2050: // o_dr: DR EQUAL LOGARITHMIC_REDUCTION
#line 3999 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("dr_logarithmic_reduction", "true"); }
#line 7992 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2051: // o_dr: DR EQUAL DEFAULT
#line 4000 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("dr_cycle_reduction", "false"); driver.option_num("dr_logarithmic_reduction", "false"); }
#line 7998 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2052: // o_dr_cycle_reduction_tol: DR_CYCLE_REDUCTION_TOL EQUAL non_negative_number
#line 4001 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("dr_cycle_reduction_tol", yystack_[0].value.as < string > ()); }
#line 8004 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2053: // o_dr_cycle_reduction_maxiter: DR_CYCLE_REDUCTION_MAXITER EQUAL INT_NUMBER
#line 4002 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.option_num("dr_cycle_reduction_maxiter", yystack_[0].value.as < string > ()); }
#line 8010 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2054: // o_dr_logarithmic_reduction_tol: DR_LOGARITHMIC_REDUCTION_TOL EQUAL non_negative_number
#line 4003 "../preprocessor/src/DynareBison.yy"
                                                                                        { driver.option_num("dr_logarithmic_reduction_tol", yystack_[0].value.as < string > ()); }
#line 8016 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2055: // o_dr_logarithmic_reduction_maxiter: DR_LOGARITHMIC_REDUCTION_MAXITER EQUAL INT_NUMBER
#line 4004 "../preprocessor/src/DynareBison.yy"
                                                                                       { driver.option_num("dr_logarithmic_reduction_maxiter", yystack_[0].value.as < string > ()); }
#line 8022 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2056: // o_psd_detail_plot: DETAIL_PLOT
#line 4005 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.detail_plot", "true"); }
#line 8028 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2057: // o_icd_detail_plot: DETAIL_PLOT
#line 4006 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("initial_condition_decomp.detail_plot", "true"); }
#line 8034 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2058: // o_psd_interactive: INTERACTIVE
#line 4007 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.interactive", "true"); }
#line 8040 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2059: // o_psd_screen_shocks: SCREEN_SHOCKS
#line 4008 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("plot_shock_decomp.screen_shocks", "true"); }
#line 8046 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2060: // o_psd_steadystate: STEADYSTATE
#line 4009 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("plot_shock_decomp.steadystate", "true"); }
#line 8052 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2061: // o_icd_steadystate: STEADYSTATE
#line 4010 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("initial_condition_decomp.steadystate", "true"); }
#line 8058 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2062: // o_icd_fig_name: FIG_NAME EQUAL filename
#line 4011 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_str("initial_condition_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 8064 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2063: // o_psd_fig_name: FIG_NAME EQUAL filename
#line 4012 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_str("plot_shock_decomp.fig_name", yystack_[0].value.as < string > ()); }
#line 8070 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2064: // o_psd_type: TYPE EQUAL QOQ
#line 4014 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "qoq"); }
#line 8076 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2065: // o_psd_type: TYPE EQUAL YOY
#line 4016 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "yoy"); }
#line 8082 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2066: // o_psd_type: TYPE EQUAL AOA
#line 4018 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("plot_shock_decomp.type", "aoa"); }
#line 8088 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2067: // o_icd_type: TYPE EQUAL QOQ
#line 4021 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "qoq"); }
#line 8094 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2068: // o_icd_type: TYPE EQUAL YOY
#line 4023 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "yoy"); }
#line 8100 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2069: // o_icd_type: TYPE EQUAL AOA
#line 4025 "../preprocessor/src/DynareBison.yy"
             { driver.option_str("initial_condition_decomp.type", "aoa"); }
#line 8106 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2070: // o_icd_plot_init_date: PLOT_INIT_DATE EQUAL date_expr
#line 4027 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_date("initial_condition_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 8112 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2071: // o_icd_plot_end_date: PLOT_END_DATE EQUAL date_expr
#line 4028 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_date("initial_condition_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 8118 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2072: // o_psd_plot_init_date: PLOT_INIT_DATE EQUAL date_expr
#line 4029 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_date("plot_shock_decomp.plot_init_date", yystack_[0].value.as < string > ()); }
#line 8124 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2073: // o_psd_plot_end_date: PLOT_END_DATE EQUAL date_expr
#line 4030 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_date("plot_shock_decomp.plot_end_date", yystack_[0].value.as < string > ()); }
#line 8130 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2074: // o_icd_write_xls: WRITE_XLS
#line 4031 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("initial_condition_decomp.write_xls", "true"); }
#line 8136 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2075: // o_psd_write_xls: WRITE_XLS
#line 4032 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("plot_shock_decomp.write_xls", "true"); }
#line 8142 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2076: // o_psd_realtime: REALTIME EQUAL INT_NUMBER
#line 4033 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("plot_shock_decomp.realtime", yystack_[0].value.as < string > ()); }
#line 8148 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2077: // o_psd_vintage: VINTAGE EQUAL INT_NUMBER
#line 4034 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("plot_shock_decomp.vintage", yystack_[0].value.as < string > ()); }
#line 8154 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2078: // o_psd_diff: DIFF
#line 4035 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("plot_shock_decomp.diff", "true"); }
#line 8160 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2079: // o_icd_diff: DIFF
#line 4036 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("initial_condition_decomp.diff", "true"); }
#line 8166 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2080: // o_psd_flip: FLIP
#line 4037 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("plot_shock_decomp.flip", "true"); }
#line 8172 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2081: // o_icd_flip: FLIP
#line 4038 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("initial_condition_decomp.flip", "true"); }
#line 8178 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2082: // o_bvar_prior_tau: BVAR_PRIOR_TAU EQUAL signed_number
#line 4039 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("bvar_prior_tau", yystack_[0].value.as < string > ()); }
#line 8184 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2083: // o_bvar_prior_decay: BVAR_PRIOR_DECAY EQUAL non_negative_number
#line 4040 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("bvar_prior_decay", yystack_[0].value.as < string > ()); }
#line 8190 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2084: // o_bvar_prior_lambda: BVAR_PRIOR_LAMBDA EQUAL signed_number
#line 4041 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("bvar_prior_lambda", yystack_[0].value.as < string > ()); }
#line 8196 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2085: // o_bvar_prior_mu: BVAR_PRIOR_MU EQUAL non_negative_number
#line 4042 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("bvar_prior_mu", yystack_[0].value.as < string > ()); }
#line 8202 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2086: // o_bvar_prior_omega: BVAR_PRIOR_OMEGA EQUAL INT_NUMBER
#line 4043 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("bvar_prior_omega", yystack_[0].value.as < string > ()); }
#line 8208 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2087: // o_bvar_prior_flat: BVAR_PRIOR_FLAT
#line 4044 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("bvar_prior_flat", "true"); }
#line 8214 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2088: // o_bvar_prior_train: BVAR_PRIOR_TRAIN EQUAL INT_NUMBER
#line 4045 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("bvar_prior_train", yystack_[0].value.as < string > ()); }
#line 8220 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2089: // o_bvar_replic: BVAR_REPLIC EQUAL INT_NUMBER
#line 4046 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("bvar_replic", yystack_[0].value.as < string > ()); }
#line 8226 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2090: // o_stderr_multiples: STDERR_MULTIPLES
#line 4047 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("irf_opt.stderr_multiples", "true"); }
#line 8232 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2091: // o_diagonal_only: DIAGONAL_ONLY
#line 4048 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("irf_opt.diagonal_only", "true"); }
#line 8238 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2092: // o_number_of_particles: NUMBER_OF_PARTICLES EQUAL INT_NUMBER
#line 4049 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("particle.number_of_particles", yystack_[0].value.as < string > ()); }
#line 8244 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2093: // o_particle_filter_options: PARTICLE_FILTER_OPTIONS EQUAL '(' name_value_pair_with_boolean_list ')'
#line 4050 "../preprocessor/src/DynareBison.yy"
                                                                                                    { driver.option_str("particle.particle_filter_options", yystack_[1].value.as < string > ()); }
#line 8250 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2095: // o_resampling: RESAMPLING EQUAL NONE
#line 4052 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.none", "true"); }
#line 8256 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2096: // o_resampling: RESAMPLING EQUAL GENERIC
#line 4053 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("particle.resampling.status.systematic", "false"); driver.option_num("particle.resampling.status.generic", "true"); }
#line 8262 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2097: // o_resampling_threshold: RESAMPLING_THRESHOLD EQUAL non_negative_number
#line 4054 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_num("particle.resampling.threshold", yystack_[0].value.as < string > ()); }
#line 8268 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2098: // o_resampling_method: RESAMPLING_METHOD EQUAL KITAGAWA
#line 4055 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("particle.resampling.method.kitagawa", "true"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 8274 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2099: // o_resampling_method: RESAMPLING_METHOD EQUAL SMOOTH
#line 4056 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "true"); driver.option_num("particle.resampling.smethod.stratified", "false"); }
#line 8280 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2100: // o_resampling_method: RESAMPLING_METHOD EQUAL STRATIFIED
#line 4057 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("particle.resampling.method.kitagawa", "false"); driver.option_num("particle.resampling.method.smooth", "false"); driver.option_num("particle.resampling.method.stratified", "true"); }
#line 8286 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2101: // o_cpf_weights: CPF_WEIGHTS EQUAL AMISANOTRISTANI
#line 4058 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("particle.cpf_weights_method.amisanotristani", "true"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "false"); }
#line 8292 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2102: // o_cpf_weights: CPF_WEIGHTS EQUAL MURRAYJONESPARSLOW
#line 4059 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("particle.cpf_weights_method.amisanotristani", "false"); driver.option_num("particle.cpf_weights_method.murrayjonesparslow", "true"); }
#line 8298 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2103: // o_filter_algorithm: FILTER_ALGORITHM EQUAL symbol
#line 4060 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_str("particle.filter_algorithm", yystack_[0].value.as < string > ()); }
#line 8304 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2104: // o_nonlinear_filter_initialization: NONLINEAR_FILTER_INITIALIZATION EQUAL INT_NUMBER
#line 4061 "../preprocessor/src/DynareBison.yy"
                                                                                     { driver.option_num("particle.initialization", yystack_[0].value.as < string > ()); }
#line 8310 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2105: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL CUBATURE
#line 4062 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_num("particle.proposal_approximation.cubature", "true"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "false"); }
#line 8316 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2106: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL UNSCENTED
#line 4063 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "true"); driver.option_num("particle.proposal_approximation.montecarlo", "false"); }
#line 8322 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2107: // o_proposal_approximation: PROPOSAL_APPROXIMATION EQUAL MONTECARLO
#line 4064 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("particle.proposal_approximation.cubature", "false"); driver.option_num("particle.proposal_approximation.unscented", "false"); driver.option_num("particle.proposal_approximation.montecarlo", "true"); }
#line 8328 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2108: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL CUBATURE
#line 4065 "../preprocessor/src/DynareBison.yy"
                                                                         { driver.option_num("particle.distribution_approximation.cubature", "true"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "false"); }
#line 8334 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2109: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL UNSCENTED
#line 4066 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "true"); driver.option_num("particle.distribution_approximation.montecarlo", "false"); }
#line 8340 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2110: // o_distribution_approximation: DISTRIBUTION_APPROXIMATION EQUAL MONTECARLO
#line 4067 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("particle.distribution_approximation.cubature", "false"); driver.option_num("particle.distribution_approximation.unscented", "false"); driver.option_num("particle.distribution_approximation.montecarlo", "true"); }
#line 8346 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2111: // o_gsa_identification: IDENTIFICATION EQUAL INT_NUMBER
#line 4068 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("identification", yystack_[0].value.as < string > ()); }
#line 8352 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2112: // o_gsa_morris: MORRIS EQUAL INT_NUMBER
#line 4069 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("morris", yystack_[0].value.as < string > ()); }
#line 8358 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2113: // o_gsa_stab: STAB EQUAL INT_NUMBER
#line 4070 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("stab", yystack_[0].value.as < string > ()); }
#line 8364 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2114: // o_gsa_redform: REDFORM EQUAL INT_NUMBER
#line 4071 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("redform", yystack_[0].value.as < string > ()); }
#line 8370 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2115: // o_gsa_pprior: PPRIOR EQUAL INT_NUMBER
#line 4072 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("pprior", yystack_[0].value.as < string > ()); }
#line 8376 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2116: // o_gsa_prior_range: PRIOR_RANGE EQUAL INT_NUMBER
#line 4073 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("prior_range", yystack_[0].value.as < string > ()); }
#line 8382 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2117: // o_gsa_ppost: PPOST EQUAL INT_NUMBER
#line 4074 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("ppost", yystack_[0].value.as < string > ()); }
#line 8388 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2118: // o_gsa_ilptau: ILPTAU EQUAL INT_NUMBER
#line 4075 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ilptau", yystack_[0].value.as < string > ()); }
#line 8394 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2119: // o_gsa_morris_nliv: MORRIS_NLIV EQUAL INT_NUMBER
#line 4076 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("morris_nliv", yystack_[0].value.as < string > ()); }
#line 8400 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2120: // o_gsa_morris_ntra: MORRIS_NTRA EQUAL INT_NUMBER
#line 4077 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("morris_ntra", yystack_[0].value.as < string > ()); }
#line 8406 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2121: // o_gsa_nsam: NSAM EQUAL INT_NUMBER
#line 4078 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("Nsam", yystack_[0].value.as < string > ()); }
#line 8412 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2122: // o_gsa_load_redform: LOAD_REDFORM EQUAL INT_NUMBER
#line 4079 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("load_redform", yystack_[0].value.as < string > ()); }
#line 8418 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2123: // o_gsa_load_rmse: LOAD_RMSE EQUAL INT_NUMBER
#line 4080 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("load_rmse", yystack_[0].value.as < string > ()); }
#line 8424 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2124: // o_gsa_load_stab: LOAD_STAB EQUAL INT_NUMBER
#line 4081 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("load_stab", yystack_[0].value.as < string > ()); }
#line 8430 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2125: // o_gsa_alpha2_stab: ALPHA2_STAB EQUAL non_negative_number
#line 4082 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("alpha2_stab", yystack_[0].value.as < string > ()); }
#line 8436 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2126: // o_gsa_logtrans_redform: LOGTRANS_REDFORM EQUAL INT_NUMBER
#line 4083 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("logtrans_redform", yystack_[0].value.as < string > ()); }
#line 8442 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2127: // o_gsa_threshold_redform: THRESHOLD_REDFORM EQUAL vec_value_w_inf
#line 4084 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_vec_value("threshold_redform", yystack_[0].value.as < vector<string> > ()); }
#line 8448 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2128: // o_gsa_ksstat_redform: KSSTAT_REDFORM EQUAL non_negative_number
#line 4085 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("ksstat_redform", yystack_[0].value.as < string > ()); }
#line 8454 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2129: // o_gsa_alpha2_redform: ALPHA2_REDFORM EQUAL non_negative_number
#line 4086 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("alpha2_redform", yystack_[0].value.as < string > ()); }
#line 8460 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2130: // o_gsa_namendo: NAMENDO EQUAL '(' symbol_list_or_wildcard ')'
#line 4087 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_symbol_list("namendo", yystack_[1].value.as < vector<string> > ()); }
#line 8466 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2131: // o_gsa_namlagendo: NAMLAGENDO EQUAL '(' symbol_list_or_wildcard ')'
#line 4088 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_symbol_list("namlagendo", yystack_[1].value.as < vector<string> > ()); }
#line 8472 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2132: // o_gsa_namexo: NAMEXO EQUAL '(' symbol_list_or_wildcard ')'
#line 4089 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_symbol_list("namexo", yystack_[1].value.as < vector<string> > ()); }
#line 8478 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2133: // o_gsa_rmse: RMSE EQUAL INT_NUMBER
#line 4090 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("rmse", yystack_[0].value.as < string > ()); }
#line 8484 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2134: // o_gsa_lik_only: LIK_ONLY EQUAL INT_NUMBER
#line 4091 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("lik_only", yystack_[0].value.as < string > ()); }
#line 8490 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2135: // o_gsa_var_rmse: VAR_RMSE EQUAL '(' symbol_list_or_wildcard ')'
#line 4092 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_symbol_list("var_rmse", yystack_[1].value.as < vector<string> > ()); }
#line 8496 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2136: // o_gsa_pfilt_rmse: PFILT_RMSE EQUAL non_negative_number
#line 4093 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("pfilt_rmse", yystack_[0].value.as < string > ()); }
#line 8502 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2137: // o_gsa_istart_rmse: ISTART_RMSE EQUAL INT_NUMBER
#line 4094 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("istart_rmse", yystack_[0].value.as < string > ()); }
#line 8508 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2138: // o_gsa_alpha_rmse: ALPHA_RMSE EQUAL non_negative_number
#line 4095 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("alpha_rmse", yystack_[0].value.as < string > ()); }
#line 8514 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2139: // o_gsa_alpha2_rmse: ALPHA2_RMSE EQUAL non_negative_number
#line 4096 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("alpha2_rmse", yystack_[0].value.as < string > ()); }
#line 8520 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2140: // o_gsa_sample_file: GSA_SAMPLE_FILE EQUAL INT_NUMBER
#line 4098 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 8526 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2141: // o_gsa_sample_file: GSA_SAMPLE_FILE EQUAL filename
#line 4100 "../preprocessor/src/DynareBison.yy"
                    { driver.option_str("gsa_sample_file", yystack_[0].value.as < string > ()); }
#line 8532 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2142: // o_gsa_neighborhood_width: NEIGHBORHOOD_WIDTH EQUAL non_negative_number
#line 4102 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_num("neighborhood_width", yystack_[0].value.as < string > ()); }
#line 8538 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2143: // o_gsa_pvalue_ks: PVALUE_KS EQUAL non_negative_number
#line 4103 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("pvalue_ks", yystack_[0].value.as < string > ()); }
#line 8544 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2144: // o_gsa_pvalue_corr: PVALUE_CORR EQUAL non_negative_number
#line 4104 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("pvalue_corr", yystack_[0].value.as < string > ()); }
#line 8550 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2145: // o_load_ident_files: LOAD_IDENT_FILES EQUAL INT_NUMBER
#line 4105 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("load_ident_files", yystack_[0].value.as < string > ()); }
#line 8556 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2146: // o_useautocorr: USEAUTOCORR EQUAL INT_NUMBER
#line 4106 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("useautocorr", yystack_[0].value.as < string > ()); }
#line 8562 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2147: // o_prior_mc: PRIOR_MC EQUAL INT_NUMBER
#line 4107 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("prior_mc", yystack_[0].value.as < string > ()); }
#line 8568 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2148: // o_advanced: ADVANCED EQUAL signed_integer
#line 4108 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("advanced", yystack_[0].value.as < string > ()); }
#line 8574 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2149: // o_max_dim_cova_group: MAX_DIM_COVA_GROUP EQUAL INT_NUMBER
#line 4109 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("max_dim_cova_group", yystack_[0].value.as < string > ()); }
#line 8580 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2150: // o_homotopy_mode: HOMOTOPY_MODE EQUAL INT_NUMBER
#line 4111 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("homotopy_mode", yystack_[0].value.as < string > ()); }
#line 8586 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2151: // o_homotopy_steps: HOMOTOPY_STEPS EQUAL INT_NUMBER
#line 4112 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("homotopy_steps", yystack_[0].value.as < string > ()); }
#line 8592 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2152: // o_homotopy_force_continue: HOMOTOPY_FORCE_CONTINUE EQUAL INT_NUMBER
#line 4113 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("homotopy_force_continue", yystack_[0].value.as < string > ()); }
#line 8598 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2153: // o_nocheck: NOCHECK
#line 4114 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("steadystate.nocheck", "true"); }
#line 8604 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2154: // o_controlled_varexo: CONTROLLED_VAREXO EQUAL '(' symbol_list ')'
#line 4116 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_symbol_list("controlled_varexo", yystack_[1].value.as < vector<string> > ()); }
#line 8610 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2155: // o_parameter_set: PARAMETER_SET EQUAL PRIOR_MODE
#line 4118 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "prior_mode"); }
#line 8616 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2156: // o_parameter_set: PARAMETER_SET EQUAL PRIOR_MEAN
#line 4120 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "prior_mean"); }
#line 8622 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2157: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MEAN
#line 4122 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_mean"); }
#line 8628 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2158: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MODE
#line 4124 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_mode"); }
#line 8634 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2159: // o_parameter_set: PARAMETER_SET EQUAL POSTERIOR_MEDIAN
#line 4126 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "posterior_median"); }
#line 8640 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2160: // o_parameter_set: PARAMETER_SET EQUAL MLE_MODE
#line 4128 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "mle_mode"); }
#line 8646 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2161: // o_parameter_set: PARAMETER_SET EQUAL CALIBRATION
#line 4130 "../preprocessor/src/DynareBison.yy"
                  { driver.option_str("parameter_set", "calibration"); }
#line 8652 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2162: // o_nodecomposition: NODECOMPOSITION
#line 4132 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("nodecomposition", "true"); }
#line 8658 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2163: // o_spectral_density: SPECTRAL_DENSITY
#line 4133 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("SpectralDensity.trigger", "true"); }
#line 8664 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2164: // o_ms_drop: DROP EQUAL INT_NUMBER
#line 4134 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.drop", yystack_[0].value.as < string > ()); }
#line 8670 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2165: // o_ms_mh_replic: MH_REPLIC EQUAL INT_NUMBER
#line 4135 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("ms.mh_replic", yystack_[0].value.as < string > ()); }
#line 8676 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2166: // o_freq: FREQ EQUAL INT_NUMBER
#line 4137 "../preprocessor/src/DynareBison.yy"
         { driver.option_num("ms.freq", yystack_[0].value.as < string > ()); }
#line 8682 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2167: // o_freq: FREQ EQUAL MONTHLY
#line 4139 "../preprocessor/src/DynareBison.yy"
         { driver.option_num("ms.freq", "12"); }
#line 8688 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2168: // o_freq: FREQ EQUAL QUARTERLY
#line 4141 "../preprocessor/src/DynareBison.yy"
         { driver.option_num("ms.freq", "4"); }
#line 8694 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2169: // o_initial_year: INITIAL_YEAR EQUAL INT_NUMBER
#line 4143 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("ms.initial_year", yystack_[0].value.as < string > ()); }
#line 8700 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2170: // o_initial_subperiod: INITIAL_SUBPERIOD EQUAL INT_NUMBER
#line 4144 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("ms.initial_subperiod", yystack_[0].value.as < string > ()); }
#line 8706 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2171: // o_final_year: FINAL_YEAR EQUAL INT_NUMBER
#line 4145 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.final_year", yystack_[0].value.as < string > ()); }
#line 8712 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2172: // o_final_subperiod: FINAL_SUBPERIOD EQUAL INT_NUMBER
#line 4146 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("ms.final_subperiod", yystack_[0].value.as < string > ()); }
#line 8718 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2173: // o_data: DATA EQUAL filename
#line 4147 "../preprocessor/src/DynareBison.yy"
                             { driver.option_str("ms.data", yystack_[0].value.as < string > ()); }
#line 8724 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2174: // o_vlist: VLIST EQUAL INT_NUMBER
#line 4148 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.vlist", yystack_[0].value.as < string > ()); }
#line 8730 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2175: // o_vlistlog: VLISTLOG EQUAL '(' symbol_list ')'
#line 4149 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_symbol_list("ms.vlistlog", yystack_[1].value.as < vector<string> > ()); }
#line 8736 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2176: // o_vlistper: VLISTPER EQUAL INT_NUMBER
#line 4150 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.vlistper", yystack_[0].value.as < string > ()); }
#line 8742 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2177: // o_restriction_fname: RESTRICTION_FNAME EQUAL NAME
#line 4152 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname", yystack_[0].value.as < string > ());
                      }
#line 8751 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2178: // o_restriction_fname: RESTRICTION_FNAME EQUAL UPPER_CHOLESKY
#line 4157 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname", "upper_cholesky");
                      }
#line 8760 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2179: // o_restriction_fname: RESTRICTION_FNAME EQUAL LOWER_CHOLESKY
#line 4162 "../preprocessor/src/DynareBison.yy"
                      {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname", "lower_cholesky");
                      }
#line 8769 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2180: // o_nlags: NLAGS EQUAL INT_NUMBER
#line 4167 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.nlags", yystack_[0].value.as < string > ()); }
#line 8775 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2181: // o_cross_restrictions: CROSS_RESTRICTIONS
#line 4168 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.cross_restrictions", "true"); }
#line 8781 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2182: // o_contemp_reduced_form: CONTEMP_REDUCED_FORM
#line 4169 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("ms.contemp_reduced_form", "true"); }
#line 8787 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2183: // o_real_pseudo_forecast: REAL_PSEUDO_FORECAST EQUAL INT_NUMBER
#line 4170 "../preprocessor/src/DynareBison.yy"
                                                               { driver.option_num("ms.real_pseudo_forecast", yystack_[0].value.as < string > ()); }
#line 8793 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2184: // o_no_bayesian_prior: NO_BAYESIAN_PRIOR
#line 4171 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("ms.bayesian_prior", "false"); }
#line 8799 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2185: // o_dummy_obs: DUMMY_OBS EQUAL INT_NUMBER
#line 4172 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("ms.dummy_obs", yystack_[0].value.as < string > ()); }
#line 8805 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2186: // o_nstates: NSTATES EQUAL INT_NUMBER
#line 4173 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.nstates", yystack_[0].value.as < string > ()); }
#line 8811 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2187: // o_indxscalesstates: INDXSCALESSTATES EQUAL INT_NUMBER
#line 4174 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("ms.indxscalesstates", yystack_[0].value.as < string > ()); }
#line 8817 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2188: // o_alpha: ALPHA EQUAL non_negative_number
#line 4175 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.alpha", yystack_[0].value.as < string > ()); }
#line 8823 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2189: // o_beta: BETA EQUAL non_negative_number
#line 4176 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("ms.beta", yystack_[0].value.as < string > ()); }
#line 8829 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2190: // o_gsig2_lmdm: GSIG2_LMDM EQUAL INT_NUMBER
#line 4177 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.gsig2_lmdm", yystack_[0].value.as < string > ()); }
#line 8835 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2191: // o_specification: SPECIFICATION EQUAL SIMS_ZHA
#line 4179 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ms.specification", "1"); }
#line 8841 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2192: // o_specification: SPECIFICATION EQUAL NONE
#line 4181 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ms.specification", "0"); }
#line 8847 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2193: // o_q_diag: Q_DIAG EQUAL non_negative_number
#line 4183 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("ms.q_diag", yystack_[0].value.as < string > ()); }
#line 8853 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2194: // o_flat_prior: FLAT_PRIOR EQUAL INT_NUMBER
#line 4184 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.flat_prior", yystack_[0].value.as < string > ()); }
#line 8859 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2195: // o_ncsk: NCSK EQUAL INT_NUMBER
#line 4185 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.ncsk", yystack_[0].value.as < string > ()); }
#line 8865 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2196: // o_nstd: NSTD EQUAL INT_NUMBER
#line 4186 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.nstd", yystack_[0].value.as < string > ()); }
#line 8871 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2197: // o_ninv: NINV EQUAL INT_NUMBER
#line 4187 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.ninv", yystack_[0].value.as < string > ()); }
#line 8877 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2198: // o_indxparr: INDXPARR EQUAL INT_NUMBER
#line 4188 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.indxparr", yystack_[0].value.as < string > ()); }
#line 8883 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2199: // o_indxovr: INDXOVR EQUAL INT_NUMBER
#line 4189 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.indxovr", yystack_[0].value.as < string > ()); }
#line 8889 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2200: // o_aband: ABAND EQUAL INT_NUMBER
#line 4190 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.aband", yystack_[0].value.as < string > ()); }
#line 8895 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2201: // o_indxap: INDXAP EQUAL INT_NUMBER
#line 4191 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.indxap", yystack_[0].value.as < string > ()); }
#line 8901 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2202: // o_apband: APBAND EQUAL INT_NUMBER
#line 4192 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.apband", yystack_[0].value.as < string > ()); }
#line 8907 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2203: // o_indximf: INDXIMF EQUAL INT_NUMBER
#line 4193 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.indximf", yystack_[0].value.as < string > ()); }
#line 8913 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2204: // o_indxfore: INDXFORE EQUAL INT_NUMBER
#line 4194 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.indxfore", yystack_[0].value.as < string > ()); }
#line 8919 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2205: // o_foreband: FOREBAND EQUAL INT_NUMBER
#line 4195 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.foreband", yystack_[0].value.as < string > ()); }
#line 8925 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2206: // o_indxgforhat: INDXGFOREHAT EQUAL INT_NUMBER
#line 4196 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_num("ms.indxgforehat", yystack_[0].value.as < string > ()); }
#line 8931 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2207: // o_indxgimfhat: INDXGIMFHAT EQUAL INT_NUMBER
#line 4197 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("ms.indxgimfhat", yystack_[0].value.as < string > ()); }
#line 8937 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2208: // o_indxestima: INDXESTIMA EQUAL INT_NUMBER
#line 4198 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.indxestima", yystack_[0].value.as < string > ()); }
#line 8943 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2209: // o_indxgdls: INDXGDLS EQUAL INT_NUMBER
#line 4199 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.indxgdls", yystack_[0].value.as < string > ()); }
#line 8949 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2210: // o_eq_ms: EQ_MS EQUAL INT_NUMBER
#line 4200 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.eq_ms", yystack_[0].value.as < string > ()); }
#line 8955 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2211: // o_cms: CMS EQUAL INT_NUMBER
#line 4201 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("ms.cms", yystack_[0].value.as < string > ()); }
#line 8961 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2212: // o_ncms: NCMS EQUAL INT_NUMBER
#line 4202 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.ncms", yystack_[0].value.as < string > ()); }
#line 8967 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2213: // o_eq_cms: EQ_CMS EQUAL INT_NUMBER
#line 4203 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.eq_cms", yystack_[0].value.as < string > ()); }
#line 8973 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2214: // o_tlindx: TLINDX EQUAL INT_NUMBER
#line 4204 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.tlindx", yystack_[0].value.as < string > ()); }
#line 8979 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2215: // o_tlnumber: TLNUMBER EQUAL INT_NUMBER
#line 4205 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("ms.tlnumber", yystack_[0].value.as < string > ()); }
#line 8985 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2216: // o_cnum: CNUM EQUAL INT_NUMBER
#line 4206 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.cnum", yystack_[0].value.as < string > ()); }
#line 8991 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2217: // o_k_order_solver: K_ORDER_SOLVER
#line 4207 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("k_order_solver", "true"); }
#line 8997 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2218: // o_pruning: PRUNING
#line 4208 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("pruning", "true"); }
#line 9003 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2219: // o_chain: CHAIN EQUAL INT_NUMBER
#line 4209 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_num("ms.chain", yystack_[0].value.as < string > ()); }
#line 9009 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2220: // o_restrictions: RESTRICTIONS EQUAL vec_of_vec_value
#line 4211 "../preprocessor/src/DynareBison.yy"
                 { driver.option_vec_of_vec_value("ms.restrictions", yystack_[0].value.as < vector<vector<string>> > ()); }
#line 9015 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2221: // o_duration: DURATION EQUAL non_negative_number
#line 4214 "../preprocessor/src/DynareBison.yy"
             { driver.option_num("ms.duration", yystack_[0].value.as < string > ()); }
#line 9021 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2222: // o_duration: DURATION EQUAL vec_value_w_inf
#line 4216 "../preprocessor/src/DynareBison.yy"
             { driver.option_vec_value("ms.duration", yystack_[0].value.as < vector<string> > ()); }
#line 9027 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2223: // o_number_of_regimes: NUMBER_OF_REGIMES EQUAL INT_NUMBER
#line 4218 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("ms.number_of_regimes", yystack_[0].value.as < string > ()); }
#line 9033 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2224: // o_number_of_lags: NUMBER_OF_LAGS EQUAL INT_NUMBER
#line 4219 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("ms.number_of_lags", yystack_[0].value.as < string > ()); }
#line 9039 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2225: // o_parameters: PARAMETERS EQUAL '[' symbol_list ']'
#line 4220 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_symbol_list("ms.parameters", yystack_[1].value.as < vector<string> > ()); }
#line 9045 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2226: // o_coefficients: COEFFICIENTS
#line 4221 "../preprocessor/src/DynareBison.yy"
                              { driver.option_str("ms.coefficients", "svar_coefficients"); }
#line 9051 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2227: // o_variances: VARIANCES
#line 4222 "../preprocessor/src/DynareBison.yy"
                        { driver.option_str("ms.variances", "svar_variances"); }
#line 9057 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2228: // o_equations: EQUATIONS EQUAL vec_int
#line 4224 "../preprocessor/src/DynareBison.yy"
              { driver.option_vec_int("ms.equations", yystack_[0].value.as < vector<int> > ()); }
#line 9063 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2229: // o_equations: EQUATIONS EQUAL vec_int_number
#line 4226 "../preprocessor/src/DynareBison.yy"
              { driver.option_vec_int("ms.equations", yystack_[0].value.as < vector<int> > ()); }
#line 9069 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2230: // o_silent_optimizer: SILENT_OPTIMIZER
#line 4228 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("silent_optimizer", "true"); }
#line 9075 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2231: // o_instruments: INSTRUMENTS EQUAL '(' symbol_list ')'
#line 4229 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_symbol_list("instruments", yystack_[1].value.as < vector<string> > ()); }
#line 9081 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2232: // o_ext_func_name: EXT_FUNC_NAME EQUAL namespace_qualified_filename
#line 4231 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.external_function_option("name", yystack_[0].value.as < string > ()); }
#line 9087 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2233: // o_ext_func_nargs: EXT_FUNC_NARGS EQUAL INT_NUMBER
#line 4232 "../preprocessor/src/DynareBison.yy"
                                                   { driver.external_function_option("nargs", yystack_[0].value.as < string > ()); }
#line 9093 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2234: // o_first_deriv_provided: FIRST_DERIV_PROVIDED EQUAL namespace_qualified_filename
#line 4234 "../preprocessor/src/DynareBison.yy"
                         { driver.external_function_option("first_deriv_provided", yystack_[0].value.as < string > ()); }
#line 9099 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2235: // o_first_deriv_provided: FIRST_DERIV_PROVIDED
#line 4236 "../preprocessor/src/DynareBison.yy"
                         { driver.external_function_option("first_deriv_provided", ""); }
#line 9105 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2236: // o_second_deriv_provided: SECOND_DERIV_PROVIDED EQUAL namespace_qualified_filename
#line 4239 "../preprocessor/src/DynareBison.yy"
                          { driver.external_function_option("second_deriv_provided", yystack_[0].value.as < string > ()); }
#line 9111 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2237: // o_second_deriv_provided: SECOND_DERIV_PROVIDED
#line 4241 "../preprocessor/src/DynareBison.yy"
                          { driver.external_function_option("second_deriv_provided", ""); }
#line 9117 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2238: // o_filter_covariance: FILTER_COVARIANCE
#line 4244 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("filter_covariance", "true"); }
#line 9123 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2239: // o_updated_covariance: UPDATED_COVARIANCE
#line 4247 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("updated_covariance", "true"); }
#line 9129 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2240: // o_filter_decomposition: FILTER_DECOMPOSITION
#line 4250 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("filter_decomposition", "true"); }
#line 9135 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2241: // o_smoothed_state_uncertainty: SMOOTHED_STATE_UNCERTAINTY
#line 4253 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("smoothed_state_uncertainty", "true"); }
#line 9141 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2242: // o_smoother_redux: SMOOTHER_REDUX
#line 4256 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("smoother_redux", "true"); }
#line 9147 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2243: // o_selected_variables_only: SELECTED_VARIABLES_ONLY
#line 4259 "../preprocessor/src/DynareBison.yy"
                           { driver.option_num("selected_variables_only", "true"); }
#line 9153 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2244: // o_cova_compute: COVA_COMPUTE EQUAL INT_NUMBER
#line 4262 "../preprocessor/src/DynareBison.yy"
                 { driver.option_num("cova_compute", yystack_[0].value.as < string > ()); }
#line 9159 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2245: // o_output_file_tag: OUTPUT_FILE_TAG EQUAL filename
#line 4264 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_str("ms.output_file_tag", yystack_[0].value.as < string > ()); }
#line 9165 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2246: // o_file_tag: FILE_TAG EQUAL filename
#line 4265 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("ms.file_tag", yystack_[0].value.as < string > ()); }
#line 9171 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2247: // o_no_create_init: NO_CREATE_INIT
#line 4266 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.create_init", "false"); }
#line 9177 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2248: // o_simulation_file_tag: SIMULATION_FILE_TAG EQUAL filename
#line 4267 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_str("ms.simulation_file_tag", yystack_[0].value.as < string > ()); }
#line 9183 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2249: // o_coefficients_prior_hyperparameters: COEFFICIENTS_PRIOR_HYPERPARAMETERS EQUAL vec_value
#line 4269 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_vec_value("ms.coefficients_prior_hyperparameters", yystack_[0].value.as < vector<string> > ()); }
#line 9189 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2250: // o_convergence_starting_value: CONVERGENCE_STARTING_VALUE EQUAL non_negative_number
#line 4271 "../preprocessor/src/DynareBison.yy"
                               { driver.option_num("ms.convergence_starting_value", yystack_[0].value.as < string > ()); }
#line 9195 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2251: // o_convergence_ending_value: CONVERGENCE_ENDING_VALUE EQUAL non_negative_number
#line 4273 "../preprocessor/src/DynareBison.yy"
                             { driver.option_num("ms.convergence_ending_value", yystack_[0].value.as < string > ()); }
#line 9201 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2252: // o_convergence_increment_value: CONVERGENCE_INCREMENT_VALUE EQUAL non_negative_number
#line 4275 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("ms.convergence_increment_value", yystack_[0].value.as < string > ()); }
#line 9207 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2253: // o_max_iterations_starting_value: MAX_ITERATIONS_STARTING_VALUE EQUAL INT_NUMBER
#line 4277 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.max_iterations_starting_value", yystack_[0].value.as < string > ()); }
#line 9213 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2254: // o_max_iterations_increment_value: MAX_ITERATIONS_INCREMENT_VALUE EQUAL non_negative_number
#line 4279 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.max_iterations_increment_value", yystack_[0].value.as < string > ()); }
#line 9219 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2255: // o_max_block_iterations: MAX_BLOCK_ITERATIONS EQUAL INT_NUMBER
#line 4281 "../preprocessor/src/DynareBison.yy"
                         { driver.option_num("ms.max_block_iterations", yystack_[0].value.as < string > ()); }
#line 9225 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2256: // o_max_repeated_optimization_runs: MAX_REPEATED_OPTIMIZATION_RUNS EQUAL INT_NUMBER
#line 4283 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.max_repeated_optimization_runs", yystack_[0].value.as < string > ()); }
#line 9231 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2257: // o_function_convergence_criterion: FUNCTION_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4285 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.function_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9237 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2258: // o_parameter_convergence_criterion: PARAMETER_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4287 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("ms.parameter_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9243 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2259: // o_number_of_large_perturbations: NUMBER_OF_LARGE_PERTURBATIONS EQUAL INT_NUMBER
#line 4289 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.number_of_large_perturbations", yystack_[0].value.as < string > ()); }
#line 9249 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2260: // o_number_of_small_perturbations: NUMBER_OF_SMALL_PERTURBATIONS EQUAL INT_NUMBER
#line 4291 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.number_of_small_perturbations", yystack_[0].value.as < string > ()); }
#line 9255 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2261: // o_number_of_posterior_draws_after_perturbation: NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION EQUAL INT_NUMBER
#line 4293 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("ms.number_of_posterior_draws_after_perturbation", yystack_[0].value.as < string > ()); }
#line 9261 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2262: // o_max_number_of_stages: MAX_NUMBER_OF_STAGES EQUAL INT_NUMBER
#line 4295 "../preprocessor/src/DynareBison.yy"
                         { driver.option_num("ms.max_number_of_stages", yystack_[0].value.as < string > ()); }
#line 9267 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2263: // o_random_function_convergence_criterion: RANDOM_FUNCTION_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4297 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.random_function_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9273 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2264: // o_random_parameter_convergence_criterion: RANDOM_PARAMETER_CONVERGENCE_CRITERION EQUAL non_negative_number
#line 4299 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_num("ms.random_parameter_convergence_criterion", yystack_[0].value.as < string > ()); }
#line 9279 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2265: // o_thinning_factor: THINNING_FACTOR EQUAL INT_NUMBER
#line 4300 "../preprocessor/src/DynareBison.yy"
                                                     { driver.option_num("ms.thinning_factor", yystack_[0].value.as < string > ()); }
#line 9285 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2266: // o_adaptive_mh_draws: ADAPTIVE_MH_DRAWS EQUAL INT_NUMBER
#line 4301 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("ms.adaptive_mh_draws", yystack_[0].value.as < string > ()); }
#line 9291 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2267: // o_save_draws: SAVE_DRAWS
#line 4302 "../preprocessor/src/DynareBison.yy"
                          { driver.option_num("ms.save_draws", "true"); }
#line 9297 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2268: // o_proposal_draws: PROPOSAL_DRAWS EQUAL INT_NUMBER
#line 4303 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("ms.proposal_draws", yystack_[0].value.as < string > ()); }
#line 9303 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2269: // o_use_mean_center: USE_MEAN_CENTER
#line 4304 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("ms.use_mean_center", "true"); }
#line 9309 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2270: // o_proposal_type: PROPOSAL_TYPE EQUAL INT_NUMBER
#line 4305 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("ms.proposal_type", yystack_[0].value.as < string > ()); }
#line 9315 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2271: // o_proposal_lower_bound: PROPOSAL_LOWER_BOUND EQUAL signed_number
#line 4306 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("ms.proposal_lower_bound", yystack_[0].value.as < string > ()); }
#line 9321 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2272: // o_proposal_upper_bound: PROPOSAL_UPPER_BOUND EQUAL signed_number
#line 4307 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("ms.proposal_upper_bound", yystack_[0].value.as < string > ()); }
#line 9327 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2273: // o_parameter_uncertainty: PARAMETER_UNCERTAINTY
#line 4308 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_num("ms.parameter_uncertainty", "true"); }
#line 9333 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2274: // o_horizon: HORIZON EQUAL INT_NUMBER
#line 4309 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_num("ms.horizon", yystack_[0].value.as < string > ()); }
#line 9339 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2275: // o_filtered_probabilities: FILTERED_PROBABILITIES
#line 4310 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("ms.filtered_probabilities", "true"); }
#line 9345 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2276: // o_real_time_smoothed: REAL_TIME_SMOOTHED
#line 4311 "../preprocessor/src/DynareBison.yy"
                                          { driver.option_num("ms.real_time_smoothed_probabilities", "true"); }
#line 9351 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2277: // o_no_error_bands: NO_ERROR_BANDS
#line 4312 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("ms.error_bands", "false"); }
#line 9357 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2278: // o_error_band_percentiles: ERROR_BAND_PERCENTILES EQUAL vec_value
#line 4313 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_vec_value("ms.percentiles", yystack_[0].value.as < vector<string> > ()); }
#line 9363 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2279: // o_shock_draws: SHOCK_DRAWS EQUAL INT_NUMBER
#line 4314 "../preprocessor/src/DynareBison.yy"
                                             { driver.option_num("ms.shock_draws", yystack_[0].value.as < string > ()); }
#line 9369 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2280: // o_shocks_per_parameter: SHOCKS_PER_PARAMETER EQUAL INT_NUMBER
#line 4315 "../preprocessor/src/DynareBison.yy"
                                                               { driver.option_num("ms.shocks_per_parameter", yystack_[0].value.as < string > ()); }
#line 9375 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2281: // o_free_parameters: FREE_PARAMETERS EQUAL vec_value
#line 4316 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_vec_value("ms.free_parameters", yystack_[0].value.as < vector<string> > ()); }
#line 9381 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2282: // o_median: MEDIAN
#line 4317 "../preprocessor/src/DynareBison.yy"
                  { driver.option_num("ms.median", "1"); }
#line 9387 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2283: // o_median: MEDIAN EQUAL signed_number
#line 4318 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("median", yystack_[0].value.as < string > ()); }
#line 9393 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2284: // o_regimes: REGIMES
#line 4319 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("ms.regimes", "true"); }
#line 9399 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2285: // o_regime: REGIME EQUAL INT_NUMBER
#line 4320 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("ms.regime", yystack_[0].value.as < string > ()); }
#line 9405 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2286: // o_data_obs_nbr: DATA_OBS_NBR EQUAL INT_NUMBER
#line 4321 "../preprocessor/src/DynareBison.yy"
                                               { driver.option_num("ms.forecast_data_obs", yystack_[0].value.as < string > ()); }
#line 9411 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2287: // o_discretionary_tol: DISCRETIONARY_TOL EQUAL non_negative_number
#line 4322 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_num("discretionary_tol", yystack_[0].value.as < string > ()); }
#line 9417 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2288: // o_analytic_derivation: ANALYTIC_DERIVATION
#line 4323 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("analytic_derivation", "1"); }
#line 9423 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2289: // o_analytic_derivation_mode: ANALYTIC_DERIVATION_MODE EQUAL signed_number
#line 4324 "../preprocessor/src/DynareBison.yy"
                                                                          { driver.option_num("analytic_derivation_mode", yystack_[0].value.as < string > ()); }
#line 9429 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2290: // o_endogenous_prior: ENDOGENOUS_PRIOR
#line 4325 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_num("endogenous_prior", "true"); }
#line 9435 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2291: // o_use_univariate_filters_if_singularity_is_detected: USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED EQUAL INT_NUMBER
#line 4326 "../preprocessor/src/DynareBison.yy"
                                                                                                                         { driver.option_num("use_univariate_filters_if_singularity_is_detected", yystack_[0].value.as < string > ()); }
#line 9441 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2292: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL HESSIAN
#line 4328 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9447 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2293: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL PRIOR_VARIANCE
#line 4329 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9453 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2294: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL IDENTITY_MATRIX
#line 4331 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9459 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2295: // o_mcmc_jumping_covariance: MCMC_JUMPING_COVARIANCE EQUAL filename
#line 4333 "../preprocessor/src/DynareBison.yy"
                            { driver.option_str("MCMC_jumping_covariance", yystack_[0].value.as < string > ()); }
#line 9465 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2296: // o_rescale_prediction_error_covariance: RESCALE_PREDICTION_ERROR_COVARIANCE
#line 4335 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("rescale_prediction_error_covariance", "true"); }
#line 9471 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2297: // o_use_penalized_objective_for_hessian: USE_PENALIZED_OBJECTIVE_FOR_HESSIAN
#line 4336 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("hessian.use_penalized_objective", "true"); }
#line 9477 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2298: // o_irf_plot_threshold: IRF_PLOT_THRESHOLD EQUAL non_negative_number
#line 4337 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("impulse_responses.plot_threshold", yystack_[0].value.as < string > ()); }
#line 9483 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2299: // o_dr_display_tol: DR_DISPLAY_TOL EQUAL non_negative_number
#line 4338 "../preprocessor/src/DynareBison.yy"
                                                            { driver.option_num("dr_display_tol", yystack_[0].value.as < string > ()); }
#line 9489 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2300: // o_consider_all_endogenous: CONSIDER_ALL_ENDOGENOUS
#line 4339 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_variables"); }
#line 9495 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2301: // o_consider_all_endogenous_and_auxiliary: CONSIDER_ALL_ENDOGENOUS_AND_AUXILIARY
#line 4340 "../preprocessor/src/DynareBison.yy"
                                                                                { driver.option_str("endo_vars_for_moment_computations_in_estimation", "all_endogenous_and_auxiliary_variables"); }
#line 9501 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2302: // o_consider_only_observed: CONSIDER_ONLY_OBSERVED
#line 4341 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_str("endo_vars_for_moment_computations_in_estimation", "only_observed_variables"); }
#line 9507 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2303: // o_no_homotopy: NO_HOMOTOPY
#line 4342 "../preprocessor/src/DynareBison.yy"
                            { driver.option_num("no_homotopy", "true"); }
#line 9513 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2304: // o_endval_steady: ENDVAL_STEADY
#line 4343 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("simul.endval_steady", "true"); }
#line 9519 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2305: // o_homotopy_max_completion_share: HOMOTOPY_MAX_COMPLETION_SHARE EQUAL non_negative_number
#line 4344 "../preprocessor/src/DynareBison.yy"
                                                                                          { driver.option_num("simul.homotopy_max_completion_share", yystack_[0].value.as < string > ()); }
#line 9525 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2306: // o_homotopy_min_step_size: HOMOTOPY_MIN_STEP_SIZE EQUAL non_negative_number
#line 4345 "../preprocessor/src/DynareBison.yy"
                                                                            { driver.option_num("simul.homotopy_min_step_size", yystack_[0].value.as < string > ()); }
#line 9531 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2307: // o_homotopy_initial_step_size: HOMOTOPY_INITIAL_STEP_SIZE EQUAL non_negative_number
#line 4346 "../preprocessor/src/DynareBison.yy"
                                                                                    { driver.option_num("simul.homotopy_initial_step_size", yystack_[0].value.as < string > ()); }
#line 9537 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2308: // o_homotopy_step_size_increase_success_count: HOMOTOPY_STEP_SIZE_INCREASE_SUCCESS_COUNT EQUAL INT_NUMBER
#line 4347 "../preprocessor/src/DynareBison.yy"
                                                                                                         { driver.option_num("simul.homotopy_step_size_increase_success_count", yystack_[0].value.as < string > ()); }
#line 9543 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2309: // o_homotopy_linearization_fallback: HOMOTOPY_LINEARIZATION_FALLBACK
#line 4348 "../preprocessor/src/DynareBison.yy"
                                                                    { driver.option_num("simul.homotopy_linearization_fallback", "true"); }
#line 9549 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2310: // o_homotopy_marginal_linearization_fallback: HOMOTOPY_MARGINAL_LINEARIZATION_FALLBACK
#line 4349 "../preprocessor/src/DynareBison.yy"
                                                                                      { driver.option_num("simul.homotopy_marginal_linearization_fallback", "0.01"); }
#line 9555 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2311: // o_homotopy_marginal_linearization_fallback: HOMOTOPY_MARGINAL_LINEARIZATION_FALLBACK EQUAL non_negative_number
#line 4350 "../preprocessor/src/DynareBison.yy"
                                                                                                                { driver.option_num("simul.homotopy_marginal_linearization_fallback", yystack_[0].value.as < string > ()); }
#line 9561 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2312: // o_homotopy_exclude_varexo: HOMOTOPY_EXCLUDE_VAREXO EQUAL '(' symbol_list ')'
#line 4351 "../preprocessor/src/DynareBison.yy"
                                                                              { driver.option_symbol_list("simul.homotopy_exclude_varexo", yystack_[1].value.as < vector<string> > ()); }
#line 9567 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2313: // o_infile: INFILE EQUAL filename
#line 4353 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_str("infile", yystack_[0].value.as < string > ()); }
#line 9573 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2314: // o_invars: INVARS EQUAL '(' symbol_list ')'
#line 4354 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_symbol_list("invars", yystack_[1].value.as < vector<string> > ()); }
#line 9579 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2315: // o_period: PERIOD EQUAL INT_NUMBER
#line 4355 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("period", yystack_[0].value.as < string > ()); }
#line 9585 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2316: // o_outfile: OUTFILE EQUAL filename
#line 4356 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_str("outfile", yystack_[0].value.as < string > ()); }
#line 9591 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2317: // o_outvars: OUTVARS EQUAL '(' symbol_list ')'
#line 4357 "../preprocessor/src/DynareBison.yy"
                                              { driver.option_symbol_list("outvars", yystack_[1].value.as < vector<string> > ()); }
#line 9597 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2318: // o_lmmcp: LMMCP
#line 4358 "../preprocessor/src/DynareBison.yy"
                { driver.option_num("lmmcp.status", "true"); }
#line 9603 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2319: // o_function: FUNCTION EQUAL filename
#line 4359 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("function", yystack_[0].value.as < string > ()); }
#line 9609 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2320: // o_sampling_draws: SAMPLING_DRAWS EQUAL INT_NUMBER
#line 4360 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("sampling_draws", yystack_[0].value.as < string > ()); }
#line 9615 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2321: // o_use_shock_groups: USE_SHOCK_GROUPS
#line 4361 "../preprocessor/src/DynareBison.yy"
                                      { driver.option_str("plot_shock_decomp.use_shock_groups", "default"); }
#line 9621 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2322: // o_use_shock_groups: USE_SHOCK_GROUPS EQUAL symbol
#line 4362 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_str("plot_shock_decomp.use_shock_groups", yystack_[0].value.as < string > ()); }
#line 9627 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2323: // o_colormap: COLORMAP EQUAL symbol
#line 4364 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("plot_shock_decomp.colormap", yystack_[0].value.as < string > ()); }
#line 9633 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2324: // o_icd_colormap: COLORMAP EQUAL symbol
#line 4365 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("initial_condition_decomp.colormap", yystack_[0].value.as < string > ()); }
#line 9639 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2325: // o_no_init_estimation_check_first_obs: NO_INIT_ESTIMATION_CHECK_FIRST_OBS
#line 4366 "../preprocessor/src/DynareBison.yy"
                                                                          { driver.option_num("no_init_estimation_check_first_obs", "true"); }
#line 9645 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2326: // o_heteroskedastic_filter: HETEROSKEDASTIC_FILTER
#line 4367 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("heteroskedastic_filter", "true"); }
#line 9651 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2327: // o_pfwee_constant_simulation_length: CONSTANT_SIMULATION_LENGTH
#line 4368 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("pfwee.constant_simulation_length", "true"); }
#line 9657 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2328: // o_fsolve_options: FSOLVE_OPTIONS EQUAL '(' name_value_pair_with_boolean_list ')'
#line 4369 "../preprocessor/src/DynareBison.yy"
                                                                                  { driver.option_str("fsolve_options", yystack_[1].value.as < string > ()); }
#line 9663 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2329: // o_bartlett_kernel_lag: BARTLETT_KERNEL_LAG EQUAL INT_NUMBER
#line 4372 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("mom.bartlett_kernel_lag", yystack_[0].value.as < string > ()); }
#line 9669 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2330: // o_weighting_matrix: WEIGHTING_MATRIX EQUAL vec_str
#line 4373 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_vec_cellstr("mom.weighting_matrix", yystack_[0].value.as < vector<string> > ()); }
#line 9675 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2331: // o_weighting_matrix_scaling_factor: WEIGHTING_MATRIX_SCALING_FACTOR EQUAL non_negative_number
#line 4374 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.option_num("mom.weighting_matrix_scaling_factor", yystack_[0].value.as < string > ()); }
#line 9681 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2332: // o_analytic_standard_errors: ANALYTIC_STANDARD_ERRORS
#line 4375 "../preprocessor/src/DynareBison.yy"
                                                      { driver.option_num("mom.analytic_standard_errors", "true"); }
#line 9687 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2333: // o_analytic_jacobian: ANALYTIC_JACOBIAN
#line 4376 "../preprocessor/src/DynareBison.yy"
                                        { driver.option_num("mom.analytic_jacobian", "true"); }
#line 9693 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2334: // o_mom_method: MOM_METHOD EQUAL GMM
#line 4378 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.mom_method", "GMM"); }
#line 9699 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2335: // o_mom_method: MOM_METHOD EQUAL SMM
#line 4380 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.mom_method", "SMM"); }
#line 9705 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2336: // o_mom_method: MOM_METHOD EQUAL IRF_MATCHING
#line 4382 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.mom_method", "IRF_MATCHING"); }
#line 9711 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2337: // o_simulation_method: SIMULATION_METHOD EQUAL STOCH_SIMUL
#line 4384 "../preprocessor/src/DynareBison.yy"
               { driver.option_str("mom.simulation_method", "STOCH_SIMUL"); }
#line 9717 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2338: // o_penalized_estimator: PENALIZED_ESTIMATOR
#line 4385 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("mom.penalized_estimator", "true"); }
#line 9723 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2339: // o_verbose: VERBOSE
#line 4386 "../preprocessor/src/DynareBison.yy"
                    { driver.option_num("mom.verbose", "true"); }
#line 9729 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2340: // o_simulation_multiple: SIMULATION_MULTIPLE EQUAL INT_NUMBER
#line 4387 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("mom.simulation_multiple", yystack_[0].value.as < string > ()); }
#line 9735 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2341: // o_mom_burnin: BURNIN EQUAL INT_NUMBER
#line 4388 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("mom.burnin", yystack_[0].value.as < string > ()); }
#line 9741 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2342: // o_bounded_shock_support: BOUNDED_SHOCK_SUPPORT
#line 4389 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_num("mom.bounded_shock_support", "true"); }
#line 9747 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2343: // o_mom_seed: SEED EQUAL INT_NUMBER
#line 4390 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("mom.seed", yystack_[0].value.as < string > ()); }
#line 9753 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2344: // o_additional_optimizer_steps: ADDITIONAL_OPTIMIZER_STEPS EQUAL vec_int
#line 4391 "../preprocessor/src/DynareBison.yy"
                                                                        { driver.option_vec_int("additional_optimizer_steps", yystack_[0].value.as < vector<int> > ()); }
#line 9759 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2345: // o_mom_se_tolx: SE_TOLX EQUAL non_negative_number
#line 4392 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("mom.se_tolx", yystack_[0].value.as < string > ()); }
#line 9765 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2346: // o_irf_matching_file: IRF_MATCHING_FILE EQUAL filename
#line 4393 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_str("mom.irf_matching_file.name", yystack_[0].value.as < string > ()); }
#line 9771 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2347: // o_add_tiny_number_to_cholesky: ADD_TINY_NUMBER_TO_CHOLESKY EQUAL non_negative_number
#line 4394 "../preprocessor/src/DynareBison.yy"
                                                                                      { driver.option_num("add_tiny_number_to_cholesky", yystack_[0].value.as < string > ()); }
#line 9777 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2348: // o_analytical_girf: ANALYTICAL_GIRF
#line 4396 "../preprocessor/src/DynareBison.yy"
                                    { driver.option_num("irf_opt.analytical_GIRF", "true"); }
#line 9783 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2349: // o_irf_in_percent: IRF_IN_PERCENT
#line 4397 "../preprocessor/src/DynareBison.yy"
                                  { driver.option_num("irf_opt.percent", "true"); }
#line 9789 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2350: // o_emas_girf: EMAS_GIRF
#line 4398 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("irf_opt.ergodic_mean_irf", "true"); }
#line 9795 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2351: // o_emas_drop: EMAS_DROP EQUAL INT_NUMBER
#line 4399 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("irf_opt.EM.drop", yystack_[0].value.as < string > ()); }
#line 9801 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2352: // o_emas_tolf: EMAS_TOLF EQUAL non_negative_number
#line 4400 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("irf_opt.EM.tolf", yystack_[0].value.as < string > ()); }
#line 9807 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2353: // o_emas_max_iter: EMAS_MAX_ITER EQUAL INT_NUMBER
#line 4401 "../preprocessor/src/DynareBison.yy"
                                                 { driver.option_num("irf_opt.EM.iter", yystack_[0].value.as < string > ()); }
#line 9813 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2354: // o_non_zero: NON_ZERO
#line 4402 "../preprocessor/src/DynareBison.yy"
                      { driver.option_num("steady.non_zero", "true"); }
#line 9819 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2355: // o_no_identification_strength: NO_IDENTIFICATION_STRENGTH
#line 4405 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("no_identification_strength", "true"); }
#line 9825 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2356: // o_no_identification_reducedform: NO_IDENTIFICATION_REDUCEDFORM
#line 4406 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("no_identification_reducedform", "true"); }
#line 9831 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2357: // o_no_identification_moments: NO_IDENTIFICATION_MOMENTS
#line 4407 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("no_identification_moments", "true"); }
#line 9837 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2358: // o_no_identification_minimal: NO_IDENTIFICATION_MINIMAL
#line 4408 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("no_identification_minimal", "true"); }
#line 9843 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2359: // o_no_identification_spectrum: NO_IDENTIFICATION_SPECTRUM
#line 4409 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("no_identification_spectrum", "true"); }
#line 9849 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2360: // o_normalize_jacobians: NORMALIZE_JACOBIANS EQUAL INT_NUMBER
#line 4410 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("normalize_jacobians", yystack_[0].value.as < string > ()); }
#line 9855 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2361: // o_grid_nbr: GRID_NBR EQUAL INT_NUMBER
#line 4411 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("grid_nbr", yystack_[0].value.as < string > ()); }
#line 9861 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2362: // o_tol_rank: TOL_RANK EQUAL non_negative_number
#line 4412 "../preprocessor/src/DynareBison.yy"
                                                { driver.option_num("tol_rank", yystack_[0].value.as < string > ()); }
#line 9867 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2363: // o_tol_deriv: TOL_DERIV EQUAL non_negative_number
#line 4413 "../preprocessor/src/DynareBison.yy"
                                                  { driver.option_num("tol_deriv", yystack_[0].value.as < string > ()); }
#line 9873 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2364: // o_tol_sv: TOL_SV EQUAL non_negative_number
#line 4414 "../preprocessor/src/DynareBison.yy"
                                            { driver.option_num("tol_sv", yystack_[0].value.as < string > ()); }
#line 9879 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2365: // o_checks_via_subsets: CHECKS_VIA_SUBSETS EQUAL INT_NUMBER
#line 4415 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("checks_via_subsets", yystack_[0].value.as < string > ()); }
#line 9885 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2366: // o_max_dim_subsets_groups: MAX_DIM_SUBSETS_GROUPS EQUAL INT_NUMBER
#line 4416 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("max_dim_subsets_groups", yystack_[0].value.as < string > ()); }
#line 9891 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2367: // o_block_static: BLOCK_STATIC
#line 4417 "../preprocessor/src/DynareBison.yy"
                              { driver.option_num("block_static", "true"); }
#line 9897 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2368: // o_block_dynamic: BLOCK_DYNAMIC
#line 4418 "../preprocessor/src/DynareBison.yy"
                                { driver.option_num("block_dynamic", "true"); }
#line 9903 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2369: // o_incidence: INCIDENCE
#line 4419 "../preprocessor/src/DynareBison.yy"
                        { driver.option_num("incidence", "true"); }
#line 9909 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2370: // o_evaluate_planner_objective_periods: PERIODS EQUAL INT_NUMBER
#line 4422 "../preprocessor/src/DynareBison.yy"
                                                                { driver.option_num("ramsey.periods", yystack_[0].value.as < string > ()); }
#line 9915 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2371: // o_evaluate_planner_objective_drop: DROP EQUAL INT_NUMBER
#line 4423 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("ramsey.drop", yystack_[0].value.as < string > ()); }
#line 9921 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2372: // o_occbin_simul_maxit: SIMUL_MAXIT EQUAL INT_NUMBER
#line 4426 "../preprocessor/src/DynareBison.yy"
                                                    { driver.option_num("simul.maxit", yystack_[0].value.as < string > ()); }
#line 9927 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2373: // o_occbin_simul_periods: SIMUL_PERIODS EQUAL INT_NUMBER
#line 4427 "../preprocessor/src/DynareBison.yy"
                                                        { driver.option_num("simul.periods", yystack_[0].value.as < string > ()); }
#line 9933 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2374: // o_occbin_simul_curb_retrench: SIMUL_CURB_RETRENCH
#line 4428 "../preprocessor/src/DynareBison.yy"
                                                   { driver.option_num("simul.curb_retrench", "true"); }
#line 9939 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2375: // o_occbin_simul_check_ahead_periods: SIMUL_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4429 "../preprocessor/src/DynareBison.yy"
                                                                                { driver.option_num("simul.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9945 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2376: // o_occbin_simul_max_check_ahead_periods: SIMUL_MAX_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4430 "../preprocessor/src/DynareBison.yy"
                                                                                        { driver.option_num("simul.max_check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 9951 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2377: // o_occbin_simul_reset_check_ahead_periods: SIMUL_RESET_CHECK_AHEAD_PERIODS
#line 4431 "../preprocessor/src/DynareBison.yy"
                                                                           { driver.option_num("simul.reset_check_ahead_periods_in_new_period", "true"); }
#line 9957 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2378: // o_occbin_simul_debug: SIMUL_DEBUG
#line 4432 "../preprocessor/src/DynareBison.yy"
                                   { driver.option_num("simul.debug", "true"); }
#line 9963 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2379: // o_occbin_simul_periodic_solution: SIMUL_PERIODIC_SOLUTION
#line 4433 "../preprocessor/src/DynareBison.yy"
                                                           { driver.option_num("simul.periodic_solution", "true"); }
#line 9969 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2380: // o_occbin_likelihood_inversion_filter: LIKELIHOOD_INVERSION_FILTER
#line 4436 "../preprocessor/src/DynareBison.yy"
                                                                   { driver.option_num("likelihood.inversion_filter", "true"); }
#line 9975 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2381: // o_occbin_likelihood_piecewise_kalman_filter: LIKELIHOOD_PIECEWISE_KALMAN_FILTER
#line 4437 "../preprocessor/src/DynareBison.yy"
                                                                                 { driver.option_num("likelihood.inversion_filter", "false"); }
#line 9981 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2382: // o_occbin_likelihood_maxit: LIKELIHOOD_MAXIT EQUAL INT_NUMBER
#line 4438 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("likelihood.maxit", yystack_[0].value.as < string > ()); }
#line 9987 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2383: // o_occbin_likelihood_periods: LIKELIHOOD_PERIODS EQUAL INT_NUMBER
#line 4439 "../preprocessor/src/DynareBison.yy"
                                                                  { driver.option_num("likelihood.periods", yystack_[0].value.as < string > ()); }
#line 9993 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2384: // o_occbin_likelihood_curb_retrench: LIKELIHOOD_CURB_RETRENCH
#line 4440 "../preprocessor/src/DynareBison.yy"
                                                             { driver.option_num("likelihood.curb_retrench", "true"); }
#line 9999 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2385: // o_occbin_likelihood_check_ahead_periods: LIKELIHOOD_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4441 "../preprocessor/src/DynareBison.yy"
                                                                                          { driver.option_num("likelihood.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 10005 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2386: // o_occbin_likelihood_max_check_ahead_periods: LIKELIHOOD_MAX_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4442 "../preprocessor/src/DynareBison.yy"
                                                                                                  { driver.option_num("likelihood.max_check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 10011 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2387: // o_occbin_likelihood_periodic_solution: LIKELIHOOD_PERIODIC_SOLUTION
#line 4443 "../preprocessor/src/DynareBison.yy"
                                                                     { driver.option_num("likelihood.periodic_solution", "true"); }
#line 10017 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2388: // o_occbin_likelihood_max_kalman_iterations: LIKELIHOOD_MAX_KALMAN_ITERATIONS EQUAL INT_NUMBER
#line 4444 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.option_num("likelihood.max_number_of_iterations", yystack_[0].value.as < string > ()); }
#line 10023 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2389: // o_occbin_smoother_inversion_filter: SMOOTHER_INVERSION_FILTER
#line 4445 "../preprocessor/src/DynareBison.yy"
                                                               { driver.option_num("smoother.inversion_filter", "true"); }
#line 10029 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2390: // o_occbin_smoother_piecewise_kalman_filter: SMOOTHER_PIECEWISE_KALMAN_FILTER
#line 4446 "../preprocessor/src/DynareBison.yy"
                                                                             { driver.option_num("smoother.inversion_filter", "false"); }
#line 10035 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2391: // o_occbin_smoother_maxit: SMOOTHER_MAXIT EQUAL INT_NUMBER
#line 4447 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_num("smoother.maxit", yystack_[0].value.as < string > ()); }
#line 10041 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2392: // o_occbin_smoother_periods: SMOOTHER_PERIODS EQUAL INT_NUMBER
#line 4448 "../preprocessor/src/DynareBison.yy"
                                                              { driver.option_num("smoother.periods", yystack_[0].value.as < string > ()); }
#line 10047 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2393: // o_occbin_smoother_curb_retrench: SMOOTHER_CURB_RETRENCH
#line 4449 "../preprocessor/src/DynareBison.yy"
                                                         { driver.option_num("smoother.curb_retrench", "true"); }
#line 10053 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2394: // o_occbin_smoother_check_ahead_periods: SMOOTHER_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4450 "../preprocessor/src/DynareBison.yy"
                                                                                      { driver.option_num("smoother.check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 10059 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2395: // o_occbin_smoother_max_check_ahead_periods: SMOOTHER_MAX_CHECK_AHEAD_PERIODS EQUAL INT_NUMBER
#line 4451 "../preprocessor/src/DynareBison.yy"
                                                                                              { driver.option_num("smoother.max_check_ahead_periods", yystack_[0].value.as < string > ()); }
#line 10065 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2396: // o_occbin_smoother_debug: SMOOTHER_DEBUG
#line 4452 "../preprocessor/src/DynareBison.yy"
                                         { driver.option_num("smoother.debug", "true"); }
#line 10071 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2397: // o_occbin_smoother_periodic_solution: SMOOTHER_PERIODIC_SOLUTION
#line 4453 "../preprocessor/src/DynareBison.yy"
                                                                 { driver.option_num("smoother.periodic_solution", "true"); }
#line 10077 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2398: // o_occbin_filter_use_relaxation: FILTER_USE_RELEXATION
#line 4454 "../preprocessor/src/DynareBison.yy"
                                                       { driver.option_num("filter.use_relaxation", "true"); }
#line 10083 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2399: // o_occbin_write_regimes_periods: PERIODS EQUAL vec_int
#line 4458 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_vec_int("write_regimes.periods", yystack_[0].value.as < vector<int> > ()); }
#line 10089 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2400: // o_occbin_write_regimes_periods: PERIODS EQUAL vec_int_number
#line 4460 "../preprocessor/src/DynareBison.yy"
                                 { driver.option_vec_int("write_regimes.periods", yystack_[0].value.as < vector<int> > ()); }
#line 10095 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2401: // o_occbin_write_regimes_filename: FILENAME EQUAL filename
#line 4461 "../preprocessor/src/DynareBison.yy"
                                                          { driver.option_str("write_regimes.filename", yystack_[0].value.as < string > ()); }
#line 10101 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2402: // o_occbin_write_regimes_smoother: SMOOTHER
#line 4462 "../preprocessor/src/DynareBison.yy"
                                           { driver.option_str("write_regimes.type", "smoother"); }
#line 10107 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2403: // o_occbin_write_regimes_simul: SIMUL
#line 4463 "../preprocessor/src/DynareBison.yy"
                                     { driver.option_str("write_regimes.type", "simul"); }
#line 10113 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2404: // o_occbin_graph_noconstant: NOCONSTANT
#line 4466 "../preprocessor/src/DynareBison.yy"
                                       { driver.option_num("graph.steady_state", "false"); }
#line 10119 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2405: // range: symbol ':' symbol
#line 4469 "../preprocessor/src/DynareBison.yy"
        { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 10125 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2406: // integer_range: INT_NUMBER ':' INT_NUMBER
#line 4472 "../preprocessor/src/DynareBison.yy"
                { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 10131 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2407: // integer_range_w_inf: INT_NUMBER ':' INT_NUMBER
#line 4475 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), yystack_[0].value.as < string > ()}; }
#line 10137 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2408: // integer_range_w_inf: INT_NUMBER ':' INF_CONSTANT
#line 4477 "../preprocessor/src/DynareBison.yy"
                      { yylhs.value.as < pair<string,string> > () = {yystack_[2].value.as < string > (), "Inf"}; }
#line 10143 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2409: // signed_integer_range: signed_integer ':' signed_integer
#line 4481 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = yystack_[2].value.as < string > () + ':' + yystack_[0].value.as < string > (); }
#line 10149 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2410: // signed_integer_range: MINUS '(' signed_integer ':' signed_integer ')'
#line 4483 "../preprocessor/src/DynareBison.yy"
                       { yylhs.value.as < string > () = "-(" + yystack_[3].value.as < string > () + ':' + yystack_[1].value.as < string > () + ")"; }
#line 10155 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2411: // vec_int_number: INT_NUMBER
#line 4486 "../preprocessor/src/DynareBison.yy"
                 { yylhs.value.as < vector<int> > () = {stoi(yystack_[0].value.as < string > ())}; }
#line 10161 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2412: // vec_int_elem: vec_int_number
#line 4489 "../preprocessor/src/DynareBison.yy"
               { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 10167 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2413: // vec_int_elem: INT_NUMBER ':' INT_NUMBER
#line 4491 "../preprocessor/src/DynareBison.yy"
               {
                 auto v = views::iota(stoi(yystack_[2].value.as < string > ()), stoi(yystack_[0].value.as < string > ()) + 1);
                 yylhs.value.as < vector<int> > () = {v.begin(), v.end()};
               }
#line 10176 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2414: // vec_int_1: '[' vec_int_elem
#line 4498 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 10182 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2415: // vec_int_1: '[' COMMA vec_int_elem
#line 4500 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<int> > () = yystack_[0].value.as < vector<int> > (); }
#line 10188 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2416: // vec_int_1: vec_int_1 vec_int_elem
#line 4502 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 10197 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2417: // vec_int_1: vec_int_1 COMMA vec_int_elem
#line 4507 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > ();
              yylhs.value.as < vector<int> > ().insert(yylhs.value.as < vector<int> > ().end(), yystack_[0].value.as < vector<int> > ().begin(), yystack_[0].value.as < vector<int> > ().end());
            }
#line 10206 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2418: // vec_int: vec_int_1 ']'
#line 4513 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<int> > () = yystack_[1].value.as < vector<int> > (); }
#line 10212 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2419: // vec_int: vec_int_1 COMMA ']'
#line 4514 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<int> > () = yystack_[2].value.as < vector<int> > (); }
#line 10218 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2420: // vec_str_1: '[' QUOTED_STRING
#line 4518 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10224 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2421: // vec_str_1: '[' COMMA QUOTED_STRING
#line 4520 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10230 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2422: // vec_str_1: vec_str_1 QUOTED_STRING
#line 4522 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 10239 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2423: // vec_str_1: vec_str_1 COMMA QUOTED_STRING
#line 4527 "../preprocessor/src/DynareBison.yy"
            {
              yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
              yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
            }
#line 10248 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2424: // vec_str: vec_str_1 ']'
#line 4533 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 10254 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2425: // vec_str: vec_str_1 COMMA ']'
#line 4534 "../preprocessor/src/DynareBison.yy"
          { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 10260 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2426: // vec_value_1: '[' signed_number
#line 4538 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10266 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2427: // vec_value_1: '[' COMMA signed_number
#line 4540 "../preprocessor/src/DynareBison.yy"
              { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10272 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2428: // vec_value_1: vec_value_1 signed_number
#line 4542 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 10281 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2429: // vec_value_1: vec_value_1 COMMA signed_number
#line 4547 "../preprocessor/src/DynareBison.yy"
              {
                yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
              }
#line 10290 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2430: // vec_value: vec_value_1 ']'
#line 4553 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 10296 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2431: // vec_value: vec_value_1 COMMA ']'
#line 4554 "../preprocessor/src/DynareBison.yy"
            { yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > (); }
#line 10302 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2432: // vec_value_w_inf_1: signed_number_w_inf
#line 4558 "../preprocessor/src/DynareBison.yy"
                    { yylhs.value.as < vector<string> > () = {yystack_[0].value.as < string > ()}; }
#line 10308 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2433: // vec_value_w_inf_1: vec_value_w_inf_1 signed_number_w_inf
#line 4560 "../preprocessor/src/DynareBison.yy"
                    {
                      yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > ();
                      yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                    }
#line 10317 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2434: // vec_value_w_inf_1: vec_value_w_inf_1 COMMA signed_number_w_inf
#line 4565 "../preprocessor/src/DynareBison.yy"
                    {
                      yylhs.value.as < vector<string> > () = yystack_[2].value.as < vector<string> > ();
                      yylhs.value.as < vector<string> > ().push_back(yystack_[0].value.as < string > ());
                    }
#line 10326 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2435: // vec_value_w_inf: '[' vec_value_w_inf_1 ']'
#line 4572 "../preprocessor/src/DynareBison.yy"
                  { yylhs.value.as < vector<string> > () = yystack_[1].value.as < vector<string> > (); }
#line 10332 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2436: // vec_of_vec_value_1: vec_of_vec_value_1 COMMA vec_value
#line 4576 "../preprocessor/src/DynareBison.yy"
                     {
                       yylhs.value.as < vector<vector<string>> > () = yystack_[2].value.as < vector<vector<string>> > ();
                       yylhs.value.as < vector<vector<string>> > ().push_back(yystack_[0].value.as < vector<string> > ());
                     }
#line 10341 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2437: // vec_of_vec_value_1: vec_value
#line 4581 "../preprocessor/src/DynareBison.yy"
                     { yylhs.value.as < vector<vector<string>> > () = {yystack_[0].value.as < vector<string> > ()}; }
#line 10347 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2438: // vec_of_vec_value: '[' vec_of_vec_value_1 ']'
#line 4585 "../preprocessor/src/DynareBison.yy"
                   { yylhs.value.as < vector<vector<string>> > () = yystack_[1].value.as < vector<vector<string>> > (); }
#line 10353 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2439: // symbol: NAME
#line 4588 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10359 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2440: // symbol: ALPHA
#line 4589 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10365 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2441: // symbol: BETA
#line 4590 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10371 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2442: // symbol: NINV
#line 4591 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10377 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2443: // symbol: ABAND
#line 4592 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10383 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2444: // symbol: CMS
#line 4593 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10389 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2445: // symbol: NCMS
#line 4594 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10395 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2446: // symbol: CNUM
#line 4595 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10401 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2447: // symbol: GAMMA
#line 4596 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10407 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2448: // symbol: INV_GAMMA
#line 4597 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10413 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2449: // symbol: INV_GAMMA1
#line 4598 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10419 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2450: // symbol: INV_GAMMA2
#line 4599 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10425 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2451: // symbol: NORMAL
#line 4600 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10431 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2452: // symbol: UNIFORM
#line 4601 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10437 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2453: // symbol: EPS
#line 4602 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10443 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2454: // symbol: PDF
#line 4603 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10449 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2455: // symbol: FIG
#line 4604 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10455 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2456: // symbol: NONE
#line 4605 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10461 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2457: // symbol: DR
#line 4606 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10467 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2458: // symbol: PRIOR
#line 4607 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10473 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2459: // symbol: TRUE
#line 4608 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10479 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2460: // symbol: FALSE
#line 4609 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10485 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2461: // symbol: BIND
#line 4610 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10491 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2462: // symbol: RELAX
#line 4611 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10497 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2463: // symbol: ERROR_BIND
#line 4612 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10503 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2464: // symbol: ERROR_RELAX
#line 4613 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10509 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2465: // symbol: KIND
#line 4614 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10515 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2466: // symbol: LL
#line 4615 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10521 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2467: // symbol: DL
#line 4616 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10527 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2468: // symbol: DD
#line 4617 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10533 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2469: // symbol: ADD
#line 4618 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10539 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2470: // symbol: MULTIPLY
#line 4619 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10545 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;

  case 2471: // symbol: MFS
#line 4620 "../preprocessor/src/DynareBison.yy"
         { yylhs.value.as < string > () = yystack_[0].value.as < string > (); }
#line 10551 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"
    break;


#line 10555 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    const int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        const int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        const int yychecklim = yylast_ - yyn + 1;
        const int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }






  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -3988;

  const short parser::yytable_ninf_ = -2459;

  const short
  parser::yypact_[] =
  {
    7842,   380,   381,  -131, 13858,  -125,  -116,  -101,   -31,   -64,
   13941,   605,    35,    57,   107, 14425,   161,    68,   775,   825,
     120,    74, -3988,   171, 14508,   180,   836,   186,   840,   895,
     970,   205,   976,   211,   231,   192,  1049, 15005,  1105,  1120,
     242,   246,   263, -3988,  1143,   293,   352,   427, 15685, 21588,
   16911, -3988, 16943,  1146,  1173,  1193,  1196, 21588,   305,  1201,
    1211, 16176,  1255,  1277,  1282,   453,  1292, 16450, 16532,  1301,
   16561,   503, 16642,  1302,  1311,  1314,  1332, 16720, -3988, -3988,
   -3988, -3988, -3988, 21588, 17021, 17102, 21588, -3988, -3988, 21588,
     366, 16752, 21588,  1343,  1344,  1349,   597,   396,   423,   606,
    1350,  1356,   615,  1366, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988,  1369,   646, 16833,  1392,  1401,  1417,
    1420,  1421,  1425, -3988,   674,   630,   705,   640,   733,   756,
     767,   654,   778, -3988, -3988, -3988, -3988, -3988, -3988,  1437,
   17135,   868,   904,   916, 21588,   704,  1450,  1451,  1456, 21588,
     526,  7251, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,   385, -3988, -3988,  1092, -3988,
   -3988,  1106, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,   386,   749,  3444,   940,
    3158,  1241, -3988,  2772,  5749, -3988,   307, -3988,  1631,  1259,
    1309, 21588, -3988,  1516,  5992,   335, 21313, 21313, 21588,   388,
   -3988, 12272,  6167, 18332,  1445, 11719, 18795,  1565, -3988,  1622,
    1647, 21588,  1832, -3988,  1645,  6262, 21588, 21588,  1720,  1918,
   21588,  1025, -3988,   735, 21588,  1762,  1918, 21588,  1484, 21313,
    1634, -3988, -3988,   499, -3988,  1632,  1050,  5322, -3988, -3988,
     796,  1440,   271, -3988, 21588, 21588,   628,   649, 21588, 21588,
   21588, -3988, 12599,  6423,  6694,  1063,  7964,   156, 15432,  1551,
    8170, -3988,   650, -3988,  4093, -3988,  1589, -3988,  6156,  8265,
   21313,   571,   316,  1441,  1597, -3988,  2767,  8342, 21362,  1626,
   -3988,  3701, -3988,  1132, -3988, -3988,  2750, -3988, 12823,  8368,
   -3988,  1630,  8424, -3988,  1164, -3988, 12920,  8590, -3988, -3988,
   12904,  8643, -3988,   608, -3988, 12260, -3988,  1655, -3988,   541,
   -3988,  1649,  8670,  8696,   376,  8768,  1134,  8891,  8944, 21588,
   21588,  8971,  1258, -3988,  2795,  9011,  9273,  1492, -3988,  1668,
   -3988,  1675, -3988,  1683, -3988,   287, -3988,   321, -3988, 19446,
   -3988, 19446,   610, 21588,  1640, -3988, 20957,  1359, -3988,  3515,
    9312, -3988,  3929, -3988,  3287, -3988,   892, -3988,  1462, -3988,
     927, -3988,  3937,  1156,  1158, -3988,  1072, -3988,   829,   296,
     296, -3988, 21588, -3988, 13404, -3988,  9350, 12754, 12754,   511,
    9471, 18332, -3988,  1218,  1099,  1654, 21588,  1691,  9516,  1432,
   -3988, -3988, 14584, 21588, 18976, 19002, 16373, 21011, -3988,  1908,
   -3988,  1940,  1962,  1969,  1982,  1986, -3988,  1997,  1998,  2016,
   -3988,  2021,  2028,  2034,  2041, -3988,  2082,  1371, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,  2081,  2086,  2087, -3988,  2114,
    1427, -3988, -3988, -3988,  2120,  2105, -3988,  2125,  2132, -3988,
   -3988,  2135, -3988, -3988, -3988, -3988, -3988, -3988,  1454,  2184,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, 21588,
   -3988, -3988, -3988, -3988, -3988, -3988,  1463, -3988,  2166,  2171,
    2175,  2179,  2180,  2182,  2185, -3988,  2186,  2188, -3988,  2189,
   -3988,   294, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,  2192,  2193,  2194,  2197,
     299, -3988, -3988, -3988, -3988, -3988, -3988, 21588,   619, -3988,
    2206,  2198, -3988, -3988, -3988,  2201, -3988,  2202,  2203,  2204,
   -3988,  2208, -3988,  2209, -3988,  1502,  2234, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988,  1515, -3988,  1517,  1519, 19556, -3988,   349,  1520,
    2219, -3988, -3988,  2229,  2230, -3988, -3988, -3988,  2232,  2235,
    2236, -3988, -3988, -3988,  2237,  2238,  2239,  2240, -3988,  2241,
    2242, -3988, -3988,  2243,  2244, -3988,  2247,  2253,  2254, -3988,
    2259,  2261, -3988, -3988, -3988,  2264,  2268,  2271,  2274,  2277,
    2278,  2282,  2284,  2287,  2288, -3988,  2301,  2302, -3988, -3988,
    2304,  2305,  2310,  2311, -3988,  2314,  2316,  2321,  2323,  2324,
   -3988, -3988,  2327,  2335,  2342,  2344, -3988,  2352,  2356,  2358,
    2359,  2364,  2365,  2367,  2384,  2389,  2399,  2400, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,  2401,  2404, -3988,
    2406, -3988,  2407,  2413,  2437,  2442, -3988, -3988, -3988,  2501,
    2510,  2511, -3988,  2515, -3988,  2517, -3988, -3988, -3988,  2522,
    2524,  2526,   315, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, 21588, -3988, 21588,
   18370, -3988,   359, -3988,  1657, 21588, 21588, 18571, -3988,  2553,
   21588, 21588, 18633, -3988,  2555,  1830, -3988, -3988,  2549,  2550,
   -3988,  1855,  2582, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
     115, 19582, -3988,  2583,  2575,  2600,  2636,  2640,  2641,   341,
   -3988,   343, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  1938,
   19611, -3988,  1947,  1948,  2651,  2654,  2657,  2661,  2666,  2670,
     347, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, 19670, -3988,  2702,  1977,  2682,  2684,  2688,  2697,
    2699,  2700,  2709,  2710,  2723, -3988, -3988, -3988, -3988, -3988,
    2724,  2725,  2730,  2732,  2733,  2734,  2736,  2013,  2759, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, 19770, -3988,  2739,  2040,   351, 19829,
   -3988,   430,  2047,  2048,  2745, 15432, 15044,  2756, -3988, -3988,
    2757,  2758, -3988, -3988,  2762, -3988,  2763,  2765,  2766, -3988,
     353,  2769,  2063,   639, 21313, -3988,  1999, -3988, -3988, -3988,
     355, -3988, -3988, -3988, -3988, 21588, -3988,   678, -3988,  2775,
   -3988,   256, -3988, 19884, -3988,  2798, 19929, -3988,  2074,  2077,
    2802,   637, -3988,  2084,  2807, -3988, -3988, 20091, -3988,  2083,
   20130, 20157,  5490,  2789,  2790,  2791, -3988,  2792,  2793,  2794,
    2796,  2800, -3988, -3988, -3988, -3988, -3988, -3988,  2801,  2806,
   -3988,   358, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  2808,
   21588, -3988,   164,  2092, 18757,  1115, -3988, -3988, -3988,  2095,
    2104,  2106,  2108,  2109,  2110, 15432, 15432,  2112,  2113,  2115,
    2129,  2130,  2138,  2139,  2140,  2144,  2145,  2147,  2148,  2154,
    2155,  2157,  2158,  2161,  2163,  2164,  2165,  2168,  2169,  2170,
    2173,  2174,  2176,  2177,  2178, 15432,  2764, -3988,  -104,  1435,
    2817, -3988,  2835,  2874, -3988,   368, -3988, -3988, -3988, -3988,
   -3988, -3988,  2878,  2882, -3988,  2885,  2887, -3988, -3988,  2888,
   -3988,  2889,  2892,  2893,  2895,  2896,  2899,  2903,  2905,  2906,
   -3988,  2907,  2908,   397, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988,   403, -3988, -3988, -3988, -3988, -3988, -3988, -3988,   405,
   -3988, -3988, -3988,  2205, 21588, 21588,   600, -3988, -3988, -3988,
     406,   416,  2910,  2911, 21588,   682, -3988,  2211,  2913,  2916,
   -3988,  2917,  2918, -3988,  2217,  2944, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  2923, 19277, -3988,  2924,  2925, -3988, -3988,
     425, -3988,  2927,  2928,  2930,  2931,  2932,  2231,  2955, -3988,
   -3988, -3988, -3988, -3988,  6627,   426, -3988,  2934,  2937, -3988,
     428, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  2938,
    2939,  2940,  2941,  2245,  2965, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  2945,  2948,
    2951,   451, -3988, -3988, -3988, -3988, -3988,   452, -3988, -3988,
   -3988, -3988, 15432,  2958,  2960,   477, -3988, -3988, -3988, -3988,
   -3988,  2961,  2962,  2251,  2966, -3988, -3988,  2963,  2967,  2968,
    2969,  2970,  2971, -3988, -3988, -3988,  2972,  2974, -3988,  2977,
    2978,  2979,  2981, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  2983,  2260,  3008, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  2285,  3017, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  2996,  2998, -3988, -3988,  2295,  3022, -3988,
   -3988, -3988, -3988, -3988,  2297,  3024, -3988, -3988, -3988,  3004,
     479,  3005,  3006, -3988,  3009, -3988, -3988,  9675, -3988,  9732,
   -3988, -3988,  3010,  3011,  3013,  3014,  3015,  3016,  3018,   484,
   -3988,  3019, -3988, -3988, -3988, -3988, -3988,  3021,  3023,  3026,
   -3988,  3027,  3028,  3029, -3988, -3988, -3988,  3031,  3034,  2313,
    3044, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, 21588, -3988,  2698, -3988,  2332,  2333,  2334,  3041,
   -3988,  3042,   485, -3988, -3988, -3988, -3988,   393,  3043,  3046,
    3047,   488, -3988, -3988, -3988, -3988,  3048,  3049,  3050,  3051,
    3053,  3054,  3055,  3056,  3057,  3058,  3059,  3073,  3075,  3081,
    3083,  3096,  3097,  3098,  3099,  3100,  3101,  3102,  3103,  3105,
    3110,  3111,  3116,  3119,  3120,  3121,  3125,  2340,  3146, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988,  2439,  3147,  3148,  3149,  3150,   489, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, 20185, -3988, 19189,  3151,  3152,
    3155,  3156,  3161,  3162,  3166,  3167,  3169,  3171,  3172, -3988,
    3173, -3988,  3174,  3176,  3177,  3178, -3988,  3181,  3182,  3183,
    3184,  3188,  3189,  3191,  3204,  3206,  3227,  3228,  3230,  3231,
    3232,  3234,  3236,  3238,  3239,  3240,  3242,  3243,  3244,  3245,
    3248,  3249,  3250,  3253,  3254,  3168,  2471, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,  3255, -3988, -3988,  3257,  3258,
    3259,  3261,  3262,  3263,  3264,  3265,  3266,  3268, -3988,  3269,
    3293,  2568, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3295,  2570,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988,  3275, -3988,  3281,  3284,  3285,  3286,
    3288,  3290,  3292,  3294,  3296,  3297,  3298,  3299,  3302,  3303,
    3306,  3309,  2585, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3308,  3310,
   -3988,  3312,  3315,  2591, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988,  3313,  3314,  3317,  3318, -3988,  3326,  2605, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3337,  2615, -3988,
   -3988, -3988, -3988,  3320,  3343,  2618, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
     240,  3323,  3324,  3325,  3327,  3341,  3345,   490, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,  3179, -3988, -3988,  3346,   491,
   -3988, -3988, -3988, -3988, -3988,  3349,  3350,  3351,  3352,   493,
   -3988, -3988, -3988, -3988, -3988,  3353,  3354,   495, -3988, -3988,
   -3988,   521,  3192,  2622,  3355,  3358,  3359,  3366,  3368,  3370,
   -3988, -3988, -3988, -3988,  3374,  3375, -3988,  3376,  3377,  3379,
    3380,  2677,  3404, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, 21588, -3988,   523,  3385,   524,
     525, -3988,  2687, 18402, -3988,  2685, 21588, 21588,   617, -3988,
    3185,  2691, 20250, -3988,  3413,  2693,  2703, -3988, -3988,  2701,
    2706,  2705,  2694,   529, -3988,  3403,  2711,  2712,  2716,  2704,
    2727,  2728,  2718,  2720, -3988,  2729,  2735,  2737,  2741, -3988,
   16373, 16373,  2742,  2743,  2744,  2746,  2748,  2751,  2754,  2760,
    2778,  2780,  2781,  2782,  2784,  2786,  2805,  2809,  2812,  2813,
    2814,  2815,  2818,  2821, 16373,  2696, -3988,    10, -3988, -3988,
    2822,   431,  2731,   639,  1028,   639,  3363,  1028,  3365, 21313,
    3367,   281,  3372,  3378, 21411, 21588,  3444,  3382,  3390,   639,
    3391,  3158,  3392,  3215,  2787,  3423,   639,  1310, 17212,  2772,
   -3988, 21588,  3424,  3425,  3427,   639,   639,   639,  3440,   639,
    3441,  2823,  1631,  2819,   639,  2824,  3458,  3459,  1259,  2829,
    2833,  2836, -3988, 21588, 21313,  1384,  1121,  1647,  1647, 21588,
    3466, 17294,  1516, -3988, 17322, 17403,  2837, -3988, 16373, 16373,
   16373,  2838,   629,  3470,  3311,   639, 21588,   639,   639,  3484,
     639,  3487, 21313,   281,  1263,   281,  3488,  2853,   639,   639,
    3489,  1334,   639,   639,   639,   639,   639,   639,   639,   639,
     639,  3490,  3491, 21313, 21313, 21313,  3492,   751,  3497,  3509,
   21521, 21313,  3511,  2787,  2877,  2877,  3514, 20825,  3547,   399,
     639,  1538,  1396,  3548, 21588,  1652,  1666,  2919,  3549,  3550,
     639,  2921,   697,  3551,  3555,  1578,  2929,  3556,  2787,  3557,
     639,  3558, 12272, 17481,  3607, -3988,  2933, -3988,   784, -3988,
    2936,  3653,  3655,  2943, -3988, 16373,  3657,  3660,  2946, -3988,
   16373,  2952,  3569,  3570,  2953,  1622,  3571,  2980,  2984, -3988,
   16373,  3401,  3402,  3405,  3408,  3422,  1832,  2985,  1645, 17513,
    2982,  2986, -3988,   731,  2987, 21588, 21313,   785,   811,   826,
    1075,  1918,  2988,  2992, -3988, 16373,  2993,  1028,   639,  3598,
    3636,   731,  3638,  3639, 21038,  3640,  3641,  3642,   639,   639,
     639,  3643,  3647,  3030,   735,  3032, -3988, 16373,  3033,  3039,
    3040, -3988, 21588,  3648,  3065,  3068, -3988, 14477,  6684, 21588,
   21588, 13342, -3988,  1137, -3988,   639,   639,  3025,  3067,  3649,
    3650, 21588,   511,  3070,   652, 21313,  3038,  3072,   639,   796,
    3076,  3077,  3078, -3988,   629,  3079, -3988,  3080, -3988, 21588,
    3082, -3988,   731, -3988, 21588,  3084, -3988,  3085,   649,  3088,
   -3988, 16373,  3089,  3090,  8090, 21588,  7008,   639,  3652, 21203,
     639,  3659,  3662,   639,  3665,   639,  3679, 12599, 17565, 21588,
     230,  2092, -3988, -3988, 21588, -3988,  3436, 13382, -3988, -3988,
   15432, 15432, 15432, 15432, 21588, 21588,  3395,  3395, 15432, 15432,
   15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432,
   15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432,
   15432, 15432, 15432,   731, 21588, 15432,  1513, 15432, 15432, 15432,
   15432, 15432, 15432, 15432, 15432, 15432, 15432, 15432,  3091, 21588,
    3092, -3988, -3988, -3988,  3714,  1647,  1647,   650,  3093,   639,
     639,  3723,   639,  3728,  3734,  3736,   639,   639,   639,   639,
     639,   639,  3737,   639,  3106,  4093,  3107,  1589,  3113,  6156,
    3114,  3115,  3752,   437,  3117, -3988,    25,  3118,  3589,  3122,
     629, 21588,  3126,  3127, -3988,  3128,  1326,  3741, 21588, 21588,
   17596,  2767, 21588,  3129, -3988, 21588, 21588,  3701,  3132, 21313,
    3109, 21313,  3123,  3747,  3133,  1132, 21588,  5908, -3988,  3820,
    2750,  3134,   639,  2787, 12823, 17672,  3751,   281,  3755,  2787,
   17783,  1630,  3135, 16373,  3506,  1164,  3136, 12920, 17866,  7714,
   14885,  3766,   639, 12904, 17942,  3769,  3770,  3140,   608,  3775,
    3776,  3779,  3780,  3781,  3795,  3807,  3816,  3817,  3818,  3819,
    3821,  3824,  3194, 12260,  3195,  1655, 21313,   281,  3196,   541,
   17973,  1649, -3988,  3381, 21588, -3988, 21588, 21588, 21588, -3988,
   -3988, 21588, -3988, -3988, -3988, 21588, 16373, 21588, 21588,  3830,
     731,  1258,  3200, 21313,  1491,  3832,  3834,  1340,  1647,  1647,
   21588,  3835, 18026,  2795,  3580, -3988,  3209,  3210,  3211, 21588,
    3208,   287,  3216,  3916,  3922,  3924, -3988,  3926,  3928,   532,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, 21588,  3208,  3208,
     321,  3229,  3859,  3861,  3862,  3863,  3865,  3867,  3868,  3869,
    3870,  3871,  3872,  3873,  3874,   639,  3877,  3246,   639,   639,
    3251,  3252,  3256,  3878,  3886,  3260,   639,  3887,   639,   639,
     639,   639,   639,  3267, 19446,  3270, 21313,  1647,  1647,  3888,
     610,  3271,  3272, -3988, 21588,  3274, 21588,   318,  3890,  3891,
    3894,  3895, 21313,  3897,  3277,  3899,   398,  3911,  3912,  3913,
    3914,  3915,   639,   639,  3919,  3920,  3921,  3923,  3927,  3931,
     639,  3933,  3934,  3935,  3936,  3938,  3940,  3941,  3942,  3943,
    3946,  3948,  3949,  3950,  3952,  3953,  3954,  3955,  3956,  2877,
   20957,  3291, -3988,  3957, 21313,  3958, 21313, 21313,  2877,  3963,
    3964,  2877,  1028,  3977,  3515, 18055,  3929,  3301,   203,   639,
     639,   639,  3978,   639,  3979,  3980,   639,   639,  3982,  3983,
    3984,  3985,   639,   639,  3287,  3316,  3989,  3990,  3992,   892,
    3364,  3994,  1028,  1028,  3996,  1462,  3384,   927,  3386,  3997,
    3937,  3387,  3416,   247,  3388,  3393,   956, -3988,  3371,  3410,
    3998,   500,  3999,  4003,  1158,  3396, -3988,   647, -3988,   281,
    1072,  3397, 21619,  4013, 21619, 21619,   829,  3409, 21313,  4016,
     296,  3412,  3417,  3742,   657, -3988,  3420,   639,  1373,  3716,
    4020,  3208,   639,  4021,  4023,   639,  4026, 21313,   639,  3421,
   13404,   314, -3988, 12959,  3426,  3750,  3428,  3433, -3988,  3434,
   -3988,  3435,  3462,  3463,  3465, -3988,  1391,  3477,  3480, -3988,
   21588,  4053,  3481,  3348, 21588, 21588, -3988,  4041, 21588,  3482,
    1647, 21588, 21588, -3988, 21889, 21588, 21588, -3988, 21713, 16373,
   16373, 16373, 16373,  3620,  3620, 16373, 16373, 16373, 16373, 16373,
   16373, 16373, 16373, 16373, 16373, 16373, 16373, 16373, 16373, 16373,
   16373, 16373, 16373, 16373, 16373, 16373, 16373,  2453, 16373, 16373,
   16373, 16373, 16373, 16373, 16373, 16373, 16373, 16373, 16373, -3988,
    3483,  1862,  3494,   408, -3988,   639,   639, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,   638, -3988,   310, -3988,
   -3988, -3988, -3988, -3988, -3988,  3305, -3988,  3498, -3988, -3988,
   -3988, -3988,  3499,  3500, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,  9774, -3988,  9850, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3882, -3988, -3988,
   -3988, 21588, -3988, -3988, -3988, -3988,  3908, -3988,  3502, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,  1084, -3988,  3626,
    3626, -3988, -3988, -3988,  9893, -3988, -3988,  9933, -3988,  9976,
   -3988,  7883,  7960,  8153, 21588, -3988,  3503,  3626, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
    1084, -3988, -3988, -3988, -3988, 21588, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  1390,
    1482, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988,   959,   350, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3882, -3988,
   -3988, -3988,  3882, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
    3893, -3988, -3988, -3988, -3988, -3988, -3988, -3988, 10052, 21588,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  8308,
    4206,  3507,  4209, 18332, 21588, 16373, -3988,  1338, 21588, 16373,
   -3988,  8390, 18675, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
    1575, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   10094, 21246, -3988, -3988,  4120,  4121,  3505, 21588, -3988, -3988,
    3626, -3988,  3626, -3988,  3626, -3988,  3626, -3988, -3988, -3988,
     998, 20344, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988,  8488, 21588, -3988, -3988,  4215,   333,  3508, 21588,
   -3988, 15432,  3512,  8559, -3988,   320,  4195,  3513, -3988, -3988,
   15432, 15432, -3988, -3988, -3988, 21588, 21313, -3988, -3988,  3516,
   -3988, -3988, -3988, -3988,  5370, -3988,   639,  3517, -3988, -3988,
    4002, -3988, -3988,  1440, -3988,   432, -3988,  3520,   363,  4198,
   -3988,   703, -3988, -3988,  2717, -3988, -3988, 21588,  8644, 16373,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, 10155,  3521,  2092, -3988, -3988, -3988,
    3959, -3988, -3988,  1741,  2827,  3668,  3733,  3522,  3523,  3875,
    3932,  3981,  4089,  4197,  4248,  4305,  4353,  4514,  4565,  4595,
    4675,  4712,  4750,  4762,  4905,  4917,  4954,  5034,  2964,  5103,
    5122,   361,   377,  5151,  3526,  3528,  5164, -3988,  1547,  1547,
    1270,  1270,  1270,  1270,   365,   365,  3395,  3395,  3823, -3988,
   -3988, 15432,  3529,  3626,  3626, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, 21588, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   21588, 21588, 16373,   412, -3988,  3531,  4216,  4236,   609,  3533,
    1440,   533,   534,  4019, -3988,   693, -3988, -3988, -3988, -3988,
   -3988, -3988, 10253, -3988, 10314, -3988, -3988, 10353,  3536, -3988,
   -3988, -3988, 21588, -3988, 21588, -3988, -3988, -3988,   747,  3553,
   -3988, 16373, -3988, -3988, -3988, -3988, -3988, -3988, 10476, -3988,
   -3988, -3988, -3988, -3988, -3988, 10512, -3988, 21588,  4285, -3988,
   -3988, -3988, -3988, -3988, 10557, -3988,  3554,  8946, -3988, -3988,
   -3988, -3988, 10671, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   10719, -3988, 15432,  4252, 10778, 15432,  3552,  3561, -3988, -3988,
   15432, -3988,  4285, -3988, -3988,  3559, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,  1084, -3988,  3626,  3626,
   -3988, -3988, -3988, 10830, -3988, -3988, -3988, -3988, -3988, -3988,
     581,   311, -3988, -3988, -3988, 21588, 21588, 21588,  4258, 21588,
    1395,   393,  3566, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,   751, -3988, -3988, -3988, 16070, 16070, 16070,
   -3988, -3988, 16070, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3567, -3988,
    3565, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   21588, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   15432, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, 10879, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988,  4189,  4190,  3572, -3988, -3988,  3578, -3988, 21588,
    2877, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  4262,
    3579, -3988, -3988, -3988, -3988, -3988, -3988,  3563, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  3581,
    3582, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, 21588,
   -3988, -3988, 21588, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
    3944,  3951, -3988,  3584,   576, -3988,   215,  1099, -3988,  4294,
    1257,  3577, 21588,   800,  4309,  3585, -3988, -3988,   233,  4314,
    3605,  3603,  3604,  4315,  3610, -3988,  3608,  3104,  3131,  5200,
    5212,  5268,  5310,  5377,  5527,  5620,  5719,  5779,  5804,  5827,
    5877,  5958,  6198,  6545,  6557,  6600,  6630,  6707,  6761,  6773,
    6812,   415,   531, -3988,  1772,  1772,  1347,  1347,  1347,  1347,
    1289,  1289,  3620,  3620,  3823, 16373,  4317,  4318,  4319,   535,
   -3988, -3988, -3988, -3988,  1494,  3617,  4321, -3988, -3988,  4257,
    3630, -3988, -3988,   379, -3988, -3988, 21588, -3988, -3988,  3632,
   -3988, -3988,  4358, -3988, -3988,   536,  1163,  1391,  3629, -3988,
     537, -3988, -3988, -3988, -3988, -3988, -3988, 20409,  3637,   538,
    1323, -3988, -3988,  1028, -3988,   607, -3988, -3988,   558,   559,
    4361, -3988, -3988,   560, -3988, -3988,   784, -3988, 16373, 18456,
    4362,  3175, 16373,  4363,  9018, -3988,  3644, 18730, 16373, -3988,
   -3988,  3658,   435,  3634, -3988, -3988,  4343, 20435, 16373, -3988,
    3664, 20503, -3988, 20617,   267,  4274,  4380,  4382, 20665,  6831,
   -3988, -3988, 15432, 15432, -3988,  3219,  9089,  2749, -3988,   562,
   -3988, 15044, -3988,  3667, -3988,  1391,   694,   267,   955,  4369,
   21588, -3988,  1028,  3672,   709,  3673, 16373, -3988,  9141, -3988,
   21588, -3988, -3988, 15432, 15432, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  4119, -3988,
   -3988, 15432, -3988, 15432, -3988, -3988,  3674, -3988, -3988,  2764,
     563, 21588,  3139,  4375,  4376,  9169, 16373,  3691,   629, 21588,
    3692,   612,  3693, -3988,   702,  4181,  3695,  4183,  3697,  1391,
    3698,   714, -3988, 21588, -3988, -3988, -3988,  3700,  3947,  4731,
    4402, -3988,  9194, -3988, -3988,  4784, -3988, -3988, -3988, -3988,
   -3988,  6917, -3988, -3988,  6949, 21588, 21588,  2764,   848,   565,
   -3988,  4159, -3988,   214, -3988, -3988, -3988, -3988, -3988, 15432,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,   391, -3988,
   19348,  3721,  3722,  3729,  3730, -3988,  3703,  4901,  6994, -3988,
    4427,  3726, -3988, -3988,   954, -3988,   332, 16373, -3988,  1542,
   -3988,  1085, -3988,   334, 15044, 21588, 21588,  4366,  1391,   184,
   -3988,  1647,   691, 16373,  4454,  4460, 20710,  4439,  4440,  4441,
    4442,  4445,  4446,  4447,  4448,  4449,   568, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, 21588,  3758,
    1647, 21588,  3760,  3995, 21588,  3761,  4370, 16373, 16373, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, 16373, -3988, 16373, -3988,  4285,   569,  3246,   639,  1028,
    1862,  3772,  4471,  4474,   570, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,  1862,  3773, -3988,  4408,
   -3988, -3988, -3988, -3988,  1428,  3882, -3988, -3988,   598, 21287,
    1084, -3988,  3789, 21588, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988,   706,  3893, -3988,  4285,  4502,  4503,  4504, -3988,  3794,
   16373, 16373,  9293, 16373, -3988, -3988,  3802,  9328,  1862,  3801,
     410, 16373,  3804,  9353, -3988,  3805,  3806, -3988, -3988, 16373,
    3812, -3988, 21588, 21588,  3814, 21588,  1149,  9391, 15432, -3988,
   -3988, -3988, 21313, -3988,  3815, 13751, -3988,   599,  3822,  3826,
     384,  1468,  3825, 16373,  4508, -3988, -3988,  3827, -3988,  9486,
   -3988, 10937,  7029,  7069,   572,  3202,  3289, 15432, 15432, -3988,
   11097, -3988, 16373, 16373, -3988,  9529,  1440,  3828,  3831, -3988,
    3833,  1440,  3836, -3988,  3837,  1440,  3841,   616,   602, -3988,
    3838, -3988, 21362, -3988, -3988, 16373, -3988, -3988, 21588, 15432,
   21588, 11132, 11196, -3988, -3988, -3988, -3988, -3988, -3988,  2764,
     751, -3988, -3988, -3988, -3988, -3988, -3988, 21588, -3988, 21588,
   -3988,  3991, -3988,  2877, -3988,  9648, 15432, 15432, 15432, 15432,
    1542, -3988, 15432, 15432, 21588,   716, -3988, -3988, -3988, 13910,
    3839,  3846, -3988, -3988,   424,   424, -3988,  3626,  3847,  9670,
   21588, 21588,  3848,  1028,  2877,   639,  3410,  1028,  2877,  1595,
    2877,  2877,   800,  3849,  3850,  4434,  3626,  3851, 21939, -3988,
    3852, 21780, -3988,  7117,  7183,  3304,  3329, 16373, -3988, -3988,
   -3988, -3988, -3988, -3988,  1028, 16373,  1494,  3856,   574,  1494,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,  4193, -3988,  3880,
     518,  3811, -3988, -3988, 20737,  4277, -3988, -3988, 16373, 16373,
   16373, -3988,  3389,  9793, -3988,  9906, -3988, -3988,   575,  1494,
    3883,  4536, 10230, -3988, -3988, -3988, -3988,  3486, -3988,  4560,
    4574, -3988, 11256, 15432, 15432, -3988, -3988, 10372, -3988, 15044,
    3876,   228, -3988, -3988,   731,   731,  4575,  4596, 10503,  1028,
   -3988, -3988, -3988, -3988, -3988,   395, -3988, 15432, 15432,  7195,
    2764, -3988, 10532, 10694, -3988,   718,  3879,  3889, -3988,   802,
   -3988,  3892,   804,  3896, 21588, -3988,   631,  1276, -3988, 19511,
   10853, 11291,  7261, 11451, -3988, -3988, -3988, 20776, 11499, 15465,
    4511,  4049, -3988, -3988, 10948, 11130, 11314, 11446, -3988, 11473,
   11575,  3907,  3909, -3988,  3910, -3988, -3988, 16373,   601, -3988,
     604, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,  3881,  3884,  3603,  3904,
    3905, -3988,  3917, -3988, -3988, 16373, 16373,  4285, -3988,  4285,
   -3988, -3988,  3930,   582,   424,  1862,  3885,   413,  3945,  4613,
   -3988,   583,  4616, -3988,  4620, 16373, -3988, -3988,  3961,   584,
    1862,  3925, -3988, 16373,   267,   267, -3988,  4657, 11635, -3988,
   14318, -3988,   424,   424,   424,  3939, -3988,   267,   267, -3988,
   -3988,  3960,  3962,  7273,  7300, -3988, -3988, -3988,  3966,  1440,
     616,  3967,  1440,  3968,   616,   447,  3969, -3988,   424,   424,
    3970, -3988, -3988, 21588, -3988,  3986, -3988, 15850, 15956,  3987,
    5337,  4629, 15465, -3988,  4652,  4562, -3988, -3988, -3988, -3988,
      49, -3988, -3988, -3988, -3988,  7376,   457,  3993, 16373, -3988,
    4295,  4550, 21981,  4158, 21822,  4557,  7556,  7585, -3988,  3988,
     611,   585,  1494,  4004,  4643, -3988,  1431,  4277, -3988,  1361,
   16373, 11729, -3988,  4000,   586,  1494,  1394,  4005,  4007, 15432,
   -3988, -3988,  4009,   614,   618,   623,   731,  4010,  4011, -3988,
   -3988, -3988, -3988, -3988,   819,   688, -3988,   863, -3988,   699,
    4367, -3988,   633,   636, -3988, 11557, -3988,  4015,  4027, 21588,
   16341, -3988,  5337, -3988, 21588,  4666, 15432, 21588,  1395,    49,
   -3988, -3988, 16373, -3988,   424,  7620,   424,  3603,  3974, -3988,
   -3988,  3976, -3988, -3988, -3988, -3988, -3988,  4012,   587,  1862,
    4029, -3988,  4670,  4671, -3988, -3988,  4018,   589, -3988, -3988,
   -3988, 11786, -3988, -3988, -3988, -3988,  4031, -3988, -3988,  4032,
    4035,  4036,  4038, -3988, -3988, -3988, 21588, 21588,  4672,  4037,
   15465, 11610, 21588, 11924,  4040,  4043, -3988,  7660,   779, -3988,
     973,  4217,  4601, -3988,  4044,   590,  1494, 16373, 16373, -3988,
    4045, -3988, -3988, -3988, -3988, -3988, -3988,  4714,  4715,  4626,
   21588,  4046, -3988, 11658, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  4047,   591, -3988,  4719, -3988,  4628,  4644,
    4050,  4721, -3988, -3988, -3988,  4048, 16373,  4052,  4055, -3988,
    4681, -3988,  4285, -3988, -3988,  4056, -3988
  };

  const short
  parser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2460,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2439,     0,     0,     0,     0,     0,     0,
       0,  1226,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2459,  2461,
    2462,  2463,  2464,     0,     0,     0,     0,  1124,  1129,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2440,  2441,  2443,  2442,  2444,  2445,
    2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,  2455,
    2457,  2456,  2458,  2471,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2465,  2466,  2467,  2468,  2469,  2470,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,    48,    49,    96,    98,     5,   129,    33,
      35,    34,   122,     6,     7,     8,     4,     9,    10,    11,
      17,    13,   112,    14,    15,    16,    32,   123,   124,   125,
     130,   131,    12,   126,   127,   128,    18,    20,    90,    91,
      92,    93,    19,    21,    22,    57,   113,   114,   115,   116,
     119,   117,   118,    23,    94,    24,    26,    28,    27,    29,
      52,    30,    31,    38,    39,     0,    36,    37,     0,    40,
      41,     0,    25,    42,    46,    43,    44,    45,    47,    50,
      51,    53,    54,    55,    75,    76,    77,    56,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    68,    69,    70,
      71,   105,   103,   104,   102,   101,   100,    99,    72,    73,
      74,    87,    89,    88,    95,   106,    97,   107,   108,   109,
     110,   111,   120,   121,   132,   133,     0,     0,     0,     0,
       0,     0,  1721,     0,     0,   138,     0,   580,     0,     0,
       0,     0,  1341,     0,     0,     0,     0,     0,     0,     0,
     973,     0,     0,     0,     0,     0,     0,     0,  1759,     0,
       0,     0,     0,  1690,     0,     0,     0,     0,     0,     0,
       0,     0,  1171,     0,     0,     0,     0,     0,     0,     0,
       0,   329,   376,     0,  1213,     0,  1220,     0,  1212,   586,
       0,     0,     0,  1769,     0,     0,     0,     0,     0,     0,
       0,  1161,     0,     0,     0,     0,     0,   156,     0,     0,
       0,   593,     0,   602,     0,   632,     0,   640,     0,     0,
       0,     0,     0,     0,     0,  1329,     0,     0,     0,     0,
     746,     0,  1786,     0,  1715,   564,     0,   759,     0,     0,
    1333,     0,     0,  1229,     0,  1231,     0,     0,  1235,  1303,
       0,     0,  1239,     0,  1245,     0,  1276,     0,  1288,     0,
    1296,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1337,     0,     0,     0,   143,  1322,     0,
    1324,     0,  1326,     0,  1328,     0,   193,     0,  1555,     0,
    1557,     0,     0,     0,     0,  1427,     0,     0,  1481,     0,
       0,  1445,     0,  1553,     0,  1514,     0,  1503,     0,  1491,
       0,  1463,     0,     0,     0,   315,     0,   525,     0,     0,
       0,   333,     0,   646,     0,  1345,     0,     0,     0,     0,
       0,     0,   360,     0,     0,     0,     0,     0,     0,     0,
       1,     3,     0,     0,     0,     0,     0,     0,  1366,     0,
    2087,     0,     0,     0,     0,     0,  2028,     0,     0,     0,
    2029,     0,     0,     0,     0,  1354,  1365,     0,  1355,  1360,
    1358,  1361,  1359,  1356,  1357,  1362,  1363,  1347,  1348,  1349,
    1350,  1351,  1352,  1353,  1374,     0,     0,     0,  1368,  1373,
       0,  1370,  1369,  1371,     0,     0,  2008,     0,     0,  1993,
    2035,     0,  2238,  2239,  2240,  2241,  2242,  2326,     0,  1726,
    1729,  1745,  1733,  1730,  1732,  1727,  1731,  1737,  1742,  1743,
    1728,  1738,  1741,  1734,  1735,  1736,  1739,  1740,  1744,     0,
    1723,   136,   223,   224,   225,   226,     0,  2153,     0,     0,
       0,     0,     0,     0,     0,  2018,     0,     0,  2354,     0,
     584,     0,   583,   568,   573,   576,   577,   572,   585,   575,
     569,   570,   571,   574,   578,   579,     0,     0,     0,     0,
       0,  1702,  1705,  1704,  1706,  1707,  1708,     0,     0,  1712,
       0,     0,  2074,  2061,  2057,     0,  2081,     0,     0,     0,
    1943,     0,  2079,     0,  1956,     0,  1668,  1675,  1681,  1676,
    1682,  1670,  1671,  1677,  1669,  1673,  1674,  1672,  1678,  1679,
    1680,  1343,     0,   134,     0,     0,     0,   306,     0,     0,
       0,  2037,  2288,     0,     0,  1998,  2230,  2162,     0,     0,
       0,  2300,  2301,  2302,     0,     0,     0,     0,  2290,     0,
       0,  1909,  1929,     0,     0,  1996,     0,     0,     0,  2010,
       0,     0,  1991,  1992,  1995,     0,     0,     0,     0,     0,
       0,     0,     0,  1973,     0,  1989,     0,     0,  2030,  2031,
       0,     0,     0,     0,  1984,     0,     0,     0,     0,     0,
    2006,  2007,     0,     0,     0,     0,  2025,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2297,  2296,
    1942,  1997,  1928,  1930,  1931,  2090,  2091,     0,     0,  2038,
       0,  1978,     0,     0,  2001,     0,  2009,  2005,  2003,     0,
       0,     0,  2243,     0,  2325,     0,  2348,  2349,  2350,     0,
       0,     0,     0,   978,  1034,  1044,  1066,  1019,  1055,  1069,
     979,  1091,  1092,   980,  1053,   981,  1096,  1098,   982,   983,
     984,   985,   986,   987,   988,   989,   990,   991,  1077,   992,
     993,   994,   995,   996,  1097,  1094,  1095,   997,   998,   999,
    1000,  1002,  1003,  1005,  1004,  1006,  1007,  1008,  1009,  1010,
    1011,  1012,  1026,  1014,  1015,  1017,  1018,  1020,  1021,  1022,
    1023,  1024,  1025,  1016,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1070,  1071,  1073,  1072,  1074,  1035,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1045,  1046,  1056,  1057,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1107,  1108,  1081,  1082,
    1083,  1084,  1085,  1088,  1086,  1087,  1089,  1090,  1013,  1093,
    1047,  1048,  1049,  1050,  1051,  1052,  1054,  1065,  1067,  1068,
    1075,  1100,  1099,  1076,  1078,  1079,  1080,  1109,  1110,  1001,
    1101,  1102,  1103,  1104,  1105,  1106,   975,     0,   841,     0,
       0,   835,     0,   839,     0,     0,     0,     0,   861,     0,
       0,     0,     0,   855,     0,     0,  1848,  1849,     0,     0,
    2318,     0,  1762,  1763,  1764,  1765,  1766,  1767,  1768,   890,
       0,     0,   871,     0,     0,     0,     0,     0,     0,     0,
     323,     0,  1694,  1696,  1698,  1699,  1700,  1697,  1692,     0,
       0,   313,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   289,   299,   291,   290,   298,   292,   293,   294,   295,
     296,   297,     0,  1686,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2355,  2356,  2357,  2358,  2359,
       0,     0,     0,     0,     0,     0,     0,     0,  1174,  1208,
    1183,  1175,  1182,  1186,  1188,  1189,  1190,  1192,  1195,  1187,
    1209,  1191,  1181,  1184,  1177,  1176,  1178,  1179,  1180,  1185,
    1193,  1194,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
    1204,  1205,  1206,  1207,     0,   284,     0,     0,     0,     0,
    1781,     0,     0,     0,     0,     0,     0,     0,   362,   366,
       0,   369,   371,   368,     0,   367,     0,     0,     0,   375,
       0,     0,     0,     0,     0,  1210,  1222,  2367,  2368,  2369,
       0,   589,   590,   591,   592,     0,   550,     0,   546,     0,
     548,     0,   544,     0,  1774,     0,     0,  1141,     0,     0,
       0,     0,  1755,     0,  1751,  1752,  1753,     0,  1137,     0,
       0,     0,     0,     0,     0,     0,  2217,     0,     0,     0,
       0,     0,  1835,  1836,  1837,  1838,  2017,  2218,     0,     0,
    1152,     0,  1151,   765,   766,   767,   768,   769,   770,   772,
     773,   774,   778,   779,   789,   790,   791,   792,  1153,  1154,
    1155,   793,   794,   795,  1157,   800,   775,   776,   777,  1156,
     810,   771,   780,   796,   797,   798,   799,   803,   804,   805,
     806,   807,   787,   788,   801,   802,  1158,  1159,  1160,   808,
     809,   781,   782,   783,   784,   785,   786,  1163,  1149,     0,
       0,   219,   154,   162,     0,     0,   159,   821,   820,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1227,   403,   399,  1214,
       0,  1709,     0,     0,  2304,     0,   596,   597,   598,   600,
     601,   599,     0,     0,  1994,     0,     0,  2303,  1830,     0,
    1829,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2309,  2310,     0,     0,   605,   613,   606,   614,   610,   609,
     616,   617,   607,   620,   621,   622,   623,   624,   608,   611,
     619,   618,   612,   625,   626,   627,   628,   629,   630,   631,
     615,     0,   635,   636,   637,   638,   639,  2327,   645,     0,
     643,   644,   166,     0,     0,     0,     0,   483,   485,   484,
       0,     0,     0,     0,     0,     0,   501,     0,     0,     0,
    1933,  2321,     0,  1955,     0,  1614,  1616,  1621,  1620,  1625,
    1619,  1622,  1623,  1624,  1626,  1627,  1629,  1630,  1628,  1615,
    1617,  1618,  1331,     0,     0,  1798,     0,     0,   750,   751,
       0,   749,     0,     0,     0,     0,     0,     0,  1789,  1790,
    1791,  1792,  1793,  1794,     0,     0,   567,     0,  1852,  2163,
       0,   811,   764,   816,   815,   812,   813,   814,   761,     0,
       0,     0,     0,     0,  1632,  1634,  1636,  1635,  1639,  1640,
    1641,  1642,  1643,  1644,  1633,  1637,  1638,  1335,     0,     0,
       0,     0,  1313,  1314,  1315,  1316,  1319,     0,  1318,  1320,
    1321,  1233,     0,     0,     0,     0,  1308,  1309,  1311,  1310,
    1305,     0,     0,     0,  1242,  1243,  1244,     0,     0,     0,
       0,     0,     0,  2374,  2384,  2393,     0,     0,  2377,     0,
       0,     0,     0,  2378,  2396,  2379,  2387,  2397,  2380,  2389,
    2398,  2381,  2390,     0,     0,  1248,  1250,  1249,  1251,  1252,
    1253,  1256,  1255,  1254,  1264,  1265,  1258,  1257,  1259,  1260,
    1261,  1262,  1263,  1272,  1273,  1267,  1266,  1268,  1269,  1270,
    1274,  1271,  1275,     0,  1279,  1281,  1280,  1282,  1283,  1284,
    1285,  1286,  1287,     0,     0,  2403,  2402,     0,  1291,  1292,
    1293,  1294,  1295,  2404,     0,  1301,  1302,  1298,  1143,     0,
       0,     0,     0,   171,     0,   215,   217,     0,  1128,     0,
    1133,   218,     0,     0,     0,     0,     0,     0,     0,     0,
     204,     0,  2075,  2058,  2059,  2060,  2056,     0,     0,     0,
    2080,     0,     0,     0,  1944,  1932,  2078,  1945,     0,     0,
    1646,  1664,  1649,  1665,  1666,  1650,  1651,  1652,  1653,  1654,
    1656,  1655,  1660,  1661,  1657,  1658,  1659,  1662,  1663,  1647,
    1648,  1339,     0,   221,   141,   146,     0,     0,     0,     0,
    1886,     0,     0,   183,   184,   185,   186,     0,     0,     0,
       0,     0,   189,   190,   191,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1560,  1607,
    1593,  1594,  1595,  1596,  1597,  1609,  1598,  1599,  1600,  1601,
    1602,  1604,  1603,  1608,  1610,  1561,  1562,  1563,  1564,  1565,
    1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,  1575,
    1576,  1585,  1577,  1578,  1586,  1588,  1587,  1579,  1580,  1589,
    1581,  1582,  1583,  1584,  1590,  1591,  1592,  1605,  1606,  1611,
    1612,     0,     0,     0,     0,     0,     0,   895,   896,   897,
     898,   899,   900,   901,   902,     0,  1807,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2181,
       0,  2182,     0,     0,     0,     0,  2184,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1426,     0,  1377,  1423,  1378,
    1379,  1380,  1381,  1382,  1383,  1384,  1385,  1386,  1387,  1388,
    1389,  1390,  1391,  1392,  1393,  1394,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,
    1419,  1420,  1421,  1422,  1424,     0,  2273,  2284,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2282,  2275,     0,
    1480,     0,  1465,  1466,  1467,  1474,  1468,  1469,  1470,  1471,
    1472,  1473,  1475,  1476,  1478,  1477,  1483,  2277,  1444,     0,
    1429,  1430,  1431,  1437,  1441,  1442,  1432,  1433,  1434,  1435,
    1436,  1438,  1440,  1439,     0,  2247,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1552,     0,  1522,  1523,  1524,  1517,  1518,  1519,  1520,
    1521,  1525,  1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,
    1534,  1535,  1516,  1536,  1537,  1538,  1539,  1540,  1541,  1542,
    1543,  1544,  1545,  1546,  1547,  1548,  1549,  1550,     0,     0,
    2267,     0,  1513,     0,  1508,  1507,  1505,  1506,  1509,  1510,
    1511,     0,     0,     0,     0,  2269,  1502,     0,  1493,  1494,
    1495,  1499,  1500,  1496,  1497,  1498,  2276,  1490,     0,  1485,
    1486,  1487,  1488,     0,  1462,     0,  1447,  1448,  1449,  1454,
    1459,  1460,  1451,  1452,  1453,  1455,  1456,  1458,  1457,  1450,
       0,     0,     0,     0,     0,     0,     0,     0,   528,   529,
     531,   530,   532,   533,   534,     0,  2226,  2227,     0,     0,
     537,   541,   538,   539,   540,     0,     0,  2235,  2237,     0,
     754,   755,   756,   757,   758,     0,     0,     0,   743,   744,
     745,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2332,  2333,  2338,  2339,     0,     0,  2342,     0,     0,     0,
       0,     0,   649,   712,   726,   666,   721,   722,   659,   660,
     670,   705,   717,   667,   718,   709,   708,   669,   681,   692,
     715,   682,   688,   694,   693,   711,   716,   706,   683,   704,
     703,   699,   700,   701,   702,   719,   690,   689,   673,   674,
     675,   707,   733,   725,   727,   710,   739,   738,   732,   668,
     723,   724,   657,   691,   684,   685,   687,   686,   714,   652,
     731,   676,   677,   679,   678,   661,   663,   662,   665,   664,
     672,   720,   728,   658,   680,   734,   655,   736,   737,   654,
     653,   696,   729,   713,   735,   730,   695,   656,   697,   651,
     698,   671,   650,  1346,   464,     0,   465,     0,   397,     0,
       0,   180,     0,     0,   866,     0,     0,     0,     0,  1812,
       0,     0,     0,  1822,     0,     0,     0,   227,   914,     0,
       0,     0,     0,     0,   909,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   276,     0,     0,     0,     0,   275,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   231,   230,  1214,   905,
     967,   910,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     137,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1713,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   135,     0,     0,     0,   305,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   838,     0,   834,   279,   837,
       0,     0,     0,     0,   860,     0,     0,     0,     0,   854,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   870,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   312,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1687,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   283,     0,     0,     0,
       0,  1782,     0,     0,     0,     0,   169,     0,     0,     0,
       0,     0,   384,     0,   385,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1224,     0,     0,
       0,     0,     0,   549,     0,     0,   545,     0,  1775,     0,
       0,  1140,     0,  1746,     0,     0,  1754,     0,     0,     0,
    1136,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,   160,   157,   165,     0,   148,     0,     0,   152,   150,
       0,     0,     0,     0,     0,     0,   420,   419,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   400,   401,   402,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   482,     0,     0,     0,     0,
       0,     0,     0,     0,   500,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1797,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1718,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   177,     0,     0,   173,     0,     0,     0,  1125,
    1126,     0,  1130,  1131,   207,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   142,   144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1877,     0,     0,     0,
     196,   197,   198,   199,   200,   201,   202,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1806,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   167,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   507,     0,     0,
       0,     0,     0,     0,     0,     0,   319,     0,   318,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   335,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   395,     0,     0,     0,     0,     0,   868,     0,
     867,     0,     0,     0,     0,  1813,     0,     0,     0,  1823,
       0,     0,     0,     0,     0,     0,   904,     0,     0,     0,
       0,     0,     0,   948,     0,     0,     0,   966,     0,     0,
       0,     0,     0,   244,   243,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   228,
       0,     0,     0,     0,  2083,     0,     0,   824,  2084,  2085,
    2086,  2082,  2088,  1883,  1899,  2411,     0,  1890,     0,  1889,
    1925,  1926,  2020,  2019,  2021,     0,  1364,     0,  2089,  1964,
    2004,  1372,     0,     0,  2022,  2011,  2013,  2161,  2155,  2156,
    2158,  2157,  2159,  2160,  1722,     0,  1725,     0,  2150,  2151,
    2152,  1859,  1860,  1863,  1850,  1872,  1827,     0,   582,   581,
    1966,     0,  1845,  1832,  1703,  1701,     0,  1711,     0,  2062,
    2067,  2068,  2069,  1957,  1959,  1958,  1960,     0,  1951,  2070,
    2071,  2324,  1947,  1342,     0,  1667,  1167,     0,  1165,     0,
     302,     0,     0,     0,     0,   300,     0,   301,  1834,  1898,
    1888,  1977,  1965,  2052,  2053,  2054,  2055,  1887,  1897,  1896,
       0,  1949,  1895,  1894,  1839,     0,  2298,  2012,  1927,  2043,
    2045,  2042,  2044,  2047,  2048,  1967,  1970,  1979,  1980,  1971,
    1972,  1974,  1990,  1968,  2032,  2033,  2034,  1969,   827,     0,
       0,   829,   828,  1985,  1987,  1986,  1982,  1983,  1981,  2039,
    2023,     0,     0,  2024,  2026,  2027,  2293,  2292,  2294,  2295,
    2092,  2094,  2096,  2095,  2097,  2098,  2100,  2099,  2101,  2102,
    2104,  2103,  2105,  2106,  2107,  2108,  2109,  2110,     0,  1831,
    2036,  1988,     0,  2000,  1999,  2002,  2291,  2049,  2050,  2051,
       0,  2244,  2344,  2351,  2352,  2353,   977,   974,     0,     0,
     832,   882,   883,   885,   886,   888,   884,   887,   889,   280,
       0,     0,     0,     0,     0,     0,   859,     0,     0,     0,
     851,     0,     0,  1847,  1846,  1760,  1761,   891,   892,   869,
       0,   328,   325,   324,   327,   326,   322,   321,  1695,  1691,
       0,     0,   310,   819,     0,     0,     0,     0,  1882,  1884,
    1900,  1901,  1902,  1903,  1904,  1907,  1908,   288,   286,  1683,
       0,     0,  2289,  2014,  2145,  2149,  2148,  2147,  2146,  2140,
    2141,  2116,  2360,  2361,  2362,  2363,  2364,  2365,  2366,  1172,
    1173,   281,     0,     0,   287,  1779,     0,     0,     0,     0,
    1169,     0,     0,     0,   331,     0,     0,     0,   382,   383,
       0,     0,   387,   373,   363,     0,     0,   364,   365,     0,
     374,   378,  2015,  2016,     0,  1221,     0,     0,   588,   587,
       0,   542,   547,     0,  1773,     0,  1139,     0,     0,     0,
    1747,     0,  1750,  1134,     0,  1135,  1144,     0,     0,     0,
    1147,  2299,  1833,  1861,  1862,  1841,  1842,  1843,  1856,  1855,
    1871,  1870,  1150,  1162,     0,     0,   161,   158,   163,   149,
       0,   153,   151,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   398,   412,   413,
     408,   409,   410,   411,   404,   405,   407,   406,   414,  1228,
    1215,     0,     0,  1905,  1906,   595,   594,  1857,  1858,  1851,
    1869,  1828,  1864,  1865,  1866,  1867,  1868,  2305,  2306,  2307,
    2308,  2311,     0,   604,   603,   634,   633,   642,   641,  1170,
       0,     0,     0,     0,   470,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   497,     0,  1936,  1935,  1934,  2322,
    2323,  1330,     0,  1613,     0,  1803,  1795,     0,     0,   748,
     747,  2313,     0,  2316,     0,  2315,  1787,  1788,     0,     0,
    1717,     0,   566,   565,  1844,  1853,   763,   760,     0,  1938,
    1941,  1940,  1937,  1939,  1334,     0,  1631,     0,  2040,  2041,
    1312,  1230,  1317,  1232,     0,  1238,     0,     0,  1854,  2287,
    1307,  1304,     0,  2371,  2370,  1240,  1241,  2372,  2382,  2391,
    2373,  2383,  2392,  2375,  2376,  2385,  2386,  2394,  2395,  2388,
    1246,  1247,  1277,  1278,  2401,  2400,  2399,  1289,  1290,  1297,
       0,  1300,     0,     0,     0,     0,     0,     0,  1127,  1132,
       0,   212,   213,   206,   209,   210,   211,   214,   205,   203,
    2063,  2064,  2065,  2066,  2076,  2077,     0,  1953,  2072,  2073,
    1946,  1948,  1338,     0,  1645,   145,  1323,  1325,  1327,  1881,
       0,     0,  1885,   182,   181,     0,     0,     0,     0,     0,
       0,     0,     0,  1891,  1892,  1893,   188,   187,  2111,  2112,
    2113,  2114,  2115,  2117,  2118,  2119,  2120,  2121,  2122,  2123,
    2124,  2125,  2126,     0,  2127,  2128,  2129,     0,     0,     0,
    2133,  2134,     0,  2136,  2137,  2138,  2139,  2142,  2143,  2144,
    1556,  1559,  1558,  1873,  1910,   894,   893,  1804,     0,  1808,
       0,  2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,  2174,
       0,  2176,  2177,  2178,  2179,  2180,  2183,  2185,  2186,  2187,
    2188,  2189,  2200,  2197,  2211,  2212,  2216,  2190,  2193,  2194,
    2195,  2196,  2198,  2199,  2201,  2202,  2203,  2204,  2205,  2206,
    2207,  2208,  2209,  2210,  2213,  2214,  2215,  2249,  1425,  1428,
       0,  2285,  2245,  2274,  2248,  2246,  2278,  2280,  2279,  2281,
    2283,  2265,  1479,  1482,     0,  1443,  1446,  2191,  2192,  2250,
    2251,  2252,  2253,  2254,  2255,  2256,  2257,  2258,  2259,  2260,
    2261,  2262,  2263,  2264,  1551,  1554,  2164,  2165,  2266,  1512,
    1515,  2270,  2272,  2271,  2268,  1501,  1504,  1489,  1492,  2286,
    1461,  1464,     0,     0,     0,   513,   514,     0,   506,     0,
       0,  2220,  2219,  2221,  2222,  2223,  2224,   527,   526,     0,
       0,   317,  2229,  2228,   536,   535,  1217,  1216,  2232,  2233,
    2234,  2236,   753,   752,  2319,  2320,   742,   740,   741,     0,
       0,   336,   344,  2046,  2334,  2335,  2336,  2337,  2329,  2330,
    2331,  2340,  2343,  2345,  2341,  2346,  2347,   647,   648,     0,
     466,   467,     0,   468,   460,   396,   461,   463,   865,   361,
       0,     0,  1810,   554,     0,   551,   556,     0,  1820,     0,
       0,     0,     0,     0,     0,     0,   908,   903,     0,     0,
       0,   949,     0,     0,     0,   967,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   229,   241,   242,   237,   238,   239,   240,
     232,   233,   235,   234,   236,     0,     0,     0,     0,     0,
     962,   963,   964,   965,     0,   968,   912,   822,   823,     0,
    2411,  2412,  2414,     0,  2418,  2416,     0,  1367,  1375,     0,
    1724,   222,     0,  1115,  1117,     0,     0,     0,     0,  1961,
       0,  1344,  1168,  1166,   307,   308,   309,     0,     0,     0,
       0,   825,   826,     0,  2426,     0,  2430,  2428,     0,     0,
       0,  1119,  1122,     0,   976,   840,   279,   836,   279,     0,
       0,     0,     0,     0,     0,   858,     0,     0,     0,  1693,
     906,   969,   916,     0,   817,   818,     0,     0,     0,  1689,
       0,     0,   285,     0,     0,     0,     0,     0,     0,     0,
     330,   332,     0,     0,   377,     0,     0,     0,  1218,     0,
     380,     0,  1211,     0,  1223,     0,     0,     0,     0,     0,
       0,  1756,     0,     0,     0,     0,     0,  1145,     0,  1164,
       0,   164,   147,     0,     0,   443,   444,   416,   417,   421,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   453,   454,   422,     0,   441,
     442,     0,   450,     0,   452,   455,     0,   418,   456,   457,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   496,     0,     0,     0,     0,     0,     0,
       0,     0,  1332,     0,  1800,  1802,  1799,     0,     0,     0,
       0,  1716,     0,   762,  1336,     0,  1234,  1236,  1237,  1306,
    1299,     0,   175,   172,     0,     0,     0,   208,     0,     0,
    1340,     0,  2420,     0,  2422,  2424,  1874,  1876,  1875,     0,
    1879,   357,   358,   359,  1880,   195,   194,  2432,     0,   140,
     139,     0,     0,     0,     0,  1809,     0,     0,     0,  1484,
       0,     0,   509,   505,     0,  2437,     0,     0,   316,     0,
     334,     0,   394,     0,     0,     0,     0,     0,     0,     0,
     552,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   937,   938,   946,
     944,   939,   942,   941,   947,   945,   943,   940,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   263,
     264,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   273,   274,   261,
     262,     0,   270,     0,   272,   277,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   925,   926,   934,   932,   927,
     930,   929,   935,   933,   931,   928,     0,     0,  2415,     0,
    2419,  2417,  2405,  1376,     0,     0,  2328,  2154,     0,     0,
       0,  1952,     0,     0,  1950,  1840,  2427,  2431,  2429,  1975,
    2093,     0,     0,  1976,   280,     0,     0,     0,   842,     0,
       0,     0,     0,     0,   856,   852,     0,     0,     0,     0,
       0,     0,     0,     0,  1684,     0,     0,  1771,  1772,     0,
       0,  2406,     0,     0,     0,     0,     0,     0,     0,   386,
     391,   370,     0,   372,     0,     0,  1225,     0,     0,     0,
       0,     0,     0,     0,     0,  1758,  1748,     0,  1138,     0,
    1148,     0,     0,     0,     0,     0,     0,     0,     0,   448,
       0,  2312,     0,     0,   487,     0,     0,     0,     0,   472,
       0,     0,     0,   495,     0,     0,     0,     0,     0,   499,
       0,  1801,     0,  2314,  2317,     0,  1719,  2231,     0,     0,
       0,     0,     0,  2408,  2407,  1954,  2421,  2423,  2425,  1878,
       0,  2435,  2433,  2130,  2131,  2132,  2135,     0,  2175,     0,
     510,     0,  2225,     0,  2438,     0,     0,     0,     0,     0,
     337,   338,     0,     0,     0,     0,   346,   350,   469,     0,
       0,     0,   555,   553,     0,     0,  1814,   557,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1963,     0,     0,   950,
       0,     0,   968,     0,     0,     0,     0,     0,   268,  1920,
    1918,  1919,   961,   955,     0,     0,     0,     0,     0,     0,
    2413,   831,  1111,   830,  1112,  1116,  1118,     0,   907,   971,
     920,     0,  1962,   303,     0,     0,  1120,  1123,   279,   279,
     279,   833,     0,     0,   864,     0,   853,   872,     0,     0,
     970,   918,     0,   311,  1688,  1685,   282,     0,  1783,     0,
       0,  1780,     0,     0,     0,   389,   459,     0,  1219,     0,
       0,     0,   543,  1776,     0,     0,     0,     0,     0,     0,
    1749,  1146,   220,   445,   446,     0,   423,     0,     0,     0,
     458,  1710,     0,     0,   486,     0,     0,     0,   471,     0,
     473,     0,     0,     0,     0,   491,     0,     0,   498,     0,
       0,     0,     0,     0,   179,   216,  2434,     0,     0,     0,
       0,   508,  2436,   320,     0,     0,     0,     0,   339,     0,
       0,     0,     0,   347,     0,  1815,  1816,     0,     0,   563,
       0,  1811,  1824,  1825,  1826,  1821,  1911,  1915,  1917,  1924,
    1913,  1922,   873,   874,   876,   877,   879,   875,   878,   880,
     881,  1912,  1921,  1916,   936,   915,     0,     0,   951,     0,
       0,   969,     0,   265,   266,     0,     0,   278,  1914,  1923,
     924,   911,     0,     0,     0,     0,     0,     0,     0,     0,
    1113,     0,   846,   843,   847,     0,   862,   857,     0,     0,
       0,     0,   314,     0,     0,     0,   170,     0,     0,   390,
       0,   379,     0,     0,     0,     0,  2409,     0,     0,  1142,
    1757,     0,     0,     0,     0,   415,   489,   488,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   490,     0,     0,
       0,  1720,   178,     0,   174,     0,   168,     0,     0,     0,
     517,     0,   518,   519,     0,     0,   340,   341,   342,   343,
       0,   348,   349,   345,   462,     0,     0,  1817,     0,   562,
       0,     0,     0,     0,     0,     0,     0,     0,   956,     0,
       0,     0,     0,   972,   922,   304,     0,     0,  1121,     0,
     279,     0,   957,     0,     0,     0,     0,     0,     0,     0,
     388,   393,     0,     0,     0,     0,     0,     0,     0,   424,
     425,   449,   451,   475,     0,     0,   474,     0,   476,     0,
       0,   479,     0,     0,  1796,     0,  1805,     0,     0,     0,
       0,   511,     0,   520,     0,     0,     0,     0,     0,   351,
     352,   560,     0,   561,     0,     0,     0,   953,     0,   952,
     971,     0,   970,   269,   271,   913,  1714,     0,     0,     0,
       0,  1114,     0,   848,   863,   917,     0,     0,  1770,  1784,
    1785,     0,   381,   492,   493,   494,     0,  1777,  1778,     0,
       0,     0,     0,   502,   503,   176,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   353,     0,     0,   559,
       0,     0,     0,   959,     0,     0,     0,   279,   279,   958,
       0,   392,  2410,   478,   481,   477,   480,     0,     0,     0,
       0,     0,   516,     0,   354,   355,   356,   558,  1818,  1819,
     954,   972,   921,     0,     0,   844,   849,   919,     0,     0,
       0,     0,   512,   515,   960,     0,     0,     0,     0,   521,
       0,   923,   850,   522,   523,     0,   524
  };

  const short
  parser::yypgoto_[] =
  {
   -3988, -3988,  4674, -3988,   404, -2214, -3594,  -898, -3988,  -980,
     -79, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  2107, -3988, -3988,  2089, -3988, -3988, -3988,
    1226, -3988, -3988,  2131, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988,  3124, -3988, -3988, -2270, -3988,  1537,
   -1056, -3988, -3988,  4495,  2432, -2174, -3988, -2782,  -684, -3988,
    1577,  -974, -3988, -3988, -3988,  1950, -3988, -3988, -3988,  2463,
   -3988, -3988, -3988, -3988, -3988, -3988,  1941, -3988,   462, -3988,
   -3988, -3988,   463, -3988, -3988,    90,    92, -3988,  2409,  4373,
   -3988, -3988, -3988, -3988, -3436, -2286, -2140,  -489,  2530, -3988,
   -3988, -2257, -3988, -3988, -3988, -3988,  4377, -3988,  1405, -1321,
   -2851, -3987,  -349, -2929, -3988,  1399, -1333, -3988, -3988, -3988,
    1980, -3988, -3988, -3988,    48, -3988,   187, -3988, -3988, -3988,
    1976, -3988, -3988,  1975, -3988, -3988,  3765,  1544, -3157, -3216,
   -2846, -3988, -3988,  -281, -3988, -3988,  2626, -3988, -3988,  2445,
   -3988, -3988,  -186, -3988, -3988,  -215, -3988, -3988,  2318, -3988,
   -3988,  2330, -3988,  1990, -3988, -3988, -3988,  4443,  2011, -3988,
   -3988,  2290, -3988, -3988,  2018, -3988, -3988,  -250,  2291, -2276,
    2361, -1341, -3988, -3291, -3988, -3988,  1699,  -929,  -210, -3988,
   -3882, -3988,  1694,  -939, -3988, -3988,  4022, -3988, -3988,  2785,
   -3988, -3988,  3971, -3988, -3611,  -311, -3988, -3988, -3988,  2149,
   -3988, -3988,  4425, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3880,   509, -3988,   512, -3988,  4431, -3988, -3630,
     737, -3988,  4453, -3988, -3988,  2584, -2902, -3988,   715, -2446,
     700, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
    4602,   272, -3988, -3988,  3853, -3988, -3988, -3988, -3988, -3988,
    2466, -3988, -3988, -3988, -3988, -3988, -3988,  2540, -3988, -3988,
    -276,  1684, -1185, -3988,  2513, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988,  2308, -3988, -3988,  2298, -3988, -3988,
    2299, -3988, -3988,  2294, -3988, -3988,  2289, -3988, -3988, -3988,
    2322, -3988,  2331, -3988,  -308, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,   -11,  2752, -3988, -3988,  2755,
   -3988, -3988, -3988,  2150, -3988, -3988,  2133, -3988, -3988,  2097,
   -3988, -3988,  2137, -3988, -3988,  2111, -3988, -3988,  2116, -3988,
   -3988,  2118, -3988, -3988,  2119, -3988, -3988,  -381, -3988,  2371,
   -3988,  2348, -3988,  2279, -3988,  2738, -3988, -3988,  1719,  -995,
   -3988, -3988,  2620, -3988, -3988,  2761, -3988, -3988, -3988,  4368,
   -3988, -3988, -3988,  2382, -3988,  2773, -3988, -3988,  2536, -3988,
    1674, -1110, -3988, -3988,  2642, -3988, -3988, -3481, -3988, -3988,
    4024, -3988,  1721, -1059, -3988,  2393, -3988, -3988,   669, -1381,
    2408, -3988,   645, -1712, -3988,  1197, -1875, -3988, -3988, -3988,
    1204, -1878,  2088,   165, -3988, -3988, -3988,  -292,  -283,  -458,
    -192, -3988, -3988, -3988, -3988,  -107,   -43, -3988, -3988, -3988,
   -3988,   450, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,  -188, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988,  -447,  -278, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988,  -386,  -208, -3988, -3988,
   -3988,  -439,  -339,  -198, -3988, -3988, -3988,   -33, -3988,  -436,
    -207,  -369, -3988, -3988,  -195,  -161, -3988,  -361, -3988, -3988,
   -3417, -3250, -3241, -3988, -3988, -3240, -3237, -3988, -3988, -3988,
   -3236, -3235, -3988, -3988,  -204,  -282,   -42,  -197, -3988, -3988,
    -231, -3988, -3988, -3988, -3988, -3988, -3988,  -191, -3988, -3988,
   -3988, -3988, -3988,  -187, -3988, -3988,  -226, -3988, -1991, -2573,
    2142, -3988,    66, -3988,  -289,  -428,  -387,  -367,  -359,  -358,
    -352,  -334,  -350, -3988,  -345, -3988,  -337,  -277,  -331,  -330,
    -328,  -326,  -324,  -312,  -323,  -319,  -313,  -310,   217, -3988,
    -299, -3988,  -297, -3988, -3988, -3988,  -287,  -246, -3988, -3988,
     -28,   -26,  -294, -3988,    12, -3988,  -181,  -293, -3988,   190,
    -273,  -275,  -234,   -23,  -286,  -284,  -272,  -271,  -270,     3,
      20,  -267,  -265,  -264,  -263,  -261,   389,  -260,  -268,    38,
    -253,  -305, -3988,  -249, -3988,  -248,  -247,  -262,  -259,  -258,
    -257,  -256, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988,   -73,   -19, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,   -93,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,   -63,   -61, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988,    79,  -304, -3988,
   -3988, -3988,  -384,  -380,  -377,  -374,  -371, -3988, -3988, -3988,
   -3988, -3988,  -368,  -356,  -355, -3988,  -302, -3988, -3988, -3988,
    -291,  -235,  -230, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  -245,  -238,
    -412, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,  -327,
    -298, -3988, -3988, -3988, -3988,    95,    97,   106,   109,   110,
   -3988,  -229,  -122,   -97, -3988,  -144,  -175, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988,  -394, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
    -153,  -152,  -401, -3988, -3988,  -129,  -111,   -90,   -81,  -468,
     -78,   -76, -3988, -3988,   -62,   -51, -3988, -3988,  -223, -3988,
    -221,   121, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
     -53, -3988, -3988,    58,    72, -3988, -3988,   126, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988,  -219, -3988, -3988, -3988,   127,   129,   130,
     143,   145,   212,  4546, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988,  -325,  -317,  -315,  -274,  -254,  -251,  -237,  -218, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988, -3988,
   -3988, -3988, -3988, -3988,  2093, -3988, -3988, -1527, -2699, -3988,
   -1753, -3988, -2443, -3988, -2123, -3988, -2589, -3988,   658,     0
  };

  const short
  parser::yydefgoto_[] =
  {
       0,   161,   162,   163,  4130,  4131,   446,  2515,  1225,  1226,
     376,   164,   165,  3710,   166,  3311,   167,  3565,  4369,  3562,
     168,   169,  1622,  1623,   170,  1631,  1632,   171,  1627,  2739,
    2740,   172,  1569,  1570,  3570,   173,   174,   175,   176,   177,
     178,   606,   179,   180,  4274,  3020,  4226,  4277,   181,  1074,
    1075,   182,   183,  1000,  1001,  3116,   184,   686,   687,   185,
     990,   991,   186,  2005,  2907,  2908,  3779,   187,   979,   980,
     188,  1085,  2447,   189,  2032,  2924,  2925,  4400,  4401,   190,
    4151,  4405,  4406,  4407,  4779,  4780,  4124,   191,  1099,  1100,
     192,  1086,  4001,  4314,  2451,  2452,  2941,  2942,  2453,  2570,
    4060,  2454,   193,   194,  4154,   195,  2147,   196,  1346,  1347,
    1348,  4546,  4073,  4074,   197,  1355,  1356,   198,   483,  2896,
    2897,  4559,  4830,  4561,  4691,  4692,  4693,   199,   200,  1997,
    1998,   201,  2009,  2010,   202,  1121,  1122,  1117,  3834,  3835,
    4578,   203,  1405,   620,   204,   621,   622,   205,  1110,  1111,
     206,  1275,  1388,   207,  1303,  1338,   208,  1331,  1332,   209,
    1339,  1340,   210,  2051,  2052,   211,   212,  2027,  2028,   213,
    1390,  1391,   214,  2019,  2020,   215,  1410,  1446,  1412,  3266,
    2216,  4579,  3162,  3163,  4465,   216,   940,   941,   942,  3231,
    4278,   217,   952,   953,   218,   947,   948,   219,  2153,  2154,
     220,   971,   972,  4601,  3232,  3836,   221,   222,  1726,  1727,
     223,   224,   225,  2173,   226,  3022,  4247,  2963,  4289,  4641,
    4626,  4800,  4234,  4235,  4176,  4177,   227,   228,   229,  3899,
    3900,   230,   231,   232,   802,   803,  3923,  4631,  3924,  3925,
    3952,  3953,   233,   439,  1557,   234,   440,  1559,   235,   236,
    1137,  1138,   237,  1126,  1127,   238,   239,  1141,   240,  1161,
    1162,   241,   242,   243,   244,   245,   246,  1037,  1038,   247,
     356,  2217,  3788,  3999,   357,   248,   378,  2568,   249,   250,
     251,  1452,  2660,   252,  1463,  1464,   253,  1494,  1495,   254,
    1523,  1524,   255,  1537,  1538,   256,  1544,  1545,   257,  1455,
    1456,  1441,  1442,  1447,  1457,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   535,   536,   537,   267,   559,   560,
     268,   269,  1785,  1786,   270,  1868,  1869,   271,  1974,  1975,
     272,  1850,  1851,   273,  1967,  1968,   274,  1956,  1957,   275,
    1942,  1943,   276,  1901,  1902,   277,   278,  1667,  1668,  1364,
    1365,  1423,  1424,  1589,  1590,   665,   666,   279,  1012,  1013,
     280,   981,   982,   281,   640,   641,   282,   283,   648,   649,
     284,  1404,  2637,  2638,   285,   578,   579,   286,  1133,  1134,
    1131,  1132,  3348,   287,   961,   962,   288,  4300,   289,  1123,
    1124,   290,  1079,  1080,   291,  1397,  1398,   292,  1384,  1385,
    3484,   293,  1735,  1736,   294,  2158,  2159,  2160,  4416,   295,
    2162,  2163,  2164,  1163,  1306,  1307,  1308,  1164,  1165,  1166,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1413,  1177,   964,   965,   966,   967,   624,  1309,  1414,  1458,
    1178,  1179,  1310,  1311,   625,   626,  1180,  1312,  1313,  1314,
    1315,  1316,  1317,  1318,  1181,  1182,  1183,  1728,  2741,  2742,
    2743,  2744,  3608,  2745,  2746,  1624,  1002,   538,  1004,  1625,
    1626,   811,   812,   539,  1633,  1634,  1635,  1185,   815,   816,
     540,  1007,  1008,  1009,  1279,  1280,  1010,  1011,   817,  1732,
    4236,  4237,  4238,  4239,  4181,  4240,  4241,  3901,  3902,  3903,
    4242,  4243,  4244,  4186,   541,   542,  1675,  1186,   822,  1591,
    1370,  1371,  1372,  1429,  1430,  1431,  1432,  1187,   667,  1592,
    1593,   668,  1594,  1188,   669,  1595,  1373,   670,  3929,  3930,
    2174,   561,  1679,   644,  1680,   827,   828,   829,   830,   831,
     832,   833,   834,   835,   836,   837,   838,  1681,   840,   841,
     842,   843,   844,   845,   846,   847,   848,   849,  1682,  1319,
     851,   852,   853,   854,   855,   856,  1190,   562,   859,   860,
    1191,   585,  1192,   864,  1683,   866,   587,  1050,  1102,  1193,
    1194,   543,   544,   590,   871,   872,   873,   874,   875,   545,
     546,   878,   879,   880,   881,   882,  1684,   884,  1195,  1196,
     887,  1449,  1444,   888,  2112,   889,   890,  1197,  1198,  1199,
    1200,  1201,  1596,   671,  1597,  1598,  1599,   672,   673,  1600,
    1601,   674,   675,   676,  1602,  1603,   677,  1604,  1605,  1606,
    1607,   678,  1608,   679,   547,   548,   549,   550,   551,   552,
     553,   563,  1202,  1203,   898,   899,   900,   901,   902,   903,
     904,   905,   906,   907,  1685,  1686,  1687,  1688,  1689,  1690,
    1691,  1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,
    1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1710,
    1711,  1712,  1713,  1053,  1714,  1715,  1716,  1717,  1718,  1056,
    1057,  1058,   630,   631,   632,   633,   645,   592,   908,  1417,
    1944,  1945,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1796,
    1797,  1798,  1799,  1800,  1801,  1802,  1803,  1804,  1805,  1806,
    1807,  1808,  1809,  1918,  1810,  1811,  1812,  1813,  1814,  1815,
    1816,  1817,  1818,  1819,  1820,  1821,  1822,  1823,  1824,  1825,
    1826,  1827,  1828,  1829,  1830,  1831,  1832,  1833,  1204,  1205,
    1999,  2000,  2001,  2002,  2003,  2004,  2012,  2013,  2014,   909,
    1450,  2021,  2022,  2023,  2024,   593,   594,   595,   596,   597,
     915,   916,  1852,  1853,  1921,  1854,  1834,  1923,  1924,  1925,
    1926,  1927,  1928,  1929,  1930,  1931,  1932,  1933,  1934,  1935,
    1936,  1937,  1855,  1949,  1950,  1961,  1962,  1963,  1964,  1965,
    1856,  1857,  1858,  1972,  1877,  1859,  1860,  1861,  1862,  4245,
    1864,  1865,  1989,  1459,  1719,  1720,   918,   919,   920,   921,
     922,  1209,  1210,   924,   925,   926,  1322,  1281,  1323,  1324,
    1325,  1326,  1327,  1328,  1329,  1399,  1400,  1401,  1402,  1403,
    1330,  2029,  2030,  1380,  1381,   680,   927,   598,  1341,   634,
    2126,  2127,  2128,  2129,  2130,  2131,  2132,  2133,  2134,  2135,
    2136,  2137,  2138,   929,  2140,  2141,  2142,  1211,  1212,  1213,
    1214,  1215,  1216,   635,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1071,  1072,  1073,  1112,  1113,  1114,  1465,
    1466,  1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,
    1505,  1506,  1507,  1508,  1509,  1510,  1511,  1512,  1513,  1514,
    1515,  1516,  1517,  1518,  1519,  1520,  1521,  1522,  1539,  1540,
    1541,  1542,  1546,  3044,  3308,  3576,  4322,  3911,  3912,  3038,
    3039,  3601,  3602,  3172,  3173,  4128,  3634,  4146,  3771,  2218
  };

  const short
  parser::yytable_[] =
  {
     296,  1863,  2287,  2624,   305,   435,   437,   438,  2146,  2146,
     305,  2367,  1116,  2379,  1986,   305,  2402,  2414,  2436,   970,
    2441,  2486,  2614,  2793,   305,  2605,   642,   863,   588,   805,
     628,  1047,   826,  1184,   857,   629,  2055,   358,  1189,   819,
     684,   685,  1349,   809,   839,  1206,   868,  2056,   305,   305,
     377,  1039,   305,   885,  1082,  2059,  1048,   305,  2062,   891,
    1040,   305,   892,   893,   894,   895,  2069,   305,   305,   589,
     305,  1876,   305,  1083,  2011,   858,  1729,   305,  1873,  1971,
    1721,  1106,  1948,   305,   377,   377,   377,   869,  1979,   305,
    1906,   305,   447,  1730,  1907,   580,   582,  1908,  3230,   583,
    1909,  1731,  1525,  1910,  1416,   581,  1911,  2070,  1448,  1443,
    1526,  1321,  1527,   810,  1343,  1321,  1445,   818,  1912,  1913,
     627,  1376,  1160,   813,   821,  1406,   305,  2071,  1321,   806,
     823,  1003,  1006,   629,   824,  2072,  2073,   984,  1003,  1006,
     867,  1005,  2074,   985,  2076,  3286,  1044,   986,  1005,  2077,
     305,  1041,  1045,  1528,   305,  2060,  1046,  2078,  1411,   305,
    2075,   296,  1377,  2080,  2081,  3318,  2082,  2122,  2083,  1304,
    2084,  2086,  1914,  1529,  1278,  2087,  1530,  1674,  1334,  1674,
    1428,  2088,  2085,  1915,  2089,  1433,  1389,  1733,  1366,  1368,
    1531,  1335,  1369,  1278,  3319,  2090,  1276,  2091,  1367,  1904,
    2093,  2094,  2053,  1425,  1427,  2068,  3347,  2092,  2098,  1532,
    2099,  2054,  3174,  1426,   807,  1375,  2057,  2079,   627,  2096,
    1788,  2095,  2100,  2101,  2102,  1336,  2109,  2103,  1734,  2104,
    2105,  2106,  2115,  2107,  2108,  2116,  2117,  2118,  2119,  1916,
    1905,  2110,  2512,  2513,  1917,  2111,  2113,  2114,   896,  2120,
    1052,  1670,  1672,  1670,  1672,  1673,  2121,  1673,  1787,   917,
    2097,  1671,  1676,  1671,  1676,  2123,  1903,  1669,  1677,  1669,
    1677,  2124,  1678,  2125,  1678,  2139,   968,  3414,   808,   820,
    1054,  1060,  1055,  2955,  2959,  3098,  2058,  2063,   814,   558,
    2064,  2152,  1061,   861,  1135,   862,  2061,  2065,   870,  1922,
    3342,  1043,   897,  2066,   601,  3614,  3615,  2067,  3951,  3315,
    1207,   650,  3774,  3131,   601,   586,   358,   358,   688,  1874,
    1875,  1208,   601,   943,   876,   949,   954,  2519,  1872,  1980,
    1981,   973,  3937,   865,  1960,   601,   989,   992,  1978,  3915,
    1014,   877,  4127,  1878,  1076,  4276,  2262,  1081,  1136,   358,
    1870,  2268,  1919,  1982,  1946,  1049,  1958,   358,  1969,   886,
    1976,  1879,  3913,  4113,  1125,  1128,  3819,  2362,  1139,  1139,
    1142,  1983,  3819,   601,   601,  1871,  1222,  1920,  1269,  1947,
     601,  1959,  1880,  1970,  4393,  1977,  3819,   825,   646,   601,
     358,  1881,  1984,  2396,  1882,  2398,  1883,   601,  1386,  2411,
     987,  1985,  3945,  2411,  1987,  2462,  1988,  2469,   304,   601,
    2507,  2368,   601,  4051,   314,  4010,   910,   601,   911,   322,
    2577,   601,  1059,  2288,   689,  3035,  4178,   912,   335,  4053,
     913,   914,   601,   601,  3577,  1222,  3471,  1222,  1222,  1558,
    1560,   601,   923,  4380,  1227,   601,  1614,   928,   930,  2595,
     931,   932,   373,   374,  3910,  2597,   380,  2599,  2606,   512,
     516,   389,  3661,  1737,   933,   397,   934,  4221,  2608,  1435,
     601,   409,   412,   623,   417,  1379,   421,  2627,  2640,   682,
    2644,   432,  2442,  1436,  4007,  1227,   804,   433,  3809,  3461,
    1434,  3054,  2033,   441,  1228,   445,   601,  2148,  2148,  3461,
     601,   943,  1609,  2655,  2657,  -949,  2165,  1087,   601,  -951,
    1088,  3462,  2172,  2175,  2179,  2183,  1610,  2222,  1227,  1087,
     584,  3462,  1088,  3910,   297,   299,  4319,  3158,  3975,  2663,
     470,  2693,  4377,   935,  1089,  1228,  2711,  2731,   850,  4661,
    2750,  2790,  2904,  2910,  1118,  2916,  1089,  2920,  1090,  1305,
    3129,  1227,  3133,  1305,   496,  1549,  1223,  3939,   500,  1118,
    1090,  1619,  2386,   508,  2511,  4315,  1305,  3905,  1228,  4490,
    1091,   623,  4723,  2920,  1320,  2943,  2943,  2462,  1320,  4623,
    3170,  2968,  1091,  4223,  3611,  4075,  4077,  4230,  4255,  4260,
    4260,  1320,  -953,  4179,  1227,  1628,  4414,  4633,   602,  2250,
    2025,  1228,  4180,  4182,  1350,  3212,  4183,  4184,  4185,  4639,
    4255,  4255,  4272,  1374,  4312,  4338,  4458,  4260,  4160,  1344,
    4432,  4447,  4456,  1533,  4525,  1415,  4230,  4230,  4158,  4114,
    3376,  3181,  3182,  4111,  4456,  4727,  4456,  4230,  4230,  4456,
    4652,  4456,  4230,  4456,  1228,  4776,   301,  2270,  1344,  3672,
    4158,  4158,   306,  4706,  4158,  1629,  4706,  1344,  4488,   307,
    1344,   308,  2386,  4706,  1344,  1092,  4706,  2733,  1722,   994,
    4706,   969,  2604,  -447,  1461,  4706,   309,  1092,  2569,  1344,
    2386,  4070,  2734,  4755,  4350,  4706,   688,  4759,  4706,  2954,
    3909,  2271,   591,   969,   969,  1227,  1723,   969,  1227,  1724,
    1129,  1227,  3465,  4676,  3037,  1227,  4005,   527,  1227,  2485,
     883,  4502,  1227,   311,  4297,  4298,  3707,  1227,  4409,  3780,
    3833,   603,   604,   605,   969,  3716,  3587,  1227,  3719,  3800,
    1227,  4777,  1051,  1227,  4778,  3727,  1344,  1272,  1273,   692,
    1016,   693,  3833,  3833,   310,  1228,  3833,  1344,  1228,   315,
    2472,  1228,  3948,  3728,  2613,  1228,  3949,  1093,  1228,   643,
    4820,  2892,  1228,  4418,  4066,  4080,  4318,  1228,  2473,  1093,
    4258,  4822,  3466,  3115,  4352,  4013,  3128,  1228,  3132,   963,
    1228,  4327,  3910,  1228,   983,  1378,  4360,  -267,  4572,  1094,
    4668,  1227,  2569,  1042,  3221,  4558,  3467,  3025,  3026,   599,
    1227,  1094,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,   316,  2567,  2565,  2566,  3332,  2567,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  2467,  2567,
    1550,  4706,  1277,  3203,   317,  1534,  1333,  4382,  3159,  3160,
      22,  1228,  4798,   325,  2893,  1227,  2894,  2895,  4317,   331,
    1228,  1277,  3763,   712,   713,  4807,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  2735,  3018,  3764,  1725,
    3333,  3025,  3026,  1227,  4671,  3263,  4673,    22,  1227,  1130,
     969,  1535,   318,  3028,   319,  1536,  3031,  3158,  1130,   567,
    3505,  4819,  1017,  2387,  3511,  1228,  3513,   330,  2906,  4112,
     721,  3222,  1462,  1018,  3025,  3026,   969,  1095,  2923,  4167,
    4168,  4169,  4170,  4171,  4172,  4173,  4174,  4653,  4654,  1095,
    2184,   969,  4358,  1228,   775,   776,  3662,  3663,  1228,  3034,
    3223,  3224,  3225,  1224,  3556,  4821,   323,  2364,   324,  2365,
     943,  1224,  4413,  2026,   638,  2371,  2372,   949,   332,  3183,
    2376,  2377,   954,  4415,  1130,  3271,   570,   336,  1938,  3906,
    1130,  4491,  1620,   339,  4724,  4875,  4874,   351,  1551,  2185,
    3273,   973,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,   346,  3018,  4373,  1345,  3161,  2186,   349,  2736,
     992,  4161,  4374,  1351,  4378,  4721,   770,  1349,    43,  2187,
    2188,   772,  1621,  1119,  3673,  3674,   599,  1224,   350,  4190,
    4734,  3943,  1014,  4109,  1345,  4178,   778,   363,  1119,  1019,
    1020,   364,  1120,  1345,  4462,  4706,  1345,   571,  3767,   638,
    4544,  2156,  2157,   647,  2475,    43,  1630,  1120,   365,   533,
     534,  2189,  4160,  1021,   782,  4544,  4299,    22,  3025,  3026,
    3978,  3025,  3026,  1227,  3025,  3026,  3226,  1096,  3025,  3026,
    3036,  3025,  3026,  1352,   639,  3025,  3026,  1227,   368,  1096,
    3025,  3026,  2263,  4650,  1076,  2737,  3282,  2269,  2738,  1081,
    3025,  3026,   390,  3025,  3026,  1269,  1269,  1353,  1939,  4556,
    3914,  4115,  1115,  2363,  3820,   788,  1354,  2289,  2290,  3263,
    3992,  4160,  4544,  1228,   358,  2156,  2157,  1354,  1115,  3985,
     683,  3986,  4394,  4544,  4408,  2471,  1115,  1228,  4802,  2397,
    3510,  2399,  1227,  1125,  4175,  2412,  1128,   369,  1354,  2439,
    3946,  2463,  1115,  2470,  2369,   690,  2508,  1139,  4011,  4052,
    1139,  2494,  4160,   442,  1022,  1023,  2578,  1552,    78,    79,
      80,    81,    82,  3025,  3026,  4054,  3783,   298,   300,  4250,
    3555,  4514,   513,  4737,  4738,  1940,   514,  2517,   517,  4845,
     969,  4381,  1228,   455,  3036,  2596,  4747,  4748,  3264,  3265,
     515,  2598,  4179,  2600,  2607,    78,    79,    80,    81,    82,
    3227,  4180,  4182,  4222,  2609,  4183,  4184,  4185,  3159,  3160,
     456,  4577,   370,  2628,  2641,    43,  2645,  2443,    22,  4008,
    4248,  3320,  3463, -2458,  4251,   599,  1115, -2458,  1115,  3275,
    2510,  1024,  4760,  4503,  2516,  2516,  3025,  3026,   404,  2656,
    2658,  2190,  2191,  1115,  4782,  1269,  1269,  2192,  2193,  2194,
    2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,
    2205,  2206,  2207,  2208,  2209,  2664,    22,  2694,  2210,  2211,
    2212,  2213,  2712,  2732,  1097,  1269,  2751,  2791,  2905,  2911,
    1098,  2917,  1438,  2921,  1392,  1393,  1097,  1115,   418,  3633,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  2922,
   -2458,  2944,  2946,  2947,   636,   123,   637,  2969,   509,  4224,
    3612,  4076,  4078,  4231,  4256,  4261,  4264,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,  4269,  4270,  4273,  1562,
    4313,  4339,   123,  4375,  2602,  2603,  4433,  4448,  4457,  3228,
    4526,  4159,  4622,  4638,  2612,    78,    79,    80,    81,    82,
    4719,  4728,  4733,  4797,  4806,  4844,    43,  4850,  4873,  4885,
    3951,  3221,   454,  4467,  4511,   599,  4707,  4547,  4708,  4710,
    3057,  4708,  3782,   457,  1386,   564,  4796,  4267,  4708,  4813,
    3962,  4708,   462,  4814,  3139,  4708,  4402,  4403,  4815,  4404,
    4708,  1274,  3264,  4320,  2639,   485,  3025,  3026,  4823,  2490,
    4708,  4824,  2490,  4708,    43,   487,    22,  4535,  1394,  1395,
    3025,  3026,  4539,   467,  4132,  4133,  4542,  1396,  4134,   491,
    3140,  3141,   143,   144,   145,   146,   147,   148,  1847,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  1991,
    3018,   484,  1269,  2015,  2016,  2017,  2018,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,   143,
     144,   145,   146,   147,   148,  3025,  3026,  2892,  3222,   501,
    1839,  4474,   486,  4475,  1227,  3600,   969,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,  4545,  3223,  3224,  3225,
     488,  3720,   123,  2156,  2157,  1839,    78,    79,    80,    81,
      82,  4461,  1227,  1842,   518,  1227,  3941,  4090,  1439,  1440,
    3377,  3378,  1563,   489,  1228,  3833,   651,   652,  1107,  1108,
    1109,  3752,  3753,   653,   490,  1941,  1849,  1564,   654,   655,
     326,   571,   327,   638,  4868,   492,  4708,  2700,  1842,  2703,
    2893,  2214,  2894,  2895,    78,    79,    80,    81,    82,  4580,
    1848,  1966,  1228,  4630,    43,  1228,  1227,   955,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,   639,  2567,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
     328,  2567,   329,  4167,  4232,  4169,  4233,  4171,  4172,  4173,
    4174,   337,  2724,   338,   656,   340,  3379,   341,  3942,  3382,
    3058,  3059,  3060,  3061,  3062,  3063,  1228,  3968,  3207,  3208,
    3093,  3094,  3095,  3226,  3096,   657,  3188,  3189,  4449,   143,
     144,   145,   146,   147,   148,   497,   527,  4145,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  3093,  3094,  3095,
     342,  3096,   343,   123,  3209,  1565,  1272,  1273,   658,   659,
    3142,   498,  4153,  1993,  3476,  3477,  4275,   527,  4678,  4679,
     700,  2006,  2007,   499,  2008,  4677,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   554,   528,  2563,  2564,  2565,
    2566,   123,  2567,   647,    78,    79,    80,    81,    82,  3790,
    3791,  1566,  4321,   944,  4392,  1737,  1419,  2795,  3016,  3017,
    4754,  3018,   969,  4757,  1992,   344,  4462,   345,  4869,  4462,
    4708,   347,   607,   348,   956,   957,   993,   608,   609,   610,
    2571,  2572,  2573,   712,   713,  4402,  4403,  3227,  4404,  1993,
    1994,  1995,  1996,  3979,  3185,  3186,  3187,   660,  4720,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  1015,
    3018,   611,   612,  4023,  3014,  3015,  3016,  3017,  1077,  3018,
     143,   144,   145,   146,   147,   148,  4743,  4744,  4745,  3093,
    3094,  3095,   786,  3096,   613,  1084,  1101,   614,  4175,  4545,
    3090,  3091,  3092,  4545,   352,  4801,   353,  1103,  4476,  4463,
    3944,  3947,  4762,  4763,  1219,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,  1270,  3018,  1567,   143,   144,
     145,   146,   147,   148,  1115,  1354,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,  3025,  3026,  1387,  3025,  3026,
     359,   123,   360,   638,  1420,  1357,  3093,  3094,  3095,   529,
    3096,  1738,  1615,  2518,  4347,   361,  1360,   362,  3097,  3192,
    3193,  3194,   615,   958,  4677,  1554,   770,  3321,  4677,  1543,
    1616,   772,  3322,  3195,  3196,  3197,   638,  1617,   366,  4504,
     367,   381,   571,   382,  4505,  1618,  3228,  3581,  3582,  3583,
    1421,  1990,  1568,   974,   975,   976,   977,   978,  4838,   638,
    4840,  4257,  2161,  2152,  4396,  4397,  4398,  4399,   383,   661,
     384,   616,  1835,  3033,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,   618,  2567,  3099,  3100,   385,  1361,
     386,   387,   959,   388,   588,   527,   391,   994,   392,  2166,
     617,  3117,  2223,  2168,   628,   642,   393,   662,   394,   629,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  3089,  2567,
     995,  3896,  3897,  3898,   996,   997,   998,   999,   143,   144,
     145,   146,   147,   148,  2224,   589,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  3127,  3018,  1467,  3318,
     398,  1470,   399,  3985,  1473,  4164,  2225,  1476,  1477,  1478,
    3130,   580,   582,  2226,  1483,   583,  1485,  3154,  3155,  3156,
    1839,   581,   400,   960,   401,  3168,  2227,   402,  3319,   403,
    2228,  3179,  1268,  1362,  3804,  3805,  3806,   405,   863,   406,
     805,  2229,  2230,   826,   627,   857,   413,   422,   414,   423,
     819,  4121,  4122,  4123,   809,   839,   424,   868,   425,   426,
    2231,   427,  1841,  1842,   885,  2232,  3270,  3272,  3274,  3276,
     891,  4265,  2233,   892,   893,   894,   895,   428,  2234,   429,
    1951,  1952,  1953,  1954,  1955,  2235,   858,  3586,   448,   450,
     449,   451,  1047,  3318,   452,   458,   453,   459,   869,  4592,
    3269,   460,  1847,   461,  2236,  4593,  4594,  4595,  4596,  4597,
    4598,   463,  1039,   464,   465,  2148,   466,  1048,  3290,  2237,
    4599,  1040,  3319,   943,   810,  2238,  2952,  2953,   818,  4600,
    2239,  2240,  2165,  3117,   813,   821,  2241,   471,  1184,   472,
     806,   823,  2243,  1189,  4808,   824,   473,   529,   474,  2244,
    1206,   867,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,   475,  2567,   476,   477,   479,   478,   480,  2245,
     481,   984,   482,  1003,  1006,  2242,  2246,   985,  4632,  2247,
    4634,   986,   493,  1005,   494,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,  3364,  3018,   502,   504,   503,   505,   358,
     558,   506,  2248,   507,  3043,  3045,  2249,  1044,  4655,  4656,
    2252,  2251,  1041,  1045,  4515,  2253,  4516,  1046,   305,  2254,
     663,   305,   664,  2255,  2256,   807,  2257,  1160,  2273,  2258,
    2259,   586,  2260,  2261,  3433,  3434,  2264,  2265,  2266,  4472,
    4562,  2267,  2274,  3088,   358,  2275,  2276,  2277,  2278,  3101,
    2281,   305,  2279,  2280,   305,   305,  2282,  2955,  2959,   896,
    2283,  3417,  3161,  2292,  1422,  2284,  3121,  2285,  2291,  3117,
     917,  4587,   358,  2293,  2294,  4591,  2295,  4602,  4603,  2296,
    2297,  2298,  2299,  2300,  2301,  2302,  2303,  2304,  2305,   808,
     820,  2306,  1321,   358,   358,   358,  1321,  2307,  2308,   814,
    3167,   358,   968,  2309,   861,  2310,   862,   358,  2311,   870,
    1416,  1052,  2312,   897,  3191,  2313,  1376,   646,  2314,  3522,
    1443,  2315,  2316,  3491,  1321,  3493,  2317,  1445,  2318,  3502,
    1525,  2319,  2320,   305,  3318,   876,  1363,   629,  1526,  1278,
    1527,  1054,  1060,  1055,   865,  2321,  2322,   618,  2323,  2324,
    3453,   619,   877,  1061,  2325,  2326,  1863,  1377,  2327,  1334,
    2328,  3435,  1043,  3319,  1411,  2329,  4021,  2330,  2331,   305,
     886,  2332,  1335,  3651,  1729,  3268,   358,  3588,  3589,  2333,
    3554,  1528,  1389,  1366,  1368,  1135,  2334,  1369,  2335,  1278,
    1428,  1730,  1986,  1367,   358,  1433,  2336,   623,   825,  1731,
    2337,  1529,  2338,  2339,  1530,  2370,  1336,  3580,  2340,  2341,
    1375,  2342,  3306,  1425,  1427,  1207,  1049,  1269,  1531,  2148,
    3316,  1269,   627,  1426,  3823,  1876,  1208,   910,  2343,   911,
    4803,  3329,  1873,  2344,   987,   358,   584,  1532,   912,  1136,
    4816,   913,   914,  2345,  2346,  2347,  3270,  3276,  2348,  3345,
    2349,  2350,  2055,   923,  3349,  1948,  1971,  2351,   928,   930,
    1906,   931,   932,  2056,  1907,  3359,  1979,  1908,  2011,   358,
    1909,  2059,  1674,  1910,  2062,   933,  1911,   934,   305,  3375,
    3653,  2352,  2069,  1059,  2516,  1733,  2353,  2516,  1912,  1913,
    1269,  1269,  1269,  1269,  3387,  3388,  3668,   804,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,
    1269,  1269,  1269,  2070,  3415,  1269,  1734,  1269,  1269,  1269,
    1269,  1269,  1269,  1269,  1269,  1269,  1269,  1269,  3712,  3430,
    3714,  3715,  1914,  2071,   935,  2354,  1670,  1672,  4876,   850,
    1673,  2072,  2073,  1915,  2355,  2356,  1671,  1676,  2074,  2357,
    2076,  2358,  1669,  1677,  1788,  2077,  2359,  1678,  2360,  1904,
    2361,  2060,  4266,  2078,  4268,  2375,  2075,  2380,  2381,  2080,
    2081,  3472,  2082,  2122,  2083,  3564,  2084,  2086,  3479,  3480,
     305,  2087,  3485,  2382,  2383,  3485,  3488,  2088,  2085,   358,
    2089,   358,  1787,  2384,  2385,  2390,   305,  2639,   591,  1916,
    1905,  2090,  3794,  2091,  1917,   305,  2093,  2094,  2053,  2391,
     305,  2068,  3065,  2092,  2098,  3067,  2099,  2054,   305,  3848,
    1269,  3815,  2057,  2079,   305,  2096,  1903,  2095,  2100,  2101,
    2102,  4325,  2109,  2103,  2392,  2104,  2105,  2106,  2115,  2107,
    2108,  2116,  2117,  2118,  2119,  3104,   358,  2110,  3107,  3109,
     305,  2111,  2113,  2114,   377,  2120,  3566,  3567,  3568,  1922,
    1379,  3569,  2121,  1874,  1875,  3571,  2097,  3573,  3574,  1435,
    2393,  2123,  1872,   358,  2394,  2395,  2400,  2124,   643,  2125,
    3590,  2139,   305,  1436,  2403,  2405,  2404,  1878,  2406,  3599,
    1434,  2407,  2058,  2063,  1870,  2408,  2064,  1980,  1981,  1267,
    2409,  1960,  2061,  2065,  2410,  1879,  1978,  3613,  2614,  2066,
    2605,   883,  1919,  2067,  2415,  2416,  2417,  1946,  2418,  1871,
    1305,  1982,  2419,  1958,  1305,  1969,  1880,  3218,  1976,  1268,
    1268,  2420,  4662,  2421,  2422,  1881,  2468,  1920,  1882,  1983,
    1883,  1609,  1947,  2423,  2424,  1320,   358,  3161,  1959,  1320,
    1970,  2433,  1305,  1977,  3658,  1610,  3660,  2425,  2426,  2427,
    1984,   599,   358,  3260,  2428,   623,  2429,  2430,  2431,  1985,
    2432,  2434,  1987,  2437,  1988,  1571,  1572,  1320,  2438,  2446,
    1573,  1574,  1575,  1051,   527,  2444,  2445,  1576,  1577,   527,
    2455,  2456,  2457,  1578,  1579,   963,  2458,  2459,  1374,  2460,
    2461,  2465,    22,  2464,   358,  2793,   358,   358,   983,  2474,
    2479,  2482,  2483,   528,  2484,   305,   565,   566,   528,  2488,
    2491,  1415,  2487,  2497,  2498,  2499,  2500,  2501,  2502,  1224,
    2503,   607,  2520,  1358,  2504,  2505,   608,   609,   610,  4024,
    2506,  2521,  2509,  2522,  1042,  2523,  2524,  2525,  4451,  2528,
    2529,  2574,  2530,  1580,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,  2486,  3018,  2531,  2532,  1266,  2575,
     611,   612,  3374,  4464,  1581,  2533,  2534,  2535,   358,  1268,
    1268,  2536,  2537,   568,  2538,  2539,   567,  2436,   568,  2441,
    4464,  2540,  2541,   613,  2542,  2543,   614,   358,  2544,   569,
    2545,  2546,  2547,  2148,   569,  2548,  2549,  2550,  2576,  1268,
    2551,  2552,  2579,  2553,  2554,  2555,  2580,  1582,  1583,  2581,
    2165,  2582,  2583,  2584,  3844,  3845,  2585,  2586,  2175,  2587,
    2588,  3849,  3850,  2589,  3852,  3853,  3854,  2590,  3856,  2591,
    2592,  2593,  2594,  2601,  2610,  2611,  2414,  2616,   570,  2615,
    2617,  2618,  2619,   570,  1116,  2620,  2621,  2622,  2625,  2626,
      43,  2629,  2630,  2402,  2631,  2632,  2633,  2635,  2642,  2634,
    1378,  2643,  2646,  2647,  2648,  2649,  4048,  2651,  2668,  2652,
    1359,   615,  2653,  2650,  3482,  2654,   529,  1277,  2379,  2667,
    2367,   529,  2661,  1360,  2662,  2665,  2666,  2669,  2682,  3161,
    3498,  2670,  2671,  2672,  2673,  2674,  2675,  1333,  2676,  3508,
    3998,  2677,  2678,  2679,  3515,  2680,  1584,  2681,  1106,   571,
    2683,  1585,  3524,  2684,   571,   601,   531,   601,  3532,  2685,
    2686,   531,  2687,  2688,  2689,  2690,  2691,  1277,  2692,  2695,
    2696,   305,  4586,  2697,  2704,  2705,  4590,  2706,  2707,  2708,
    2709,  2722,  2710,  2713,  3560,  2714,  2723,  2715,  2725,   617,
    2716,  2717,  2718,  2719,   601,  2720,  1361,   601,  2721,   601,
    2726,  2727,  2728,  4618,   688,  2729,  2730,  2747,  2783,  1349,
    2748,  2749,  2752,  2753,  2754,  2755,  3593,  2756,  2757,  2758,
    2759,  2760,  2761,  2762,  1361,   305,  1268,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,  2763,  3018,  2764,
      78,    79,    80,    81,    82,  2765,  4197,  2766,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  2624,  3018,
    2767,  2768,  2769,  2770,  2771,  2772,  2773,  2774,  4660,  2775,
     519,   520,   521,  4198,  2776,  2777,   522,   523,   524,   525,
    2778,   599,   555,  2779,  2780,  2781,   533,   534,  2784,  2782,
    1362,   533,   534,   556,   526,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,   527,  2567,  2785,   601,  3955,
    2840,  2786,  2787,  2788,  2789,  2796,  2797,  4281,  1362,  2798,
    2799,  3883,    22,   943,  3960,  2800,  2801,  4709,  3963,  4709,
    2802,  2803,   954,  2804,   528,  2805,  2806,  2807,  2808,  2841,
    2809,  2810,  2811,  2287,  4527,  2812,  2813,  2814,  2815,  3724,
     601,  3973,  2816,  2817,   557,  2818,  1586,   992,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  2819,  2567,
    2820,  1014,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  2821,  2822,  1076,  2823,  2824,  2825,   123,  2826,  1081,
    2827,  1269,  2828,  2829,  2830,  1587,  2831,  2832,  2833,  2834,
    1269,  1269,  2835,  2836,  2837,   305,   358,  2838,  2839,  2842,
    4152,  2843,  2844,  2845,   358,  2846,  2847,  2848,  2849,  2850,
    2851,  4528,  2852,  2853,   527,  2854,  2855,  2856,  2857,  2858,
     572,   573,   574,   575,   576,  2859,  4615,  4016,  2860,  2861,
    2862,  2874,  2863,  2875,  2864,  4783,  2865,  2879,  2866,  2880,
    2867,  2868,  2869,  2870,   601,  4187,  2871,  2872,  2885,  4709,
    2873,  4616,  2876,  2886,  2877,  4464,  2878,  2881,  2882,  2887,
      43,  2883,  2884,  2888,  2889,  2890,  2891,  2898,  2899,  2900,
    2926,  2901,  4709,  4709,  4709,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,  2902,  2567,   529,   530,  2903,
    2909,  4709,  4709,  2912,  2913,  2914,  2915,  2918,  2919,  2927,
    2906,  1269,  2928,  2929,   143,   144,   145,   146,   147,   148,
    2930,  4635,  2931,  2923,  2932,   577,  1267,  1267,  2933,  2934,
    2935,  2936,   305,  2937,  2938,  2939,  2940,   531,   532,  2945,
    4063,  4064,  2948,  2951,  2466,  2960,   519,   520,   521,  2957,
    2961,  3019,   522,   523,   524,   525,  2967,  2970,  2964,  2956,
    2966,  2962,   601,  2965,  4085,  3926,  2974,  4085,  2971,  2972,
     526,  2973,   305,  2977,   305,  4015,   618,  4709,   601,  4709,
     619,   527,  2978,  1363,  2975,  2976,  2979,  3030,   601,  3032,
    3380,  3034,  2980,  3023,  2981,   601,  3040,   305,  2982,  2985,
    2986,  2987,  3041,  2988,   601,  2989,  3047,  4311,  2990,  1588,
     528,  2991,   601,  3053,  3048,  3050,  3052,  2992,  4643,  3940,
      78,    79,    80,    81,    82,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,  2993,  3018,  2994,  2995,  2996,
     601,  2997,  1269,  2998,  1222,  1269,  3036,  3055,  3068,  3069,
    1269,  3070,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,  2999,  3018,  3074,  3076,  3000,   533,   534,  3001,
    3002,  3003,  3004,   601,  3079,  3005,  1267,  1267,  3006,  3021,
    3077,  3081,  3082,  3083,  3085,  4116,  4117,  4118,  3086,  4120,
    3102,  3087,  3110,  3114,  3118,  2448,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  1267,  3018,  3124,  3119,
    3135,  3126,  3134,  3138,  3152,  3153,  3157,   305,   305,   305,
    2215,  3164,   305,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,  3165,  2567,  3169,  3171,  2473,  3175,  3219,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
     305,  2567,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  3180,  3190,  3199,  3200,  3205,  3198,   123,  3202,  3206,
    3211,  3213,  3215,   529,   530,  3234,  3210,  3235,  3220,  3238,
    1269,  3233,  3239,  3243,  3244,  3247,   533,   534,  3236,  3251,
    3252,  3240,  1349,  3253,   601,  4353,  3254,  3242,  3245,  3997,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
    3255,  2567,  3284,   531,   532,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,  3248,  3018,  3117,   527,  3249,
    3257,  3262,  3267,  3278,  3261,  2526,  2527,  3279,  3281,   305,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
    3285,  3018,  3287,  3288,  3291,  3292,  3293,  3297,  1272,  1273,
    2287,  3298,  3307,  3327,  3328,  2556,  3362,  1739,  1740,  1741,
    1742,  1743,  3325,  3366,  3460,  3299,  3367,  3301,  3303,  3369,
    1749,  1750,  1751,  1267,  3304,  3305,  3335,  1756,  1884,  2148,
    1757,  1758,  2148,  3371,   143,   144,   145,   146,   147,   148,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
    3309,  3018,  2165,  3310,  3326,  3331,  1764,  2567,  1836,  3336,
    4417,  3339,  3340,  3341,  3343,  3344,  4062,  3346,  3432,  3350,
    3351,  1282,  1283,  3353,  3355,  3356,  3429,  3439,  3436,  3431,
    1837,  1838,  3441,   533,   534,  1839,  1284,  3469,  3442,  4436,
    3443,  3450,  3454,  3452,   613,  3478,  3492,  1285,  3456,  3458,
    3459,  3495,  3464,  3468,  3501,  3509,  4088,  3470,  4089,  3512,
    3494,  3473,  3474,  3475,  3486,  1286,  3519,  3490,  3496,  3503,
    3528,  3521,  3517,  3533,  3534,  3535,  4252,  4341,  1842,  3537,
    3538,  4095,  1885,  3539,  3540,  3541,   601,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,   688,  3018,  3542,
     601,  4331,  1784,  1886,  1887,  1888,  1889,  1890,  1891,  1892,
    1893,  3543,  1894,  1895,  1896,  1897,  1898,  1899,  1900,   943,
    3544,  3545,  3546,  3547,  4187,  3548,  1287,   954,  3549,  3550,
    3552,  3557,   615,  3563,  3575,  3579,  3584,   992,  3585,  3591,
    3595,  1014,  2659,  1076,  3596,  3597,  3598,  3600,  1081,  4308,
    3605,  3604,  1269,  1269,  4309,   638,  3606,   601,  3607,   599,
    3609,  1269,  3610,  3618,  3617,  3619,  3620,  3621,  1156,  3622,
    4324,  3623,  3624,  3625,  3626,  3627,  3628,  3629,  3630,  3762,
     377,  3632,  3640,  1269,  1269,  3633,  4371,  4372,  3637,  3638,
    3641,  3644,  3654,  3639,  3664,  3665,  4508,  3642,  3666,  3667,
      22,  3669,  3650,  3671,  1288,  3652,  3656,  3657,  1289,  3659,
     617,  1269,  1290,  1269,  3670,  3675,  3676,  3677,  3678,  3679,
    3799,   305,   601,  3682,  3683,  3684,  3709,  3685,  3825,  4348,
    3807,  3686,  3018,  2386,  4137,  3687,  3726,  3689,  3690,  3691,
    3692,  3916,  3693,  4361,  3694,  3695,  3696,  3697,   601,   601,
    3698,  3745,  3699,  3700,  3701,   601,  3702,  3703,  3704,  3705,
    3706,  3711,  3713,  1839,  1840,   377,   377,  3717,  3718,  2557,
    2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  1269,
    2567,  3721,  3732,  3734,  3735,  3843,  3738,  3739,  3740,  3741,
     601,  1268,   960,  3746,  3747,  1268,  3748,   601,  3751,  3750,
    3754,  3759,  3772,  3775,   601,  1841,  1842,  3776,  1843,  1844,
    3769,  1845,  1846,  1847,  1269,  4410,  4411,  3789,  1848,  3756,
    3795,  3758,  3761,  3765,  3808,  3811,  2165,  3812,  3766,  1849,
    3814,  3778,  3785,  4144,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,  3793,  2567,  4353,  3797,  4434,  3770,
    4353,  4437,  3798,  4353,  4440,  3802,  3817,  3840,    43,  2219,
    3922,  3824,  3927,  3826,  1268,  1268,  1268,  1268,  3827,  3828,
    3829,  3950,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  1268,  1268,  1268,  1268,  1268,  3830,  3831,  1268,
    3832,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,  1268,
    1268,  1268,  3837,  1282,  1283,  3838,  3842,  3847,  3956,  4471,
    3895,  3958,  1836,   688,  3974,  3975,  2496,  3984,  1284,  3993,
    1836,  3904,  4012,  3917,  3918, -2459,   613,  4022,  3919,  1285,
    3928,  3938,  3957,  3976,  1837,  1838,  3987,  3990,  3994,  4551,
    4068,  4553,  1837,  1838,  4000,  4004,  4005,  1286,  4009,  4020,
    4027,  4028,  4499,  4500,  4056,   447,  4057,  4061,  1269,  4067,
    4069,  4072,   358,  4079,  4087,  1269,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  4102,  2567,  4091,  4097,
    4105,  1222,  4119,  4140,  4141,  4108,  4147,  1269,  1269,  4106,
     601,  4126,  4135,  4136,  1268,  2569,  4163,  4142,    78,    79,
      80,    81,    82,  4143,  4148,  4165,  4149,  4150,  1287,  4155,
    4157,  4188,  1386,  4189,   615,  4156,  4191,  4194,   377,  1269,
     377,  1222,  1222,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,  4192,  2567, -2458,  4193,  1737,  4195,   447,
    4196,  4227,  4228,  4229,  4246,  -950,  1269,  1269,  1269,  1269,
    1156,  3910,  1269,  1269,  4571,  4353,  4249,  4253,  4353,  1269,
    4254,  4259,  4263,  4271,  4280,  4283,  4290,  4291,  4301,  4285,
    4583,  4584,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,  4302,  2567,  4303,  4288,  1288,  4334,  4609,  4294,
    1289,  4612,   617,  4323,  1290,  4316,  4025,  4326,  4328,  4342,
    4343,  4337,  1274,  1291,  1292,  1293,  1294,  1295,  1296,  1297,
    1298,  1299,  1300,  1301,  1302,  4340,  4346,  4349,  4351,  4354,
    4355,  4356,  4357,  4359,   688,  4362,  4365,  4376,  4387,  4390,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  4383,
    4384,  4391,  1614,  1269,  1269,   123,  4420,  4385,  4386,  1269,
    4412,  4026,  4421,  4423,  4424,  4425,  4426,  1839,  1840,  4427,
    4428,  4429,  4430,  4431,   960,  1839,  1840,  1269,  1269,  4442,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
    4435,  2567,  4438,  4441,  4675,  4454,  4439,  4453,  4455,  1386,
    4459,  1222,  4460,  1222,  4478,  4479,  4480,  1737,  1614,  1841,
    1842,  1867,  1843,  1844,  4473,  1845,  1846,  1841,  1842,  4481,
    1843,  1844,  1848,  1845,  1846,  1847,  1973,  4486,  4489,  4493,
    4495,  4496,  4519,  1849,  3024,  3027,  3029,  4498,  3027,  4501,
    4509,  1849,  3970,  4627,  4560,  4629,  3787,  4512,  3787,  3787,
    3049,  4513,  4520,  4517,  4765,  4624,  4536,  3056,  4538,  4537,
    -952,  4540,  4644,  4548,  4575,  4541,  3071,  3072,  3073,  4543,
    3075,  4576,  4581,  4585,  4605,  3080,  4645,  4657,  4606,  4607,
    4610,  4621,   143,   144,   145,   146,   147,   148,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  4658,  2567,
    1269,  4651,  4695,  4029,  4669,  4694,  3120,  4625,  3122,  3123,
    4640,  3125,  4722,  4711,  4670,  4726,  4712,  4672,  4729,  3136,
    3137,  4674,  4730,  3143,  3144,  3145,  3146,  3147,  3148,  3149,
    3150,  3151,  4702,   377,  4703,  4704,  4713,  4714,  3027,  2557,
    2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  4715,
    2567,  3184,  4735,  4771,  4774,  4718,  4775,  4786,  4468,  4789,
    4030,  3201,  4788,  3204,  4791,  4746,  4792,  -954,  4832,  4066,
    4725,  3214,  4847,  4848,  4859,  4363,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,  4732,  3018,  4749,  1269,
    4750,  4753,  4756,  4758,  4761,  4764,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  4841,  2567,  4842,  4031,
    4871,  4766,  4784,  4795,  4769,  1222,  4878,  4879,  4870,  4828,
    4880,  4886,  4887,  4890,   305,  4805,  1269,  4834,  3027,  3283,
    4809,  4799,  4810,   599,  4812,  4817,  4818,  4843,  4888,  3294,
    3295,  3296,  4826,  4849,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,  4827,  2567,  4846,  4853,  1267,  4852,
    4854,  4855,  1267,  4856,  4860,  4865,  3323,  3324,  4866,  4872,
    4877,  4882,  4884,  4891,    22,  4895,  4857,  4858,  4889,  3337,
    4893,   601,   305,  4894,  4896,   511,   599,  4125,  3603,  3616,
    3983,  1078,  3578,  3277,  3977,  1291,  1292,  1293,  1294,  1295,
    1296,  1297,  1298,  1299,  1300,  1301,  1302,  3781,  3361,  3256,
    4881,  3365,  4568,   601,  3368,  3801,  3370,  4032,  4573,  4836,
    4835,  3330,  2150,  4071,  4081,  2149,  3768,    22,  4861,  4773,
    3777,  1267,  1267,  1267,  1267,  3784,  2476,  4006,  3078,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,
    1267,  1267,  1267,  1267,  3338,  3455,  1267,  3489,  1267,  1267,
    1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  1267,  3457,
    3818,  3796,  3959,  2031,  3792,  3506,  3967,  2171,  2950,  3655,
    3437,  3438,  2389,  3440,  4604,  2178,  3216,  3444,  3445,  3446,
    3447,  3448,  3449,   599,  3451,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,  4620,  2567,  4452,  2182,  2374,
    4466,  1140,  4477,  3372,  3300,  4033,  3536,  3313,  3334,  2481,
    3561,  3551,    43,  3558,  3553,  3530,  3520,  3760,  3046,  3725,
    3708,  3722,  3483,  3744,    22,  1268,  3051,  3749,  3757,  3516,
    3981,  3755,  3594,  3504,  1268,  1268,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  2272,  2567,  3258,  3500,
    3105,  1267,  3066,  3529,  3352,  4014,  4034,  3246,  3497,  3084,
    3988,  4549,  4557,  3487,  4162,    43,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  4166,  2567,  3839,  2155,
    3383,  3384,  3385,  3386,  3841,     0,     0,     0,  3389,  3390,
    3391,  3392,  3393,  3394,  3395,  3396,  3397,  3398,  3399,  3400,
    3401,  3402,  3403,  3404,  3405,  3406,  3407,  3408,  3409,  3410,
    3411,  3412,  3413,  4035,  4589,  3416,     0,  3418,  3419,  3420,
    3421,  3422,  3423,  3424,  3425,  3426,  3427,  3428,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,
    3846,     0,     0,     0,     0,  1268,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,  3631,  2567,     0,  3635,
    3636,  4036,    78,    79,    80,    81,    82,  3643,     0,  3645,
    3646,  3647,  3648,  3649,     0,     0,     0,  2478,     0,     0,
       0,     0,    43,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,     0,  2567,     0,     0,     0,     0,     0,
       0,     0,     0,  3680,  3681,     0,     0,     0,  4831,     0,
       0,  3688,     0,     0,     0,    78,    79,    80,    81,    82,
    3527,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,
    2566,     0,  2567,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,  3027,  2567,     0,     0,     0,     0,     0,
    3729,  3730,  3731,     0,  3733,     0,     0,  3736,  3737,     0,
       0,     0,     0,  3742,  3743,     0,  4863,     0,     0,     0,
       0,     0,     0,  3027,  3027,     0,  1268,     0,     0,  1268,
       0,     0,     0,     0,  1268,     0,     0,     0,     0,     0,
       0,     0,  3773,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,  3803,   123,
       0,     0,  4037,  3810,     0,     0,  3813,     0,     0,  3816,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,  2983,  2984,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,  3007,     0,
       0,     0,   123,  4038,     0,     0,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,
       0,     0,     0,  4039,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  3907,  3908,     0,     0,
       0,     0,     0,     0,  1268,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,     0,     0,     0,
       0,     0,  3111,  3112,  3113,    22,   143,   144,   145,   146,
     147,   148,  1104,     0,     0,     0,     0,  4739,     0,     0,
       0,     0,  4740,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,  4040,     0,     0,     0,     0,     0,   123,
       0,     0,     0,    22,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,     0,     0,     0,
    4041,     0,  3229,     0,     0,     0,     0,     0,     0,  3237,
       0,     0,     0,     0,  3241,     0,     0,     0,     0,  4364,
       0,     0,     0,     0,  3250,     0,     0,     0,     0,     0,
    3907,  3908,     0,     0,     0,     0,     0,     0,  4042,     0,
       0,     0,  3027,  3027,     0,     0,     0,     0,     0,  3280,
    4043,     0,  2495,     0,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,     0,  2567,     0,     0,     0,     0,
       0,  3302,  4367,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,    43,  2567,     0,     0,     0,     0,     0,
       0,     0,     0,    22,  1227,     0,   143,   144,   145,   146,
     147,   148,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,     0,  2567,     0,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,  3354,  2567,     0,  3358,     0,
       0,    43,     0,     0,     0,     0,  2184,     0,     0,     0,
       0,     0,     0,     0,  1228,     0,     0,     0,     0,     0,
     354,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,     0,  3018,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,     0,  3018,     0,     0,     0,     0,     0,
       0,     0,  1267,     0,     0,  2185,  1268,  1268,     0,  4388,
       0,  1267,  1267,  4044,     0,  1268,     0,     0,   354,     0,
       0,     0,     0,  2186,     0,  4045,     0,  4003,     0,     0,
       0,     0,     0,     0,     0,  2187,  2188,  1268,  1268,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,  4046,     0,     0,  1268,     0,  1268,     0,     0,
       0,    43,     0,     0,     0,     0,     0,  2189,     0,     0,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,     0,  3018,     0,     0,     0,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,  3518,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  4770,  3017,     0,  3018,
       0,     0,  1267,     0,     0,     0,     0,     0,     0,     0,
       0,   599,     0,  1268,     0,     0,     0,     0,     0,     0,
       0,     0,  4047,     0,     0,     0,     0,     0,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,
    3572,     0,     0,     0,     0,     0,     0,     0,  1268,     0,
       0,  3989,    22,     0,     0,     0,     0,     0,     0,     0,
    3995,  3996,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,  4049,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
    4050,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,  1267,     0,     0,  1267,     0,   123,  4055,
       0,  1267,     0,     0,     0,     0,     0,  2190,  2191,     0,
       0,     0,  4058,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,  2208,
    2209,  4059,     0,     0,  2210,  2211,  2212,  2213,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  4199,  3018,
    3499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    4200,     0,  1268,     0,  3027,     0,     0,     0,     0,  1268,
      43,    22,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,  1268,  1268,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,   599,     0,  4201,     0,   123,     0,
       0,     0,     0,  1268,     0,   143,   144,   145,   146,   147,
     148,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,  1267,  3018,     0,     0,     0,     0,     0,     0,     0,
    1268,  1268,  1268,  1268,     0,    22,  1268,  1268,  4202,     0,
       0,     0,  4101,  1268,     0,  4104,     0,  1105,     0,     0,
    4107,     0,     0,  3857,  3858,  3859,  3860,     0,     0,  3861,
    3862,  3863,  3864,  3865,  3866,  3867,  3868,  3869,  3870,  3871,
    3872,  3873,  3874,  3875,  3876,  3877,  3878,  3879,  3880,  3881,
    3882,     0,  3884,  3885,  3886,  3887,  3888,  3889,  3890,  3891,
    3892,  3893,  3894,     0,     0,  4002,     0,     0,     0,     0,
      78,    79,    80,    81,    82,  4203,     0,     0,     0,    43,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
       0,  3018,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,  1268,  1268,     0,
       0,     0,     0,  1268,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1268,  1268,     0,     0,     0,     0,     0,     0,   599,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
       0,  3018,     0,     0,     0,     0,     0,     0,     0,     0,
    4138,     0,     0,    43,     0,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,     0,  3018,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,  2214,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,  3027,  4204,  3027,   123,     0,    78,
      79,    80,    81,    82,   599,     0,  1282,  1283,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,
       0,  1284,     0,     0,  1268,     0,     0,     0,     0,   613,
       0,     0,  1285,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1267,  1267,    22,     0,     0,     0,  3961,
    1286,     0,  1267,  3964,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3027,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1267,  1267,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,  4205,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,     0,  1267,     0,  1267,     0,     0,     0,    43,     0,
       0,  1287,     0,  1268,     0,     0,     0,   615,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
    1268,     0,     0,  1156,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,   599,     0,     0,     0,     0,
    1267,     0,     0,  4018,     0,     0,     0,     0,     0,  3027,
       0,     0,     0,     0,     0,     0,     0,  4206,     0,  1288,
       0,     0,     0,  1289,     0,   617,     0,  1290,     0,     0,
       0,     0,     0,    43,     0,  1267,    22,     0,     0,     0,
       0,     0,  4306,  4307,   600,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,     0,     0,  4332,  4333,     0,     0,  4207,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
       0,  4335,  4208,  4336,     0,     0,  4065,   960,     0,  4450,
    3027,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,  4209,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3027,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  4092,     0,     0,     0,     0,
       0,     0,  3027,     0,     0,     0,     0,     0,     0,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  4379,
    3018,     0,     0,     0,     0,  4210,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,  1267,
       0,     0,     0,     0,    43,     0,  1267,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,  2636,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1267,  1267,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
      22,     0,     0,     0,     0,   123,     0,     0,     0,     0,
    1267,     0,     0,     0,     0,     0,  4211,     0,     0,     0,
       0,  3027,     0,     0,     0,     0,   599,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1267,  1267,  1267,
    1267,     0,     0,  1267,  1267,     0,     0,   681,     0,     0,
    1267,     0,     0,     0,     0,  3027,  3027,     0,     0,     0,
       0,     0,     0,     0,  3027,     0,  4588,    22,  3027,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,  3027,     0,     0,     0,     0,
     123,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,  1337,     0,     0,     0,     0,     0,  4507,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,  1267,  1267,     0,  4529,  4530,     0,
    1267,     0,     0,     0,     0,     0,     0,     0,    43,     0,
    3027,     0,     0,     0,     0,     0,     0,     0,  1267,  1267,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  4552,
       0,     0,     0,     0,     0,     0,     0,     0,  1291,  1292,
    1293,  1294,  1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,
       0,     0,     0,     0,     0,     0,  4564,  4565,  4566,  4567,
       0,     0,  4569,  4570,     0,     0,     0,     0,     0,  3027,
       0,  3027,   936,     0,     0,    43,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,  4212,     0,     0,     0,
       0,   123,     0,     0,     0,  3027,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,
       0,  1267,     0,  3027,  3027,  3027,     0,     0,     0,  4225,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,  4647,  4648,     0,     0,   988,     0,  3027,
    3027,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,     0,  3018,     0,     0,     0,     0,  4663,  4664,     0,
       0,     0,     0,     0,     0,     0,     0,  3027,     0,     0,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,  3027,  3018,     0,     0,     0,  4282,  3027,     0,     0,
       0,     0,  4287,     0,     0,    78,    79,    80,    81,    82,
    1267,     0,  4293,     0,  3027,  3027,  3027,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3027,  3027,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,  1267,     0,     0,
    4329,     0,     0,     0,     0,  3027,     0,  3027,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
    4345,     0,     0,     0,     0,     0,     0,     0,  1217,  3027,
       0,  3027,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,     0,  3018,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,   510,   123,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,     0,  3018,     1,     2,     3,     0,  4811,
       0,  4395,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,     0,  2567,     0,     0,     0,  4419,     0,     0,
       0,     4,     5,     6,     7,     8,     0,     0,     0,     9,
       0,     0,     0,     0,     0,     0,  4833,    10,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,    11,    12,
      13,  4443,  4444,  4213,    14,     0,    15,    16,    17,    18,
      19,     0,     0,     0,     0,  4214,     0,     0,     0,     0,
       0,    20,    21,     0,    22,  4445,     0,  4446,     0,     0,
       0,    23,     0,     0,     0,     0,     0,    24,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,
       0,     0,     0,    25,    26,    27,    28,     0,  4215,   143,
     144,   145,   146,   147,   148,     0,    29,     0,    30,    31,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
       0,  2567,     0,    32,  4482,  4483,  2636,  4485,  4216,     0,
       0,     0,     0,     0,     0,  4492,     0,     0,     0,     0,
       0,     0,    33,  4497,     0,     0,     0,     0,     0,     0,
       0,    34,     0,    35,     0,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,  4518,     0,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,  3314,
    3018,     0,    36,    37,    38,    39,  4532,  4533,    40,  1218,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
      41,  2567,     0,     0,     0,  4217,     0,     0,     0,  4550,
       0,     0,     0,     0,    42,     0,     0,     0,     0,     0,
       0,     0,    43,     0,     0,     0,     0,    44,     0,     0,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
       0,  2567,     0,     0,     0,     0,     0,     0,    45,    46,
       0,    47,     0,    48,    49,     0,     0,     0,     0,  4218,
       0,     0,    50,     0,     0,     0,     0,    51,    52,     0,
       0,  4219,    53,    54,     0,     0,    55,    56,  3008,  3009,
    3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,
       0,  4617,     0,     0,     0,     0,     0,     0,     0,  4619,
       0,     0,    57,    58,     0,     0,    59,    60,    61,    62,
    4220,    63,     0,     0,     0,     0,    64,     0,     0,    65,
       0,     0,     0,     0,    66,    67,     0,     0,    68,  4305,
       0,     0,    69,    70,    71,     0,     0,    72,     0,    73,
      74,    75,    76,    77,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,    83,     0,
       0,     0,     0,     0,     0,    84,    85,    86,     0,    87,
      88,    89,     0,    90,    91,    92,    93,    94,    95,    96,
       0,     0,     0,  4690,     0,    97,    98,     0,     0,     0,
       0,    99,     0,     0,     0,  4368,     0,     0,     0,     0,
       0,  4705,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,     0,  2567,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,     0,  2567,     0,  4370,     0,     0,
       0,   100,   101,     0,     0,     0,     0,     0,     0,  4716,
    4717,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,
    2566,     0,  2567,     0,     0,     0,     0,     0,     0,  4731,
       0,     0,     0,     0,     0,     0,   102,  4736,     0,     0,
       0,   103,  4389,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  3360,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,  4523,     0,   123,
       0,  2983,  2984,     0,     0,     0,  4772,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,     0,
       0,     0,  4785,     0,     0,     0,     0,     0,     0,     0,
       0,   124,   125,     0,     0,   126,   127,  4524,   128,   129,
     130,   131,   132,   133,     0,     0,     1,     2,     3,     0,
       0,   134,     0,     0,     0,     0,   135,   136,   137,     0,
       0,     0,     0,     0,   138,     0,     0,     0,     0,     0,
       0,     0,     4,     5,     6,     7,     8,     0,     0,     0,
       9,     0,     0,     0,  3892,  4613,   139,   140,    10,     0,
       0,     0,     0,     0,     0,     0,  4837,     0,     0,    11,
      12,    13,     0,     0,     0,    14,     0,    15,    16,    17,
      18,    19,     0,     0,     0,     0,     0,     0,     0,   141,
     142,     0,    20,    21,     0,    22,   143,   144,   145,   146,
     147,   148,    23,     0,     0,   149,     0,     0,    24,     0,
       0,     0,     0,     0,  4690,     0,     0,     0,     0,     0,
       0,  4614,     0,     0,    25,    26,    27,    28,     0,     0,
       0,     0,     0,  4665,     0,     0,     0,    29,     0,    30,
      31,     0,     0,     0,     0,     0,   150,     0,   151,   152,
     153,   154,   155,     0,    32,     0,   156,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,     0,
    4892,     0,     0,    33,     0,     0,  1220,     0,   157,   158,
       0,     0,    34,   159,    35,   160,  3008,  3009,  3010,  3011,
    3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,     0,  4683,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  4751,     0,    36,    37,    38,    39,    22,     0,    40,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,    41,  3018,     0,     0,     0,     0,     0,  4752,     0,
       0,     0,     0,     0,     0,    42,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,     0,     0,    44,     0,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,     0,  3018,     0,     0,     0,     0,     0,     0,    45,
      46,     0,    47,     0,    48,    49,     0,     0,     0,     0,
       0,     0,     0,    50,     0,     0,     0,     0,    51,    52,
       0,     0,  3357,    53,    54,     0,     0,    55,    56,     0,
       0,     0,     0,     0,  4781,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,     0,     0,     0,
       0,     0,     0,    57,    58,     0,     0,    59,    60,    61,
      62,     0,    63,    22,  1227,     0,     0,    64,     0,     0,
      65,     0,     0,     0,     0,    66,    67,     0,     0,    68,
       0,     0,     0,    69,    70,    71,     0,     0,    72,     0,
      73,    74,    75,    76,    77,    43,     0,     0,     0,     0,
       0,     0,   599,     0,     0,     0,  2184,     0,     0,     0,
       0,     0,     0,     0,  1228,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,    83,
       0,     0,     0,     0,     0,     0,    84,    85,    86,     0,
      87,    88,    89,    22,    90,    91,    92,    93,    94,    95,
      96,     0,     0,     0,     0,  2185,    97,    98,     0,     0,
       0,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2187,  2188,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   599,     0,     0,
       0,     0,   100,   101,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,  4793,  3018,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,  2189,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   102,    22,     0,
       0,     0,   103,  4794,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   599,     0,     0,     0,  4839,     0,
     123,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,     0,  3018,     0,     0,     0,     0,     0,     0,     0,
     599,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   124,   125,     0,    22,   126,   127,  4867,   128,
     129,   130,   131,   132,   133,     0,     0,     0,     0,     0,
       0,     0,   134,     0,     0,     0,     0,   135,   136,   137,
       0,    22,     0,     0,     0,   138,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   599,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   139,   140,  3525,
       0,    78,    79,    80,    81,    82,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,    22,     0,     0,
     141,   142,   123,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,   149,  2190,  2191,     0,
       0,     0,     0,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,  2208,
    2209,     0,     0,     0,  2210,  2211,  2212,  2213,     0,     0,
       0,    78,    79,    80,    81,    82,     0,   150,     0,   151,
     152,   153,   154,   155,     0,     0,     0,   156,     0,     0,
       0,     0,     0,    43,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,     0,     0,     0,   157,
     158,     0,     0,     0,   159,     0,   160,     0,     0,    43,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   599,     0,     0,     0,     0,     0,   123,   143,
     144,   145,   146,   147,   148,     0,     0,     0,  3934,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   599,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   599,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,  3935,    22,     0,     0,  1221,
       0,     0,     0,    78,    79,    80,    81,    82,   599,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,     0,     0,    22,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
    1220,     0,     0,   123,     0,    78,    79,    80,    81,    82,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,    43,  3018,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,    22,     0,     0,     0,     0,     0,  2214,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,     0,     0,     0,     0,     0,
     123,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,    43,     0,     0,     0,     0,   123,     0,  3936,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,     0,     0,  1220,     0,  1271,     0,    43,     0,     0,
     143,   144,   145,   146,   147,   148,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,     0,    22,     0,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,  1220,     0,     0,     0,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
       0,  2567,     0,     0,     0,     0,     0,     0,     0,    43,
       0,     0,     0,   599,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,    22,     0,     0,
    1342,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,   599,    22,     0,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,  -845,     0,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,     0,  3018,    78,    79,    80,
      81,    82,     0,     0,    22,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,  1382,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    43,  1418,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3965,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    43,     0,     0,     0,  1437,
       0,   123,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    43,     0,     0,     0,     0,     0,   123,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,    43,  3982,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,  1612,   123,     0,   143,   144,
     145,   146,   147,   148,  3991,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,   599,  1451,    22,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,     0,
       0,     0,   599,     0,     0,    22,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,  1460,  4017,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    22,     0,  1547,     0,     0,     0,   123,
       0,     0,     0,   143,   144,   145,   146,   147,   148,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,  1548,     0,     0,     0,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   599,    43,     0,     0,     0,     0,   123,
    2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,
       0,  2567,     0,  1553,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,    22,     0,     0,     0,   599,   123,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,     0,  3018,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,    22,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
       0,  3018,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,     0,  3018,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,  1555,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,  1556,
       0,  4098,    43,     0,     0,     0,     0,  2698,     0,     0,
       0,     0,     0,     0,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,  1561,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    43,    22,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,     0,     0,     0,  2701,     0,  1611,     0,     0,     0,
       0,     0,     0,  4284,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,    22,   599,     0,     0,     0,
       0,   123,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,     0,  2567,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,  4310,     0,     0,    22,     0,     0,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   599,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,  4330,    78,    79,    80,
      81,    82,     0,     0,     0,     0,    43,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,     0,
       0,     0,     0,    22,  4344,   599,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,  4366,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
       0,  3018,     0,    43,     0,   599,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,    43,    22,     0,   599,   123,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,  1613,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  4484,    22,
       0,     0,     0,     0,   123,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,  1866,     0,  3008,
    3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,
    3018,    43,     0,  4487,   599,     0,     0,     0,     0,     0,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,     0,  3018,     0,     0,  2143,     0,     0,  4494,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,    43,    22,   599,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,  4506,     0,     0,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,    43,     0,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,   599,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,     0,     0,
       0,     0,     0,   123,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,  2151,     0,    22,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,  4521,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,  2167,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,  4534,   599,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,    43,    22,  3008,  3009,  3010,
    3011,  3012,  3013,  3014,  3015,  3016,  3017,     0,  3018,     0,
     143,   144,   145,   146,   147,   148,  4083,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,  4083,    43,    22,   123,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,  4563,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,  4582,    22,     0,     0,     0,
    2699,   123,     0,    78,    79,    80,    81,    82,     0,   143,
     144,   145,   146,   147,   148,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,    43,     0,     0,  2702,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   599,     0,
       0,     0,     0,     0,   123,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,  3920,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,   599,    43,     0,     0,  4636,    22,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,    22,     0,     0,     0,   599,
     123,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,  3921,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
      22,     0,   123,     0,    78,    79,    80,    81,    82,     0,
       0,   143,   144,   145,   146,   147,   148,     0,  3931,     0,
       0,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,
    3017,  4637,  3018,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,  3932,     0,
       0,     0,     0,   123,     0,    78,    79,    80,    81,    82,
       0,     0,     0,   599,     0,     0,     0,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,  3933,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,    22,     0,     0,     0,     0,     0,
       0,   599,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,    43,     0,
       0,   123,    22,  2557,  2558,  2559,  2560,  2561,  2562,  2563,
    2564,  2565,  2566,     0,  2567,     0,     0,  3954,     0,     0,
    1220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,  3969,
       0,    22,   123,     0,     0,     0,     0,    78,    79,    80,
      81,    82,   599,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,    43,    22,     0,     0,     0,     0,     0,     0,
    4019,   599,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
      43,     0,    22,  3008,  3009,  3010,  3011,  3012,  3013,  3014,
    3015,  3016,  3017,     0,  3018,     0,     0,     0,     0,  1220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  4642,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,  4082,    43,
      22,     0,     0,     0,   123,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,  4084,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,  4086,     0,
      43,     0,     0,     0,     0,  3008,  3009,  3010,  3011,  3012,
    3013,  3014,  3015,  3016,  3017,     0,  3018,  4649,     0,   599,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,  1220,     0,     0,     0,    43,     0,
      22,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,    22,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  1220,     0,
       0,  4093,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,  4659,     0,
      78,    79,    80,    81,    82,     0,     0,  4094,     0,    22,
       0,     0,     0,     0,  3008,  3009,  3010,  3011,  3012,  3013,
    3014,  3015,  3016,  3017,     0,  3018,     0,  4666,  1612,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,  4096,     0,     0,     0,   123,     0,    78,    79,
      80,    81,    82,  1220,     0,     0,     0,     0,    43,    22,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    43,    22,     0,     0,     0,   123,  2557,
    2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,
    2567,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,     0,     0,     0,     0,  4099,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,  4667,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,  4100,   123,     0,     0,    78,    79,
      80,    81,    82,  1220,     0,     0,     0,    43,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,    43,     0,    22,     0,     0,     0,     0,     0,
       0,  1612,     0,  4103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,
    2566,     0,  2567,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,  4110,     0,     0,     0,  1220,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  4681,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
      22,     0,     0,     0,  4139,   123,     0,    78,    79,    80,
      81,    82,   599,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,    43,    22,     0,     0,     0,     0,     0,     0,
     599,     0,  4522,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4696,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
      43,    22,     0,     0,   123,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,   945,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    43,     0,
       0,     0,    22,     0,   123,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4531,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,     0,
      78,    79,    80,    81,    82,  4697,     0,  4554,     0,    43,
       0,     0,     0,     0,  2557,  2558,  2559,  2560,  2561,  2562,
    2563,  2564,  2565,  2566,     0,  2567,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
      43,  4555,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,     0,     0,
       0,  4646,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,     0,    78,
      79,    80,    81,    82,     0,     0,  4682,     0,     0,     0,
       0,   946,     0,     0,     0,     0,  2557,  2558,  2559,  2560,
    2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,     0,  4698,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,   123,     0,
    3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,  3016,  3017,
       0,  3018,     0,     0,   143,   144,   145,   146,   147,   148,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,  4699,     0,     0,     0,     0,  4684,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,     0,  2567,     0,
       0,     0,   143,   144,   145,   146,   147,   148,  4700,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,  4686,   691,   692,   123,   693,   694,
       0,   695,     0,     0,     0,   696,     0,     0,     0,   697,
       0,   698,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,   699,
       0,     0,     0,     0,     0,     0,     0,   700,   526,     0,
       0,     0,     0,     0,     0,   701,   702,   703,     0,   527,
       0,     0,  4825,   704,   705,   706,   707,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
    4701,     0,   708,     0,     0,   709,   565,   566,   710,     0,
       0,     0,     0,     0,   711,  2557,  2558,  2559,  2560,  2561,
    2562,  2563,  2564,  2565,  2566,     0,  2567,     0,   557,     0,
       0,     0,     0,     0,     0,  4862,     0,     0,     0,     0,
     712,   713,   714,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
    4741,     0,     0,     0,     0,     0,     0,   715,     0,     0,
       0,   716,   717,   718,     0,   719,   567,   720,   568,     0,
       0,     0,     0,  4883,     0,     0,     0,   721,     0,     0,
       0,   722,   723,     0,   569,   724,   725,     0,     0,   726,
     727,     0,     0,     0,     0,     0,     0,     0,     0,   728,
     729,   730,   731,   732,   733,   734,   735,   736,   737,   738,
     739,   740,   741,   742,   743,     0,     0,   744,   745,   746,
     747,   748,   749,     0,     0,     0,     0,     0,     0,     0,
       0,   750,   751,   570,   752,   753,   754,   755,   756,   757,
     758,     0,   759,   760,  4804,     0,   761,   762,     0,     0,
       0,   763,     0,     0,     0,     0,   764,   765,   766,     0,
       0,     0,   767,     0,   768,     0,     0,   769,     0,     0,
       0,   529,   530,   770,     0,   771,     0,     0,   772,   773,
     774,     0,     0,     0,     0,     0,     0,   775,   776,     0,
       0,   777,     0,   778,     0,     0,     0,     0,     0,     0,
       0,  4851,     0,     0,     0,   779,     0,     0,     0,     0,
     780,   531,   532,     0,     0,   781,     0,     0,     0,     0,
       0,   782,     0,     0,     0,     0,     0,     0,     0,   783,
       0,     0,   616,   784,   785,     0,     0,     0,     0,     0,
     786,     0,   691,   692,  1016,   693,     0,     0,     0,     0,
       0,     0,   696,     0,     0,     0,   787,  1143,   698,     0,
       0,   617,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   788,  1467,  1468,  1469,  1470,  1471,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,  1481,  1482,  1483,
    1484,  1485,  1486,  1487,  1488,  1489,  1490,  1491,  1492,  1493,
     704,   705,   706,   707,     0,  1144,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   789,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1145,  4864,
       0,   533,   534,     0,     0,     0,  1146,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   712,   713,   714,
       0,     0,     0,     0,     0,     0,     0,     0,  1147,  1148,
    1149,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   716,   717,
     718,     0,     0,     0,     0,     0,     0,     0,     0,  1150,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1151,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   751,
       0,   790,     0,     0,     0,     0,   691,     0,     0,   693,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     697,  1143,     0,     0,     0,     0,     0,    22,     0,     0,
     572,   573,   574,   575,   576,     0,     0,     0,     0,   791,
     770,  1152,     0,  1153,     0,   772,     0,     0,  1154,  1155,
     615,     0,     0,     0,   775,   776,     0,     0,   777,     0,
     778,     0,     0,     0,   704,   705,   706,   707,     0,  1144,
       0,     0,   779,   638,     0,     0,     0,     0,     0,     0,
     792,   793,     0,     0,     0,     0,  1156,   691,     0,     0,
     693,     0,     0,     0,     0,  1157,     0,     0,  1158,   616,
       0,     0,  1143,   691,     0,     0,   693,   786,   639,  1159,
    1146,     0,     0,     0,     0,     0,     0,     0,  1143,     0,
       0,   712,   713,   714,   794,   577,     0,     0,   617,     0,
       0,     0,  1147,  1148,  1149,     0,     0,  1407,     0,   788,
       0,     0,     0,     0,     0,   704,   705,   706,   707,     0,
    1144,     0,   716,   717,   718,     0,     0,     0,     0,     0,
     795,   704,   705,   706,   707,     0,  1144,     0,   796,   797,
     798,   799,   800,   801,     0,   569,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    43,     0,     0,     0,     0,
       0,  1146,  1438,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   712,   713,   714,     0,     0,  1146,  1438,     0,
       0,     0,     0,  1147,  1148,  1149,     0,     0,   712,   713,
     714,     0,     0,   751,     0,     0,     0,     0,     0,  1147,
    1148,  1149,    22,   716,   717,   718,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   716,
     717,   718,  2144,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   770,  1152,     0,  1153,     0,   772,
    1453,     0,  1154,  1155,   615,     0,     0,     0,   775,   776,
       0,     0,     0,     0,   778,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   779,   638,     0,     0,
       0,     0,     0,     0,   751,     0,     0,     0,     0,     0,
    1156,     0,     0,     0,     0,     0,     0,     0,     0,  1157,
     751,     0,  1158,   616,     0,     0,     0,     0,   790,     0,
       0,   786,   639,  1159,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,   770,  1152,     0,  1153,     0,
     772,     0,   617,  1154,  1155,   615,     0,     0,     0,   775,
     776,   770,  1152,   788,  1153,   778,   772,     0,     0,  1154,
    1155,   615,     0,     0,     0,   775,   776,   779,   638,     0,
       0,   778,     0,     0,     0,     0,     0,     0,     0,     0,
      43,  1156,     0,   779,   638,     0,     0,     0,     0,     0,
    1157,     0,     0,  1158,   616,     0,     0,  1156,     0,     0,
       0,     0,   786,   639,  1159,     0,  1157,     0,     0,  1158,
     616,     0,     0,     0,     0,     0,     0,     0,   786,   639,
    1159,     0,     0,   617,     0,  1408,     0,     0,     0,     0,
       0,     0,     0,     0,   788,     0,     0,     0,  1439,   617,
       0,  1454,     0,     0,     0,     0,     0,  3821,     0,     0,
     788,     0,     0,     0,  1439,     0,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,     0,     0,   796,   797,   798,   799,   800,
     801,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1409,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,   790,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   691,     0,     0,
       0,   694,     0,     0,  3317,     0,     0,   696,     0,     0,
       0,     0,     0,   698,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,  1227,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,   790,     0,     0,     0,     0,     0,     0,
       0,   527,     0,     0,     0,   704,   705,   706,   707,   790,
    1144,     0,     0,     0,     0,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1228,   709,     0,     0,
     528,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  1146,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,   712,   713,     0,     0,     0,  1229,     0,     0,
       0,     0,     0,  2145,     0,     0,     0,     0,     0,   796,
     797,   798,   799,   800,   801,  1230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,  1232,     0,
       0,  1017,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   722,   723,     0,     0,   724,   725,     0,
    2034,   726,   727,     0,     0,     0,     0,     0,     0,     0,
       0,   728,   729,    43,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,     0,     0,   744,
     745,   746,   747,   748,   749,     0,     0,     0,     0,     0,
     796,   797,   798,   799,   800,   801,   752,   753,   754,   755,
     756,   757,   758,    43,     0,     0,   796,   797,   798,   799,
     800,   801,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,   768,     0,     0,     0,
       0,     0,     0,   529,     0,   770,     0,   771,     0,     0,
     772,     0,     0,     0,     0,   615,     0,     0,     0,     0,
       0,     0,     0,   777,     0,   778,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   780,   531,     0,     0,     0,   781,     0,     0,
       0,     0,     0,   782,     0,     0,     0,     0,     0,     0,
    1157,     0,     0,  1158,   616,     0,     0,     0,     0,     0,
       0,     0,   786,   639,     0,     0,     0,     0,  3822,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1233,   788,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1234,     0,    78,    79,    80,    81,    82,     0,  1235,
    1236,     0,     0,     0,     0,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,     0,  1257,  1258,  1259,  1260,
    1261,  1262,     0,  4510,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   533,   534,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,  1227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,  1228,     0,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,  1229,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    22,     0,   790,  1230,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1231,  1232,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  4574,     0,     0,     0,     0,     0,     0,     0,
       0,   791,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    43,    22,  1227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1263,   143,   144,   145,
     146,   147,   148,   793,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1228,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1229,     0,     0,     0,  2035,
    2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,  2044,    43,
    2045,  2046,   795,  1230,  2047,  1264,  2048,  2049,  2050,  1265,
       0,  2449,     0,  2450,     0,  1231,  1232,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
    3381,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1233,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1234,     0,    43,     0,     0,     0,     0,     0,  1235,  1236,
       0,     0,     0,     0,  1237,  1238,  1239,  1240,  1241,  1242,
    1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,
    1253,  1254,  1255,  1256,     0,  1257,  1258,  1259,  1260,  1261,
    1262,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,  1234,
       0,     0,     0,     0,     0,     0,     0,  1235,  1236,     0,
       0,     0,     0,  1237,  1238,  1239,  1240,  1241,  1242,  1243,
    1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,
    1254,  1255,  1256,     0,  1257,  1258,  1259,  1260,  1261,  1262,
    4742,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,    22,  1227,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1263,   143,   144,   145,   146,
     147,   148,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  1228,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
       0,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,  1230,     0,     0,  1264,     0,     0,     0,  1265,     0,
    2449,     0,  2450,  1231,  1232,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,  3312,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    43,
      22,  1227,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1263,   143,   144,   145,   146,   147,
     148,    22,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1228,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,  2169,   302,     0,   303,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1229,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    43,    22,     0,     0,
    1230,     0,     0,  1264,     0,     0,     0,  1265,     0,  2449,
       0,  2450,  1231,  1232,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   312,     0,   313,    78,
      79,    80,    81,    82,     0,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1233,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1234,     0,    43,
       0,     0,     0,     0,     0,  1235,  1236,     0,     0,     0,
       0,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,
    1246,  1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,
    1256,     0,  1257,  1258,  1259,  1260,  1261,  1262,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1233,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,  1234,     0,     0,     0,
       0,     0,     0,     0,  1235,  1236,     0,     0,     0,     0,
    1237,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
       0,  1257,  1258,  1259,  1260,  1261,  1262,  3526,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,    22,  1227,
       0,     0,     0,   123,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1263,   143,   144,   145,   146,   147,   148,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  1228,
       0,     0,     0,     0,     0,   123,     0,     0,     0,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,     0,     0,
    1229,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1230,     0,
       0,  1264,     0,     0,     0,  1265,     0,  2449,    22,  2450,
    1231,  1232,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,    22,  1227,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1263,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1228,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
     320,     0,   321,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1229,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1230,     0,     0,
    1264,     0,     0,     0,  1265,     0,    43,     0,     0,  1231,
    1232,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,   333,     0,   334,    78,    79,    80,    81,
      82,     0,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1233,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   354,  1234,     0,     0,     0,     0,     0,
       0,     0,  1235,  1236,     0,     0,     0,     0,  1237,  1238,
    1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,
    1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,     0,  1257,
    1258,  1259,  1260,  1261,  1262,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1234,     0,     0,     0,     0,     0,     0,
       0,  1235,  1236,     0,     0,     0,     0,  1237,  1238,  1239,
    1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,
    1250,  1251,  1252,  1253,  1254,  1255,  1256,     0,  1257,  1258,
    1259,  1260,  1261,  1262,     0,    22,  1227,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,    22,  1227,
       0,     0,     0,   123,     0,     0,     0,     0,     0,  1263,
     143,   144,   145,   146,   147,   148,  1228,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,  2184,   123,     0,     0,     0,     0,     0,     0,  1228,
       0,     0,     0,     0,     0,     0,     0,  1229,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1230,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1231,  1232,     0,
    2185,     0,     0,     0,     0,     0,     0,     0,  1264,     0,
       0,     0,  1265,     0,     0,     0,     0,     0,  2186,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2187,  2188,     0,    43,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,  2189,     0,     0,     0,     0,     0,  1263,   143,
     144,   145,   146,   147,   148,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,   355,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1264,     0,     0,
       0,  1265,     0,  2449,     0,  2450,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1233,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,  1234,     0,     0,     0,     0,     0,     0,     0,  1235,
    1236,     0,     0,     0,     0,  1237,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,
    1252,  1253,  1254,  1255,  1256,     0,  1257,  1258,  1259,  1260,
    1261,  1262,  4687,  4688,     0,     0,     0,     0,  2192,  2193,
    2194,  2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,
    2204,  2205,  2206,  2207,  2208,  2209,    43,     0,     0,  2210,
    2211,  2212,  2213,    22,  1227,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,  2184,     0,     0,     0,
     123,     0,     0,     0,  1228,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2185,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
    1227,     0,     0,  2186,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2187,  2188,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  4689,     0,     0,    78,    79,    80,    81,
      82,     0,  2184,     0,     0,     0,     0,     0,     0,     0,
    1228,    43,     0,     0,     0,     0,     0,  2189,     0,     0,
       0,     0,     0,     0,     0,     0,  1263,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2185,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,  2186,
       0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
       0,  2187,  2188,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1264,     0,    43,     0,  1265,
       0,     0,     0,  2189,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,  2214,   123,     0,     0,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2190,  2191,     0,
       0,     0,     0,  2192,  2193,  2194,  2195,  2196,  2197,  2198,
    2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,  2208,
    2209,    43,     0,     0,  2210,  2211,  2212,  2213,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,  2190,  2191,     0,     0,     0,   123,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,  2207,  2208,  2209,    43,     0,     0,
    2210,  2211,  2212,  2213,    22,  1227,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     371,     0,   372,     0,     0,     0,    22,  1227,  4767,     0,
       0,    78,    79,    80,    81,    82,     0,  2184,     0,     0,
       0,     0,     0,     0,     0,  1228,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,  2184,
       0,     0,     0,     0,   123,     0,     0,  1228,     0,     0,
       0,     0,     0,     0,     0,     0,  2185,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,    22,  2186,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2187,  2188,  2185,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  4768,     0,  2186,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,  2187,  2188,
       0,     0,    43,     0,     0,     0,     0,     0,  2189,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,    43,    22,     0,  2214,   123,     0,
    2189,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,  2214,   123,    22,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,     0,     0,     0,     0,  2190,  2191,
       0,     0,     0,     0,  2192,  2193,  2194,  2195,  2196,  2197,
    2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,  2206,  2207,
    2208,  2209,    43,    22,     0,  2210,  2211,  2212,  2213,     0,
    2190,  2191,     0,     0,     0,     0,  2192,  2193,  2194,  2195,
    2196,  2197,  2198,  2199,  2200,  2201,  2202,  2203,  2204,  2205,
    2206,  2207,  2208,  2209,     0,    22,  4129,  2210,  2211,  2212,
    2213,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,     0,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,    22,     0,     0,     0,
       0,   123,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   395,     0,   396,     0,     0,     0,     0,     0,  4829,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    43,    22,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,    22,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,     0,     0,     0,     0,     0,
     123,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,    22,     0,     0,     0,  2214,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2214,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,    22,     0,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,   407,     0,   408,    22,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    43,     0,     0,     0,     0,     0,   123,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,    22,     0,   410,     0,   411,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,   415,     0,   416,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,    43,    22,     0,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,    22,     0,   419,     0,   420,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,     0,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   430,    22,   431,     0,     0,
       0,   123,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,   443,     0,   444,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,    43,     0,     0,     0,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,    22,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,    22,     0,   468,     0,
     469,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,     0,     0,     0,    22,     0,
     123,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,   375,    22,
       0,     0,     0,   123,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
     379,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,    22,     0,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,   434,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,    43,     0,     0,
       0,     0,   123,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,    22,     0,     0,   436,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
     495,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,    22,
       0,   123,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,     0,     0,  3064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,    43,    22,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,    22,     0,     0,  3103,
       0,   123,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,  3106,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,     0,    22,
       0,     0,     0,   123,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    22,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,  3108,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,    43,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,     0,     0,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,  3217,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,    43,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,  3259,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
    3373,   123,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,  3481,     0,     0,    78,    79,    80,    81,    82,     0,
     937,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   937,     0,
       0,     0,     0,     0,   123,    22,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2366,     0,     0,     0,     0,  3507,     0,     0,
     937,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,    22,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,  2949,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,    22,     0,     0,     0,     0,
     123,     0,     0,     0,   937,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,  4279,     0,
       0,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,   143,   144,   145,   146,   147,   148,     0,  3514,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,    43,   123,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,   945,
       0,    43,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,  3523,     0,  2373,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    43,     0,   938,     0,     0,   143,   144,
     145,   146,   147,   148,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   950,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,   938,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2378,     0,    43,     0,     0,
       0,   143,   144,   145,   146,   147,   148,  3531,     0,     0,
       0,     0,   939,   950,     0,   938,    22,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
     143,   144,   145,   146,   147,   148,     0,  3966,  3559,     0,
       0,     0,     0,     0,   939,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,    78,    79,    80,    81,    82,     0,     0,   950,   938,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  3592,  4286,    78,    79,    80,    81,    82,   939,  2514,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    43,    22,     0,     0,     0,     0,     0,     0,
    3723,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   950,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,    43,     0,     0,     0,    22,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,   946,     0,     0,    43,     0,   123,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,     0,     0,     0,   951,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    43,     0,
       0,     0,     0,     0,   123,     0,     0,   143,   144,   145,
     146,   147,   148,     0,  2176,     0,     0,   951,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,     0,    43,     0,     0,     0,
    2180,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,   951,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,    22,     0,     0,  2177,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,  2181,     0,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,   951,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,    43,     0,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,  2794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    43,     0,     0,   143,   144,   145,   146,
     147,   148,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    22,     0,     0,     0,     0,     0,   123,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
       0,     0,     0,     0,     0,   123,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,  2623,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     599,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      43,    22,   143,   144,   145,   146,   147,   148,     0,     0,
     692,  1016,   693,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,   700,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   527,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,    43,     0,
       0,     0,   528,     0,   123,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,     0,     0,     0,   712,   713,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1636,     0,  4680,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,  1383,     0,     0,     0,    43,
     567,     0,     0,     0,    22,     0,     0,     0,     0,     0,
       0,   721,     0,     0,  1018,     0,     0,     0,   569,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2286,     0,
       0,     0,     0,   728,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    22,
       0,     0,     0,     0,  2388,     0,   749,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,   570,     0,     0,
       0,     0,     0,     0,     0,    22,     0,     0,    78,    79,
      80,    81,    82,  2401,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,   529,     0,   770,     0,     0,
       0,     0,   772,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,  2413,     0,     0,   531,   532,   123,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,     0,     0,
       0,     0,    43,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    43,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  1383,
       0,     0,     0,    43,     0,   123,     0,     0,     0,     0,
       0,     0,  2435,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1022,     0,     0,     0,     0,
       0,     0,    43,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,  2440,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,    22,     0,     0,     0,     0,     0,  1637,  1638,
    1639,  1640,  1024,  1641,  1642,  1643,  1644,  1645,  1646,  1647,
    1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,  1657,
    1658,  1659,  1660,  1661,  1662,  1663,  2477,    78,    79,    80,
      81,    82,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2480,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
      43,     0,     0,     0,     0,     0,  1664,  1665,  1666,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,    43,     0,     0,     0,     0,
     123,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,  2489,     0,     0,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
      43,     0,     0,     0,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,  2492,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    22,     0,     0,     0,     0,   123,  2493,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,  2792,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,  2958,     0,     0,     0,     0,     0,   123,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,    43,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    43,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,     0,
       0,     0,     0,     0,     0,     0,  3980,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,    43,    22,     0,     0,
       0,     0,   123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,  4262,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,    43,    22,     0,     0,     0,     0,  4292,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,     0,     0,   143,
     144,   145,   146,   147,   148,  4295,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,    43,    22,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,     0,     0,     0,     0,     0,   123,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
      43,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,    43,     0,   123,  4296,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,     0,
      22,     0,     0,     0,     0,   123,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  4304,     0,     0,
       0,     0,     0,   123,     0,    78,    79,    80,    81,    82,
       0,     0,     0,     0,    43,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,  4422,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,    22,     0,     0,     0,     0,   123,  4628,
      78,    79,    80,    81,    82,   143,   144,   145,   146,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,    78,    79,    80,    81,
      82,     0,   143,   144,   145,   146,   147,   148,  4685,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    43,    22,
     143,   144,   145,   146,   147,   148,     0,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,     0,     0,     0,     0,
       0,     0,   123,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,     0,     0,     0,    43,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,    43,     0,     0,     0,     0,     0,   123,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,    43,     0,
       0,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   527,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,     0,    43,     0,   143,
     144,   145,   146,   147,   148,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,   557,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,    43,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,   354,     0,     0,     0,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,  2219,
    2220,     0,     0,     0,     0,   123,     0,    78,    79,    80,
      81,    82,  3289,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,     0,     0,     0,
       0,     0,     0,   123,     0,     0,    78,    79,    80,    81,
      82,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,    43,     0,     0,     0,     0,     0,   123,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,    43,
       0,     0,     0,     0,     0,   123,    22,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,     0,     0,
       0,     0,     0,     0,   123,     0,     0,     0,     0,    22,
       0,     0,     0,     0,     0,     0,     0,  3363,     0,     0,
     143,   144,   145,   146,   147,   148,   354,     0,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,  3176,  3177,  3178,
      22,     0,     0,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,     0,     0,  3970,  3971,    22,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,  4468,  4469,     0,     0,     0,
       0,     0,     0,     0,    43,    22,     0,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,  1739,  1740,  1741,
    1742,  1743,  1744,  1745,  1746,  1747,     0,     0,     0,  1748,
    1749,  1750,  1751,  1752,  1753,  1754,  1755,  1756,     0,     0,
    1757,  1758,  1759,  1760,  1761,  1762,  1763,    43,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
     143,   144,   145,   146,   147,   148,  1764,  1765,  1766,  1767,
    1768,   354,     0,  1769,  1770,  1771,  1772,  1773,  1774,  1775,
    1776,  1777,  1778,  1779,  1780,     0,     0,     0,    43,     0,
    1781,  1782,  1783,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,  2221,     0,    43,     0,     0,     0,     0,   123,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
       0,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,     0,  1784,    43,    22,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   354,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    78,    79,    80,
      81,    82,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    43,     0,     0,  3166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1383,    22,     0,     0,     0,     0,     0,     0,    78,    79,
      80,    81,    82,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,    78,    79,    80,    81,    82,     0,
       0,     0,     0,   143,   144,   145,   146,   147,   148,  3042,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,  3972,     0,     0,
       0,     0,     0,     0,   123,     0,    22,     0,     0,     0,
       0,     0,    78,    79,    80,    81,    82,     0,     0,     0,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,  4470,    43,
       0,     0,     0,     0,     0,   123,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
      43,   123,  3855,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,    22,     0,     0,     0,     0,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,   143,   144,   145,   146,   147,   148,  3786,     0,  4611,
       0,     0,     0,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,     0,    43,     0,     0,     0,     0,   123,
       0,     0,   143,   144,   145,   146,   147,   148,     0,     0,
       0,  4790,    22,     0,     0,     0,     0,     0,     0,    78,
      79,    80,    81,    82,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,    43,    22,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,    43,    22,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    78,    79,    80,    81,    82,     0,
       0,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      43,     0,     0,     0,     0,     0,   123,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,     0,     0,     0,     0,     0,     0,   123,     0,     0,
       0,    78,    79,    80,    81,    82,     0,     0,     0,     0,
      43,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,    79,    80,    81,    82,     0,     0,
       0,     0,    43,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,     0,     0,     0,     0,     0,
       0,   123,     0,   143,   144,   145,   146,   147,   148,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,     0,     0,     0,     0,     0,     0,   123,     0,
      78,    79,    80,    81,    82,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,     0,     0,     0,     0,     0,     0,
     123,     0,    78,    79,    80,    81,    82,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   143,   144,
     145,   146,   147,   148,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
    3851,     0,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   143,   144,   145,   146,   147,
     148,     0,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
    4608,     0,     0,     0,     0,     0,     0,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   143,   144,   145,
     146,   147,   148,     0,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,  4787,     0,     0,     0,     0,     0,     0,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   143,   144,   145,   146,   147,   148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   143,   144,   145,   146,
     147,   148
  };

  const short
  parser::yycheck_[] =
  {
       0,   469,   686,  1384,     4,    84,    85,    86,   497,   498,
      10,   940,   361,   952,   482,    15,   990,  1012,  1074,   330,
    1079,  1131,  1355,  1735,    24,  1346,   309,   321,   303,   321,
     308,   343,   321,   372,   321,   308,   494,    37,   372,   321,
     316,   317,   391,   321,   321,   372,   321,   494,    48,    49,
      50,   343,    52,   321,   348,   494,   343,    57,   494,   321,
     343,    61,   321,   321,   321,   321,   494,    67,    68,   303,
      70,   472,    72,   349,   486,   321,   462,    77,   472,   480,
     461,   357,   476,    83,    84,    85,    86,   321,   482,    89,
     474,    91,    92,   462,   474,   303,   303,   474,  2368,   303,
     474,   462,   427,   474,   408,   303,   474,   494,   416,   414,
     427,   384,   427,   321,   390,   388,   414,   321,   474,   474,
     308,   396,   372,   321,   321,   406,   126,   494,   401,   321,
     321,   339,   339,   406,   321,   494,   494,   334,   346,   346,
     321,   339,   494,   334,   494,  2421,   343,   334,   346,   494,
     150,   343,   343,   427,   154,   494,   343,   494,   408,   159,
     494,   161,   396,   494,   494,  2451,   494,   494,   494,   384,
     494,   494,   474,   427,   382,   494,   427,   459,   386,   461,
     411,   494,   494,   474,   494,   411,   401,   462,   396,   396,
     427,   386,   396,   401,  2451,   494,   382,   494,   396,   474,
     494,   494,   494,   411,   411,   494,  2482,   494,   494,   427,
     494,   494,  2335,   411,   321,   396,   494,   494,   406,   494,
     466,   494,   494,   494,   494,   386,   494,   494,   462,   494,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   474,
     474,   494,  1222,  1223,   474,   494,   494,   494,   321,   494,
     343,   459,   459,   461,   461,   459,   494,   461,   466,   321,
     494,   459,   459,   461,   461,   494,   474,   459,   459,   461,
     461,   494,   459,   494,   461,   494,   329,  2553,   321,   321,
     343,   343,   343,  2158,  2162,  2276,   494,   494,   321,   300,
     494,   501,   343,   321,   367,   321,   494,   494,   321,   474,
    2474,   343,   321,   494,   304,  2748,  2749,   494,  3210,  2449,
     372,   311,  2901,  2304,   314,   303,   316,   317,   318,   472,
     472,   372,   322,   323,   321,   325,   326,  1225,   472,   482,
     482,   331,  3114,   321,   478,   335,   336,   337,   482,  3038,
     340,   321,  3633,   472,   344,  3956,    52,   347,   367,   349,
     472,    52,   474,   482,   476,   343,   478,   357,   480,   321,
     482,   472,    52,    52,   364,   365,    52,    52,   368,   369,
     370,   482,    52,   373,   374,   472,   376,   474,   378,   476,
     380,   478,   472,   480,    52,   482,    52,   321,   309,   389,
     390,   472,   482,    52,   472,    52,   472,   397,   398,    52,
     334,   482,    52,    52,   482,    52,   482,    52,     4,   409,
      52,    52,   412,    52,    10,    52,   321,   417,   321,    15,
      52,   421,   343,    74,    36,   144,  3843,   321,    24,    52,
     321,   321,   432,   433,  2710,   435,  2610,   437,   438,   439,
     440,   441,   321,    52,    94,   445,   446,   321,   321,    52,
     321,   321,    48,    49,   144,    52,    52,    52,    52,    74,
      74,    57,   144,   463,   321,    61,   321,    52,    52,   411,
     470,    67,    68,   308,    70,   396,    72,    52,    52,   144,
      52,    77,    52,   411,    52,    94,   321,    83,  2931,    52,
     411,  2244,   492,    89,   144,    91,   496,   497,   498,    52,
     500,   501,   444,    52,    52,    74,   506,     8,   508,    74,
      11,    74,   512,   513,   514,   515,   444,   517,    94,     8,
     303,    74,    11,   144,   144,   144,  4007,   136,   144,    52,
     126,    52,   318,   321,    35,   144,    52,    52,   321,   144,
      52,    52,    52,    52,   288,    52,    35,    52,    49,   384,
    2303,    94,  2305,   388,   150,   179,   400,  3130,   154,   288,
      49,   274,   447,   159,   400,  4001,   401,   159,   144,   159,
      71,   406,   159,    52,   384,    52,    52,    52,   388,  4459,
    2333,    52,    71,    52,    52,    52,    52,    52,    52,    52,
      52,   401,    74,  3843,    94,   274,   412,  4479,   291,   599,
     304,   144,  3843,  3843,   288,  2358,  3843,  3843,  3843,  4489,
      52,    52,    52,   396,    52,    52,  4246,    52,  3834,    48,
      52,    52,    52,    82,    52,   408,    52,    52,    52,   318,
     400,   232,   233,    52,    52,    52,    52,    52,    52,    52,
     412,    52,    52,    52,   144,   596,   777,   647,    48,   251,
      52,    52,   777,    52,    52,   334,    52,    48,  4288,   775,
      48,   777,   447,    52,    48,   166,    52,   274,    58,    59,
      52,    95,    72,   777,    66,    52,   777,   166,   782,    48,
     447,    72,   289,  4670,    72,    52,   686,  4674,    52,    72,
      52,    72,   303,    95,    95,    94,    86,    95,    94,    89,
      72,    94,   677,    72,  2231,    94,   294,    57,    94,    72,
     321,  4305,    94,   777,   447,   448,  2839,    94,  4154,    72,
     144,   414,   415,   416,    95,  2848,  2717,    94,  2851,    72,
      94,   682,   343,    94,   685,   532,    48,    87,    88,     4,
       5,     6,   144,   144,   775,   144,   144,    48,   144,   144,
      72,   144,  3198,   550,    72,   144,  3202,   258,   144,   309,
      72,   521,   144,    72,   352,    72,    72,   144,  1117,   258,
    3927,    72,   747,   144,    72,    72,  2303,   144,  2305,   329,
     144,    72,   144,   144,   334,   396,    72,   777,    72,   290,
      72,    94,   782,   343,    10,  4389,   771,   447,   448,    52,
      94,   290,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   777,   452,   449,   450,   164,   452,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,  1104,   452,
     454,    52,   382,   136,   777,   294,   386,  4128,   447,   448,
      93,   144,  4722,   775,   604,    94,   606,   607,  4005,   775,
     144,   401,   605,   118,   119,  4735,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   473,   452,   621,   259,
     218,   447,   448,    94,    72,   144,    72,    93,    94,   251,
      95,   340,   775,  2224,   777,   344,  2227,   136,   251,   154,
    2643,    72,   157,   778,  2647,   144,  2649,   777,   251,   318,
     165,   117,   294,   168,   447,   448,    95,   408,   251,   109,
     110,   111,   112,   113,   114,   115,   116,   689,   690,   408,
     136,    95,  4079,   144,   275,   276,   608,   609,   144,   144,
     146,   147,   148,   777,  2687,    72,   775,   937,   777,   939,
     940,   777,  4158,   647,   294,   945,   946,   947,   777,   550,
     950,   951,   952,   769,   251,   144,   221,   777,    66,   551,
     251,   551,   675,   777,   551,  4847,  4846,   775,   592,   185,
     144,   971,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   777,   452,   136,   414,  2327,   203,   777,   596,
     990,   776,   144,   677,   780,  4625,   261,  1346,   251,   215,
     216,   266,   715,   747,   606,   607,    52,   777,   777,   776,
    4640,    52,  1012,  3586,   414,  4432,   281,   775,   747,   284,
     285,   775,   766,   414,   318,    52,   414,   292,    72,   294,
     414,   414,   415,   414,   778,   251,   715,   766,   775,   429,
     430,   257,  4258,   308,   309,   414,   779,    93,   447,   448,
      52,   447,   448,    94,   447,   448,   272,   558,   447,   448,
     779,   447,   448,   747,   329,   447,   448,    94,   775,   558,
     447,   448,   778,  4509,  1074,   682,  2417,   778,   685,  1079,
     447,   448,   777,   447,   448,  1085,  1086,   771,   196,  4380,
     780,   780,   414,   778,   780,   360,   414,   748,   749,   144,
     780,  4317,   414,   144,  1104,   414,   415,   414,   414,   776,
     775,   778,   780,   414,   780,  1115,   414,   144,  4729,   778,
    2647,   778,    94,  1123,   324,   778,  1126,   775,   414,   778,
     780,   778,   414,   778,   775,   747,   778,  1137,   775,   778,
    1140,  1141,  4358,   777,   409,   410,   778,   771,   401,   402,
     403,   404,   405,   447,   448,   778,  2909,   777,   777,   780,
    2687,   777,   777,  4644,  4645,   273,    74,    52,   782,  4799,
      95,   780,   144,   777,   779,   778,  4657,  4658,   447,   448,
      74,   778,  4432,   778,   778,   401,   402,   403,   404,   405,
     406,  4432,  4432,   778,   778,  4432,  4432,  4432,   447,   448,
     777,   777,   775,   778,   778,   251,   778,   777,    93,   777,
    3909,    74,   775,   782,  3913,    52,   414,   782,   414,   144,
    1220,   486,   775,    74,  1224,  1225,   447,   448,   775,   778,
     778,   447,   448,   414,   777,  1235,  1236,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   778,    93,   778,   474,   475,
     476,   477,   778,   778,   765,  1265,   778,   778,   778,   778,
     771,   778,   108,   778,   142,   143,   765,   414,   775,   779,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   778,
     782,   778,   778,   778,    45,   558,    47,   778,   782,   778,
     778,   778,   778,   778,   778,   778,   778,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   778,   778,   778,    81,
     778,   778,   558,   778,  1344,  1345,   778,   778,   778,   565,
     778,   775,   778,   778,  1354,   401,   402,   403,   404,   405,
     778,   778,   778,   778,   778,   778,   251,   778,   778,   778,
    4272,    10,   775,   775,   775,    52,   775,   775,   777,   775,
      70,   777,  2909,   777,  1384,   144,   775,   780,   777,   775,
      52,   777,   777,   775,    60,   777,   680,   681,   775,   683,
     777,   751,   447,   448,  1404,   775,   447,   448,   775,  1137,
     777,   775,  1140,   777,   251,   775,    93,  4346,   286,   287,
     447,   448,  4351,   777,  3638,  3639,  4355,   295,  3642,   775,
      96,    97,   685,   686,   687,   688,   689,   690,   638,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   291,
     452,   777,  1452,   624,   625,   626,   627,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   685,
     686,   687,   688,   689,   690,   447,   448,   521,   117,   775,
     588,  4263,   777,   777,    94,   779,    95,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,  4357,   146,   147,   148,
     777,  2852,   558,   414,   415,   588,   401,   402,   403,   404,
     405,    93,    94,   631,   775,    94,   136,   780,   364,   365,
    2510,  2511,   274,   777,   144,   144,    20,    21,   742,   743,
     744,  2882,  2883,    27,   777,   653,   654,   289,    32,    33,
     775,   292,   777,   294,   775,   777,   777,  1557,   631,  1559,
     604,   777,   606,   607,   401,   402,   403,   404,   405,  4415,
     643,   644,   144,  4475,   251,   144,    94,    12,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   329,   452,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     775,   452,   777,   109,   110,   111,   112,   113,   114,   115,
     116,   775,  1612,   777,    98,   775,  2514,   777,   136,  2517,
     310,   311,   312,   313,   314,   315,   144,    52,    50,    51,
     546,   547,   548,   272,   550,   119,   240,   241,  4227,   685,
     686,   687,   688,   689,   690,   777,    57,  3770,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   546,   547,   548,
     775,   550,   777,   558,    96,   417,    87,    88,   162,   163,
     346,   777,  3822,   611,   358,   359,  3956,    57,   412,   413,
      45,   619,   620,   777,   622,  4546,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   775,    86,   447,   448,   449,
     450,   558,   452,   414,   401,   402,   403,   404,   405,  2914,
    2915,   473,  4008,   288,   780,  1735,   106,  1737,   449,   450,
    4669,   452,    95,  4672,   586,   775,   318,   777,   775,   318,
     777,   775,   121,   777,   132,   133,    36,   126,   127,   128,
     325,   326,   327,   118,   119,   680,   681,   406,   683,   611,
     612,   613,   614,   775,   236,   237,   238,   261,  4624,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   764,
     452,   160,   161,    52,   447,   448,   449,   450,    36,   452,
     685,   686,   687,   688,   689,   690,  4652,  4653,  4654,   546,
     547,   548,   328,   550,   183,   181,   184,   186,   324,  4670,
     436,   437,   438,  4674,   775,  4727,   777,   777,  4271,   401,
    3171,  3172,  4678,  4679,   771,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   294,   452,   589,   685,   686,
     687,   688,   689,   690,   414,   414,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   447,   448,   251,   447,   448,
     775,   558,   777,   294,   254,   288,   546,   547,   548,   259,
     550,   251,   400,   778,  4068,   775,   266,   777,   777,   247,
     248,   249,   271,   281,  4755,   771,   261,   770,  4759,   260,
     242,   266,   775,   247,   248,   249,   294,   242,   775,   770,
     777,   775,   292,   777,   775,   242,   565,   436,   437,   438,
     300,   775,   674,   101,   102,   103,   104,   105,  4784,   294,
    4786,   778,   288,  2153,   402,   403,   404,   405,   775,   433,
     777,   320,   593,  2229,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   746,   452,  2277,  2278,   775,   339,
     777,   775,   350,   777,  2249,    57,   775,    59,   777,   288,
     349,  2292,    74,   551,  2262,  2268,   775,   471,   777,  2262,
     443,   444,   445,   446,   447,   448,   449,   450,  2274,   452,
      82,   139,   140,   141,    86,    87,    88,    89,   685,   686,
     687,   688,   689,   690,    74,  2249,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,  2302,   452,   373,  4315,
     775,   376,   777,   776,   379,   778,    74,   382,   383,   384,
     777,  2249,  2249,    74,   389,  2249,   391,  2323,  2324,  2325,
     588,  2249,   775,   431,   777,  2331,    74,   775,  4315,   777,
      74,  2337,   378,   433,   691,   692,   693,   775,  2362,   777,
    2362,    74,    74,  2362,  2262,  2362,   775,   775,   777,   777,
    2362,   686,   687,   688,  2362,  2362,   775,  2362,   777,   775,
      74,   777,   630,   631,  2362,    74,  2407,  2408,  2409,  2410,
    2362,   778,    74,  2362,  2362,  2362,  2362,   775,    74,   777,
     648,   649,   650,   651,   652,    74,  2362,   777,   775,   775,
     777,   777,  2434,  4409,   775,   775,   777,   777,  2362,   534,
    2406,   775,   638,   777,    52,   540,   541,   542,   543,   544,
     545,   775,  2434,   777,   775,  2145,   777,  2434,  2424,   778,
     555,  2434,  4409,  2153,  2362,    74,  2156,  2157,  2362,   564,
      74,    74,  2162,  2474,  2362,  2362,    52,   775,  2507,   777,
    2362,  2362,    52,  2507,   780,  2362,   775,   259,   777,    74,
    2507,  2362,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   775,   452,   777,   775,   775,   777,   777,    74,
     775,  2398,   777,  2411,  2411,   778,    74,  2398,  4478,    74,
    4480,  2398,   775,  2411,   777,   443,   444,   445,   446,   447,
     448,   449,   450,  2499,   452,   775,   775,   777,   777,  2229,
    2241,   775,   778,   777,  2234,  2235,    52,  2434,  4514,  4515,
      74,   778,  2434,  2434,   776,    74,   778,  2434,  2248,    74,
     734,  2251,   736,    74,    74,  2362,    74,  2507,    52,    74,
      74,  2249,    74,    74,  2575,  2576,    74,    74,    74,  4260,
    4393,    74,    74,  2273,  2274,    74,    74,    74,    74,  2279,
     778,  2281,    74,    74,  2284,  2285,    52,  4162,  4166,  2362,
     775,   778,  3633,    74,   664,   778,  2296,   778,   778,  2610,
    2362,  4424,  2302,    74,    74,  4428,    74,  4430,  4431,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,  2362,
    2362,    74,  2595,  2323,  2324,  2325,  2599,    74,    74,  2362,
    2330,  2331,  2385,    74,  2362,    74,  2362,  2337,    74,  2362,
    2644,  2434,    74,  2362,  2344,    74,  2621,  2268,    74,  2657,
    2655,    74,    74,  2629,  2627,  2631,    74,  2655,    74,  2640,
    2685,    74,    74,  2363,  4650,  2362,   736,  2640,  2685,  2577,
    2685,  2434,  2434,  2434,  2362,    74,    74,   746,    74,    74,
    2595,   750,  2362,  2434,    74,    74,  2854,  2621,    74,  2597,
      74,  2577,  2434,  4650,  2644,    74,  3376,    74,    74,  2399,
    2362,    74,  2597,  2784,  2790,  2405,  2406,  2718,  2719,    74,
    2686,  2685,  2627,  2621,  2621,  2488,    74,  2621,    74,  2627,
    2651,  2790,  2890,  2621,  2424,  2651,    74,  2262,  2362,  2790,
      74,  2685,    74,    74,  2685,   778,  2597,  2713,    74,    74,
    2621,    74,  2442,  2651,  2651,  2507,  2434,  2447,  2685,  2449,
    2450,  2451,  2640,  2651,  2943,  2856,  2507,  2362,    74,  2362,
    4730,  2461,  2856,    74,  2398,  2465,  2249,  2685,  2362,  2488,
    4746,  2362,  2362,    74,    74,    74,  2787,  2788,    74,  2479,
      74,    74,  2940,  2362,  2484,  2879,  2887,    74,  2362,  2362,
    2874,  2362,  2362,  2940,  2874,  2495,  2890,  2874,  2910,  2499,
    2874,  2940,  2784,  2874,  2940,  2362,  2874,  2362,  2508,  2509,
    2786,    74,  2940,  2434,  2514,  2790,    74,  2517,  2874,  2874,
    2520,  2521,  2522,  2523,  2524,  2525,  2802,  2362,  2528,  2529,
    2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,
    2550,  2551,  2552,  2940,  2554,  2555,  2790,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,  2567,  2844,  2569,
    2846,  2847,  2874,  2940,  2362,    74,  2784,  2784,  4848,  2362,
    2784,  2940,  2940,  2874,    74,    74,  2784,  2784,  2940,    74,
    2940,    74,  2784,  2784,  2840,  2940,    74,  2784,    74,  2874,
      74,  2940,  3943,  2940,  3945,    52,  2940,    52,   778,  2940,
    2940,  2611,  2940,  2940,  2940,  2694,  2940,  2940,  2618,  2619,
    2620,  2940,  2622,    74,    74,  2625,  2626,  2940,  2940,  2629,
    2940,  2631,  2840,   778,    52,    52,  2636,  2637,  2249,  2874,
    2874,  2940,  2918,  2940,  2874,  2645,  2940,  2940,  2940,    74,
    2650,  2940,  2248,  2940,  2940,  2251,  2940,  2940,  2658,  2970,
    2660,  2937,  2940,  2940,  2664,  2940,  2874,  2940,  2940,  2940,
    2940,  4012,  2940,  2940,    74,  2940,  2940,  2940,  2940,  2940,
    2940,  2940,  2940,  2940,  2940,  2281,  2686,  2940,  2284,  2285,
    2690,  2940,  2940,  2940,  2694,  2940,  2696,  2697,  2698,  2874,
    2621,  2701,  2940,  2856,  2856,  2705,  2940,  2707,  2708,  2651,
      74,  2940,  2856,  2713,    74,    74,   778,  2940,  2268,  2940,
    2720,  2940,  2722,  2651,   777,    74,   778,  2856,    74,  2729,
    2651,    74,  2940,  2940,  2856,    74,  2940,  2890,  2890,   378,
      74,  2885,  2940,  2940,    74,  2856,  2890,  2747,  4081,  2940,
    4071,  2362,  2874,  2940,    52,   778,    74,  2879,    74,  2856,
    2595,  2890,    74,  2885,  2599,  2887,  2856,  2363,  2890,  1085,
    1086,    74,  4525,    74,    74,  2856,   777,  2874,  2856,  2890,
    2856,  2723,  2879,    74,    74,  2595,  2786,  4128,  2885,  2599,
    2887,   778,  2627,  2890,  2794,  2723,  2796,    74,    74,    74,
    2890,    52,  2802,  2399,    74,  2640,    74,    74,    74,  2890,
      74,    52,  2890,    74,  2890,    20,    21,  2627,   778,    74,
      25,    26,    27,  2434,    57,   778,   778,    32,    33,    57,
      74,    74,    74,    38,    39,  2385,    74,    74,  2621,    74,
      74,   778,    93,    74,  2844,  4557,  2846,  2847,  2398,    74,
      52,   777,   775,    86,    52,  2855,    84,    85,    86,    52,
     777,  2644,   778,    74,    74,    74,    74,    74,    74,   777,
      74,   121,   777,   106,    74,    74,   126,   127,   128,    52,
      74,   777,    74,   777,  2434,   777,   777,   777,  4229,   777,
     777,    74,   777,    98,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,  4014,   452,   777,   777,   378,    74,
     160,   161,  2508,  4254,   119,   777,   777,   777,  2918,  1235,
    1236,   777,   777,   156,   777,   777,   154,  3983,   156,  3988,
    4271,   777,   777,   183,   777,   777,   186,  2937,   777,   172,
     777,   777,   777,  2943,   172,   777,   777,   777,    74,  1265,
     777,   777,    74,   777,   777,   777,    74,   162,   163,    74,
    2960,    74,    74,    74,  2964,  2965,    74,    74,  2968,    74,
      74,  2971,  2972,    74,  2974,  2975,  2976,    74,  2978,    74,
      74,    74,    74,   778,    74,    74,  3981,    74,   221,   778,
      74,    74,    74,   221,  3343,   778,    52,    74,    74,    74,
     251,    74,    74,  3977,    74,    74,    74,    52,    74,   778,
    2621,    74,    74,    74,    74,    74,    52,    52,    52,    74,
     253,   271,    74,   778,  2620,    74,   259,  2577,  3967,   778,
    3959,   259,    74,   266,    74,    74,    74,    74,   778,  4380,
    2636,    74,    74,    74,    74,    74,    74,  2597,    74,  2645,
    3326,    74,    74,    74,  2650,    74,   261,    74,  3334,   292,
      52,   266,  2658,   778,   292,  3065,   299,  3067,  2664,    52,
      74,   299,    74,   778,    52,   778,    52,  2627,    74,    74,
      74,  3081,  4423,    74,    74,    74,  4427,    74,    74,    74,
      74,   778,    74,    74,  2690,    74,    52,    74,   400,   349,
      74,    74,    74,    74,  3104,    74,   339,  3107,    74,  3109,
     778,   778,   778,  4454,  3114,    74,    74,    74,   778,  3468,
      74,    74,    74,    74,    74,    74,  2722,    74,    74,    74,
      74,    74,    74,    74,   339,  3135,  1452,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    74,   452,    74,
     401,   402,   403,   404,   405,    74,    52,    74,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,  4549,   452,
      74,    74,    74,    74,    74,    74,    74,    74,  4519,    74,
      22,    23,    24,    52,    74,    74,    28,    29,    30,    31,
      74,    52,    34,    74,    74,    74,   429,   430,    52,    74,
     433,   429,   430,    45,    46,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    57,   452,   778,  3218,  3219,
      52,    74,    74,    74,    74,    74,    74,    52,   433,    74,
      74,   778,    93,  3233,  3234,    74,    74,  4578,  3238,  4580,
      74,    74,  3242,    74,    86,    74,    74,    74,    74,   778,
      74,    74,    74,  3937,    52,    74,    74,    74,    74,  2855,
    3260,  3261,    74,    74,   106,    74,   471,  3267,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    74,   452,
      74,  3281,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    74,    74,  3303,    74,    74,    74,   558,    74,  3309,
      74,  3311,    74,    74,    74,   520,    74,    74,    74,    74,
    3320,  3321,    74,    74,    74,  3325,  3326,    74,    74,    74,
    3819,    74,    74,    74,  3334,    74,    74,    74,    74,    74,
      74,    52,    74,    74,    57,    52,   778,    52,   778,    74,
     578,   579,   580,   581,   582,    74,    52,  3357,    74,    74,
      74,    52,    74,   778,    74,  4706,    74,    52,    74,   778,
      74,    74,    74,    74,  3374,  3843,    74,    74,    52,  4720,
      74,    52,    74,   778,    74,  4726,    74,    74,    74,    52,
     251,    74,    74,   778,    74,    52,   778,    74,    74,    74,
     778,    74,  4743,  4744,  4745,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    74,   452,   259,   260,    74,
      74,  4762,  4763,    74,    74,    74,    74,    74,    74,    74,
     251,  3431,    74,    74,   685,   686,   687,   688,   689,   690,
      74,    52,    74,   251,    74,   673,  1085,  1086,    74,    74,
      74,    74,  3452,    74,    74,   778,    52,   299,   300,    74,
    3460,  3461,   775,   778,  1103,    52,    22,    23,    24,   778,
     777,   775,    28,    29,    30,    31,   782,    74,   777,   294,
     775,   778,  3482,   777,  3484,  3081,   782,  3487,   777,   777,
      46,   775,  3492,   775,  3494,   778,   746,  4838,  3498,  4840,
     750,    57,   782,   736,   777,   777,   777,   144,  3508,   144,
      74,   144,   777,   782,   777,  3515,   144,  3517,   777,   777,
     777,   777,   144,   777,  3524,   777,   144,   778,   777,   734,
      86,   777,  3532,   318,   144,   144,   144,   777,    52,  3135,
     401,   402,   403,   404,   405,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   777,   452,   777,   777,   777,
    3560,   777,  3562,   777,  3564,  3565,   779,   144,   144,   144,
    3570,   144,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   777,   452,   144,   144,   777,   429,   430,   777,
     777,   777,   777,  3593,   775,   777,  1235,  1236,   777,   777,
     777,   777,   144,   144,   775,  3605,  3606,  3607,   775,  3609,
     144,   775,   775,   775,   144,  1085,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,  1265,   452,   144,   318,
     777,   144,   144,   144,   144,   144,   144,  3637,  3638,  3639,
     516,   144,  3642,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   144,   452,   144,   779,  4006,   144,    52,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
    3670,   452,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   144,   144,   144,   144,   144,   777,   558,   777,   144,
     144,   144,   144,   259,   260,    52,   777,    52,   775,    52,
    3710,   775,    52,   144,   144,   144,   429,   430,   775,   318,
     318,   775,  4071,   318,  3724,  4074,   318,   775,   775,  3325,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     318,   452,   144,   299,   300,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   775,   452,  4068,    57,   775,
     775,   775,   775,   775,   782,  1235,  1236,   775,   775,  3769,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     144,   452,   144,   144,   144,   144,   144,   144,    87,    88,
    4474,   144,   144,   144,   144,  1265,   144,   510,   511,   512,
     513,   514,   777,   144,    52,   775,   144,   775,   775,   144,
     523,   524,   525,  1452,   775,   775,   778,   530,   531,  3819,
     533,   534,  3822,   144,   685,   686,   687,   688,   689,   690,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     775,   452,  3842,   775,   777,   775,   559,   452,   333,   777,
    4161,   775,   775,   775,   775,   775,  3452,   775,   144,   775,
     775,   160,   161,   775,   775,   775,   775,   144,   775,   777,
     355,   356,   144,   429,   430,   588,   175,   288,   144,  4190,
     144,   144,   775,   777,   183,   144,   777,   186,   775,   775,
     775,   144,   775,   775,    74,   144,  3492,   775,  3494,   144,
     777,   775,   775,   775,   775,   204,   400,   775,   775,   775,
     144,   775,   777,   144,   144,   775,  3916,   778,   631,   144,
     144,  3517,   635,   144,   144,   144,  3926,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,  3937,   452,   144,
    3940,  4020,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   144,   665,   666,   667,   668,   669,   670,   671,  3959,
     144,   144,   144,   144,  4432,   144,   265,  3967,   144,   775,
     775,   775,   271,   592,   144,   775,   144,  3977,   144,   144,
     400,  3981,  1452,  3983,   775,   775,   775,   779,  3988,   770,
      74,   775,  3992,  3993,   775,   294,    74,  3997,    74,    52,
      74,  4001,    74,   144,   775,   144,   144,   144,   307,   144,
    4010,   144,   144,   144,   144,   144,   144,   144,   144,   603,
    4020,   144,   144,  4023,  4024,   779,  4105,  4106,   777,   777,
     144,   144,   144,   777,   144,   144,  4312,   777,   144,   144,
      93,   144,   775,   144,   343,   775,   775,   775,   347,   775,
     349,  4051,   351,  4053,   777,   144,   144,   144,   144,   144,
     318,  4061,  4062,   144,   144,   144,   775,   144,   318,  4069,
     354,   144,   452,   447,  3670,   144,   775,   144,   144,   144,
     144,   776,   144,  4083,   144,   144,   144,   144,  4088,  4089,
     144,   775,   144,   144,   144,  4095,   144,   144,   144,   144,
     144,   144,   144,   588,   589,  4105,  4106,   144,   144,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,  4119,
     452,   144,   144,   144,   144,   777,   144,   144,   144,   144,
    4130,  2447,   431,   144,   144,  2451,   144,  4137,   144,   775,
     144,   144,   144,   144,  4144,   630,   631,   144,   633,   634,
     779,   636,   637,   638,  4154,  4155,  4156,   144,   643,   775,
     144,   775,   775,   775,   144,   144,  4166,   144,   775,   654,
     144,   775,   775,  3769,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   775,   452,  4535,   775,  4188,   779,
    4539,  4191,   775,  4542,  4194,   775,   775,   144,   251,   158,
     318,   775,   294,   775,  2520,  2521,  2522,  2523,   775,   775,
     775,   318,  2528,  2529,  2530,  2531,  2532,  2533,  2534,  2535,
    2536,  2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,
    2546,  2547,  2548,  2549,  2550,  2551,  2552,   775,   775,  2555,
     775,  2557,  2558,  2559,  2560,  2561,  2562,  2563,  2564,  2565,
    2566,  2567,   775,   160,   161,   775,   775,   775,    52,  4259,
     777,    52,   333,  4263,   144,   144,  1142,    52,   175,    74,
     333,   777,    74,   775,   775,   452,   183,   318,   778,   186,
     778,   778,   775,   778,   355,   356,   778,   775,   775,  4368,
      74,  4370,   355,   356,   778,   778,   294,   204,   778,   778,
     778,   778,  4302,  4303,   778,  4305,   778,   778,  4308,   778,
      74,   778,  4312,   294,   778,  4315,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    74,   452,   775,   775,
     778,  4331,    74,   144,   144,   776,    74,  4337,  4338,   778,
    4340,   775,   775,   778,  2660,   782,    52,   775,   401,   402,
     403,   404,   405,   775,   775,   778,   775,   775,   265,   415,
     776,    52,  4362,   778,   271,   414,    52,    52,  4368,  4369,
    4370,  4371,  4372,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   778,   452,   782,   782,  4387,   778,  4389,
     782,    74,    74,    74,   777,    74,  4396,  4397,  4398,  4399,
     307,   144,  4402,  4403,  4404,  4754,   776,   775,  4757,  4409,
      52,   782,   775,    52,    52,    52,   782,    74,   144,   775,
    4420,  4421,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    52,   452,    52,   777,   343,   318,  4438,   775,
     347,  4441,   349,    74,   351,   778,   778,   775,   775,    74,
      74,   777,   751,   752,   753,   754,   755,   756,   757,   758,
     759,   760,   761,   762,   763,  4061,   775,   775,   775,   288,
     775,   288,   775,   775,  4474,   775,    74,   318,   775,    52,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   778,
     778,   775,  4502,  4503,  4504,   558,    52,   778,   778,  4509,
     144,   778,    52,    74,    74,    74,    74,   588,   589,    74,
      74,    74,    74,    74,   431,   588,   589,  4527,  4528,   159,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     782,   452,   782,   782,  4544,    74,   551,   775,    74,  4549,
     777,  4551,   144,  4553,    52,    52,    52,  4557,  4558,   630,
     631,   632,   633,   634,   775,   636,   637,   630,   631,   775,
     633,   634,   643,   636,   637,   638,   639,   775,   777,   775,
     775,   775,    74,   654,  2223,  2224,  2225,   775,  2227,   775,
     775,   654,   158,   782,   603,   318,  2912,   775,  2914,  2915,
    2239,   775,   775,   778,  4683,   412,   778,  2246,   775,   778,
      74,   775,    52,   775,   775,   778,  2255,  2256,  2257,   778,
    2259,   775,   775,   775,   775,  2264,    52,    52,   778,   778,
     778,   775,   685,   686,   687,   688,   689,   690,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    52,   452,
    4650,   775,   603,   778,   775,   144,  2295,   777,  2297,  2298,
     777,  2300,   777,   782,   775,    52,   782,   775,    52,  2308,
    2309,   775,    52,  2312,  2313,  2314,  2315,  2316,  2317,  2318,
    2319,  2320,   775,  4683,   775,   775,   782,   782,  2327,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   782,
     452,  2340,   777,    74,    52,   775,   144,   412,   158,   551,
     778,  2350,  4712,  2352,  4714,   776,   159,    74,    52,   352,
     775,  2360,    52,    52,    52,   778,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   775,   452,   778,  4739,
     778,   775,   775,   775,   775,   775,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   782,   452,   782,   778,
     159,   775,   769,   775,   777,  4765,    52,    52,   551,  4769,
     144,    52,   144,    52,  4774,   775,  4776,  4777,  2417,  2418,
     775,   777,   775,    52,   775,   775,   775,   775,   144,  2428,
    2429,  2430,   777,   775,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   777,   452,   777,   775,  2447,   778,
     775,   775,  2451,   775,   777,   775,  2455,  2456,   775,   775,
     775,   775,   775,   775,    93,   144,  4826,  4827,   778,  2468,
     778,  4831,  4832,   778,   778,   161,    52,  3611,  2731,  2750,
    3303,   346,  2711,  2411,  3267,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,  2907,  2497,  2396,
    4860,  2500,  4400,  4863,  2503,  2924,  2505,   778,  4405,  4779,
    4778,  2462,   499,  3468,  3475,   498,  2896,    93,  4830,  4692,
    2904,  2520,  2521,  2522,  2523,  2910,  1121,  3343,  2262,  2528,
    2529,  2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,
    2549,  2550,  2551,  2552,  2469,  2597,  2555,  2627,  2557,  2558,
    2559,  2560,  2561,  2562,  2563,  2564,  2565,  2566,  2567,  2599,
    2940,  2920,  3233,   490,  2916,  2644,  3242,   512,  2153,  2790,
    2579,  2580,   971,  2582,  4432,   514,  2362,  2586,  2587,  2588,
    2589,  2590,  2591,    52,  2593,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,  4456,   452,  4230,   515,   947,
    4255,   369,  4272,  2507,  2434,   778,  2668,  2447,  2465,  1126,
    2691,  2683,   251,  2689,  2685,  2663,  2655,  2890,  2236,  2856,
    2840,  2854,  2621,  2874,    93,  3311,  2241,  2879,  2887,  2651,
    3281,  2885,  2723,  2642,  3320,  3321,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   648,   452,  2398,  2637,
    2282,  2660,  2249,  2662,  2488,  3351,   778,  2385,  2635,  2268,
    3309,  4362,  4387,  2625,  3837,   251,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,  3842,   452,  2960,   503,
    2520,  2521,  2522,  2523,  2961,    -1,    -1,    -1,  2528,  2529,
    2530,  2531,  2532,  2533,  2534,  2535,  2536,  2537,  2538,  2539,
    2540,  2541,  2542,  2543,  2544,  2545,  2546,  2547,  2548,  2549,
    2550,  2551,  2552,   778,  4426,  2555,    -1,  2557,  2558,  2559,
    2560,  2561,  2562,  2563,  2564,  2565,  2566,  2567,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
    2968,    -1,    -1,    -1,    -1,  3431,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,  2765,   452,    -1,  2768,
    2769,   778,   401,   402,   403,   404,   405,  2776,    -1,  2778,
    2779,  2780,  2781,  2782,    -1,    -1,    -1,  1123,    -1,    -1,
      -1,    -1,   251,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2812,  2813,    -1,    -1,    -1,  4774,    -1,
      -1,  2820,    -1,    -1,    -1,   401,   402,   403,   404,   405,
    2660,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,  2852,   452,    -1,    -1,    -1,    -1,    -1,
    2859,  2860,  2861,    -1,  2863,    -1,    -1,  2866,  2867,    -1,
      -1,    -1,    -1,  2872,  2873,    -1,  4832,    -1,    -1,    -1,
      -1,    -1,    -1,  2882,  2883,    -1,  3562,    -1,    -1,  3565,
      -1,    -1,    -1,    -1,  3570,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2901,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,  2927,   558,
      -1,    -1,   778,  2932,    -1,    -1,  2935,    -1,    -1,  2938,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2190,  2191,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,  2214,    -1,
      -1,    -1,   558,   778,    -1,    -1,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,    -1,    -1,   778,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3025,  3026,    -1,    -1,
      -1,    -1,    -1,    -1,  3710,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,
      -1,    -1,  2288,  2289,  2290,    93,   685,   686,   687,   688,
     689,   690,    52,    -1,    -1,    -1,    -1,   770,    -1,    -1,
      -1,    -1,   775,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   778,    -1,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,
     778,    -1,  2368,    -1,    -1,    -1,    -1,    -1,    -1,  2375,
      -1,    -1,    -1,    -1,  2380,    -1,    -1,    -1,    -1,   778,
      -1,    -1,    -1,    -1,  2390,    -1,    -1,    -1,    -1,    -1,
    3159,  3160,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,  3171,  3172,    -1,    -1,    -1,    -1,    -1,  2415,
     778,    -1,    52,    -1,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,    -1,
      -1,  2437,   778,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,   251,   452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    94,    -1,   685,   686,   687,   688,
     689,   690,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,  2491,   452,    -1,  2494,    -1,
      -1,   251,    -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
     318,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3311,    -1,    -1,   185,  3992,  3993,    -1,   778,
      -1,  3320,  3321,   778,    -1,  4001,    -1,    -1,   318,    -1,
      -1,    -1,    -1,   203,    -1,   778,    -1,  3336,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   215,   216,  4023,  4024,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   778,    -1,    -1,  4051,    -1,  4053,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,  2653,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,    -1,  3431,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,  4119,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   778,    -1,    -1,    -1,    -1,    -1,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
    2706,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4154,    -1,
      -1,  3311,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3320,  3321,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,   778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     778,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,  3562,    -1,    -1,  3565,    -1,   558,   778,
      -1,  3570,    -1,    -1,    -1,    -1,    -1,   447,   448,    -1,
      -1,    -1,   778,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,  3431,    -1,    -1,   474,   475,   476,   477,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   778,   452,
      72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     778,    -1,  4308,    -1,  3633,    -1,    -1,    -1,    -1,  4315,
     251,    93,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4337,  4338,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    -1,    52,    -1,   778,    -1,   558,    -1,
      -1,    -1,    -1,  4369,    -1,   685,   686,   687,   688,   689,
     690,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,  3710,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    4396,  4397,  4398,  4399,    -1,    93,  4402,  4403,   778,    -1,
      -1,    -1,  3562,  4409,    -1,  3565,    -1,   775,    -1,    -1,
    3570,    -1,    -1,  2979,  2980,  2981,  2982,    -1,    -1,  2985,
    2986,  2987,  2988,  2989,  2990,  2991,  2992,  2993,  2994,  2995,
    2996,  2997,  2998,  2999,  3000,  3001,  3002,  3003,  3004,  3005,
    3006,    -1,  3008,  3009,  3010,  3011,  3012,  3013,  3014,  3015,
    3016,  3017,  3018,    -1,    -1,   775,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,   778,    -1,    -1,    -1,   251,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,  4503,  4504,    -1,
      -1,    -1,    -1,  4509,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4527,  4528,    -1,    -1,    -1,    -1,    -1,    -1,    52,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3710,    -1,    -1,   251,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,   777,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,  3943,   778,  3945,   558,    -1,   401,
     402,   403,   404,   405,    52,    -1,   160,   161,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,   175,    -1,    -1,  4650,    -1,    -1,    -1,    -1,   183,
      -1,    -1,   186,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3992,  3993,    93,    -1,    -1,    -1,  3235,
     204,    -1,  4001,  3239,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4012,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4023,  4024,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,   778,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,    -1,  4051,    -1,  4053,    -1,    -1,    -1,   251,    -1,
      -1,   265,    -1,  4739,    -1,    -1,    -1,   271,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
    4776,    -1,    -1,   307,    -1,    -1,   558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
    4119,    -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,  4128,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   778,    -1,   343,
      -1,    -1,    -1,   347,    -1,   349,    -1,   351,    -1,    -1,
      -1,    -1,    -1,   251,    -1,  4154,    93,    -1,    -1,    -1,
      -1,    -1,  3992,  3993,   775,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,    -1,  4023,  4024,    -1,    -1,   778,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  4051,   778,  4053,    -1,    -1,  3462,   431,    -1,  4228,
    4229,    -1,    -1,   685,   686,   687,   688,   689,   690,    -1,
      -1,    -1,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  4254,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3501,    -1,    -1,    -1,    -1,
      -1,    -1,  4271,    -1,    -1,    -1,    -1,    -1,    -1,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,  4119,
     452,    -1,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,  4308,
      -1,    -1,    -1,    -1,   251,    -1,  4315,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,   779,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4337,  4338,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      93,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,
    4369,    -1,    -1,    -1,    -1,    -1,   778,    -1,    -1,    -1,
      -1,  4380,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4396,  4397,  4398,
    4399,    -1,    -1,  4402,  4403,    -1,    -1,   775,    -1,    -1,
    4409,    -1,    -1,    -1,    -1,  4414,  4415,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  4423,    -1,  4425,    93,  4427,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,  4454,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,   676,    -1,    -1,    -1,    -1,    -1,  4308,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,    -1,    -1,
      -1,    -1,    -1,    -1,  4503,  4504,    -1,  4337,  4338,    -1,
    4509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
    4519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4527,  4528,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4369,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   752,   753,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   763,
      -1,    -1,    -1,    -1,    -1,    -1,  4396,  4397,  4398,  4399,
      -1,    -1,  4402,  4403,    -1,    -1,    -1,    -1,    -1,  4578,
      -1,  4580,   775,    -1,    -1,   251,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,   778,    -1,    -1,    -1,
      -1,   558,    -1,    -1,    -1,  4624,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,  4650,    -1,  4652,  4653,  4654,    -1,    -1,    -1,  3895,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,  4503,  4504,    -1,    -1,   775,    -1,  4678,
    4679,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,    -1,    -1,  4527,  4528,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  4706,    -1,    -1,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,  4720,   452,    -1,    -1,    -1,  3962,  4726,    -1,    -1,
      -1,    -1,  3968,    -1,    -1,   401,   402,   403,   404,   405,
    4739,    -1,  3978,    -1,  4743,  4744,  4745,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  4762,  4763,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,  4776,    -1,    -1,
    4016,    -1,    -1,    -1,    -1,  4784,    -1,  4786,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,
    4066,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   775,  4838,
      -1,  4840,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,     0,   558,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,    14,    15,    16,    -1,  4739,
      -1,  4147,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,    -1,    -1,    -1,  4163,    -1,    -1,
      -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    -1,  4776,    56,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,    67,    68,
      69,  4197,  4198,   778,    73,    -1,    75,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,    90,    91,    -1,    93,  4221,    -1,  4223,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,   106,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,    -1,    -1,   122,   123,   124,   125,    -1,   778,   685,
     686,   687,   688,   689,   690,    -1,   135,    -1,   137,   138,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,   152,  4280,  4281,   779,  4283,   778,    -1,
      -1,    -1,    -1,    -1,    -1,  4291,    -1,    -1,    -1,    -1,
      -1,    -1,   171,  4299,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   180,    -1,   182,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,  4323,    -1,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,   775,
     452,    -1,   211,   212,   213,   214,  4342,  4343,   217,   775,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
     229,   452,    -1,    -1,    -1,   778,    -1,    -1,    -1,  4365,
      -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,   256,    -1,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,   277,   278,
      -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,   778,
      -1,    -1,   291,    -1,    -1,    -1,    -1,   296,   297,    -1,
      -1,   778,   301,   302,    -1,    -1,   305,   306,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,    -1,   452,
      -1,  4447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  4455,
      -1,    -1,   331,   332,    -1,    -1,   335,   336,   337,   338,
     778,   340,    -1,    -1,    -1,    -1,   345,    -1,    -1,   348,
      -1,    -1,    -1,    -1,   353,   354,    -1,    -1,   357,   778,
      -1,    -1,   361,   362,   363,    -1,    -1,   366,    -1,   368,
     369,   370,   371,   372,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,   407,    -1,
      -1,    -1,    -1,    -1,    -1,   414,   415,   416,    -1,   418,
     419,   420,    -1,   422,   423,   424,   425,   426,   427,   428,
      -1,    -1,    -1,  4559,    -1,   434,   435,    -1,    -1,    -1,
      -1,   440,    -1,    -1,    -1,   778,    -1,    -1,    -1,    -1,
      -1,  4577,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,   778,    -1,    -1,
      -1,   480,   481,    -1,    -1,    -1,    -1,    -1,    -1,  4615,
    4616,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,  4635,
      -1,    -1,    -1,    -1,    -1,    -1,   515,  4643,    -1,    -1,
      -1,   520,   778,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   775,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,   778,    -1,   558,
      -1,  4687,  4688,    -1,    -1,    -1,  4692,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
      -1,    -1,  4708,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   590,   591,    -1,    -1,   594,   595,   778,   597,   598,
     599,   600,   601,   602,    -1,    -1,    14,    15,    16,    -1,
      -1,   610,    -1,    -1,    -1,    -1,   615,   616,   617,    -1,
      -1,    -1,    -1,    -1,   623,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    41,    42,    43,    44,    -1,    -1,    -1,
      48,    -1,    -1,    -1,  4770,   778,   645,   646,    56,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  4782,    -1,    -1,    67,
      68,    69,    -1,    -1,    -1,    73,    -1,    75,    76,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   678,
     679,    -1,    90,    91,    -1,    93,   685,   686,   687,   688,
     689,   690,   100,    -1,    -1,   694,    -1,    -1,   106,    -1,
      -1,    -1,    -1,    -1,  4830,    -1,    -1,    -1,    -1,    -1,
      -1,   778,    -1,    -1,   122,   123,   124,   125,    -1,    -1,
      -1,    -1,    -1,   778,    -1,    -1,    -1,   135,    -1,   137,
     138,    -1,    -1,    -1,    -1,    -1,   735,    -1,   737,   738,
     739,   740,   741,    -1,   152,    -1,   745,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
    4886,    -1,    -1,   171,    -1,    -1,    52,    -1,   767,   768,
      -1,    -1,   180,   772,   182,   774,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,    -1,   778,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   778,    -1,   211,   212,   213,   214,    93,    -1,   217,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   229,   452,    -1,    -1,    -1,    -1,    -1,   778,    -1,
      -1,    -1,    -1,    -1,    -1,   243,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,   256,    -1,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,   277,
     278,    -1,   280,    -1,   282,   283,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   291,    -1,    -1,    -1,    -1,   296,   297,
      -1,    -1,    52,   301,   302,    -1,    -1,   305,   306,    -1,
      -1,    -1,    -1,    -1,   778,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,
      -1,    -1,    -1,   331,   332,    -1,    -1,   335,   336,   337,
     338,    -1,   340,    93,    94,    -1,    -1,   345,    -1,    -1,
     348,    -1,    -1,    -1,    -1,   353,   354,    -1,    -1,   357,
      -1,    -1,    -1,   361,   362,   363,    -1,    -1,   366,    -1,
     368,   369,   370,   371,   372,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    52,    -1,    -1,    -1,   136,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,   407,
      -1,    -1,    -1,    -1,    -1,    -1,   414,   415,   416,    -1,
     418,   419,   420,    93,   422,   423,   424,   425,   426,   427,
     428,    -1,    -1,    -1,    -1,   185,   434,   435,    -1,    -1,
      -1,    -1,   440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   215,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,   480,   481,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,   778,   452,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,    93,    -1,
      -1,    -1,   520,   778,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    52,    -1,    -1,    -1,   778,    -1,
     558,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   590,   591,    -1,    93,   594,   595,   778,   597,
     598,   599,   600,   601,   602,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   610,    -1,    -1,    -1,    -1,   615,   616,   617,
      -1,    93,    -1,    -1,    -1,   623,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   645,   646,   775,
      -1,   401,   402,   403,   404,   405,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   251,    93,    -1,    -1,
     678,   679,   558,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,   694,   447,   448,    -1,
      -1,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,    -1,    -1,    -1,   474,   475,   476,   477,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,   735,    -1,   737,
     738,   739,   740,   741,    -1,    -1,    -1,   745,    -1,    -1,
      -1,    -1,    -1,   251,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,   767,
     768,    -1,    -1,    -1,   772,    -1,   774,    -1,    -1,   251,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    52,    -1,    -1,    -1,    -1,    -1,   558,   685,
     686,   687,   688,   689,   690,    -1,    -1,    -1,   775,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    52,    -1,    -1,    -1,    -1,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,   775,    93,    -1,    -1,   775,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    52,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    -1,
      52,    -1,    -1,   558,    -1,   401,   402,   403,   404,   405,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   251,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    93,    -1,    -1,    -1,    -1,    -1,   777,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    -1,    -1,    -1,    -1,    -1,
     558,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,   251,    -1,    -1,    -1,    -1,   558,    -1,   775,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,    -1,    -1,    52,    -1,   775,    -1,   251,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,    -1,   558,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    52,    -1,    -1,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      -1,    -1,    -1,    52,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    93,    -1,    -1,
     775,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,    -1,
      -1,    -1,    -1,    52,    93,    -1,    -1,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   775,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   401,   402,   403,
     404,   405,    -1,    -1,    93,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,    -1,    -1,   775,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   251,   775,    -1,    -1,    -1,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   775,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   251,    -1,    -1,    -1,   775,
      -1,   558,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   251,    -1,    -1,    -1,    -1,    -1,   558,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
      -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,   775,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    -1,    -1,    -1,    -1,    52,   558,    -1,   685,   686,
     687,   688,   689,   690,   775,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    52,   775,    93,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
      -1,    -1,    52,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,   775,   775,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    93,    -1,   775,    -1,    -1,    -1,   558,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   775,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,    -1,   558,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    52,   251,    -1,    -1,    -1,    -1,   558,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,   775,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   251,    93,    -1,    -1,    -1,    52,   558,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,   775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,   775,
      -1,   775,   251,    -1,    -1,    -1,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   775,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    93,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,    -1,    -1,    -1,    52,    -1,   775,    -1,    -1,    -1,
      -1,    -1,    -1,   775,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    93,    52,    -1,    -1,    -1,
      -1,   558,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,    -1,   452,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   775,    -1,    -1,    93,    -1,    -1,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    52,    -1,    -1,    -1,    -1,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   775,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,   251,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
      -1,    -1,    -1,    93,   775,    52,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,   775,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,   251,    -1,    52,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,   251,    93,    -1,    52,   558,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   775,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   775,    93,
      -1,    -1,    -1,    -1,   558,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,    -1,    -1,   775,    -1,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,   251,    -1,   775,    52,    -1,    -1,    -1,    -1,    -1,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,   775,    -1,    -1,   775,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    93,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,   775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    52,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   251,    -1,    -1,
      -1,    -1,    -1,   558,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,   775,    -1,    93,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,   775,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,   775,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   251,   775,    52,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,    -1,   558,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    93,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
     685,   686,   687,   688,   689,   690,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    -1,    -1,    52,   251,    93,   558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,   775,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   775,    93,    -1,    -1,    -1,
     775,   558,    -1,   401,   402,   403,   404,   405,    -1,   685,
     686,   687,   688,   689,   690,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
      -1,   558,    -1,    -1,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,   251,    -1,    -1,   775,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    52,    -1,
      -1,    -1,    -1,    -1,   558,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   775,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    52,   251,    -1,    -1,   775,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    93,    -1,    -1,    -1,    52,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   775,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      93,    -1,   558,    -1,   401,   402,   403,   404,   405,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,   775,    -1,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   775,   452,    -1,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,   775,    -1,
      -1,    -1,    -1,   558,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    52,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   775,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,   251,    -1,
      -1,   558,    93,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,    -1,    -1,   775,    -1,    -1,
      52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,   775,
      -1,    93,   558,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    52,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
      -1,   558,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,
     775,    52,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    -1,    93,   441,   442,   443,   444,   445,   446,   447,
     448,   449,   450,    -1,   452,    -1,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,   775,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   775,   251,
      93,    -1,    -1,    -1,   558,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   775,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,   775,    -1,
     251,    -1,    -1,    -1,    -1,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,   775,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    52,    -1,    -1,    -1,   251,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    93,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,    52,    -1,
      -1,   775,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,    -1,    -1,    -1,   558,   775,    -1,
     401,   402,   403,   404,   405,    -1,    -1,   775,    -1,    93,
      -1,    -1,    -1,    -1,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,   775,    52,    -1,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    -1,   775,    -1,    -1,    -1,   558,    -1,   401,   402,
     403,   404,   405,    52,    -1,    -1,    -1,    -1,   251,    93,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,   251,    93,    -1,    -1,    -1,   558,   441,
     442,   443,   444,   445,   446,   447,   448,   449,   450,    -1,
     452,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   775,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,   775,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      -1,    -1,    -1,    -1,   775,   558,    -1,    -1,   401,   402,
     403,   404,   405,    52,    -1,    -1,    -1,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   251,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,   775,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,    -1,   452,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,   775,    -1,    -1,    -1,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,   775,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      93,    -1,    -1,    -1,   775,   558,    -1,   401,   402,   403,
     404,   405,    52,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,   775,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   775,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
     251,    93,    -1,    -1,   558,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    48,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   251,    -1,
      -1,    -1,    93,    -1,   558,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   775,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
     401,   402,   403,   404,   405,   775,    -1,   775,    -1,   251,
      -1,    -1,    -1,    -1,   441,   442,   443,   444,   445,   446,
     447,   448,   449,   450,    -1,   452,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,   775,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,    -1,    -1,
      -1,   775,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,   401,
     402,   403,   404,   405,    -1,    -1,   775,    -1,    -1,    -1,
      -1,   352,    -1,    -1,    -1,    -1,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,    -1,   452,    -1,   775,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,
     441,   442,   443,   444,   445,   446,   447,   448,   449,   450,
      -1,   452,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,
      -1,   775,    -1,    -1,    -1,    -1,   775,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,    -1,   452,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,   775,    -1,
      -1,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,   775,     3,     4,   558,     6,     7,
      -1,     9,    -1,    -1,    -1,    13,    -1,    -1,    -1,    17,
      -1,    19,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    53,    54,    55,    -1,    57,
      -1,    -1,   775,    61,    62,    63,    64,    -1,    -1,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,    -1,
     775,    -1,    80,    -1,    -1,    83,    84,    85,    86,    -1,
      -1,    -1,    -1,    -1,    92,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,    -1,   452,    -1,   106,    -1,
      -1,    -1,    -1,    -1,    -1,   775,    -1,    -1,    -1,    -1,
     118,   119,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
     775,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,
      -1,   149,   150,   151,    -1,   153,   154,   155,   156,    -1,
      -1,    -1,    -1,   775,    -1,    -1,    -1,   165,    -1,    -1,
      -1,   169,   170,    -1,   172,   173,   174,    -1,    -1,   177,
     178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,    -1,    -1,   205,   206,   207,
     208,   209,   210,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,    -1,   230,   231,   775,    -1,   234,   235,    -1,    -1,
      -1,   239,    -1,    -1,    -1,    -1,   244,   245,   246,    -1,
      -1,    -1,   250,    -1,   252,    -1,    -1,   255,    -1,    -1,
      -1,   259,   260,   261,    -1,   263,    -1,    -1,   266,   267,
     268,    -1,    -1,    -1,    -1,    -1,    -1,   275,   276,    -1,
      -1,   279,    -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   775,    -1,    -1,    -1,   293,    -1,    -1,    -1,    -1,
     298,   299,   300,    -1,    -1,   303,    -1,    -1,    -1,    -1,
      -1,   309,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,
      -1,    -1,   320,   321,   322,    -1,    -1,    -1,    -1,    -1,
     328,    -1,     3,     4,     5,     6,    -1,    -1,    -1,    -1,
      -1,    -1,    13,    -1,    -1,    -1,   344,    18,    19,    -1,
      -1,   349,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   360,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
      61,    62,    63,    64,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   411,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,   775,
      -1,   429,   430,    -1,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,   119,   120,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   129,   130,
     131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,   150,
     151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   160,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   186,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   220,
      -1,   549,    -1,    -1,    -1,    -1,     3,    -1,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      17,    18,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
     578,   579,   580,   581,   582,    -1,    -1,    -1,    -1,   587,
     261,   262,    -1,   264,    -1,   266,    -1,    -1,   269,   270,
     271,    -1,    -1,    -1,   275,   276,    -1,    -1,   279,    -1,
     281,    -1,    -1,    -1,    61,    62,    63,    64,    -1,    66,
      -1,    -1,   293,   294,    -1,    -1,    -1,    -1,    -1,    -1,
     628,   629,    -1,    -1,    -1,    -1,   307,     3,    -1,    -1,
       6,    -1,    -1,    -1,    -1,   316,    -1,    -1,   319,   320,
      -1,    -1,    18,     3,    -1,    -1,     6,   328,   329,   330,
     107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    18,    -1,
      -1,   118,   119,   120,   672,   673,    -1,    -1,   349,    -1,
      -1,    -1,   129,   130,   131,    -1,    -1,   134,    -1,   360,
      -1,    -1,    -1,    -1,    -1,    61,    62,    63,    64,    -1,
      66,    -1,   149,   150,   151,    -1,    -1,    -1,    -1,    -1,
     708,    61,    62,    63,    64,    -1,    66,    -1,   716,   717,
     718,   719,   720,   721,    -1,   172,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,   107,   108,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   118,   119,   120,    -1,    -1,   107,   108,    -1,
      -1,    -1,    -1,   129,   130,   131,    -1,    -1,   118,   119,
     120,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,   129,
     130,   131,    93,   149,   150,   151,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
     150,   151,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,   262,    -1,   264,    -1,   266,
     186,    -1,   269,   270,   271,    -1,    -1,    -1,   275,   276,
      -1,    -1,    -1,    -1,   281,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   293,   294,    -1,    -1,
      -1,    -1,    -1,    -1,   220,    -1,    -1,    -1,    -1,    -1,
     307,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   316,
     220,    -1,   319,   320,    -1,    -1,    -1,    -1,   549,    -1,
      -1,   328,   329,   330,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,   261,   262,    -1,   264,    -1,
     266,    -1,   349,   269,   270,   271,    -1,    -1,    -1,   275,
     276,   261,   262,   360,   264,   281,   266,    -1,    -1,   269,
     270,   271,    -1,    -1,    -1,   275,   276,   293,   294,    -1,
      -1,   281,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,   307,    -1,   293,   294,    -1,    -1,    -1,    -1,    -1,
     316,    -1,    -1,   319,   320,    -1,    -1,   307,    -1,    -1,
      -1,    -1,   328,   329,   330,    -1,   316,    -1,    -1,   319,
     320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   328,   329,
     330,    -1,    -1,   349,    -1,   432,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   360,    -1,    -1,    -1,   364,   349,
      -1,   367,    -1,    -1,    -1,    -1,    -1,   318,    -1,    -1,
     360,    -1,    -1,    -1,   364,    -1,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,    -1,   558,    -1,    -1,   716,   717,   718,   719,   720,
     721,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   519,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   549,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,     7,    -1,    -1,    72,    -1,    -1,    13,    -1,    -1,
      -1,    -1,    -1,    19,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    94,    -1,    -1,   685,
     686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   549,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    57,    -1,    -1,    -1,    61,    62,    63,    64,   549,
      66,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   144,    83,    -1,    -1,
      86,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   107,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,    -1,   118,   119,    -1,    -1,    -1,   185,    -1,    -1,
      -1,    -1,    -1,   779,    -1,    -1,    -1,    -1,    -1,   716,
     717,   718,   719,   720,   721,   203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,   216,    -1,
      -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   169,   170,    -1,    -1,   173,   174,    -1,
     176,   177,   178,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   187,   188,   251,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,    -1,    -1,   205,
     206,   207,   208,   209,   210,    -1,    -1,    -1,    -1,    -1,
     716,   717,   718,   719,   720,   721,   222,   223,   224,   225,
     226,   227,   228,   251,    -1,    -1,   716,   717,   718,   719,
     720,   721,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,    -1,    -1,    -1,   252,    -1,    -1,    -1,
      -1,    -1,    -1,   259,    -1,   261,    -1,   263,    -1,    -1,
     266,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   279,    -1,   281,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   298,   299,    -1,    -1,    -1,   303,    -1,    -1,
      -1,    -1,    -1,   309,    -1,    -1,    -1,    -1,    -1,    -1,
     316,    -1,    -1,   319,   320,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   328,   329,    -1,    -1,    -1,    -1,   779,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   421,   360,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   439,    -1,   401,   402,   403,   404,   405,    -1,   447,
     448,    -1,    -1,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   429,   430,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,   144,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,   185,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    -1,   549,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   215,   216,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   587,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   684,   685,   686,   687,
     688,   689,   690,   629,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,   695,
     696,   697,   698,   699,   700,   701,   702,   703,   704,   251,
     706,   707,   708,   203,   710,   773,   712,   713,   714,   777,
      -1,   779,    -1,   781,    -1,   215,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
     778,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     439,    -1,   251,    -1,    -1,    -1,    -1,    -1,   447,   448,
      -1,    -1,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   471,   472,    -1,   474,   475,   476,   477,   478,
     479,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,   439,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,    -1,
      -1,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,    -1,   474,   475,   476,   477,   478,   479,
      72,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    93,    94,    -1,    -1,    -1,   558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   684,   685,   686,   687,   688,
     689,   690,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   144,    -1,    -1,    -1,    -1,    -1,   558,    -1,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,   203,    -1,    -1,   773,    -1,    -1,    -1,   777,    -1,
     779,    -1,   781,   215,   216,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,    72,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,
      93,    94,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   684,   685,   686,   687,   688,   689,
     690,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   144,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    48,   775,    -1,   777,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    93,    -1,    -1,
     203,    -1,    -1,   773,    -1,    -1,    -1,   777,    -1,   779,
      -1,   781,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   775,    -1,   777,   401,
     402,   403,   404,   405,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   421,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   439,    -1,   251,
      -1,    -1,    -1,    -1,    -1,   447,   448,    -1,    -1,    -1,
      -1,   453,   454,   455,   456,   457,   458,   459,   460,   461,
     462,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,    -1,   474,   475,   476,   477,   478,   479,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    -1,    -1,   439,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   447,   448,    -1,    -1,    -1,    -1,
     453,   454,   455,   456,   457,   458,   459,   460,   461,   462,
     463,   464,   465,   466,   467,   468,   469,   470,   471,   472,
      -1,   474,   475,   476,   477,   478,   479,    72,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    93,    94,
      -1,    -1,    -1,   558,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   684,   685,   686,   687,   688,   689,   690,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   144,
      -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,
     185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,
      -1,   773,    -1,    -1,    -1,   777,    -1,   779,    93,   781,
     215,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   251,    93,    94,    -1,
      -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   684,   685,   686,   687,   688,   689,   690,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,    -1,
     775,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,
     773,    -1,    -1,    -1,   777,    -1,   251,    -1,    -1,   215,
     216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   775,    -1,   777,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   318,   439,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   447,   448,    -1,    -1,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,    -1,   474,
     475,   476,   477,   478,   479,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    -1,
      -1,    -1,    -1,   558,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   421,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   439,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   447,   448,    -1,    -1,    -1,    -1,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,    -1,   474,   475,
     476,   477,   478,   479,    -1,    93,    94,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    93,    94,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,   684,
     685,   686,   687,   688,   689,   690,   144,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,   136,   558,    -1,    -1,    -1,    -1,    -1,    -1,   144,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   203,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   215,   216,    -1,
     185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   773,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,   203,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     215,   216,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,   257,    -1,    -1,    -1,    -1,    -1,   684,   685,
     686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,   777,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   773,    -1,    -1,
      -1,   777,    -1,   779,    -1,   781,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   421,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,   439,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,
     448,    -1,    -1,    -1,    -1,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,    -1,   474,   475,   476,   477,
     478,   479,   447,   448,    -1,    -1,    -1,    -1,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   251,    -1,    -1,   474,
     475,   476,   477,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,   136,    -1,    -1,    -1,
     558,    -1,    -1,    -1,   144,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    -1,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      94,    -1,    -1,   203,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   215,   216,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   618,    -1,    -1,   401,   402,   403,   404,
     405,    -1,   136,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     144,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   684,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   185,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    -1,    -1,   203,
      -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   215,   216,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   773,    -1,   251,    -1,   777,
      -1,    -1,    -1,   257,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    -1,
      -1,    -1,   777,   558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,    -1,
      -1,    -1,    -1,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   251,    -1,    -1,   474,   475,   476,   477,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,   447,   448,    -1,    -1,    -1,   558,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   251,    -1,    -1,
     474,   475,   476,   477,    93,    94,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     775,    -1,   777,    -1,    -1,    -1,    93,    94,   618,    -1,
      -1,   401,   402,   403,   404,   405,    -1,   136,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,   136,
      -1,    -1,    -1,    -1,   558,    -1,    -1,   144,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   185,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    93,   203,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   215,   216,   185,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   618,    -1,   203,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,    -1,   215,   216,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,   257,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    -1,   251,    93,    -1,   777,   558,    -1,
     257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
      -1,    -1,    -1,   777,   558,    93,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,   447,   448,
      -1,    -1,    -1,    -1,   453,   454,   455,   456,   457,   458,
     459,   460,   461,   462,   463,   464,   465,   466,   467,   468,
     469,   470,   251,    93,    -1,   474,   475,   476,   477,    -1,
     447,   448,    -1,    -1,    -1,    -1,   453,   454,   455,   456,
     457,   458,   459,   460,   461,   462,   463,   464,   465,   466,
     467,   468,   469,   470,    -1,    93,   776,   474,   475,   476,
     477,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   251,    -1,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    93,    -1,    -1,    -1,
      -1,   558,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   775,    -1,   777,    -1,    -1,    -1,    -1,    -1,   618,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,   251,    93,    -1,    -1,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    -1,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    93,    -1,    -1,    -1,   777,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     777,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    93,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,   775,    -1,   777,    93,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   251,    -1,    -1,    -1,    -1,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    93,    -1,   775,    -1,   777,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,   775,    -1,   777,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,   251,    93,    -1,    -1,
      -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    93,    -1,   775,    -1,   777,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   251,    -1,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,   775,    93,   777,    -1,    -1,
      -1,   558,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,   775,    -1,   777,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   251,    93,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    93,    -1,   775,    -1,
     777,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    -1,    -1,    -1,    93,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,   777,    93,
      -1,    -1,    -1,   558,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     777,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    93,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,   777,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,   251,    -1,    -1,
      -1,    -1,   558,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    93,    -1,    -1,   777,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     775,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    93,
      -1,   558,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,    -1,    -1,   775,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,   251,    93,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    93,    -1,    -1,   775,
      -1,   558,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,   775,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   251,    -1,    93,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    93,    -1,
      -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    -1,    -1,   775,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   251,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    -1,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,   775,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,   775,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
     775,   558,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   775,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    48,    -1,
      -1,    -1,    -1,    -1,   558,    93,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    -1,    -1,    -1,    -1,   775,    -1,    -1,
      48,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    93,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    72,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    93,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    48,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    72,    -1,
      -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,   685,   686,   687,   688,   689,   690,    -1,   775,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
      -1,    -1,    -1,   251,   558,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    -1,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    48,
      -1,   251,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   775,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,   323,    -1,    -1,   685,   686,
     687,   688,   689,   690,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    -1,    -1,   352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   323,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    72,    -1,   251,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   775,    -1,    -1,
      -1,    -1,   352,    48,    -1,   323,    93,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    72,   775,    -1,
      -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    48,   323,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   775,    72,   401,   402,   403,   404,   405,   352,    52,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,
     775,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,   251,    -1,    -1,    -1,    93,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,   352,    -1,    -1,   251,    -1,   558,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    -1,    -1,    -1,   352,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   251,    -1,
      -1,    -1,    -1,    -1,   558,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    48,    -1,    -1,   352,    -1,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      48,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,   352,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    93,    -1,    -1,   122,    -1,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,   122,    -1,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   352,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
      -1,   558,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   251,    -1,    -1,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   251,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    93,    -1,    -1,    -1,    -1,    -1,   558,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    72,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      52,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     251,    93,   685,   686,   687,   688,   689,   690,    -1,    -1,
       4,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    57,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   251,    -1,
      -1,    -1,    86,    -1,   558,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,   118,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   135,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,   318,    -1,    -1,    -1,   251,
     154,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,   165,    -1,    -1,   168,    -1,    -1,    -1,   172,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
      -1,    -1,    -1,   187,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    72,    -1,   210,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   221,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,   401,   402,
     403,   404,   405,    72,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    93,   259,    -1,   261,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    72,    -1,    -1,   299,   300,   558,    -1,   401,
     402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   318,
      -1,    -1,    -1,   251,    -1,   558,    -1,    -1,    -1,    -1,
      -1,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   409,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    72,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    93,    -1,    -1,    -1,    -1,    -1,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,    72,   401,   402,   403,
     404,   405,   685,   686,   687,   688,   689,   690,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,    -1,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,   640,   641,   642,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
      -1,    -1,    -1,    -1,   558,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,   251,    -1,    -1,    -1,    -1,
     558,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    72,    -1,    -1,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    72,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    93,    -1,    -1,    -1,    -1,   558,    72,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    72,    -1,    -1,    -1,    -1,    -1,   558,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   251,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    72,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   251,    93,    -1,    -1,
      -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    72,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   251,    93,    -1,    -1,    -1,    -1,    72,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    93,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,    -1,    -1,   685,
     686,   687,   688,   689,   690,    72,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,   251,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     251,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    -1,    -1,    -1,   251,    -1,   558,    72,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,    -1,
      93,    -1,    -1,    -1,    -1,   558,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    72,    -1,    -1,
      -1,    -1,    -1,   558,    -1,   401,   402,   403,   404,   405,
      -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    72,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    93,    -1,    -1,    -1,    -1,   558,    72,
     401,   402,   403,   404,   405,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,   404,
     405,    -1,   685,   686,   687,   688,   689,   690,    72,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   251,    93,
     685,   686,   687,   688,   689,   690,    -1,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,
      -1,    -1,   558,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   251,    -1,    93,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,   251,    -1,    -1,    -1,    -1,    -1,   558,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,   251,    -1,
      -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,    -1,   251,    -1,   685,
     686,   687,   688,   689,   690,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
      -1,   558,    -1,   106,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,    -1,   251,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,    -1,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,   318,    -1,    -1,    -1,    -1,    -1,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   158,
     159,    -1,    -1,    -1,    -1,   558,    -1,   401,   402,   403,
     404,   405,   144,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,    -1,    -1,    -1,
      -1,    -1,    -1,   558,    -1,    -1,   401,   402,   403,   404,
     405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   251,    -1,    -1,    -1,    -1,    -1,   558,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   251,
      -1,    -1,    -1,    -1,    -1,   558,    93,    -1,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
      -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,    -1,    93,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   144,    -1,    -1,
     685,   686,   687,   688,   689,   690,   318,    -1,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
      93,    -1,    -1,   558,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,    -1,    -1,   158,   159,    93,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,   685,   686,   687,   688,   689,   690,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    -1,   158,   159,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   251,    93,    -1,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   510,   511,   512,
     513,   514,   515,   516,   517,   518,    -1,    -1,    -1,   522,
     523,   524,   525,   526,   527,   528,   529,   530,    -1,    -1,
     533,   534,   535,   536,   537,   538,   539,   251,    -1,    -1,
      -1,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,    -1,
     685,   686,   687,   688,   689,   690,   559,   560,   561,   562,
     563,   318,    -1,   566,   567,   568,   569,   570,   571,   572,
     573,   574,   575,   576,   577,    -1,    -1,    -1,   251,    -1,
     583,   584,   585,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,   251,    -1,    -1,    -1,    -1,   558,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
      -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,   655,   251,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,   403,
     404,   405,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   251,    -1,    -1,   144,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     318,    93,    -1,    -1,    -1,    -1,    -1,    -1,   401,   402,
     403,   404,   405,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    93,    -1,   401,   402,   403,   404,   405,    -1,
      -1,    -1,    -1,   685,   686,   687,   688,   689,   690,   318,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
      -1,   558,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,    -1,    -1,
      -1,    -1,    -1,    -1,   558,    -1,    93,    -1,    -1,    -1,
      -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   251,
      -1,    -1,    -1,    -1,    -1,   558,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
     251,   558,   159,    93,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    93,    -1,    -1,    -1,    -1,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,   685,   686,   687,   688,   689,   690,   318,    -1,   159,
      -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,   251,    -1,    -1,    -1,    -1,   558,
      -1,    -1,   685,   686,   687,   688,   689,   690,    -1,    -1,
      -1,   159,    93,    -1,    -1,    -1,    -1,    -1,    -1,   401,
     402,   403,   404,   405,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,   251,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   251,    93,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,
      -1,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     251,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,    -1,
      -1,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,
     251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   401,   402,   403,   404,   405,    -1,    -1,
      -1,    -1,   251,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,
      -1,   558,    -1,   685,   686,   687,   688,   689,   690,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,
     401,   402,   403,   404,   405,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   533,   534,   535,   536,   537,
     538,   539,   540,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,
     558,    -1,   401,   402,   403,   404,   405,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,
     687,   688,   689,   690,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,
     690,    -1,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,   544,   545,   546,   547,   548,   549,   550,
     551,    -1,    -1,    -1,    -1,    -1,    -1,   558,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,
     688,   689,   690,    -1,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,    -1,    -1,    -1,    -1,    -1,    -1,   558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   685,   686,   687,   688,   689,   690,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   686,   687,   688,
     689,   690
  };

  const short
  parser::yystos_[] =
  {
       0,    14,    15,    16,    40,    41,    42,    43,    44,    48,
      56,    67,    68,    69,    73,    75,    76,    77,    78,    79,
      90,    91,    93,   100,   106,   122,   123,   124,   125,   135,
     137,   138,   152,   171,   180,   182,   211,   212,   213,   214,
     217,   229,   243,   251,   256,   277,   278,   280,   282,   283,
     291,   296,   297,   301,   302,   305,   306,   331,   332,   335,
     336,   337,   338,   340,   345,   348,   353,   354,   357,   361,
     362,   363,   366,   368,   369,   370,   371,   372,   401,   402,
     403,   404,   405,   407,   414,   415,   416,   418,   419,   420,
     422,   423,   424,   425,   426,   427,   428,   434,   435,   440,
     480,   481,   515,   520,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   558,   590,   591,   594,   595,   597,   598,
     599,   600,   601,   602,   610,   615,   616,   617,   623,   645,
     646,   678,   679,   685,   686,   687,   688,   689,   690,   694,
     735,   737,   738,   739,   740,   741,   745,   767,   768,   772,
     774,   784,   785,   786,   794,   795,   797,   799,   803,   804,
     807,   810,   814,   818,   819,   820,   821,   822,   823,   825,
     826,   831,   834,   835,   839,   842,   845,   850,   853,   856,
     862,   870,   873,   885,   886,   888,   890,   897,   900,   910,
     911,   914,   917,   924,   927,   930,   933,   936,   939,   942,
     945,   948,   949,   952,   955,   958,   968,   974,   977,   980,
     983,   989,   990,   993,   994,   995,   997,  1009,  1010,  1011,
    1014,  1015,  1016,  1025,  1028,  1031,  1032,  1035,  1038,  1039,
    1041,  1044,  1045,  1046,  1047,  1048,  1049,  1052,  1058,  1061,
    1062,  1063,  1066,  1069,  1072,  1075,  1078,  1081,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1100,  1103,  1104,
    1107,  1110,  1113,  1116,  1119,  1122,  1125,  1128,  1129,  1140,
    1143,  1146,  1149,  1150,  1153,  1157,  1160,  1166,  1169,  1171,
    1174,  1177,  1180,  1184,  1187,  1192,  1722,   144,   777,   144,
     777,   777,   775,   777,   787,  1722,   777,   775,   777,   777,
     775,   777,   775,   777,   787,   144,   777,   777,   775,   777,
     775,   777,   787,   775,   777,   775,   775,   777,   775,   777,
     777,   775,   777,   775,   777,   787,   777,   775,   777,   777,
     775,   777,   775,   777,   775,   777,   777,   775,   777,   777,
     777,   775,   775,   777,   318,   777,  1053,  1057,  1722,   775,
     777,   775,   777,   775,   775,   775,   775,   777,   775,   775,
     775,   775,   777,   787,   787,   777,   793,  1722,  1059,   777,
     787,   775,   777,   775,   777,   775,   777,   775,   777,   787,
     777,   775,   777,   775,   777,   775,   777,   787,   775,   777,
     775,   777,   775,   777,   775,   775,   777,   775,   777,   787,
     775,   777,   787,   775,   777,   775,   777,   787,   775,   775,
     777,   787,   775,   777,   775,   777,   775,   777,   775,   777,
     775,   777,   787,   787,   777,   793,   777,   793,   793,  1026,
    1029,   787,   777,   775,   777,   787,   789,  1722,   775,   777,
     775,   777,   775,   777,   775,   777,   777,   777,   775,   777,
     775,   777,   777,   775,   777,   775,   777,   777,   775,   777,
     787,   775,   777,   775,   777,   775,   777,   775,   777,   775,
     777,   775,   777,   901,   777,   775,   777,   775,   777,   777,
     777,   775,   777,   775,   777,   775,   787,   777,   777,   777,
     787,   775,   775,   777,   775,   777,   775,   777,   787,   782,
       0,   785,    74,   777,    74,    74,    74,   782,   775,    22,
      23,    24,    28,    29,    30,    31,    46,    57,    86,   259,
     260,   299,   300,   429,   430,  1097,  1098,  1099,  1250,  1256,
    1263,  1287,  1288,  1364,  1365,  1372,  1373,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,   775,    34,    45,   106,  1098,  1101,
    1102,  1314,  1350,  1424,   144,    84,    85,   154,   156,   172,
     221,   292,   578,   579,   580,   581,   582,   673,  1158,  1159,
    1250,  1256,  1263,  1287,  1341,  1354,  1357,  1359,  1364,  1365,
    1366,  1379,  1480,  1548,  1549,  1550,  1551,  1552,  1630,    52,
     775,  1722,   291,   414,   415,   416,   824,   121,   126,   127,
     128,   160,   161,   183,   186,   271,   320,   349,   746,   750,
     926,   928,   929,  1196,  1219,  1227,  1228,  1230,  1239,  1363,
    1475,  1476,  1477,  1478,  1632,  1656,    45,    47,   294,   329,
    1147,  1148,  1201,  1214,  1316,  1479,  1480,   414,  1151,  1152,
    1722,    20,    21,    27,    32,    33,    98,   119,   162,   163,
     261,   433,   471,   734,   736,  1138,  1139,  1301,  1304,  1307,
    1310,  1396,  1400,  1401,  1404,  1405,  1406,  1409,  1414,  1416,
    1628,   775,   144,   775,  1053,  1053,   840,   841,  1722,    36,
     747,     3,     4,     6,     7,     9,    13,    17,    19,    37,
      45,    53,    54,    55,    61,    62,    63,    64,    80,    83,
      86,    92,   118,   119,   120,   145,   149,   150,   151,   153,
     155,   165,   169,   170,   173,   174,   177,   178,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   205,   206,   207,   208,   209,   210,
     219,   220,   222,   223,   224,   225,   226,   227,   228,   230,
     231,   234,   235,   239,   244,   245,   246,   250,   252,   255,
     261,   263,   266,   267,   268,   275,   276,   279,   281,   293,
     298,   303,   309,   317,   321,   322,   328,   344,   360,   411,
     549,   587,   628,   629,   672,   708,   716,   717,   718,   719,
     720,   721,  1017,  1018,  1196,  1200,  1203,  1208,  1209,  1239,
    1250,  1254,  1255,  1256,  1260,  1261,  1262,  1271,  1287,  1288,
    1289,  1290,  1291,  1300,  1306,  1315,  1317,  1318,  1319,  1320,
    1321,  1322,  1323,  1324,  1325,  1326,  1327,  1328,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,
    1341,  1343,  1344,  1345,  1346,  1347,  1348,  1349,  1350,  1351,
    1352,  1353,  1354,  1355,  1356,  1357,  1358,  1359,  1364,  1365,
    1366,  1367,  1368,  1369,  1370,  1371,  1372,  1373,  1374,  1375,
    1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,  1386,  1388,
    1389,  1390,  1391,  1392,  1393,  1394,  1425,  1426,  1427,  1428,
    1429,  1430,  1431,  1432,  1433,  1434,  1435,  1436,  1481,  1542,
    1548,  1549,  1550,  1551,  1552,  1553,  1554,  1597,  1599,  1600,
    1601,  1602,  1603,  1604,  1606,  1607,  1608,  1629,  1630,  1646,
    1650,  1651,  1652,  1653,  1654,  1655,   775,    48,   323,   352,
     969,   970,   971,  1722,   288,    48,   352,   978,   979,  1722,
      48,   352,   975,   976,  1722,    12,   132,   133,   281,   350,
     431,  1167,  1168,  1214,  1215,  1216,  1217,  1218,  1623,    95,
     988,   984,   985,  1722,   101,   102,   103,   104,   105,   851,
     852,  1144,  1145,  1214,  1290,  1300,  1306,  1315,   775,  1722,
     843,   844,  1722,    36,    59,    82,    86,    87,    88,    89,
     836,   837,  1249,  1250,  1251,  1256,  1263,  1264,  1265,  1266,
    1269,  1270,  1141,  1142,  1722,   764,     5,   157,   168,   284,
     285,   308,   409,   410,   486,   722,   723,   724,   725,   726,
     727,   728,   729,   730,   731,   732,   733,  1050,  1051,  1200,
    1201,  1203,  1214,  1289,  1290,  1300,  1306,  1336,  1349,  1357,
    1360,  1379,  1442,  1466,  1470,  1471,  1472,  1473,  1474,  1480,
    1597,  1598,  1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,
    1665,  1666,  1667,  1668,   832,   833,  1722,    36,   836,  1175,
    1176,  1722,  1355,  1053,   181,   854,   874,     8,    11,    35,
      49,    71,   166,   258,   290,   408,   558,   765,   771,   871,
     872,   184,  1361,   777,    52,   775,  1053,   742,   743,   744,
     931,   932,  1669,  1670,  1671,   414,   895,   920,   288,   747,
     766,   918,   919,  1172,  1173,  1722,  1036,  1037,  1722,    72,
     251,  1163,  1164,  1161,  1162,  1425,  1426,  1033,  1034,  1722,
    1033,  1040,  1722,    18,    66,    99,   107,   129,   130,   131,
     160,   186,   262,   264,   269,   270,   307,   316,   319,   330,
     960,  1042,  1043,  1196,  1200,  1201,  1202,  1203,  1204,  1205,
    1206,  1207,  1208,  1209,  1210,  1211,  1212,  1214,  1223,  1224,
    1229,  1237,  1238,  1239,  1255,  1260,  1290,  1300,  1306,  1324,
    1349,  1353,  1355,  1362,  1363,  1381,  1382,  1390,  1391,  1392,
    1393,  1394,  1425,  1426,  1531,  1532,  1542,  1597,  1598,  1604,
    1605,  1650,  1651,  1652,  1653,  1654,  1655,   775,   775,   771,
      52,   775,  1722,   400,   777,   791,   792,    94,   144,   185,
     203,   215,   216,   421,   439,   447,   448,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   474,   475,   476,
     477,   478,   479,   684,   773,   777,   881,   963,  1054,  1722,
     294,   775,    87,    88,   751,   934,   935,  1214,  1250,  1267,
    1268,  1610,   160,   161,   175,   186,   204,   265,   343,   347,
     351,   752,   753,   754,   755,   756,   757,   758,   759,   760,
     761,   762,   763,   937,   938,  1196,  1197,  1198,  1199,  1220,
    1225,  1226,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1342,
    1362,  1363,  1609,  1611,  1612,  1613,  1614,  1615,  1616,  1617,
    1623,   940,   941,  1214,  1250,  1267,  1268,   676,   938,   943,
     944,  1631,   775,  1053,    48,   414,   891,   892,   893,   895,
     288,   677,   747,   771,   414,   898,   899,   288,   106,   253,
     266,   339,   433,   736,  1132,  1133,  1250,  1256,  1263,  1287,
    1293,  1294,  1295,  1309,  1341,  1359,  1364,  1365,  1379,  1480,
    1626,  1627,   775,   318,  1181,  1182,  1722,   251,   935,   938,
     953,   954,   142,   143,   286,   287,   295,  1178,  1179,  1618,
    1619,  1620,  1621,  1622,  1154,   925,   926,   134,   432,   519,
     959,   960,   961,  1213,  1221,  1341,  1481,  1482,   775,   106,
     254,   300,   664,  1134,  1135,  1250,  1256,  1263,  1293,  1296,
    1297,  1298,  1299,  1309,  1480,  1626,  1627,   775,   108,   364,
     365,  1084,  1085,  1384,  1385,  1543,   960,  1086,  1087,  1384,
    1543,   775,  1064,   186,   367,  1082,  1083,  1087,  1222,  1596,
     775,    66,   294,  1067,  1068,  1672,  1673,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,  1070,  1071,  1674,  1675,  1676,  1677,
    1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,  1687,
    1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,  1697,
    1698,  1699,  1700,  1073,  1074,  1674,  1675,  1676,  1677,  1678,
    1679,  1680,  1681,    82,   294,   340,   344,  1076,  1077,  1701,
    1702,  1703,  1704,   260,  1079,  1080,  1705,   775,   775,   179,
     454,   592,   771,   775,   771,   775,   775,  1027,  1722,  1030,
    1722,   775,    81,   274,   289,   417,   473,   589,   674,   815,
     816,    20,    21,    25,    26,    27,    32,    33,    38,    39,
      98,   119,   162,   163,   261,   266,   471,   520,   734,  1136,
    1137,  1292,  1302,  1303,  1305,  1308,  1395,  1397,  1398,  1399,
    1402,  1403,  1407,  1408,  1410,  1411,  1412,  1413,  1415,  1626,
    1627,   775,    52,   775,  1722,   400,   242,   242,   242,   274,
     675,   715,   805,   806,  1248,  1252,  1253,   811,   274,   334,
     715,   808,   809,  1257,  1258,  1259,   135,   482,   483,   484,
     485,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   640,   641,   642,  1130,  1131,  1203,
    1250,  1256,  1263,  1287,  1288,  1289,  1290,  1300,  1306,  1315,
    1317,  1330,  1341,  1357,  1379,  1437,  1438,  1439,  1440,  1441,
    1442,  1443,  1444,  1445,  1446,  1447,  1448,  1449,  1450,  1451,
    1452,  1453,  1454,  1455,  1456,  1457,  1458,  1459,  1460,  1461,
    1462,  1463,  1464,  1465,  1467,  1468,  1469,  1470,  1471,  1597,
    1598,  1130,    58,    86,    89,   259,   991,   992,  1240,  1249,
    1264,  1270,  1272,  1364,  1365,  1185,  1186,  1722,   251,   510,
     511,   512,   513,   514,   515,   516,   517,   518,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   533,   534,   535,
     536,   537,   538,   539,   559,   560,   561,   562,   563,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   583,   584,   585,   655,  1105,  1106,  1250,  1350,  1485,
    1486,  1487,  1488,  1489,  1490,  1491,  1492,  1493,  1494,  1495,
    1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,  1505,
    1507,  1508,  1509,  1510,  1511,  1512,  1513,  1514,  1515,  1516,
    1517,  1518,  1519,  1520,  1521,  1522,  1523,  1524,  1525,  1526,
    1527,  1528,  1529,  1530,  1559,   593,   333,   355,   356,   588,
     589,   630,   631,   633,   634,   636,   637,   638,   643,   654,
    1114,  1115,  1555,  1556,  1558,  1575,  1583,  1584,  1585,  1588,
    1589,  1590,  1591,  1592,  1593,  1594,   775,   632,  1108,  1109,
    1555,  1556,  1558,  1575,  1583,  1584,  1585,  1587,  1588,  1589,
    1590,  1591,  1593,  1594,   531,   635,   656,   657,   658,   659,
     660,   661,   662,   663,   665,   666,   667,   668,   669,   670,
     671,  1126,  1127,  1250,  1364,  1365,  1485,  1486,  1487,  1488,
    1489,  1495,  1496,  1497,  1499,  1503,  1504,  1505,  1506,  1555,
    1556,  1557,  1559,  1560,  1561,  1562,  1563,  1564,  1565,  1566,
    1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,    66,   196,
     273,   653,  1123,  1124,  1483,  1484,  1555,  1556,  1575,  1576,
    1577,   648,   649,   650,   651,   652,  1120,  1121,  1555,  1556,
    1558,  1578,  1579,  1580,  1581,  1582,   644,  1117,  1118,  1555,
    1556,  1585,  1586,   639,  1111,  1112,  1555,  1556,  1558,  1575,
    1583,  1584,  1588,  1589,  1590,  1591,  1592,  1593,  1594,  1595,
     775,   291,   586,   611,   612,   613,   614,   912,   913,  1533,
    1534,  1535,  1536,  1537,  1538,   846,   619,   620,   622,   915,
     916,  1533,  1539,  1540,  1541,   624,   625,   626,   627,   956,
     957,  1544,  1545,  1546,  1547,   304,   647,   950,   951,  1624,
    1625,   950,   857,  1722,   176,   695,   696,   697,   698,   699,
     700,   701,   702,   703,   704,   706,   707,   710,   712,   713,
     714,   946,   947,  1200,  1201,  1202,  1238,  1239,  1250,  1254,
    1255,  1256,  1262,  1263,  1287,  1290,  1300,  1306,  1317,  1318,
    1319,  1320,  1321,  1322,  1323,  1324,  1325,  1327,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,
    1343,  1345,  1349,  1355,  1360,  1363,  1364,  1365,  1367,  1368,
    1369,  1370,  1371,  1374,  1375,  1376,  1377,  1378,  1380,  1381,
    1383,  1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,  1394,
    1531,  1532,  1542,  1554,  1601,  1603,  1633,  1634,  1635,  1636,
    1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,  1649,   775,   318,   779,   880,   889,  1722,   889,
     872,   775,   971,   981,   982,  1656,   414,   415,  1188,  1189,
    1190,   288,  1193,  1194,  1195,  1722,   288,   775,   551,    48,
     122,   995,  1722,   996,  1313,  1722,    48,   122,  1010,  1722,
      48,   122,  1015,  1722,   136,   185,   203,   215,   216,   257,
     447,   448,   453,   454,   455,   456,   457,   458,   459,   460,
     461,   462,   463,   464,   465,   466,   467,   468,   469,   470,
     474,   475,   476,   477,   777,   827,   963,  1054,  1722,   158,
     159,   551,  1722,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    52,   778,    74,    74,
      74,    52,   778,    52,    74,    74,    74,    74,   778,    52,
    1722,   778,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    52,   778,    74,    74,    74,    74,    52,   778,
    1722,    72,  1152,    52,    74,    74,    74,    74,    74,    74,
      74,   778,    52,   775,   778,   778,    72,   841,    74,   748,
     749,   778,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    52,   778,  1722,  1722,    72,   970,    52,   775,
     778,  1722,  1722,    72,   979,    52,  1722,  1722,    72,   976,
      52,   778,    74,    74,   778,    52,   447,   778,    72,   985,
      52,    74,    74,    74,    74,    74,    52,   778,    52,   778,
     778,    72,   844,   777,   778,    74,    74,    74,    74,    74,
      74,    52,   778,    72,  1142,    52,   778,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,   778,    52,    72,   833,    74,   778,   778,
      72,  1176,    52,   777,   778,   778,    74,   855,   881,   779,
     781,   877,   878,   881,   884,    74,    74,    74,    74,    74,
      74,    74,    52,   778,    74,   778,   963,  1053,   777,    52,
     778,  1722,    72,   895,    74,   778,   919,    72,  1173,    52,
      72,  1037,   777,   775,    52,    72,  1164,   778,    52,    72,
    1034,   777,    72,    72,  1722,    52,   827,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    52,   778,    74,
    1722,   400,   792,   792,    52,   790,  1722,    52,   778,   790,
     777,   777,   777,   777,   777,   777,   881,   881,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   777,   777,   881,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   452,  1060,   782,
     882,   325,   326,   327,    74,    74,    74,    52,   778,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    52,   778,    52,   778,    52,
     778,   778,  1722,  1722,    72,   892,    52,   778,    52,   778,
      74,    74,  1722,    72,   899,   778,    74,    74,    74,    74,
     778,    52,    74,    72,  1182,    74,    74,    52,   778,    74,
      74,    74,    74,    74,   778,    52,   779,  1155,  1156,  1722,
      52,   778,    74,    74,    52,   778,    74,    74,    74,    74,
     778,    52,    74,    74,    74,    52,   778,    52,   778,   881,
    1065,    74,    74,    52,   778,    74,    74,   778,    52,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,   778,    52,   778,    52,    74,    74,   778,    52,
     778,    52,    74,    52,   778,    74,    74,    74,    52,   775,
    1722,    52,   775,  1722,    74,    74,    74,    74,    74,    74,
      74,    52,   778,    74,    74,    74,    74,    74,    74,    74,
      74,    74,   778,    52,  1722,   400,   778,   778,   778,    74,
      74,    52,   778,   274,   289,   473,   596,   682,   685,   812,
     813,  1241,  1242,  1243,  1244,  1246,  1247,    74,    74,    74,
      52,   778,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,   778,    52,   778,    74,    74,    74,    74,
      52,   778,    72,  1186,    52,  1722,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      52,   778,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    52,   778,    52,   778,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    52,   778,    74,    74,    74,    52,
     778,    74,    74,    74,    74,    52,   778,    52,   778,    74,
      52,   778,   521,   604,   606,   607,   902,   903,    74,    74,
      74,    74,    74,    74,    52,   778,   251,   847,   848,    74,
      52,   778,    74,    74,    74,    74,    52,   778,    74,    74,
      52,   778,   778,   251,   858,   859,   778,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,   778,
      52,   879,   880,    52,   778,    74,   778,   778,   775,    72,
     982,   778,  1722,  1722,    72,  1189,   294,   778,    72,  1194,
      52,   777,   778,  1000,   777,   777,   775,   782,    52,   778,
      74,   777,   777,   775,   782,   777,   777,   775,   782,   777,
     777,   777,   777,   827,   827,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   777,   777,   777,
     777,   777,   777,   777,   777,   777,   777,   827,   441,   442,
     443,   444,   445,   446,   447,   448,   449,   450,   452,   775,
     828,   777,   998,   782,   963,   447,   448,   963,   964,   963,
     144,   964,   144,  1053,   144,   144,   779,  1710,  1712,  1713,
     144,   144,   318,  1722,  1706,  1722,  1099,   144,   144,   963,
     144,  1102,   144,   318,  1713,   144,   963,    70,   310,   311,
     312,   313,   314,   315,   775,   787,  1158,   787,   144,   144,
     144,   963,   963,   963,   144,   963,   144,   777,   929,   775,
     963,   777,   144,   144,  1148,   775,   775,   775,  1722,  1053,
     436,   437,   438,   546,   547,   548,   550,   777,  1311,   988,
     988,  1722,   144,   775,   787,  1138,   775,   787,   775,   787,
     775,   827,   827,   827,   775,   144,   838,   988,   144,   318,
     963,  1722,   963,   963,   144,   963,   144,  1053,  1710,  1713,
     777,  1311,  1710,  1713,   144,   777,   963,   963,   144,    60,
      96,    97,   346,   963,   963,   963,   963,   963,   963,   963,
     963,   963,   144,   144,  1053,  1053,  1053,   144,   136,   447,
     448,   964,   965,   966,   144,   144,   144,  1722,  1053,   144,
    1713,   779,  1716,  1717,  1717,   144,   552,   553,   554,  1053,
     144,   232,   233,   550,   963,   236,   237,   238,   240,   241,
     144,  1722,   247,   248,   249,   247,   248,   249,   777,   144,
     144,   963,   777,   136,   963,   144,   144,    50,    51,    96,
     777,   144,  1713,   144,   963,   144,  1018,   775,   787,    52,
     775,    10,   117,   146,   147,   148,   272,   406,   565,   827,
     830,   972,   987,   775,    52,    52,   775,   827,    52,    52,
     775,   827,   775,   144,   144,   775,  1167,   144,   775,   775,
     827,   318,   318,   318,   318,   318,   852,   775,  1145,   775,
     787,   782,   775,   144,   447,   448,   962,   775,  1722,  1053,
     988,   144,   988,   144,   988,   144,   988,   837,   775,   775,
     827,   775,   964,   963,   144,   144,   962,   144,   144,   144,
    1053,   144,   144,   144,   963,   963,   963,   144,   144,   775,
    1050,   775,   827,   775,   775,   775,  1722,   144,  1707,   775,
     775,   798,    72,   881,   775,   879,  1722,    72,   878,   884,
      74,   770,   775,   963,   963,   777,   777,   144,   144,  1722,
     871,   775,   164,   218,  1057,   778,   777,   963,   932,   775,
     775,   775,   838,   775,   775,  1722,   775,   962,  1165,  1722,
     775,   775,  1161,   775,   827,   775,   775,    52,   827,  1722,
     775,   963,   144,   144,  1053,   963,   144,   144,   963,   144,
     963,   144,  1043,   775,   787,  1722,   400,   792,   792,   790,
      74,   778,   790,   881,   881,   881,   881,  1722,  1722,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   881,
     881,   881,   881,   881,   962,  1722,   881,   778,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   775,
    1722,   777,   144,   988,   988,   935,   775,   963,   963,   144,
     963,   144,   144,   144,   963,   963,   963,   963,   963,   963,
     144,   963,   777,   938,   775,   941,   775,   944,   775,   775,
      52,    52,    74,   775,   775,   677,   747,   771,   775,   288,
     775,   838,  1722,   775,   775,   775,   358,   359,   144,  1722,
    1722,   775,   787,  1132,  1183,  1722,   775,  1183,  1722,   954,
     775,  1053,   777,  1053,   777,   144,   775,  1178,   787,    72,
    1156,    74,   926,   775,   963,  1713,   961,   775,   787,   144,
    1710,  1713,   144,  1713,   775,   787,  1134,   777,   827,   400,
    1085,   775,  1087,   775,   787,   775,    72,   881,   144,   963,
    1083,   775,   787,   144,   144,   775,  1067,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     775,  1070,   775,  1073,  1053,  1710,  1713,   775,  1076,   775,
     787,  1079,   802,   592,   793,   800,  1722,  1722,  1722,  1722,
     817,  1722,   827,  1722,  1722,   144,  1708,   962,   816,   775,
    1053,   436,   437,   438,   144,   144,   777,  1311,   988,   988,
    1722,   144,   775,   787,  1136,   400,   775,   775,   775,  1722,
     779,  1714,  1715,   806,   775,    74,    74,    74,  1245,    74,
      74,    52,   778,  1722,  1715,  1715,   809,   775,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   963,   144,   779,  1719,   963,   963,   777,   777,   777,
     144,   144,   777,   963,   144,   963,   963,   963,   963,   963,
     775,  1130,   775,  1053,   144,   992,   775,   775,  1722,   775,
    1722,   144,   608,   609,   144,   144,   144,   144,  1053,   144,
     777,   144,   251,   606,   607,   144,   144,   144,   144,   144,
     963,   963,   144,   144,   144,   144,   144,   144,   963,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,  1717,  1106,   775,
     796,   144,  1053,   144,  1053,  1053,  1717,   144,   144,  1717,
     964,   144,  1115,   775,   787,  1109,   775,   532,   550,   963,
     963,   963,   144,   963,   144,   144,   963,   963,   144,   144,
     144,   144,   963,   963,  1127,   775,   144,   144,   144,  1124,
     775,   144,   964,   964,   144,  1121,   775,  1118,   775,   144,
    1112,   775,   603,   605,   621,   775,   775,    72,   903,   779,
     779,  1721,   144,   963,  1719,   144,   144,   913,   775,   849,
      72,   848,  1710,  1713,   916,   775,   318,  1054,  1055,   144,
    1055,  1055,   957,   775,  1053,   144,   951,   775,   775,   318,
      72,   859,   775,   963,   691,   692,   693,   354,   144,  1715,
     963,   144,   144,   963,   144,  1053,   963,   775,   946,    52,
     780,   318,   779,   880,   775,   318,   775,   775,   775,   775,
     775,   775,   775,   144,   921,   922,   988,   775,   775,  1195,
     144,  1707,   775,   777,  1722,  1722,  1313,   775,   988,  1722,
    1722,   551,  1722,  1722,  1722,   159,  1722,   827,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   827,   827,   778,   827,   827,   827,   827,   827,   827,
     827,   827,   827,   827,   827,   777,   139,   140,   141,  1012,
    1013,  1280,  1281,  1282,   777,   159,   551,   963,   963,    52,
     144,  1710,  1711,    52,   780,  1711,   776,   775,   775,   778,
     775,   775,   318,  1019,  1021,  1022,   787,   294,   778,  1311,
    1312,   775,   775,   775,   775,   775,   775,   840,   778,  1312,
     787,   136,   136,    52,   964,    52,   780,   964,  1022,  1022,
     318,  1019,  1023,  1024,   775,  1722,    52,   775,    52,   969,
    1722,   827,    52,  1722,   827,   775,    72,   975,    52,   775,
     158,   159,   551,  1722,   144,   144,   778,   843,    52,   775,
      72,  1141,   775,   832,    52,   776,   778,   778,  1175,   881,
     775,   775,   780,    74,   775,   881,   881,   787,  1053,  1056,
     778,   875,   775,   963,   778,   294,   920,    52,   777,   778,
      52,   775,    74,    72,  1163,   778,  1722,   775,   827,   775,
     778,   792,   318,    52,    52,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,    52,   778,
     778,    52,   778,    52,   778,   778,   778,   778,   778,   881,
     883,   778,   787,  1722,  1722,   827,   352,   778,    74,    74,
      72,   891,   778,   895,   896,    52,   778,    52,   778,   294,
      72,   898,   775,    52,   775,  1722,   775,   778,   787,   787,
     780,   775,   827,   775,   775,   787,   775,   775,   775,   775,
     775,   881,    74,   775,   881,   778,   778,   881,   776,  1312,
     775,    52,   318,    52,   318,   780,  1722,  1722,  1722,    74,
    1722,   686,   687,   688,   869,   813,   775,   966,  1718,   776,
     787,   788,   788,   788,   788,   775,   778,   787,   881,   775,
     144,   144,   775,   775,   787,  1717,  1720,    74,   775,   775,
     775,   863,   880,   879,   887,   415,   414,   776,    52,   775,
     922,   776,  1188,    52,   778,   778,  1193,   109,   110,   111,
     112,   113,   114,   115,   116,   324,  1007,  1008,  1273,  1274,
    1275,  1277,  1278,  1279,  1283,  1284,  1286,  1592,    52,   778,
     776,    52,   778,   782,    52,   778,   782,    52,    52,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,   778,   778,   778,   778,   778,   778,   778,   778,   778,
     778,    52,   778,    52,   778,   827,   829,    74,    74,    74,
      52,   778,   110,   112,  1005,  1006,  1273,  1274,  1275,  1276,
    1278,  1279,  1283,  1284,  1285,  1592,   777,   999,  1711,   776,
     780,  1711,  1722,   775,    52,    52,   778,   778,   921,   782,
      52,   778,    72,   775,   778,   778,   964,   780,   964,   778,
     778,    52,    52,   778,   827,   830,   987,   830,   973,    72,
      52,    52,   827,    52,   775,   775,    72,   827,   777,  1001,
     782,    74,    72,   827,   775,    72,    72,   447,   448,   779,
    1170,   144,    52,    52,    72,   778,   881,   881,   770,   775,
     775,   778,    52,   778,   876,   877,   778,   921,    72,  1170,
     448,   962,  1709,    74,  1722,   964,   775,    72,   775,   827,
     775,   793,   881,   881,   318,   881,   881,   777,    52,   778,
     787,   778,    74,    74,   775,   827,   775,   838,  1722,   775,
      72,   775,    72,   895,   288,   775,   288,   775,   921,   775,
      72,  1722,   775,   778,   778,    74,   775,   778,   778,   801,
     778,   793,   793,   136,   144,   778,   318,   318,   780,   881,
      52,   780,   966,   778,   778,   778,   778,   775,   778,   778,
      52,   775,   780,    52,   780,   827,   402,   403,   404,   405,
     860,   861,   680,   681,   683,   864,   865,   866,   780,   877,
    1722,  1722,   144,   922,   412,   769,  1191,   988,    72,   827,
      52,    52,    72,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    52,   778,  1722,   782,   988,  1722,   782,   551,
    1722,   782,   159,   827,   827,   827,   827,    52,   778,  1719,
     963,   964,  1013,   775,    74,    74,    52,   778,  1012,   777,
     144,    93,   318,   401,   964,   967,  1021,   775,   158,   159,
     551,  1722,  1311,   775,   840,   777,  1715,  1023,    52,    52,
      52,   775,   827,   827,   775,   827,   775,   775,  1012,   777,
     159,   551,   827,   775,   775,   775,   775,   827,   775,  1722,
    1722,   775,   789,    74,   770,   775,   775,   881,  1053,   775,
      72,   775,   775,   775,   777,   776,   778,   778,   827,    74,
     775,   775,   775,   778,   778,    52,   778,    52,    52,   881,
     881,   775,   827,   827,   775,   896,   778,   778,   775,   896,
     775,   778,   896,   778,   414,   893,   894,   775,   775,  1181,
     827,   793,   881,   793,   775,   775,   966,  1185,   789,   904,
     603,   906,  1717,   775,   881,   881,   881,   881,   861,   881,
     881,  1722,    72,   865,    72,   775,   775,   777,   923,   964,
     923,   775,   775,  1722,  1722,   775,   964,  1717,   963,  1721,
     964,  1717,   534,   540,   541,   542,   543,   544,   545,   555,
     564,   986,  1717,  1717,  1008,   775,   778,   778,   551,  1722,
     778,   159,  1722,   778,   778,    52,    52,   827,   964,   827,
    1006,   775,   778,  1005,   412,   777,  1003,   782,    72,   318,
    1019,  1020,   830,   973,   830,    52,   775,   775,   778,  1005,
     777,  1002,   775,    52,    52,    52,   775,   881,   881,   775,
     877,   775,   412,   689,   690,   962,   962,    52,    52,   775,
     964,   144,  1713,   881,   881,   778,   775,   775,    72,   775,
     775,    72,   775,    72,   775,  1722,    72,   893,   412,   413,
      72,   775,   775,   778,   775,    72,   775,   447,   448,   618,
     827,   907,   908,   909,   144,   603,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   827,    52,   775,   777,   964,
     775,   782,   782,   782,   782,   782,   827,   827,   775,   778,
     923,  1012,   777,   159,   551,   775,    52,    52,   778,    52,
      52,   827,   775,   778,  1012,   777,   827,  1170,  1170,   770,
     775,   775,    72,   923,   923,   923,   776,  1170,  1170,   778,
     778,   778,   778,   775,   896,   894,   775,   896,   775,   894,
     775,   775,   923,   923,   775,   793,   775,   618,   618,   777,
     449,    74,   827,   909,    52,   144,   596,   682,   685,   867,
     868,   778,   777,   964,   769,   827,   412,   551,  1722,   551,
     159,  1722,   159,   778,   778,   775,   775,   778,  1005,   777,
    1004,  1019,   987,   830,   775,   775,   778,  1005,   780,   775,
     775,   881,   775,   775,   775,   775,   962,   775,   775,    72,
      72,    72,    72,   775,   775,   775,   777,   777,  1722,   618,
     905,   787,    52,   881,  1722,   869,   868,   827,   923,   778,
     923,   782,   782,   775,   778,  1012,   777,    52,    52,   775,
     778,   775,   778,   775,   775,   775,   775,  1722,  1722,    52,
     777,   907,   775,   787,   775,   775,   775,   778,   775,   775,
     551,   159,   775,   778,  1005,   973,   830,   775,    52,    52,
     144,  1722,   775,   775,   775,   778,    52,   144,   144,   778,
      52,   775,   827,   778,   778,   144,   778
  };

  const short
  parser::yyr1_[] =
  {
       0,   783,   784,   784,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   785,   785,   785,   785,   785,   785,
     785,   785,   785,   785,   786,   786,   787,   787,   787,   788,
     788,   789,   789,   789,   789,   789,   789,   790,   791,   791,
     791,   791,   792,   792,   793,   793,   793,   793,   793,   793,
     793,   793,   793,   793,   793,   793,   794,   796,   795,   798,
     797,   799,   799,   800,   799,   801,   799,   802,   799,   799,
     803,   804,   805,   805,   806,   806,   806,   807,   808,   808,
     809,   809,   809,   811,   810,   812,   812,   813,   813,   813,
     813,   813,   813,   814,   815,   815,   816,   817,   816,   816,
     816,   816,   816,   816,   816,   818,   818,   819,   820,   821,
     821,   822,   823,   824,   824,   824,   824,   825,   826,   827,
     827,   827,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   828,   827,   827,
     827,   827,   827,   827,   827,   827,   827,   829,   829,   830,
     830,   831,   831,   832,   832,   833,   834,   835,   836,   836,
     837,   837,   837,   837,   837,   837,   837,   837,   837,   837,
     838,   838,   839,   839,   839,   840,   840,   841,   841,   841,
     842,   842,   843,   843,   844,   846,   845,   847,   847,   849,
     848,   850,   851,   851,   852,   852,   852,   852,   852,   854,
     853,   855,   855,   857,   856,   858,   858,   859,   860,   860,
     861,   861,   861,   861,   863,   862,   864,   864,   865,   865,
     865,   866,   867,   867,   868,   868,   868,   869,   869,   869,
     870,   870,   871,   871,   871,   871,   871,   871,   871,   871,
     871,   871,   871,   871,   872,   872,   874,   873,   875,   873,
     876,   873,   877,   877,   877,   877,   878,   878,   878,   878,
     878,   878,   878,   878,   879,   879,   880,   880,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   881,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   882,   881,   881,
     881,   881,   881,   881,   881,   881,   881,   883,   883,   884,
     885,   887,   886,   888,   889,   889,   889,   889,   889,   889,
     890,   890,   890,   890,   890,   890,   890,   890,   890,   890,
     890,   890,   891,   891,   892,   892,   893,   893,   893,   893,
     894,   894,   895,   895,   895,   896,   896,   897,   897,   897,
     898,   898,   899,   899,   901,   900,   902,   902,   903,   903,
     904,   905,   903,   903,   903,   906,   906,   907,   907,   908,
     908,   909,   909,   909,   909,   910,   911,   912,   912,   913,
     913,   913,   913,   913,   913,   914,   915,   915,   916,   916,
     916,   916,   917,   917,   918,   918,   919,   919,   919,   920,
     920,   921,   921,   921,   922,   922,   922,   922,   923,   923,
     923,   923,   923,   923,   924,   924,   925,   925,   926,   926,
     926,   926,   926,   926,   926,   926,   926,   926,   926,   926,
     927,   927,   928,   928,   929,   929,   930,   930,   931,   931,
     932,   932,   932,   933,   933,   934,   934,   935,   935,   935,
     935,   935,   936,   936,   937,   937,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   938,   938,   938,   938,   938,   938,   938,   938,
     938,   938,   939,   939,   940,   940,   941,   941,   941,   941,
     942,   942,   943,   943,   944,   944,   945,   945,   946,   946,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     947,   947,   947,   947,   947,   947,   947,   947,   947,   947,
     948,   949,   950,   950,   951,   951,   952,   952,   953,   953,
     954,   954,   955,   956,   956,   957,   957,   957,   957,   958,
     958,   958,   958,   959,   959,   960,   960,   960,   960,   960,
     960,   960,   960,   960,   960,   960,   960,   960,   960,   960,
     960,   960,   960,   960,   960,   960,   960,   960,   960,   960,
     960,   960,   960,   960,   960,   960,   960,   960,   960,   960,
     960,   960,   960,   960,   960,   960,   960,   960,   960,   960,
     960,   961,   961,   961,   961,   961,   961,   962,   962,   962,
     963,   963,   964,   964,   964,   965,   965,   965,   966,   966,
     967,   967,   968,   968,   969,   969,   970,   970,   971,   971,
     971,   971,   972,   972,   972,   972,   972,   973,   973,   973,
     973,   974,   974,   974,   975,   975,   976,   976,   976,   977,
     978,   978,   979,   979,   979,   980,   981,   981,   982,   983,
     984,   984,   985,   986,   986,   986,   986,   986,   986,   986,
     986,   986,   987,   987,   987,   987,   987,   987,   987,   987,
     988,   988,   989,   990,   991,   991,   992,   992,   992,   992,
     992,   992,   992,   993,   994,   995,   995,   995,   996,   996,
     998,   997,   999,   997,  1000,   997,  1001,   997,  1002,   997,
    1003,   997,  1004,   997,  1005,  1005,  1006,  1006,  1006,  1006,
    1006,  1006,  1006,  1006,  1006,  1006,  1007,  1007,  1008,  1008,
    1008,  1008,  1008,  1008,  1008,  1008,  1008,  1008,  1009,  1010,
    1010,  1010,  1010,  1010,  1010,  1011,  1011,  1011,  1011,  1011,
    1011,  1012,  1012,  1013,  1013,  1013,  1014,  1015,  1015,  1015,
    1015,  1015,  1015,  1016,  1016,  1016,  1016,  1017,  1017,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,  1018,
    1018,  1019,  1019,  1020,  1020,  1021,  1021,  1022,  1022,  1023,
    1023,  1023,  1024,  1024,  1026,  1025,  1027,  1027,  1027,  1029,
    1028,  1030,  1030,  1030,  1031,  1032,  1033,  1033,  1034,  1035,
    1036,  1036,  1037,  1038,  1039,  1040,  1040,  1040,  1040,  1041,
    1042,  1042,  1043,  1043,  1043,  1043,  1043,  1043,  1043,  1043,
    1043,  1044,  1044,  1044,  1044,  1045,  1045,  1046,  1046,  1047,
    1048,  1049,  1049,  1050,  1050,  1051,  1051,  1051,  1051,  1051,
    1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,
    1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,
    1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,  1051,
    1052,  1052,  1053,  1053,  1054,  1054,  1055,  1055,  1056,  1056,
    1057,  1057,  1057,  1057,  1057,  1057,  1059,  1060,  1058,  1061,
    1061,  1062,  1062,  1062,  1062,  1064,  1063,  1065,  1065,  1066,
    1066,  1067,  1067,  1068,  1068,  1069,  1069,  1070,  1070,  1071,
    1071,  1071,  1071,  1071,  1071,  1071,  1071,  1071,  1071,  1071,
    1071,  1071,  1071,  1071,  1071,  1071,  1071,  1071,  1071,  1071,
    1071,  1071,  1071,  1071,  1071,  1071,  1072,  1072,  1073,  1073,
    1074,  1074,  1074,  1074,  1074,  1074,  1074,  1074,  1075,  1075,
    1076,  1076,  1077,  1077,  1077,  1077,  1078,  1078,  1078,  1078,
    1079,  1079,  1080,  1081,  1081,  1081,  1081,  1082,  1082,  1083,
    1083,  1083,  1084,  1084,  1085,  1085,  1085,  1086,  1086,  1087,
    1087,  1087,  1088,  1088,  1089,  1089,  1090,  1090,  1091,  1092,
    1092,  1092,  1092,  1093,  1093,  1093,  1093,  1094,  1094,  1094,
    1094,  1095,  1095,  1095,  1095,  1096,  1096,  1097,  1097,  1097,
    1097,  1097,  1097,  1097,  1098,  1098,  1098,  1098,  1098,  1098,
    1098,  1098,  1098,  1098,  1099,  1099,  1100,  1100,  1101,  1101,
    1101,  1101,  1102,  1102,  1103,  1103,  1104,  1105,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,  1105,
    1105,  1105,  1105,  1105,  1105,  1106,  1106,  1107,  1107,  1108,
    1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,  1108,
    1108,  1108,  1108,  1109,  1109,  1110,  1110,  1111,  1111,  1111,
    1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,  1111,
    1111,  1112,  1112,  1113,  1113,  1114,  1114,  1114,  1114,  1114,
    1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1114,  1115,
    1115,  1116,  1116,  1116,  1116,  1117,  1117,  1117,  1117,  1118,
    1118,  1119,  1119,  1120,  1120,  1120,  1120,  1120,  1120,  1120,
    1120,  1121,  1121,  1122,  1122,  1123,  1123,  1123,  1123,  1123,
    1123,  1123,  1124,  1124,  1125,  1125,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,  1126,
    1126,  1127,  1127,  1128,  1128,  1129,  1129,  1129,  1129,  1130,
    1130,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,  1131,
    1131,  1131,  1131,  1132,  1132,  1133,  1133,  1133,  1133,  1133,
    1133,  1133,  1133,  1133,  1133,  1133,  1133,  1133,  1133,  1133,
    1133,  1134,  1134,  1135,  1135,  1135,  1135,  1135,  1135,  1135,
    1135,  1135,  1135,  1135,  1135,  1136,  1136,  1137,  1137,  1137,
    1137,  1137,  1137,  1137,  1137,  1137,  1137,  1137,  1137,  1137,
    1137,  1137,  1137,  1137,  1137,  1137,  1137,  1138,  1138,  1139,
    1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,  1139,
    1139,  1139,  1139,  1140,  1140,  1140,  1141,  1141,  1142,  1142,
    1143,  1143,  1143,  1143,  1144,  1144,  1145,  1145,  1145,  1145,
    1145,  1146,  1147,  1147,  1148,  1148,  1148,  1148,  1148,  1149,
    1149,  1150,  1151,  1151,  1152,  1154,  1153,  1155,  1155,  1156,
    1156,  1157,  1157,  1157,  1157,  1158,  1158,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,  1159,
    1159,  1159,  1159,  1159,  1159,  1159,  1160,  1160,  1160,  1160,
    1161,  1161,  1162,  1162,  1163,  1163,  1164,  1165,  1165,  1166,
    1166,  1167,  1167,  1168,  1168,  1168,  1168,  1168,  1168,  1169,
    1170,  1170,  1170,  1171,  1172,  1172,  1173,  1173,  1173,  1174,
    1174,  1175,  1175,  1176,  1176,  1176,  1177,  1177,  1178,  1178,
    1179,  1179,  1179,  1179,  1179,  1180,  1180,  1181,  1181,  1182,
    1182,  1183,  1183,  1183,  1184,  1184,  1185,  1185,  1186,  1186,
    1187,  1187,  1188,  1188,  1189,  1190,  1190,  1191,  1191,  1191,
    1192,  1192,  1193,  1193,  1194,  1195,  1195,  1196,  1197,  1198,
    1199,  1200,  1201,  1202,  1203,  1204,  1205,  1206,  1207,  1208,
    1209,  1210,  1211,  1212,  1213,  1214,  1215,  1216,  1217,  1218,
    1219,  1220,  1221,  1221,  1222,  1223,  1224,  1225,  1226,  1227,
    1228,  1229,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,
    1237,  1238,  1239,  1240,  1241,  1242,  1243,  1245,  1244,  1246,
    1247,  1248,  1249,  1250,  1251,  1252,  1253,  1254,  1255,  1256,
    1256,  1257,  1258,  1259,  1260,  1260,  1261,  1261,  1262,  1263,
    1264,  1265,  1265,  1266,  1266,  1267,  1268,  1269,  1270,  1271,
    1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,  1280,  1281,
    1282,  1283,  1284,  1285,  1286,  1287,  1288,  1289,  1290,  1290,
    1291,  1291,  1292,  1293,  1294,  1295,  1295,  1296,  1297,  1298,
    1299,  1299,  1300,  1301,  1302,  1303,  1303,  1304,  1305,  1306,
    1306,  1307,  1307,  1308,  1308,  1309,  1310,  1311,  1311,  1311,
    1311,  1312,  1312,  1313,  1314,  1315,  1316,  1317,  1318,  1319,
    1320,  1321,  1322,  1322,  1323,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,  1347,
    1347,  1347,  1348,  1349,  1350,  1351,  1352,  1353,  1354,  1355,
    1356,  1357,  1358,  1359,  1360,  1361,  1361,  1362,  1363,  1364,
    1364,  1365,  1366,  1367,  1368,  1369,  1370,  1371,  1372,  1373,
    1374,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,
    1384,  1385,  1386,  1386,  1386,  1386,  1387,  1388,  1389,  1390,
    1390,  1390,  1391,  1392,  1393,  1394,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1403,  1403,  1404,  1404,  1404,
    1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,  1417,  1418,  1419,  1420,  1421,  1422,  1423,  1424,
    1425,  1426,  1427,  1428,  1429,  1429,  1429,  1430,  1431,  1431,
    1431,  1432,  1432,  1433,  1434,  1435,  1435,  1435,  1436,  1436,
    1436,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,  1445,
    1446,  1447,  1448,  1449,  1450,  1451,  1452,  1453,  1454,  1455,
    1456,  1457,  1458,  1459,  1460,  1461,  1462,  1463,  1464,  1465,
    1466,  1466,  1467,  1468,  1469,  1470,  1471,  1472,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,  1480,  1480,  1480,  1480,
    1480,  1480,  1481,  1482,  1483,  1484,  1485,  1485,  1485,  1486,
    1487,  1488,  1489,  1490,  1491,  1492,  1493,  1494,  1494,  1494,
    1495,  1496,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,
    1505,  1506,  1506,  1507,  1508,  1509,  1510,  1511,  1512,  1513,
    1514,  1515,  1516,  1517,  1518,  1519,  1520,  1521,  1522,  1523,
    1524,  1525,  1526,  1527,  1528,  1529,  1530,  1531,  1532,  1533,
    1534,  1535,  1535,  1536,  1537,  1538,  1539,  1540,  1541,  1541,
    1542,  1543,  1544,  1545,  1546,  1546,  1547,  1547,  1548,  1549,
    1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,  1559,
    1560,  1561,  1562,  1563,  1564,  1565,  1566,  1567,  1568,  1569,
    1570,  1571,  1572,  1573,  1574,  1575,  1576,  1577,  1578,  1579,
    1580,  1581,  1582,  1583,  1584,  1585,  1586,  1587,  1588,  1589,
    1590,  1591,  1592,  1592,  1593,  1594,  1595,  1596,  1597,  1598,
    1599,  1600,  1601,  1601,  1601,  1601,  1602,  1603,  1604,  1605,
    1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,  1615,
    1616,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,
    1625,  1626,  1626,  1627,  1628,  1629,  1630,  1631,  1632,  1633,
    1634,  1635,  1636,  1637,  1638,  1638,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,
    1652,  1653,  1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,
    1662,  1663,  1664,  1665,  1666,  1667,  1668,  1669,  1670,  1671,
    1672,  1673,  1674,  1675,  1676,  1677,  1678,  1679,  1680,  1681,
    1682,  1683,  1684,  1685,  1686,  1687,  1688,  1689,  1690,  1691,
    1692,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,  1701,
    1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1708,  1709,
    1709,  1710,  1711,  1711,  1712,  1712,  1712,  1712,  1713,  1713,
    1714,  1714,  1714,  1714,  1715,  1715,  1716,  1716,  1716,  1716,
    1717,  1717,  1718,  1718,  1718,  1719,  1720,  1720,  1721,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,  1722,
    1722,  1722
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     4,     2,     3,     1,     1,
       1,     2,     3,     1,     3,     4,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     1,     3,     4,     2,
       3,     4,     2,     4,     5,     3,     3,     0,     9,     0,
       9,     3,     6,     0,     9,     0,    11,     0,     9,     8,
       3,     5,     3,     1,     1,     1,     1,     5,     3,     1,
       1,     1,     1,     0,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     5,     1,     3,     3,     0,     4,     3,
       3,     3,     3,     3,     3,     3,     8,     3,     3,     3,
       8,     3,     6,     1,     1,     1,     1,     3,     4,     3,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     0,     5,     8,
       4,     8,     4,     4,     4,     1,     1,     1,     3,     0,
       1,     5,     8,     2,     1,     4,     5,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     5,     8,    10,     2,     1,     4,     4,     4,
       5,     8,     2,     1,     7,     0,     6,     2,     1,     0,
       5,     5,     3,     1,     3,     3,     3,     3,     3,     0,
       6,     2,     3,     0,     6,     1,     2,     4,     1,     2,
       3,     3,     3,     3,     0,     9,     1,     2,     3,     3,
       1,     4,     1,     2,     3,     3,     3,     1,     1,     1,
       2,     5,     1,     3,     3,     3,     1,     1,     1,     1,
       5,     1,     5,     3,     3,     1,     0,     6,     0,     9,
       0,    11,     2,     2,     1,     1,     4,     2,     7,     5,
       6,     4,     9,     7,     3,     1,     3,     1,     3,     1,
       2,     2,     2,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     7,     4,     4,     4,     2,
       2,     4,     4,     6,     8,     8,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     0,     5,     8,
       4,     8,     4,     4,     4,     4,     4,     1,     3,     5,
       5,     0,     9,     5,     1,     1,     3,     3,     3,     5,
       5,     8,     7,     8,    10,    10,    10,    12,    12,    10,
      12,    12,     2,     1,     1,     1,     6,     5,     7,     7,
       2,     1,     9,     9,     9,     2,     1,     5,     8,     7,
       2,     1,     9,     9,     0,     6,     2,     1,     5,     3,
       0,     0,    10,     2,     2,     6,     5,     1,     1,     1,
       2,     6,     7,     7,     8,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     5,     3,     1,     1,     1,
       1,     1,     5,     8,     1,     2,     1,     3,     1,     2,
       1,     1,     2,     3,     1,     3,     1,     3,     5,     4,
       3,     3,     2,     1,     2,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     5,     3,     1,     1,     1,     2,     5,     3,     1,
       1,     1,     1,     2,     5,     3,     1,     1,     1,     1,
       1,     1,     2,     5,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     5,     3,     1,     1,     1,     1,     1,
       2,     5,     3,     1,     1,     1,     2,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       5,     5,     3,     1,     1,     1,     2,     5,     3,     1,
       1,     1,     5,     3,     1,     1,     1,     1,     1,     2,
       5,     3,     6,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     2,     2,     1,     2,     2,     1,     1,     1,
       1,     1,     5,     8,     2,     1,     4,     2,     2,     1,
       4,     1,     3,     5,     9,     1,     5,     3,     5,     7,
       9,     5,     7,     8,     2,     1,     5,     7,     4,     5,
       2,     1,     7,     9,     6,     5,     1,     2,     2,     5,
       2,     1,     6,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     5,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     4,     3,     6,     8,     3,     1,
       0,     8,     0,    10,     0,     8,     0,    11,     0,    13,
       0,    13,     0,    15,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     3,
       5,     6,     8,     8,    10,     7,     9,    10,    12,    12,
      14,     3,     1,     1,     1,     1,     4,     3,     5,     6,
       8,     8,    10,     2,     5,     3,     6,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     5,     1,     3,     0,     4,     2,     3,     1,     0,
       4,     2,     3,     1,     5,     5,     2,     1,     5,     5,
       2,     1,     7,     3,     5,     4,     6,     3,     5,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     5,     3,     6,     5,     6,     5,     6,     5,
       5,     2,     5,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     6,     1,     1,     1,     3,     1,     1,     1,     3,
       1,     4,     2,     5,     3,     6,     0,     0,     5,     2,
       5,     2,     5,     3,     6,     0,     6,     3,     2,     2,
       5,     3,     1,     1,     1,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     5,
       3,     1,     1,     1,     1,     1,     2,     5,     3,     6,
       3,     1,     1,     2,     5,     3,     6,     3,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     2,     5,     2,     5,     2,     5,     2,     2,
       5,     3,     6,     2,     5,     3,     6,     2,     5,     3,
       6,     2,     5,     3,     6,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     3,     6,     1,     1,
       1,     1,     3,     1,     3,     6,     7,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     3,     6,     1,     1,     1,     1,     3,
       1,     2,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     2,     5,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     2,     5,     2,     5,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     7,     8,     1,     2,     6,     4,
       2,     5,     3,     6,     1,     3,     1,     1,     1,     1,
       1,     5,     1,     3,     1,     1,     1,     1,     1,     3,
       8,     5,     1,     2,     9,     0,     6,     2,     1,     4,
       6,     2,     5,     3,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     5,     7,     8,
       3,     1,     1,     1,     2,     1,     4,     5,     3,     2,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     2,
       5,     1,     1,     5,     1,     2,     6,     9,     9,     5,
       8,     1,     2,     6,     9,     9,     2,     5,     3,     1,
       1,     1,     1,     1,     1,     5,    10,     2,     1,     4,
       4,     3,     2,     1,     5,    10,     2,     1,     3,     4,
       5,     8,     1,     2,     5,     6,     6,     3,     6,     6,
       5,     8,     1,     2,     6,     6,     6,     3,     3,     1,
       1,     3,     3,     3,     3,     1,     1,     1,     1,     3,
       5,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     0,     4,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     1,     1,     3,     3,     3,     3,
       5,     3,     5,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     3,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     5,     5,     3,     1,     3,
       3,     3,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     1,     3,     3,     1,     1,
       1,     1,     3,     3,     3,     1,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     1,     1,     3,     3,     1,     1,
       1,     1,     3,     3,     3,     3,     3,     1,     3,     3,
       1,     1,     3,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     5,     5,     3,     3,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     5,     3,     3,     3,     3,     3,
       3,     3,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     3,     3,     3,     3,
       3,     1,     1,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     5,     1,     1,     3,     3,
       1,     5,     3,     3,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     1,     3,     1,
       3,     3,     3,     1,     3,     1,     1,     1,     3,     3,
       3,     3,     1,     3,     1,     3,     3,     3,     1,     3,
       1,     3,     3,     3,     3,     3,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     3,     5,     3,     5,     3,     3,     5,     1,     3,
       3,     1,     3,     3,     3,     1,     1,     1,     5,     3,
       3,     3,     1,     1,     3,     3,     3,     3,     1,     1,
       3,     3,     1,     3,     3,     3,     3,     3,     1,     1,
       1,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     1,     1,     1,
       3,     3,     3,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     3,     3,     1,     3,     3,     1,     3,     1,
       1,     3,     3,     1,     3,     3,     1,     1,     1,     3,
       3,     3,     1,     1,     1,     3,     3,     3,     3,     3,
       6,     1,     1,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     1,     2,     3,     3,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "AIM_SOLVER",
  "ANALYTIC_DERIVATION", "ANALYTIC_DERIVATION_MODE", "AR",
  "POSTERIOR_SAMPLING_METHOD", "BALANCED_GROWTH_TEST_TOL", "BAYESIAN_IRF",
  "BETA_PDF", "BLOCK", "USE_CALIBRATION", "SILENT_OPTIMIZER",
  "BVAR_DENSITY", "BVAR_FORECAST", "BVAR_IRF", "NODECOMPOSITION",
  "DR_DISPLAY_TOL", "HUGE_NUMBER", "FIG_NAME", "WRITE_XLS",
  "BVAR_PRIOR_DECAY", "BVAR_PRIOR_FLAT", "BVAR_PRIOR_LAMBDA",
  "INTERACTIVE", "SCREEN_SHOCKS", "STEADYSTATE", "BVAR_PRIOR_MU",
  "BVAR_PRIOR_OMEGA", "BVAR_PRIOR_TAU", "BVAR_PRIOR_TRAIN", "DETAIL_PLOT",
  "TYPE", "BVAR_REPLIC", "BYTECODE", "ALL_VALUES_REQUIRED",
  "PROPOSAL_DISTRIBUTION", "REALTIME", "VINTAGE", "CALIB_SMOOTHER",
  "CHANGE_TYPE", "CHECK", "CONDITIONAL_FORECAST",
  "CONDITIONAL_FORECAST_PATHS", "CONF_SIG", "CONSTANT",
  "CONTROLLED_VAREXO", "CORR", "CUTOFF", "CYCLE_REDUCTION",
  "LOGARITHMIC_REDUCTION", "COMMA", "CONSIDER_ALL_ENDOGENOUS",
  "CONSIDER_ALL_ENDOGENOUS_AND_AUXILIARY", "CONSIDER_ONLY_OBSERVED",
  "INITIAL_CONDITION_DECOMPOSITION", "DATAFILE", "FILE", "SERIES",
  "DOUBLING", "DR_CYCLE_REDUCTION_TOL", "DR_CYCLE_REDUCTION_MAXITER",
  "DR_LOGARITHMIC_REDUCTION_TOL", "DR_LOGARITHMIC_REDUCTION_MAXITER",
  "DR_ALGO", "DROP", "DSAMPLE", "DYNASAVE", "DYNATYPE", "CALIBRATION",
  "DIFFERENTIATE_FORWARD_VARS", "END", "ENDVAL", "EQUAL", "ESTIMATION",
  "ESTIMATED_PARAMS", "ESTIMATED_PARAMS_BOUNDS", "ESTIMATED_PARAMS_INIT",
  "EXTENDED_PATH", "ENDOGENOUS_PRIOR", "EXPRESSION", "FILENAME", "DIRNAME",
  "FILTER_STEP_AHEAD", "FILTERED_VARS", "FIRST_OBS",
  "FIRST_SIMULATION_PERIOD", "LAST_SIMULATION_PERIOD", "LAST_OBS",
  "SET_TIME", "OSR_PARAMS_BOUNDS",
  "KEEP_KALMAN_ALGO_IF_SINGULARITY_IS_DETECTED", "FALSE", "FLOAT_NUMBER",
  "DATE", "DEFAULT", "FIXED_POINT", "FLIP", "OPT_ALGO",
  "COMPILATION_SETUP", "COMPILER", "ADD_FLAGS", "SUBSTITUTE_FLAGS",
  "ADD_LIBS", "SUBSTITUTE_LIBS", "FORECAST", "K_ORDER_SOLVER",
  "INSTRUMENTS", "SHIFT", "MEAN", "STDEV", "VARIANCE", "MODE", "INTERVAL",
  "SHAPE", "DOMAINN", "GAMMA_PDF", "GRAPH", "GRAPH_FORMAT",
  "CONDITIONAL_VARIANCE_DECOMPOSITION", "NOCHECK", "STD", "HISTVAL",
  "HISTVAL_FILE", "HOMOTOPY_SETUP", "HOMOTOPY_MODE", "HOMOTOPY_STEPS",
  "HOMOTOPY_FORCE_CONTINUE", "HP_FILTER", "HP_NGRID",
  "FILTERED_THEORETICAL_MOMENTS_GRID", "HYBRID",
  "USE_FIRST_ORDER_SOLUTION", "ONE_SIDED_HP_FILTER", "IDENTIFICATION",
  "INF_CONSTANT", "INITVAL", "INITVAL_FILE", "BOUNDS", "JSCALE", "INIT",
  "INFILE", "INVARS", "INT_NUMBER", "CONDITIONAL_LIKELIHOOD",
  "INV_GAMMA_PDF", "INV_GAMMA1_PDF", "INV_GAMMA2_PDF", "IRF", "IRF_SHOCKS",
  "IRF_PLOT_THRESHOLD", "IRF_CALIBRATION", "FAST_KALMAN_FILTER",
  "KALMAN_ALGO", "KALMAN_TOL", "DIFFUSE_KALMAN_TOL", "SCHUR_VEC_TOL",
  "SUBSAMPLES", "OPTIONS", "TOLF", "TOLX", "PLOT_INIT_DATE",
  "PLOT_END_DATE", "LAPLACE", "LIK_INIT", "LINEAR", "LINEAR_DECOMPOSITION",
  "LOAD_IDENT_FILES", "LOAD_MH_FILE", "LOAD_RESULTS_AFTER_LOAD_MH",
  "LOAD_PARAMS_AND_STEADY_STATE", "LOGLINEAR", "LOGDATA", "LYAPUNOV",
  "LINEAR_APPROXIMATION", "LYAPUNOV_COMPLEX_THRESHOLD",
  "LYAPUNOV_FIXED_POINT_TOL", "LYAPUNOV_DOUBLING_TOL", "LOG_DEFLATOR",
  "LOG_TREND_VAR", "LOG_GROWTH_FACTOR", "MATCHED_MOMENTS", "MARKOWITZ",
  "MARGINAL_DENSITY", "MAX", "MAXIT", "MH_CONF_SIG", "MH_DROP",
  "MH_INIT_SCALE", "MH_INIT_SCALE_FACTOR", "MH_JSCALE", "MH_TUNE_JSCALE",
  "MH_TUNE_GUESS", "MH_POSTERIOR_MODE_ESTIMATION", "MH_NBLOCKS",
  "MH_REPLIC", "MH_RECOVER", "MH_INITIALIZE_FROM_PREVIOUS_MCMC",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_DIRECTORY",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_RECORD",
  "MH_INITIALIZE_FROM_PREVIOUS_MCMC_PRIOR",
  "POSTERIOR_MAX_SUBSAMPLE_DRAWS", "MIN", "MINIMAL_SOLVING_PERIODS",
  "MODE_CHECK", "MODE_CHECK_NEIGHBOURHOOD_SIZE",
  "MODE_CHECK_SYMMETRIC_PLOTS", "MODE_CHECK_NUMBER_OF_POINTS",
  "MODE_COMPUTE", "MODE_FILE", "MODEL", "MODEL_COMPARISON", "MODEL_INFO",
  "MSHOCKS", "ABS", "SIGN", "MODEL_DIAGNOSTICS", "MODIFIEDHARMONICMEAN",
  "MOMENTS_VARENDO", "CONTEMPORANEOUS_CORRELATION", "DIFFUSE_FILTER",
  "SUB_DRAWS", "TAPER_STEPS", "GEWEKE_INTERVAL", "RAFTERY_LEWIS_QRS",
  "RAFTERY_LEWIS_DIAGNOSTICS", "BROOKS_GELMAN_PLOTROWS",
  "MCMC_JUMPING_COVARIANCE", "MOMENT_CALIBRATION", "NUMBER_OF_PARTICLES",
  "RESAMPLING", "SYSTEMATIC", "GENERIC", "RESAMPLING_THRESHOLD",
  "RESAMPLING_METHOD", "KITAGAWA", "STRATIFIED", "SMOOTH", "CPF_WEIGHTS",
  "AMISANOTRISTANI", "MURRAYJONESPARSLOW", "WRITE_EQUATION_TAGS",
  "FILTER_INITIAL_STATE", "NONLINEAR_FILTER_INITIALIZATION",
  "FILTER_ALGORITHM", "PROPOSAL_APPROXIMATION", "CUBATURE", "UNSCENTED",
  "MONTECARLO", "DISTRIBUTION_APPROXIMATION", "NAME",
  "USE_PENALIZED_OBJECTIVE_FOR_HESSIAN", "INIT_STATE", "FAST_REALTIME",
  "RESCALE_PREDICTION_ERROR_COVARIANCE", "GENERATE_IRFS", "NAN_CONSTANT",
  "NO_STATIC", "NOBS", "NOCONSTANT", "NODISPLAY", "NOCORR", "NODIAGNOSTIC",
  "NOFUNCTIONS", "NO_HOMOTOPY", "NOGRAPH", "POSTERIOR_NOGRAPH",
  "POSTERIOR_GRAPH", "NOMOMENTS", "NOMODELSUMMARY", "NOPRINT",
  "NORMAL_PDF", "SAVE_DRAWS", "MODEL_NAME", "STDERR_MULTIPLES",
  "DIAGONAL_ONLY", "DETERMINISTIC_TRENDS", "OBSERVATION_TRENDS", "OPTIM",
  "OPTIM_WEIGHTS", "ORDER", "OSR", "OSR_PARAMS", "MAX_DIM_COVA_GROUP",
  "ADVANCED", "OUTFILE", "OUTVARS", "OVERWRITE", "DISCOUNT",
  "PARALLEL_LOCAL_FILES", "PARAMETERS", "PARAMETER_SET",
  "PARTIAL_INFORMATION", "PERIODS", "PERIOD", "PLANNER_OBJECTIVE",
  "PLOT_CONDITIONAL_FORECAST", "PLOT_PRIORS", "PREFILTER", "PRESAMPLE",
  "PERFECT_FORESIGHT_SETUP", "PERFECT_FORESIGHT_SOLVER",
  "NO_POSTERIOR_KERNEL_DENSITY", "FUNCTION",
  "PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SETUP",
  "PERFECT_FORESIGHT_WITH_EXPECTATION_ERRORS_SOLVER", "PRINT", "PRIOR_MC",
  "PRIOR_TRUNC", "PRIOR_MODE", "PRIOR_MEAN", "POSTERIOR_MODE",
  "POSTERIOR_MEAN", "POSTERIOR_MEDIAN", "MLE_MODE", "PRUNING",
  "PARTICLE_FILTER_OPTIONS", "QUOTED_STRING", "QZ_CRITERIUM",
  "QZ_ZERO_THRESHOLD", "DSGE_VAR", "DSGE_VARLAG", "DSGE_PRIOR_WEIGHT",
  "TRUNCATE", "PIPE_E", "PIPE_X", "PIPE_P", "RELATIVE_IRF", "REPLIC",
  "SIMUL_REPLIC", "RPLOT", "SAVE_PARAMS_AND_STEADY_STATE",
  "PARAMETER_UNCERTAINTY", "TARGETS", "SHOCKS", "HETEROSKEDASTIC_SHOCKS",
  "SHOCK_DECOMPOSITION", "SHOCK_GROUPS", "USE_SHOCK_GROUPS", "SIMUL",
  "SIMUL_ALGO", "SIMUL_SEED", "ENDOGENOUS_TERMINAL_PERIOD", "SMOOTHER",
  "SMOOTHER2HISTVAL", "SQUARE_ROOT_SOLVER", "STACK_SOLVE_ALGO",
  "STEADY_STATE_MODEL", "SOLVE_ALGO", "SOLVER_PERIODS", "ROBUST_LIN_SOLVE",
  "STDERR", "STEADY", "STOCH_SIMUL", "REGIMES", "REGIME",
  "REALTIME_SHOCK_DECOMPOSITION", "CONDITIONAL", "UNCONDITIONAL", "TEX",
  "RAMSEY_MODEL", "RAMSEY_POLICY", "RAMSEY_CONSTRAINTS",
  "PLANNER_DISCOUNT", "PLANNER_DISCOUNT_LATEX_NAME",
  "DISCRETIONARY_POLICY", "DISCRETIONARY_TOL",
  "EVALUATE_PLANNER_OBJECTIVE", "OCCBIN_SETUP", "OCCBIN_SOLVER",
  "OCCBIN_WRITE_REGIMES", "OCCBIN_GRAPH", "SIMUL_MAXIT",
  "LIKELIHOOD_MAXIT", "SMOOTHER_MAXIT", "SIMUL_PERIODS",
  "LIKELIHOOD_PERIODS", "SMOOTHER_PERIODS", "SIMUL_CURB_RETRENCH",
  "LIKELIHOOD_CURB_RETRENCH", "SMOOTHER_CURB_RETRENCH",
  "SIMUL_CHECK_AHEAD_PERIODS", "SIMUL_MAX_CHECK_AHEAD_PERIODS",
  "SIMUL_RESET_CHECK_AHEAD_PERIODS", "LIKELIHOOD_CHECK_AHEAD_PERIODS",
  "LIKELIHOOD_MAX_CHECK_AHEAD_PERIODS", "SMOOTHER_CHECK_AHEAD_PERIODS",
  "SMOOTHER_MAX_CHECK_AHEAD_PERIODS", "SIMUL_DEBUG", "SMOOTHER_DEBUG",
  "SIMUL_PERIODIC_SOLUTION", "LIKELIHOOD_PERIODIC_SOLUTION",
  "SMOOTHER_PERIODIC_SOLUTION", "LIKELIHOOD_INVERSION_FILTER",
  "SMOOTHER_INVERSION_FILTER", "FILTER_USE_RELEXATION",
  "LIKELIHOOD_PIECEWISE_KALMAN_FILTER", "SMOOTHER_PIECEWISE_KALMAN_FILTER",
  "LIKELIHOOD_MAX_KALMAN_ITERATIONS", "TEX_NAME", "TRUE", "BIND", "RELAX",
  "ERROR_BIND", "ERROR_RELAX", "UNIFORM_PDF", "UNIT_ROOT_VARS", "USE_DLL",
  "USEAUTOCORR", "GSA_SAMPLE_FILE",
  "USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED", "VALUES", "SCALES",
  "VAR", "VAREXO", "VAREXO_DET", "VARIABLE", "VAROBS", "VAREXOBS",
  "PREDETERMINED_VARIABLES", "VAR_EXPECTATION", "VAR_EXPECTATION_MODEL",
  "PLOT_SHOCK_DECOMPOSITION", "MODEL_LOCAL_VARIABLE",
  "WRITE_LATEX_DYNAMIC_MODEL", "WRITE_LATEX_STATIC_MODEL",
  "WRITE_LATEX_ORIGINAL_MODEL", "WRITE_LATEX_STEADY_STATE_MODEL",
  "XLS_SHEET", "XLS_RANGE", "LMMCP", "BANDPASS_FILTER", "COLORMAP",
  "VAR_MODEL", "PAC_MODEL", "QOQ", "YOY", "AOA", "PAC_EXPECTATION",
  "TREND_COMPONENT_MODEL", "EQUAL_EQUAL", "EXCLAMATION_EQUAL", "LESS",
  "GREATER", "LESS_EQUAL", "GREATER_EQUAL", "PLUS", "MINUS", "TIMES",
  "DIVIDE", "UNARY", "POWER", "EXP", "LOG", "LN", "LOG10", "SIN", "COS",
  "TAN", "ASIN", "ACOS", "ATAN", "SINH", "COSH", "TANH", "ASINH", "ACOSH",
  "ATANH", "ERF", "ERFC", "DIFF", "ADL", "AUXILIARY_MODEL_NAME", "SQRT",
  "CBRT", "NORMCDF", "NORMPDF", "STEADY_STATE", "EXPECTATION",
  "SENSITIVITY", "DYNARE_SENSITIVITY", "MORRIS", "STAB", "REDFORM",
  "PPRIOR", "PRIOR_RANGE", "PPOST", "ILPTAU", "MORRIS_NLIV", "MORRIS_NTRA",
  "NSAM", "LOAD_REDFORM", "LOAD_RMSE", "LOAD_STAB", "ALPHA2_STAB",
  "LOGTRANS_REDFORM", "THRESHOLD_REDFORM", "KSSTAT_REDFORM",
  "ALPHA2_REDFORM", "NAMENDO", "NAMLAGENDO", "NAMEXO", "RMSE", "LIK_ONLY",
  "VAR_RMSE", "PFILT_RMSE", "ISTART_RMSE", "ALPHA_RMSE", "ALPHA2_RMSE",
  "FREQ", "INITIAL_YEAR", "INITIAL_SUBPERIOD", "FINAL_YEAR",
  "FINAL_SUBPERIOD", "DATA", "VLIST", "VLISTLOG", "VLISTPER",
  "SPECTRAL_DENSITY", "INIT2SHOCKS", "RESTRICTION", "RESTRICTION_FNAME",
  "CROSS_RESTRICTIONS", "NLAGS", "CONTEMP_REDUCED_FORM",
  "REAL_PSEUDO_FORECAST", "DUMMY_OBS", "NSTATES", "INDXSCALESSTATES",
  "NO_BAYESIAN_PRIOR", "SPECIFICATION", "SIMS_ZHA", "ALPHA", "BETA",
  "ABAND", "NINV", "CMS", "NCMS", "CNUM", "GAMMA", "INV_GAMMA",
  "INV_GAMMA1", "INV_GAMMA2", "NORMAL", "UNIFORM", "EPS", "PDF", "FIG",
  "DR", "NONE", "PRIOR", "PRIOR_VARIANCE", "HESSIAN", "IDENTITY_MATRIX",
  "DIRICHLET", "DIAGONAL", "OPTIMAL", "MFS", "GSIG2_LMDM", "Q_DIAG",
  "FLAT_PRIOR", "NCSK", "NSTD", "WEIBULL", "WEIBULL_PDF", "INDXPARR",
  "INDXOVR", "INDXAP", "APBAND", "INDXIMF", "INDXFORE", "FOREBAND",
  "INDXGFOREHAT", "INDXGIMFHAT", "INDXESTIMA", "INDXGDLS", "EQ_MS",
  "FILTER_COVARIANCE", "UPDATED_COVARIANCE", "FILTER_DECOMPOSITION",
  "SMOOTHED_STATE_UNCERTAINTY", "SMOOTHER_REDUX", "EQ_CMS", "TLINDX",
  "TLNUMBER", "RESTRICTIONS", "POSTERIOR_SAMPLER_OPTIONS",
  "OUTPUT_FILE_TAG", "HORIZON", "SBVAR", "TREND_VAR", "DEFLATOR",
  "GROWTH_FACTOR", "MS_IRF", "MS_VARIANCE_DECOMPOSITION", "GROWTH",
  "MS_ESTIMATION", "MS_SIMULATION", "MS_COMPUTE_MDD",
  "MS_COMPUTE_PROBABILITIES", "MS_FORECAST", "SVAR_IDENTIFICATION",
  "EQUATION", "EXCLUSION", "LAG", "UPPER_CHOLESKY", "LOWER_CHOLESKY",
  "MONTHLY", "QUARTERLY", "MARKOV_SWITCHING", "CHAIN", "DURATION",
  "NUMBER_OF_REGIMES", "NUMBER_OF_LAGS", "EPILOGUE", "SVAR",
  "SVAR_GLOBAL_IDENTIFICATION_CHECK", "COEFF", "COEFFICIENTS", "VARIANCES",
  "CONSTANTS", "EQUATIONS", "EXTERNAL_FUNCTION", "EXT_FUNC_NAME",
  "EXT_FUNC_NARGS", "FIRST_DERIV_PROVIDED", "SECOND_DERIV_PROVIDED",
  "SELECTED_VARIABLES_ONLY", "COVA_COMPUTE", "SIMULATION_FILE_TAG",
  "FILE_TAG", "NO_ERROR_BANDS", "ERROR_BAND_PERCENTILES",
  "SHOCKS_PER_PARAMETER", "NO_CREATE_INIT", "SHOCK_DRAWS",
  "FREE_PARAMETERS", "MEDIAN", "DATA_OBS_NBR", "NEIGHBORHOOD_WIDTH",
  "PVALUE_KS", "PVALUE_CORR", "FILTERED_PROBABILITIES",
  "REAL_TIME_SMOOTHED", "PRIOR_FUNCTION", "POSTERIOR_FUNCTION",
  "SAMPLING_DRAWS", "PROPOSAL_TYPE", "PROPOSAL_UPPER_BOUND",
  "PROPOSAL_LOWER_BOUND", "PROPOSAL_DRAWS", "USE_MEAN_CENTER",
  "ADAPTIVE_MH_DRAWS", "THINNING_FACTOR",
  "COEFFICIENTS_PRIOR_HYPERPARAMETERS", "CONVERGENCE_STARTING_VALUE",
  "CONVERGENCE_ENDING_VALUE", "CONVERGENCE_INCREMENT_VALUE",
  "MAX_ITERATIONS_STARTING_VALUE", "MAX_ITERATIONS_INCREMENT_VALUE",
  "MAX_BLOCK_ITERATIONS", "MAX_REPEATED_OPTIMIZATION_RUNS",
  "FUNCTION_CONVERGENCE_CRITERION", "SAVE_REALTIME",
  "PARAMETER_CONVERGENCE_CRITERION", "NUMBER_OF_LARGE_PERTURBATIONS",
  "NUMBER_OF_SMALL_PERTURBATIONS",
  "NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION", "MAX_NUMBER_OF_STAGES",
  "RANDOM_FUNCTION_CONVERGENCE_CRITERION",
  "RANDOM_PARAMETER_CONVERGENCE_CRITERION",
  "NO_INIT_ESTIMATION_CHECK_FIRST_OBS", "HETEROSKEDASTIC_FILTER",
  "TIME_SHIFT", "STRUCTURAL", "CONSTANT_SIMULATION_LENGTH", "SURPRISE",
  "OCCBIN_CONSTRAINTS", "PAC_TARGET_INFO", "COMPONENT", "TARGET",
  "AUXNAME", "AUXNAME_TARGET_NONSTATIONARY", "PAC_TARGET_NONSTATIONARY",
  "KIND", "LL", "DL", "DD", "ADD", "MULTIPLY", "GMM", "SMM",
  "IRF_MATCHING", "METHOD_OF_MOMENTS", "MOM_METHOD", "SIMULATION_METHOD",
  "BARTLETT_KERNEL_LAG", "WEIGHTING_MATRIX",
  "WEIGHTING_MATRIX_SCALING_FACTOR", "ANALYTIC_STANDARD_ERRORS",
  "ANALYTIC_JACOBIAN", "PENALIZED_ESTIMATOR", "VERBOSE",
  "SIMULATION_MULTIPLE", "MOM_SEED", "SEED", "BOUNDED_SHOCK_SUPPORT",
  "ADDITIONAL_OPTIMIZER_STEPS", "MOM_SE_TOLX", "SE_TOLX", "MOM_BURNIN",
  "BURNIN", "IRF_MATCHING_FILE", "ADD_TINY_NUMBER_TO_CHOLESKY", "EQTAGS",
  "ANALYTICAL_GIRF", "IRF_IN_PERCENT", "EMAS_GIRF", "EMAS_DROP",
  "EMAS_TOLF", "EMAS_MAX_ITER", "NO_IDENTIFICATION_STRENGTH",
  "NO_IDENTIFICATION_REDUCEDFORM", "NO_IDENTIFICATION_MOMENTS",
  "NO_IDENTIFICATION_MINIMAL", "NO_IDENTIFICATION_SPECTRUM",
  "NORMALIZE_JACOBIANS", "GRID_NBR", "TOL_RANK", "TOL_DERIV", "TOL_SV",
  "CHECKS_VIA_SUBSETS", "MAX_DIM_SUBSETS_GROUPS", "MAX_NROWS",
  "SQUEEZE_SHOCK_DECOMPOSITION", "WITH_EPILOGUE", "MODEL_REMOVE",
  "MODEL_REPLACE", "MODEL_OPTIONS", "VAR_REMOVE",
  "ESTIMATED_PARAMS_REMOVE", "BLOCK_STATIC", "BLOCK_DYNAMIC", "INCIDENCE",
  "RESID", "NON_ZERO", "LEARNT_IN", "PLUS_EQUAL", "TIMES_EQUAL",
  "FSOLVE_OPTIONS", "ENDVAL_STEADY", "STEADY_SOLVE_ALGO", "STEADY_MAXIT",
  "STEADY_TOLF", "STEADY_TOLX", "STEADY_MARKOWITZ",
  "HOMOTOPY_MAX_COMPLETION_SHARE", "HOMOTOPY_MIN_STEP_SIZE",
  "HOMOTOPY_INITIAL_STEP_SIZE",
  "HOMOTOPY_STEP_SIZE_INCREASE_SUCCESS_COUNT",
  "HOMOTOPY_LINEARIZATION_FALLBACK",
  "HOMOTOPY_MARGINAL_LINEARIZATION_FALLBACK", "HOMOTOPY_EXCLUDE_VAREXO",
  "FROM_INITVAL_TO_ENDVAL", "STATIC_MFS", "RELATIVE_TO_INITVAL",
  "MATCHED_IRFS", "MATCHED_IRFS_WEIGHTS", "WEIGHTS", "PERPENDICULAR",
  "HETEROGENEITY", "HETEROGENEITY_DIMENSION", "SUM", "SYMBOL_VEC", "';'",
  "':'", "'('", "')'", "'['", "']'", "'#'", "'.'", "$accept",
  "statement_list", "statement", "dsample", "symbol_list",
  "symbol_list_or_wildcard", "symbol_list_with_tex", "partition_elem",
  "partition_1", "partition", "symbol_list_with_tex_and_partition",
  "rplot", "trend_var", "$@1", "log_trend_var", "$@2", "var", "$@3", "$@4",
  "$@5", "var_remove", "var_model", "var_model_options_list",
  "var_model_options", "trend_component_model",
  "trend_component_model_options_list", "trend_component_model_options",
  "pac_model", "$@6", "pac_model_options_list", "pac_model_options",
  "var_expectation_model", "var_expectation_model_options_list",
  "var_expectation_model_option", "$@7", "varexo", "varexo_det",
  "predetermined_variables", "parameters", "model_local_variable",
  "change_type", "change_type_arg", "heterogeneity_dimension",
  "init_param", "expression", "$@8", "comma_expression",
  "expression_or_empty", "initval", "initval_list", "initval_elem",
  "histval_file", "initval_file", "h_options_list", "h_options",
  "integer_or_date", "endval", "endval_list", "endval_elem", "histval",
  "histval_list", "histval_elem", "epilogue", "$@9",
  "epilogue_equation_list", "epilogue_equation", "$@10",
  "compilation_setup", "compilation_setup_options_list",
  "compilation_setup_option", "matched_moments", "$@11",
  "matched_moments_list", "occbin_constraints", "$@12",
  "occbin_constraints_regimes_list", "occbin_constraints_regime",
  "occbin_constraints_regime_options_list",
  "occbin_constraints_regime_option", "pac_target_info", "$@13",
  "pac_target_info_statement_list", "pac_target_info_statement",
  "pac_target_info_component", "pac_target_info_component_list",
  "pac_target_info_component_elem", "pac_target_kind", "resid",
  "model_option", "model_options_list", "model", "$@14", "$@15", "$@16",
  "equation_list", "equation", "tag_pair_list", "tag_pair", "hand_side",
  "$@17", "comma_hand_side", "pound_expression", "model_remove",
  "model_replace", "$@18", "model_options", "tag_pair_list_for_selection",
  "shocks", "shock_list", "shock_elem", "stoch_shock_elem",
  "stoch_shock_list", "det_shock_elem", "det_shock_list",
  "heteroskedastic_shocks", "heteroskedastic_shock_list",
  "heteroskedastic_shock_elem", "svar_identification", "$@19",
  "svar_identification_list", "svar_identification_elem", "$@20", "$@21",
  "svar_equation_list", "restriction_expression",
  "restriction_expression_1", "restriction_elem_expression",
  "svar_global_identification_check", "markov_switching",
  "ms_options_list", "ms_options", "svar", "svar_options_list",
  "svar_options", "mshocks", "mshocks_options_list", "mshocks_option",
  "mshock_list", "period_list", "period_range", "value_list", "steady",
  "steady_options_list", "steady_options", "check", "check_options_list",
  "check_options", "model_info", "model_info_options_list",
  "model_info_options", "perfect_foresight_setup",
  "perfect_foresight_setup_options_list",
  "perfect_foresight_setup_options", "perfect_foresight_solver",
  "perfect_foresight_solver_options_list",
  "perfect_foresight_solver_options",
  "perfect_foresight_with_expectation_errors_setup",
  "perfect_foresight_with_expectation_errors_setup_options_list",
  "perfect_foresight_with_expectation_errors_setup_options",
  "perfect_foresight_with_expectation_errors_solver",
  "perfect_foresight_with_expectation_errors_solver_options_list",
  "perfect_foresight_with_expectation_errors_solver_options",
  "method_of_moments", "method_of_moments_options_list",
  "method_of_moments_option", "prior_function", "posterior_function",
  "prior_posterior_function_options_list",
  "prior_posterior_function_options", "simul", "simul_options_list",
  "simul_options", "external_function", "external_function_options_list",
  "external_function_options", "stoch_simul", "stoch_simul_options_list",
  "stoch_simul_primary_options", "stoch_simul_options", "signed_integer",
  "non_negative_number", "signed_number", "signed_inf",
  "signed_number_w_inf", "boolean", "estimated_params", "estimated_list",
  "estimated_elem", "estimated_elem1", "estimated_elem2",
  "estimated_elem3", "estimated_params_init", "estimated_init_list",
  "estimated_init_elem", "estimated_params_bounds",
  "estimated_bounds_list", "estimated_bounds_elem",
  "estimated_params_remove", "estimated_remove_list",
  "estimated_remove_elem", "osr_params_bounds", "osr_bounds_list",
  "osr_bounds_elem", "prior_distribution", "prior_pdf", "date_expr",
  "set_time", "data", "data_options_list", "data_options", "subsamples",
  "subsamples_eq", "subsamples_eq_opt", "subsamples_name_list", "prior",
  "$@22", "$@23", "$@24", "$@25", "$@26", "$@27", "$@28",
  "prior_options_list", "prior_options", "joint_prior_options_list",
  "joint_prior_options", "prior_eq", "prior_eq_opt", "options",
  "options_options_list", "options_options", "options_eq",
  "options_eq_opt", "estimation", "estimation_options_list",
  "estimation_options", "name_value_pair", "name_value_pair_list",
  "name_value_pair_with_boolean", "name_value_pair_with_boolean_list",
  "name_value_pair_with_suboptions",
  "name_value_pair_with_suboptions_list", "varobs", "$@29", "varobs_list",
  "varexobs", "$@30", "varexobs_list", "deterministic_trends",
  "observation_trends", "trend_list", "trend_element",
  "filter_initial_state", "filter_initial_state_list",
  "filter_initial_state_element", "unit_root_vars", "optim_weights",
  "optim_weights_list", "osr_params", "osr_options_list", "osr_options",
  "osr", "dynatype", "dynasave", "load_params_and_steady_state",
  "save_params_and_steady_state", "identification",
  "identification_options_list", "identification_option",
  "model_comparison", "filename", "namespace_qualified_symbol",
  "namespace_qualified_filename", "parallel_local_filename_list",
  "mc_filename_list", "planner_objective", "$@31", "$@32", "ramsey_model",
  "ramsey_policy", "ramsey_constraints", "$@33", "ramsey_constraints_list",
  "evaluate_planner_objective", "evaluate_planner_objective_options_list",
  "evaluate_planner_objective_option", "occbin_setup",
  "occbin_setup_options_list", "occbin_setup_option", "occbin_solver",
  "occbin_solver_options_list", "occbin_solver_option",
  "occbin_write_regimes", "occbin_write_regimes_options_list",
  "occbin_write_regimes_option", "occbin_graph",
  "occbin_graph_options_list", "occbin_graph_option",
  "discretionary_policy", "discretionary_policy_options_list",
  "discretionary_policy_options", "ramsey_model_options_list",
  "ramsey_model_options", "ramsey_policy_options_list",
  "ramsey_policy_options", "write_latex_dynamic_model",
  "write_latex_static_model", "write_latex_original_model",
  "write_latex_steady_state_model", "shock_decomposition",
  "realtime_shock_decomposition", "plot_shock_decomposition",
  "initial_condition_decomposition", "squeeze_shock_decomposition",
  "bvar_prior_option", "bvar_common_option", "bvar_density_options_list",
  "bvar_density", "bvar_forecast_option", "bvar_forecast_options_list",
  "bvar_forecast", "bvar_irf", "sbvar_option", "sbvar_options_list",
  "sbvar", "ms_variance_decomposition_option",
  "ms_variance_decomposition_options_list", "ms_variance_decomposition",
  "ms_forecast_option", "ms_forecast_options_list", "ms_forecast",
  "ms_irf_option", "ms_irf_options_list", "ms_irf",
  "ms_compute_probabilities_option",
  "ms_compute_probabilities_options_list", "ms_compute_probabilities",
  "ms_compute_mdd_option", "ms_compute_mdd_options_list", "ms_compute_mdd",
  "ms_simulation_option", "ms_simulation_options_list", "ms_simulation",
  "ms_estimation_option", "ms_estimation_options_list", "ms_estimation",
  "sensitivity", "sensitivity_options_list", "sensitivity_option",
  "shock_decomposition_options_list", "shock_decomposition_option",
  "realtime_shock_decomposition_options_list",
  "realtime_shock_decomposition_option",
  "plot_shock_decomposition_options_list",
  "plot_shock_decomposition_option",
  "initial_condition_decomposition_options_list",
  "initial_condition_decomposition_option", "homotopy_setup",
  "homotopy_list", "homotopy_item", "forecast", "forecast_options",
  "forecast_option", "conditional_forecast",
  "conditional_forecast_options", "conditional_forecast_option",
  "plot_conditional_forecast", "conditional_forecast_paths",
  "conditional_forecast_paths_shock_list",
  "conditional_forecast_paths_shock_elem", "steady_state_model", "$@34",
  "steady_state_equation_list", "steady_state_equation", "calib_smoother",
  "calib_smoother_options_list", "calib_smoother_option", "generate_irfs",
  "generate_irfs_options_list", "generate_irfs_option",
  "generate_irfs_element_list", "generate_irfs_element",
  "generate_irfs_exog_element_list", "extended_path",
  "extended_path_options_list", "extended_path_option",
  "model_diagnostics", "calibration_range", "moment_calibration",
  "moment_calibration_list", "moment_calibration_item", "irf_calibration",
  "irf_calibration_list", "irf_calibration_item", "smoother2histval",
  "smoother2histval_options_list", "smoother2histval_option",
  "shock_groups", "shock_group_list", "shock_group_element",
  "shock_name_list", "init2shocks", "init2shocks_list",
  "init2shocks_element", "matched_irfs", "matched_irfs_list",
  "matched_irfs_elem", "matched_irfs_elem_var_varexo",
  "matched_irfs_elem_values_weights", "matched_irfs_weights",
  "matched_irfs_weights_list", "matched_irfs_weights_elem",
  "matched_irfs_weights_elem_var_varexo", "o_solve_algo",
  "o_stack_solve_algo", "o_robust_lin_solve",
  "o_endogenous_terminal_period", "o_order", "o_replic", "o_drop", "o_ar",
  "o_nocorr", "o_nofunctions", "o_nomoments", "o_nomodelsummary", "o_irf",
  "o_irf_shocks", "o_hp_filter", "o_hp_ngrid",
  "o_filtered_theoretical_moments_grid", "o_one_sided_hp_filter",
  "o_periods", "o_solver_periods", "o_extended_path_order", "o_hybrid",
  "o_use_first_order_solution", "o_steady_maxit", "o_simul_maxit",
  "o_bandpass_filter", "o_dp_maxit", "o_osr_maxit", "o_osr_tolf",
  "o_pf_tolf", "o_pf_tolx", "o_steady_tolf", "o_steady_tolx", "o_opt_algo",
  "o_markowitz", "o_pf_steady_solve_algo", "o_pf_steady_maxit",
  "o_pf_steady_tolf", "o_pf_steady_tolx", "o_pf_steady_markowitz",
  "o_minimal_solving_periods", "o_simul_replic", "o_qz_criterium",
  "o_qz_zero_threshold", "o_file", "o_pac_name", "o_pac_aux_model_name",
  "o_pac_discount", "o_pac_growth", "$@35", "o_pac_auxname", "o_pac_kind",
  "o_var_name", "o_series", "o_datafile", "o_filename", "o_var_eq_tags",
  "o_var_structural", "o_dirname", "o_huge_number", "o_nobs",
  "o_trend_component_model_name", "o_trend_component_model_targets",
  "o_trend_component_model_eq_tags",
  "o_conditional_variance_decomposition", "o_est_first_obs",
  "o_posterior_sampling_method", "o_first_obs", "o_data_first_obs",
  "o_first_simulation_period", "o_last_simulation_period",
  "o_pf_first_simulation_period", "o_pf_last_simulation_period",
  "o_last_obs", "o_data_last_obs",
  "o_keep_kalman_algo_if_singularity_is_detected", "o_data_nobs",
  "o_shift", "o_shape", "o_mode", "o_mean", "o_mean_vec", "o_truncate",
  "o_stdev", "o_jscale", "o_init", "o_bounds", "o_domain", "o_interval",
  "o_variance", "o_variance_mat", "o_prefilter", "o_presample",
  "o_lik_init", "o_nograph", "o_posterior_nograph", "o_psd_nograph",
  "o_shock_decomposition_nograph", "o_init_state", "o_forecast_type",
  "o_shock_decomposition_presample", "o_shock_decomposition_forecast",
  "o_save_realtime", "o_fast_realtime", "o_nodisplay", "o_icd_nodisplay",
  "o_psd_nodisplay", "o_psd_init2shocks", "o_icd_max_nrows",
  "o_psd_max_nrows", "o_graph_format", "o_icd_graph_format",
  "o_psd_graph_format", "o_shock_decomposition_with_epilogue",
  "o_icd_with_epilogue", "allowed_graph_formats",
  "list_allowed_graph_formats", "o_subsample_name", "o_bvar_conf_sig",
  "o_forecasts_conf_sig", "o_conditional_forecast_conf_sig",
  "o_mh_conf_sig", "o_mh_replic", "o_posterior_max_subsample_draws",
  "o_mh_drop", "o_mh_jscale", "o_mh_tune_jscale", "o_mh_tune_guess",
  "o_optim", "o_posterior_sampler_options", "o_proposal_distribution",
  "o_no_posterior_kernel_density", "o_mh_init_scale",
  "o_mh_init_scale_factor", "o_mode_file", "o_mode_compute",
  "o_mode_check", "o_mode_check_neighbourhood_size",
  "o_mode_check_number_of_points", "o_mode_check_symmetric_plots",
  "o_prior_trunc", "o_mh_posterior_mode_estimation", "o_mh_nblocks",
  "o_load_mh_file", "o_load_results_after_load_mh", "o_loglinear",
  "o_linear_approximation", "o_logdata", "o_conditional_likelihood",
  "o_nodiagnostic", "o_bayesian_irf", "o_dsge_var", "o_dsge_varlag",
  "o_tex", "o_forecast", "o_smoother", "o_moments_varendo",
  "o_contemporaneous_correlation", "o_filtered_vars", "o_relative_irf",
  "o_fast_kalman_filter", "o_kalman_algo", "o_kalman_tol",
  "o_diffuse_kalman_tol", "o_schur_vec_tol", "o_marginal_density",
  "o_print", "o_noprint", "o_xls_sheet", "o_xls_range",
  "o_filter_step_ahead", "o_taper_steps", "o_geweke_interval",
  "o_raftery_lewis_diagnostics", "o_raftery_lewis_qrs",
  "o_brooks_gelman_plotrows", "o_constant", "o_noconstant", "o_mh_recover",
  "o_mh_initialize_from_previous_mcmc",
  "o_mh_initialize_from_previous_mcmc_directory",
  "o_mh_initialize_from_previous_mcmc_record",
  "o_mh_initialize_from_previous_mcmc_prior", "o_diffuse_filter",
  "o_plot_priors", "o_aim_solver", "o_partial_information", "o_sub_draws",
  "o_planner_discount", "o_planner_discount_latex_name", "o_lyapunov",
  "o_lyapunov_complex_threshold", "o_lyapunov_fixed_point_tol",
  "o_lyapunov_doubling_tol", "o_dr", "o_dr_cycle_reduction_tol",
  "o_dr_cycle_reduction_maxiter", "o_dr_logarithmic_reduction_tol",
  "o_dr_logarithmic_reduction_maxiter", "o_psd_detail_plot",
  "o_icd_detail_plot", "o_psd_interactive", "o_psd_screen_shocks",
  "o_psd_steadystate", "o_icd_steadystate", "o_icd_fig_name",
  "o_psd_fig_name", "o_psd_type", "o_icd_type", "o_icd_plot_init_date",
  "o_icd_plot_end_date", "o_psd_plot_init_date", "o_psd_plot_end_date",
  "o_icd_write_xls", "o_psd_write_xls", "o_psd_realtime", "o_psd_vintage",
  "o_psd_diff", "o_icd_diff", "o_psd_flip", "o_icd_flip",
  "o_bvar_prior_tau", "o_bvar_prior_decay", "o_bvar_prior_lambda",
  "o_bvar_prior_mu", "o_bvar_prior_omega", "o_bvar_prior_flat",
  "o_bvar_prior_train", "o_bvar_replic", "o_stderr_multiples",
  "o_diagonal_only", "o_number_of_particles", "o_particle_filter_options",
  "o_resampling", "o_resampling_threshold", "o_resampling_method",
  "o_cpf_weights", "o_filter_algorithm",
  "o_nonlinear_filter_initialization", "o_proposal_approximation",
  "o_distribution_approximation", "o_gsa_identification", "o_gsa_morris",
  "o_gsa_stab", "o_gsa_redform", "o_gsa_pprior", "o_gsa_prior_range",
  "o_gsa_ppost", "o_gsa_ilptau", "o_gsa_morris_nliv", "o_gsa_morris_ntra",
  "o_gsa_nsam", "o_gsa_load_redform", "o_gsa_load_rmse", "o_gsa_load_stab",
  "o_gsa_alpha2_stab", "o_gsa_logtrans_redform", "o_gsa_threshold_redform",
  "o_gsa_ksstat_redform", "o_gsa_alpha2_redform", "o_gsa_namendo",
  "o_gsa_namlagendo", "o_gsa_namexo", "o_gsa_rmse", "o_gsa_lik_only",
  "o_gsa_var_rmse", "o_gsa_pfilt_rmse", "o_gsa_istart_rmse",
  "o_gsa_alpha_rmse", "o_gsa_alpha2_rmse", "o_gsa_sample_file",
  "o_gsa_neighborhood_width", "o_gsa_pvalue_ks", "o_gsa_pvalue_corr",
  "o_load_ident_files", "o_useautocorr", "o_prior_mc", "o_advanced",
  "o_max_dim_cova_group", "o_homotopy_mode", "o_homotopy_steps",
  "o_homotopy_force_continue", "o_nocheck", "o_controlled_varexo",
  "o_parameter_set", "o_nodecomposition", "o_spectral_density",
  "o_ms_drop", "o_ms_mh_replic", "o_freq", "o_initial_year",
  "o_initial_subperiod", "o_final_year", "o_final_subperiod", "o_data",
  "o_vlist", "o_vlistlog", "o_vlistper", "o_restriction_fname", "o_nlags",
  "o_cross_restrictions", "o_contemp_reduced_form",
  "o_real_pseudo_forecast", "o_no_bayesian_prior", "o_dummy_obs",
  "o_nstates", "o_indxscalesstates", "o_alpha", "o_beta", "o_gsig2_lmdm",
  "o_specification", "o_q_diag", "o_flat_prior", "o_ncsk", "o_nstd",
  "o_ninv", "o_indxparr", "o_indxovr", "o_aband", "o_indxap", "o_apband",
  "o_indximf", "o_indxfore", "o_foreband", "o_indxgforhat",
  "o_indxgimfhat", "o_indxestima", "o_indxgdls", "o_eq_ms", "o_cms",
  "o_ncms", "o_eq_cms", "o_tlindx", "o_tlnumber", "o_cnum",
  "o_k_order_solver", "o_pruning", "o_chain", "o_restrictions",
  "o_duration", "o_number_of_regimes", "o_number_of_lags", "o_parameters",
  "o_coefficients", "o_variances", "o_equations", "o_silent_optimizer",
  "o_instruments", "o_ext_func_name", "o_ext_func_nargs",
  "o_first_deriv_provided", "o_second_deriv_provided",
  "o_filter_covariance", "o_updated_covariance", "o_filter_decomposition",
  "o_smoothed_state_uncertainty", "o_smoother_redux",
  "o_selected_variables_only", "o_cova_compute", "o_output_file_tag",
  "o_file_tag", "o_no_create_init", "o_simulation_file_tag",
  "o_coefficients_prior_hyperparameters", "o_convergence_starting_value",
  "o_convergence_ending_value", "o_convergence_increment_value",
  "o_max_iterations_starting_value", "o_max_iterations_increment_value",
  "o_max_block_iterations", "o_max_repeated_optimization_runs",
  "o_function_convergence_criterion", "o_parameter_convergence_criterion",
  "o_number_of_large_perturbations", "o_number_of_small_perturbations",
  "o_number_of_posterior_draws_after_perturbation",
  "o_max_number_of_stages", "o_random_function_convergence_criterion",
  "o_random_parameter_convergence_criterion", "o_thinning_factor",
  "o_adaptive_mh_draws", "o_save_draws", "o_proposal_draws",
  "o_use_mean_center", "o_proposal_type", "o_proposal_lower_bound",
  "o_proposal_upper_bound", "o_parameter_uncertainty", "o_horizon",
  "o_filtered_probabilities", "o_real_time_smoothed", "o_no_error_bands",
  "o_error_band_percentiles", "o_shock_draws", "o_shocks_per_parameter",
  "o_free_parameters", "o_median", "o_regimes", "o_regime",
  "o_data_obs_nbr", "o_discretionary_tol", "o_analytic_derivation",
  "o_analytic_derivation_mode", "o_endogenous_prior",
  "o_use_univariate_filters_if_singularity_is_detected",
  "o_mcmc_jumping_covariance", "o_rescale_prediction_error_covariance",
  "o_use_penalized_objective_for_hessian", "o_irf_plot_threshold",
  "o_dr_display_tol", "o_consider_all_endogenous",
  "o_consider_all_endogenous_and_auxiliary", "o_consider_only_observed",
  "o_no_homotopy", "o_endval_steady", "o_homotopy_max_completion_share",
  "o_homotopy_min_step_size", "o_homotopy_initial_step_size",
  "o_homotopy_step_size_increase_success_count",
  "o_homotopy_linearization_fallback",
  "o_homotopy_marginal_linearization_fallback",
  "o_homotopy_exclude_varexo", "o_infile", "o_invars", "o_period",
  "o_outfile", "o_outvars", "o_lmmcp", "o_function", "o_sampling_draws",
  "o_use_shock_groups", "o_colormap", "o_icd_colormap",
  "o_no_init_estimation_check_first_obs", "o_heteroskedastic_filter",
  "o_pfwee_constant_simulation_length", "o_fsolve_options",
  "o_bartlett_kernel_lag", "o_weighting_matrix",
  "o_weighting_matrix_scaling_factor", "o_analytic_standard_errors",
  "o_analytic_jacobian", "o_mom_method", "o_simulation_method",
  "o_penalized_estimator", "o_verbose", "o_simulation_multiple",
  "o_mom_burnin", "o_bounded_shock_support", "o_mom_seed",
  "o_additional_optimizer_steps", "o_mom_se_tolx", "o_irf_matching_file",
  "o_add_tiny_number_to_cholesky", "o_analytical_girf", "o_irf_in_percent",
  "o_emas_girf", "o_emas_drop", "o_emas_tolf", "o_emas_max_iter",
  "o_non_zero", "o_no_identification_strength",
  "o_no_identification_reducedform", "o_no_identification_moments",
  "o_no_identification_minimal", "o_no_identification_spectrum",
  "o_normalize_jacobians", "o_grid_nbr", "o_tol_rank", "o_tol_deriv",
  "o_tol_sv", "o_checks_via_subsets", "o_max_dim_subsets_groups",
  "o_block_static", "o_block_dynamic", "o_incidence",
  "o_evaluate_planner_objective_periods",
  "o_evaluate_planner_objective_drop", "o_occbin_simul_maxit",
  "o_occbin_simul_periods", "o_occbin_simul_curb_retrench",
  "o_occbin_simul_check_ahead_periods",
  "o_occbin_simul_max_check_ahead_periods",
  "o_occbin_simul_reset_check_ahead_periods", "o_occbin_simul_debug",
  "o_occbin_simul_periodic_solution",
  "o_occbin_likelihood_inversion_filter",
  "o_occbin_likelihood_piecewise_kalman_filter",
  "o_occbin_likelihood_maxit", "o_occbin_likelihood_periods",
  "o_occbin_likelihood_curb_retrench",
  "o_occbin_likelihood_check_ahead_periods",
  "o_occbin_likelihood_max_check_ahead_periods",
  "o_occbin_likelihood_periodic_solution",
  "o_occbin_likelihood_max_kalman_iterations",
  "o_occbin_smoother_inversion_filter",
  "o_occbin_smoother_piecewise_kalman_filter", "o_occbin_smoother_maxit",
  "o_occbin_smoother_periods", "o_occbin_smoother_curb_retrench",
  "o_occbin_smoother_check_ahead_periods",
  "o_occbin_smoother_max_check_ahead_periods", "o_occbin_smoother_debug",
  "o_occbin_smoother_periodic_solution", "o_occbin_filter_use_relaxation",
  "o_occbin_write_regimes_periods", "o_occbin_write_regimes_filename",
  "o_occbin_write_regimes_smoother", "o_occbin_write_regimes_simul",
  "o_occbin_graph_noconstant", "range", "integer_range",
  "integer_range_w_inf", "signed_integer_range", "vec_int_number",
  "vec_int_elem", "vec_int_1", "vec_int", "vec_str_1", "vec_str",
  "vec_value_1", "vec_value", "vec_value_w_inf_1", "vec_value_w_inf",
  "vec_of_vec_value_1", "vec_of_vec_value", "symbol", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   270,   270,   271,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   406,   408,   412,   417,   422,   426,
     427,   431,   436,   441,   443,   448,   453,   457,   460,   462,
     464,   469,   476,   477,   480,   485,   490,   492,   497,   502,
     504,   509,   514,   516,   521,   526,   530,   532,   532,   536,
     536,   540,   542,   544,   544,   546,   546,   548,   548,   552,
     556,   558,   561,   562,   565,   566,   567,   570,   573,   574,
     577,   578,   579,   582,   582,   584,   585,   588,   589,   590,
     591,   592,   593,   596,   600,   601,   605,   607,   607,   612,
     614,   616,   618,   620,   622,   626,   628,   632,   636,   640,
     642,   646,   650,   654,   656,   658,   660,   664,   668,   670,
     672,   674,   676,   678,   680,   682,   684,   686,   688,   690,
     692,   694,   696,   698,   700,   702,   704,   706,   708,   710,
     712,   714,   716,   718,   720,   722,   724,   726,   728,   730,
     732,   734,   736,   738,   740,   742,   744,   746,   746,   748,
     750,   752,   754,   756,   758,   760,   762,   766,   768,   772,
     774,   777,   779,   783,   784,   787,   789,   792,   795,   796,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     811,   813,   817,   819,   821,   825,   826,   829,   831,   833,
     837,   839,   843,   844,   847,   849,   849,   853,   854,   857,
     857,   861,   863,   864,   867,   869,   871,   873,   875,   879,
     879,   883,   885,   892,   892,   897,   899,   906,   924,   926,
     935,   937,   939,   941,   946,   945,   952,   953,   956,   958,
     960,   963,   968,   969,   972,   974,   976,   980,   982,   984,
     988,   990,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1011,  1012,  1015,  1015,  1017,  1017,
    1019,  1019,  1023,  1024,  1025,  1026,  1029,  1031,  1033,  1035,
    1037,  1039,  1041,  1043,  1047,  1054,  1058,  1060,  1064,  1066,
    1068,  1070,  1072,  1074,  1076,  1078,  1080,  1082,  1084,  1086,
    1088,  1090,  1092,  1094,  1096,  1098,  1100,  1102,  1104,  1106,
    1108,  1110,  1112,  1114,  1116,  1118,  1120,  1122,  1124,  1126,
    1128,  1130,  1132,  1134,  1136,  1138,  1140,  1142,  1144,  1146,
    1148,  1150,  1152,  1154,  1156,  1158,  1160,  1162,  1162,  1164,
    1166,  1168,  1170,  1172,  1174,  1176,  1178,  1182,  1184,  1188,
    1191,  1195,  1194,  1199,  1201,  1203,  1205,  1207,  1212,  1217,
    1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,  1232,  1233,
    1235,  1237,  1241,  1242,  1245,  1246,  1249,  1251,  1253,  1255,
    1259,  1260,  1263,  1265,  1267,  1271,  1272,  1275,  1277,  1279,
    1283,  1284,  1287,  1289,  1293,  1293,  1297,  1298,  1301,  1303,
    1306,  1308,  1305,  1310,  1312,  1316,  1318,  1322,  1323,  1326,
    1327,  1330,  1332,  1334,  1336,  1340,  1344,  1348,  1349,  1352,
    1353,  1354,  1355,  1356,  1357,  1360,  1364,  1365,  1368,  1369,
    1370,  1371,  1374,  1376,  1390,  1392,  1401,  1403,  1405,  1409,
    1410,  1413,  1415,  1420,  1427,  1432,  1439,  1441,  1445,  1450,
    1455,  1457,  1464,  1471,  1479,  1481,  1485,  1486,  1489,  1490,
    1491,  1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,  1500,
    1503,  1505,  1509,  1510,  1513,  1514,  1517,  1519,  1523,  1524,
    1527,  1528,  1529,  1532,  1534,  1538,  1539,  1542,  1543,  1544,
    1545,  1546,  1549,  1551,  1555,  1556,  1559,  1560,  1561,  1562,
    1563,  1564,  1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,
    1573,  1574,  1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,
    1583,  1584,  1587,  1589,  1593,  1594,  1597,  1598,  1599,  1600,
    1603,  1605,  1609,  1610,  1613,  1614,  1617,  1619,  1623,  1624,
    1627,  1628,  1629,  1630,  1631,  1632,  1633,  1634,  1635,  1636,
    1637,  1638,  1639,  1640,  1641,  1642,  1643,  1644,  1645,  1646,
    1647,  1648,  1649,  1650,  1651,  1652,  1653,  1654,  1655,  1656,
    1657,  1658,  1659,  1660,  1661,  1662,  1663,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1676,
    1677,  1678,  1679,  1680,  1681,  1682,  1683,  1684,  1685,  1686,
    1687,  1688,  1689,  1690,  1691,  1692,  1693,  1694,  1695,  1696,
    1697,  1698,  1699,  1700,  1701,  1702,  1703,  1704,  1705,  1706,
    1707,  1708,  1709,  1710,  1711,  1712,  1713,  1714,  1715,  1716,
    1719,  1723,  1727,  1728,  1731,  1732,  1735,  1737,  1741,  1742,
    1745,  1746,  1749,  1753,  1754,  1757,  1758,  1759,  1760,  1763,
    1765,  1767,  1769,  1773,  1774,  1777,  1778,  1779,  1780,  1781,
    1782,  1783,  1784,  1785,  1786,  1787,  1788,  1789,  1790,  1791,
    1792,  1793,  1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,
    1802,  1803,  1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,
    1812,  1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,
    1822,  1825,  1826,  1827,  1828,  1829,  1830,  1833,  1835,  1840,
    1843,  1844,  1847,  1849,  1854,  1857,  1859,  1861,  1865,  1866,
    1869,  1870,  1873,  1875,  1879,  1881,  1885,  1886,  1888,  1893,
    1898,  1904,  1911,  1915,  1920,  1927,  1931,  1939,  1944,  1950,
    1957,  1967,  1969,  1971,  1975,  1977,  1981,  1987,  1994,  2002,
    2005,  2007,  2011,  2018,  2026,  2035,  2038,  2039,  2042,  2045,
    2048,  2050,  2054,  2062,  2064,  2066,  2068,  2070,  2072,  2074,
    2076,  2078,  2082,  2084,  2086,  2088,  2090,  2092,  2094,  2096,
    2100,  2102,  2106,  2110,  2114,  2115,  2118,  2119,  2120,  2121,
    2122,  2123,  2124,  2127,  2131,  2135,  2137,  2139,  2143,  2144,
    2147,  2147,  2149,  2149,  2151,  2151,  2153,  2153,  2155,  2155,
    2157,  2157,  2159,  2159,  2163,  2164,  2167,  2168,  2169,  2170,
    2171,  2172,  2173,  2174,  2175,  2176,  2179,  2180,  2183,  2184,
    2185,  2186,  2187,  2188,  2189,  2190,  2191,  2192,  2195,  2200,
    2202,  2204,  2206,  2208,  2210,  2214,  2216,  2218,  2220,  2222,
    2224,  2228,  2229,  2232,  2233,  2234,  2237,  2242,  2244,  2246,
    2248,  2250,  2252,  2256,  2258,  2260,  2262,  2266,  2267,  2270,
    2271,  2272,  2273,  2274,  2275,  2276,  2277,  2278,  2279,  2280,
    2281,  2282,  2283,  2284,  2285,  2286,  2287,  2288,  2289,  2290,
    2291,  2292,  2293,  2294,  2295,  2296,  2297,  2298,  2299,  2300,
    2301,  2302,  2303,  2304,  2305,  2306,  2307,  2308,  2309,  2310,
    2311,  2312,  2313,  2314,  2315,  2316,  2317,  2318,  2319,  2320,
    2321,  2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,
    2331,  2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,
    2341,  2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,
    2351,  2352,  2353,  2354,  2355,  2356,  2357,  2358,  2359,  2360,
    2361,  2362,  2363,  2364,  2365,  2366,  2367,  2368,  2369,  2370,
    2371,  2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,
    2381,  2382,  2383,  2384,  2385,  2386,  2387,  2388,  2389,  2390,
    2391,  2392,  2393,  2394,  2395,  2396,  2397,  2398,  2399,  2400,
    2401,  2404,  2406,  2410,  2411,  2415,  2416,  2420,  2421,  2426,
    2427,  2438,  2442,  2443,  2447,  2447,  2449,  2451,  2453,  2457,
    2457,  2459,  2461,  2463,  2467,  2468,  2470,  2471,  2474,  2476,
    2480,  2481,  2484,  2488,  2490,  2492,  2494,  2496,  2498,  2502,
    2505,  2506,  2509,  2510,  2511,  2512,  2513,  2514,  2515,  2516,
    2517,  2520,  2522,  2524,  2526,  2530,  2532,  2536,  2538,  2542,
    2546,  2550,  2552,  2556,  2557,  2560,  2561,  2562,  2563,  2564,
    2565,  2566,  2567,  2568,  2569,  2570,  2571,  2572,  2573,  2574,
    2575,  2576,  2577,  2578,  2579,  2580,  2581,  2582,  2583,  2584,
    2585,  2586,  2587,  2588,  2589,  2590,  2591,  2592,  2593,  2594,
    2597,  2599,  2603,  2604,  2607,  2608,  2612,  2613,  2616,  2618,
    2622,  2624,  2626,  2628,  2630,  2632,  2636,  2637,  2636,  2639,
    2641,  2645,  2647,  2649,  2651,  2656,  2655,  2661,  2666,  2670,
    2672,  2676,  2677,  2680,  2681,  2684,  2686,  2689,  2690,  2693,
    2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,  2703,
    2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2712,  2713,
    2714,  2715,  2716,  2717,  2718,  2719,  2722,  2724,  2728,  2729,
    2732,  2733,  2734,  2735,  2736,  2737,  2738,  2739,  2742,  2744,
    2747,  2748,  2751,  2752,  2753,  2754,  2757,  2759,  2761,  2763,
    2767,  2768,  2771,  2773,  2775,  2777,  2779,  2783,  2784,  2787,
    2788,  2789,  2792,  2793,  2796,  2797,  2798,  2801,  2802,  2805,
    2806,  2807,  2810,  2812,  2816,  2818,  2822,  2824,  2828,  2832,
    2834,  2836,  2838,  2842,  2844,  2846,  2848,  2852,  2854,  2856,
    2858,  2862,  2864,  2866,  2868,  2872,  2874,  2878,  2879,  2880,
    2881,  2882,  2883,  2884,  2887,  2888,  2889,  2890,  2891,  2892,
    2893,  2894,  2895,  2896,  2899,  2900,  2903,  2905,  2909,  2910,
    2911,  2912,  2915,  2916,  2919,  2921,  2925,  2928,  2929,  2930,
    2931,  2932,  2933,  2934,  2935,  2936,  2937,  2938,  2939,  2940,
    2941,  2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2950,
    2951,  2952,  2953,  2954,  2955,  2956,  2957,  2958,  2959,  2960,
    2961,  2962,  2963,  2964,  2965,  2966,  2967,  2968,  2969,  2970,
    2971,  2972,  2973,  2974,  2975,  2978,  2979,  2982,  2984,  2988,
    2989,  2990,  2991,  2992,  2993,  2994,  2995,  2996,  2997,  2998,
    2999,  3000,  3001,  3004,  3005,  3008,  3010,  3014,  3015,  3016,
    3017,  3018,  3019,  3020,  3021,  3022,  3023,  3024,  3025,  3026,
    3027,  3030,  3031,  3034,  3036,  3040,  3041,  3042,  3043,  3044,
    3045,  3046,  3047,  3048,  3049,  3050,  3051,  3052,  3053,  3056,
    3057,  3060,  3062,  3064,  3066,  3070,  3071,  3072,  3073,  3076,
    3077,  3080,  3082,  3086,  3087,  3088,  3089,  3090,  3091,  3092,
    3093,  3096,  3097,  3100,  3102,  3106,  3107,  3108,  3109,  3110,
    3111,  3112,  3115,  3116,  3119,  3121,  3125,  3126,  3127,  3128,
    3129,  3130,  3131,  3132,  3133,  3134,  3135,  3136,  3137,  3138,
    3139,  3140,  3141,  3142,  3143,  3144,  3145,  3146,  3147,  3148,
    3149,  3150,  3151,  3152,  3153,  3154,  3155,  3156,  3157,  3158,
    3159,  3162,  3163,  3166,  3168,  3172,  3174,  3176,  3181,  3188,
    3189,  3192,  3193,  3194,  3195,  3196,  3197,  3198,  3199,  3200,
    3201,  3202,  3203,  3204,  3205,  3206,  3207,  3208,  3209,  3210,
    3211,  3212,  3213,  3214,  3215,  3216,  3217,  3218,  3219,  3220,
    3221,  3222,  3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,
    3231,  3232,  3233,  3234,  3235,  3236,  3237,  3238,  3239,  3240,
    3241,  3242,  3243,  3246,  3247,  3250,  3251,  3252,  3253,  3254,
    3255,  3256,  3257,  3258,  3259,  3260,  3261,  3262,  3263,  3264,
    3265,  3268,  3269,  3272,  3273,  3274,  3275,  3276,  3277,  3278,
    3279,  3280,  3281,  3282,  3283,  3286,  3287,  3290,  3291,  3292,
    3293,  3294,  3295,  3296,  3297,  3298,  3299,  3300,  3301,  3302,
    3303,  3304,  3305,  3306,  3307,  3308,  3309,  3312,  3313,  3316,
    3317,  3318,  3319,  3320,  3321,  3322,  3323,  3324,  3325,  3326,
    3327,  3328,  3329,  3332,  3334,  3336,  3340,  3341,  3344,  3346,
    3350,  3352,  3354,  3356,  3360,  3361,  3364,  3365,  3366,  3367,
    3368,  3371,  3375,  3376,  3379,  3380,  3381,  3382,  3383,  3386,
    3388,  3392,  3396,  3397,  3400,  3406,  3406,  3410,  3411,  3414,
    3416,  3420,  3422,  3424,  3426,  3430,  3431,  3434,  3435,  3436,
    3437,  3438,  3439,  3440,  3441,  3442,  3443,  3444,  3445,  3446,
    3447,  3448,  3449,  3450,  3451,  3452,  3455,  3457,  3459,  3461,
    3465,  3466,  3469,  3470,  3473,  3474,  3477,  3481,  3483,  3487,
    3489,  3493,  3494,  3497,  3498,  3499,  3500,  3501,  3502,  3505,
    3509,  3511,  3513,  3518,  3522,  3523,  3526,  3528,  3530,  3534,
    3536,  3540,  3541,  3544,  3546,  3548,  3552,  3554,  3558,  3559,
    3562,  3563,  3564,  3565,  3566,  3569,  3571,  3575,  3576,  3579,
    3580,  3583,  3584,  3585,  3588,  3590,  3594,  3595,  3598,  3599,
    3602,  3604,  3608,  3610,  3619,  3643,  3649,  3657,  3662,  3664,
    3668,  3670,  3674,  3676,  3688,  3698,  3704,  3712,  3713,  3714,
    3715,  3716,  3717,  3718,  3719,  3720,  3721,  3722,  3723,  3724,
    3725,  3726,  3727,  3731,  3732,  3733,  3734,  3735,  3736,  3737,
    3738,  3739,  3740,  3741,  3747,  3748,  3749,  3750,  3751,  3752,
    3753,  3754,  3755,  3757,  3760,  3761,  3762,  3763,  3764,  3766,
    3767,  3768,  3769,  3770,  3771,  3772,  3773,  3774,  3774,  3775,
    3776,  3777,  3778,  3779,  3780,  3781,  3782,  3783,  3784,  3785,
    3787,  3790,  3791,  3792,  3793,  3795,  3798,  3800,  3803,  3805,
    3806,  3807,  3808,  3810,  3811,  3813,  3814,  3815,  3816,  3817,
    3818,  3819,  3820,  3821,  3822,  3823,  3824,  3825,  3826,  3827,
    3828,  3829,  3830,  3831,  3832,  3833,  3834,  3835,  3836,  3838,
    3841,  3843,  3846,  3847,  3848,  3849,  3851,  3853,  3854,  3855,
    3856,  3858,  3861,  3862,  3863,  3864,  3865,  3867,  3868,  3869,
    3871,  3874,  3876,  3879,  3881,  3884,  3885,  3886,  3888,  3890,
    3892,  3895,  3896,  3899,  3902,  3903,  3904,  3905,  3906,  3907,
    3908,  3909,  3910,  3912,  3913,  3914,  3915,  3916,  3917,  3920,
    3921,  3922,  3923,  3924,  3925,  3926,  3927,  3928,  3929,  3930,
    3931,  3932,  3933,  3934,  3935,  3936,  3937,  3938,  3939,  3940,
    3942,  3944,  3947,  3948,  3949,  3950,  3951,  3952,  3953,  3954,
    3955,  3956,  3957,  3958,  3959,  3960,  3962,  3965,  3966,  3967,
    3968,  3970,  3971,  3972,  3973,  3974,  3975,  3976,  3977,  3978,
    3979,  3980,  3981,  3982,  3983,  3984,  3985,  3986,  3987,  3988,
    3989,  3990,  3991,  3992,  3993,  3994,  3995,  3996,  3997,  3998,
    3999,  4000,  4001,  4002,  4003,  4004,  4005,  4006,  4007,  4008,
    4009,  4010,  4011,  4012,  4013,  4015,  4017,  4020,  4022,  4024,
    4027,  4028,  4029,  4030,  4031,  4032,  4033,  4034,  4035,  4036,
    4037,  4038,  4039,  4040,  4041,  4042,  4043,  4044,  4045,  4046,
    4047,  4048,  4049,  4050,  4051,  4052,  4053,  4054,  4055,  4056,
    4057,  4058,  4059,  4060,  4061,  4062,  4063,  4064,  4065,  4066,
    4067,  4068,  4069,  4070,  4071,  4072,  4073,  4074,  4075,  4076,
    4077,  4078,  4079,  4080,  4081,  4082,  4083,  4084,  4085,  4086,
    4087,  4088,  4089,  4090,  4091,  4092,  4093,  4094,  4095,  4096,
    4097,  4099,  4102,  4103,  4104,  4105,  4106,  4107,  4108,  4109,
    4111,  4112,  4113,  4114,  4116,  4117,  4119,  4121,  4123,  4125,
    4127,  4129,  4132,  4133,  4134,  4135,  4136,  4138,  4140,  4143,
    4144,  4145,  4146,  4147,  4148,  4149,  4150,  4151,  4156,  4161,
    4167,  4168,  4169,  4170,  4171,  4172,  4173,  4174,  4175,  4176,
    4177,  4178,  4180,  4183,  4184,  4185,  4186,  4187,  4188,  4189,
    4190,  4191,  4192,  4193,  4194,  4195,  4196,  4197,  4198,  4199,
    4200,  4201,  4202,  4203,  4204,  4205,  4206,  4207,  4208,  4209,
    4210,  4213,  4215,  4218,  4219,  4220,  4221,  4222,  4223,  4225,
    4228,  4229,  4231,  4232,  4233,  4235,  4238,  4240,  4243,  4246,
    4249,  4252,  4255,  4258,  4261,  4264,  4265,  4266,  4267,  4268,
    4270,  4272,  4274,  4276,  4278,  4280,  4282,  4284,  4286,  4288,
    4290,  4292,  4294,  4296,  4298,  4300,  4301,  4302,  4303,  4304,
    4305,  4306,  4307,  4308,  4309,  4310,  4311,  4312,  4313,  4314,
    4315,  4316,  4317,  4318,  4319,  4320,  4321,  4322,  4323,  4324,
    4325,  4326,  4327,  4328,  4330,  4332,  4335,  4336,  4337,  4338,
    4339,  4340,  4341,  4342,  4343,  4344,  4345,  4346,  4347,  4348,
    4349,  4350,  4351,  4353,  4354,  4355,  4356,  4357,  4358,  4359,
    4360,  4361,  4362,  4364,  4365,  4366,  4367,  4368,  4369,  4372,
    4373,  4374,  4375,  4376,  4377,  4379,  4381,  4383,  4385,  4386,
    4387,  4388,  4389,  4390,  4391,  4392,  4393,  4394,  4396,  4397,
    4398,  4399,  4400,  4401,  4402,  4405,  4406,  4407,  4408,  4409,
    4410,  4411,  4412,  4413,  4414,  4415,  4416,  4417,  4418,  4419,
    4422,  4423,  4426,  4427,  4428,  4429,  4430,  4431,  4432,  4433,
    4436,  4437,  4438,  4439,  4440,  4441,  4442,  4443,  4444,  4445,
    4446,  4447,  4448,  4449,  4450,  4451,  4452,  4453,  4454,  4457,
    4459,  4461,  4462,  4463,  4466,  4468,  4471,  4474,  4476,  4480,
    4482,  4485,  4489,  4490,  4497,  4499,  4501,  4506,  4513,  4514,
    4517,  4519,  4521,  4526,  4533,  4534,  4537,  4539,  4541,  4546,
    4553,  4554,  4557,  4559,  4564,  4571,  4575,  4580,  4584,  4588,
    4589,  4590,  4591,  4592,  4593,  4594,  4595,  4596,  4597,  4598,
    4599,  4600,  4601,  4602,  4603,  4604,  4605,  4606,  4607,  4608,
    4609,  4610,  4611,  4612,  4613,  4614,  4615,  4616,  4617,  4618,
    4619,  4620
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  parser::symbol_kind_type
  parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const short
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,   781,     2,     2,     2,     2,
     777,   778,     2,     2,     2,     2,   782,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   776,   775,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   779,     2,   780,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,   667,   668,   669,   670,   671,   672,   673,   674,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,   687,   688,   689,   690,   691,   692,   693,   694,
     695,   696,   697,   698,   699,   700,   701,   702,   703,   704,
     705,   706,   707,   708,   709,   710,   711,   712,   713,   714,
     715,   716,   717,   718,   719,   720,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,   733,   734,
     735,   736,   737,   738,   739,   740,   741,   742,   743,   744,
     745,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,   756,   757,   758,   759,   760,   761,   762,   763,   764,
     765,   766,   767,   768,   769,   770,   771,   772,   773,   774
    };
    // Last valid token kind.
    const int code_max = 1029;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return static_cast <symbol_kind_type> (translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

#line 25 "../preprocessor/src/DynareBison.yy"
} // Dynare
#line 18620 "preprocessor/src/dynare-preprocessor.p/DynareBison.cc"

#line 4623 "../preprocessor/src/DynareBison.yy"


void
Dynare::parser::error(const Dynare::parser::location_type& l, const string& m)
{
  driver.error(l, m);
}
